// Auto-generated. Do not edit!

// (in-package hrpsys_ros_bridge.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class MotorStates {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.name = null;
      this.calib_state = null;
      this.servo_state = null;
      this.power_state = null;
      this.servo_alarm = null;
      this.driver_temp = null;
      this.temperature = null;
      this.extra_data = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = [];
      }
      if (initObj.hasOwnProperty('calib_state')) {
        this.calib_state = initObj.calib_state
      }
      else {
        this.calib_state = [];
      }
      if (initObj.hasOwnProperty('servo_state')) {
        this.servo_state = initObj.servo_state
      }
      else {
        this.servo_state = [];
      }
      if (initObj.hasOwnProperty('power_state')) {
        this.power_state = initObj.power_state
      }
      else {
        this.power_state = [];
      }
      if (initObj.hasOwnProperty('servo_alarm')) {
        this.servo_alarm = initObj.servo_alarm
      }
      else {
        this.servo_alarm = [];
      }
      if (initObj.hasOwnProperty('driver_temp')) {
        this.driver_temp = initObj.driver_temp
      }
      else {
        this.driver_temp = [];
      }
      if (initObj.hasOwnProperty('temperature')) {
        this.temperature = initObj.temperature
      }
      else {
        this.temperature = [];
      }
      if (initObj.hasOwnProperty('extra_data')) {
        this.extra_data = initObj.extra_data
      }
      else {
        this.extra_data = new std_msgs.msg.Float64MultiArray();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MotorStates
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [name]
    bufferOffset = _arraySerializer.string(obj.name, buffer, bufferOffset, null);
    // Serialize message field [calib_state]
    bufferOffset = _arraySerializer.bool(obj.calib_state, buffer, bufferOffset, null);
    // Serialize message field [servo_state]
    bufferOffset = _arraySerializer.bool(obj.servo_state, buffer, bufferOffset, null);
    // Serialize message field [power_state]
    bufferOffset = _arraySerializer.bool(obj.power_state, buffer, bufferOffset, null);
    // Serialize message field [servo_alarm]
    bufferOffset = _arraySerializer.int32(obj.servo_alarm, buffer, bufferOffset, null);
    // Serialize message field [driver_temp]
    bufferOffset = _arraySerializer.int16(obj.driver_temp, buffer, bufferOffset, null);
    // Serialize message field [temperature]
    bufferOffset = _arraySerializer.float64(obj.temperature, buffer, bufferOffset, null);
    // Serialize message field [extra_data]
    bufferOffset = std_msgs.msg.Float64MultiArray.serialize(obj.extra_data, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MotorStates
    let len;
    let data = new MotorStates(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [name]
    data.name = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [calib_state]
    data.calib_state = _arrayDeserializer.bool(buffer, bufferOffset, null)
    // Deserialize message field [servo_state]
    data.servo_state = _arrayDeserializer.bool(buffer, bufferOffset, null)
    // Deserialize message field [power_state]
    data.power_state = _arrayDeserializer.bool(buffer, bufferOffset, null)
    // Deserialize message field [servo_alarm]
    data.servo_alarm = _arrayDeserializer.int32(buffer, bufferOffset, null)
    // Deserialize message field [driver_temp]
    data.driver_temp = _arrayDeserializer.int16(buffer, bufferOffset, null)
    // Deserialize message field [temperature]
    data.temperature = _arrayDeserializer.float64(buffer, bufferOffset, null)
    // Deserialize message field [extra_data]
    data.extra_data = std_msgs.msg.Float64MultiArray.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.name.forEach((val) => {
      length += 4 + val.length;
    });
    length += object.calib_state.length;
    length += object.servo_state.length;
    length += object.power_state.length;
    length += 4 * object.servo_alarm.length;
    length += 2 * object.driver_temp.length;
    length += 8 * object.temperature.length;
    length += std_msgs.msg.Float64MultiArray.getMessageSize(object.extra_data);
    return length + 28;
  }

  static datatype() {
    // Returns string type for a message object
    return 'hrpsys_ros_bridge/MotorStates';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '75f582b3495b189b341d4111731cd7fc';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This is a message that holds data to describe the state of a set of motors. 
    #
    # The state of each motor is defined by:
    #  * the temperatur of the motor (Celsius),
    #
    # Each motor is uniquely identified by its name
    # The header specifies the time at which the motor states were recorded. All the motor states
    # in one message have to be recorded at the same time.
    #
    # This message consists of a multiple arrays, one for each part of the motor state. 
    # The goal is to make each of the fields optional. When e.g. your motors have no
    # effort associated with them, you can leave the effort array empty. 
    #
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the motor name with the correct states.
    
    # hrpsys/idl/RobotHardwareService.idl
    #
    #   interface RobotHardwareService
    #   {
    #     const unsigned long CALIB_STATE_MASK = 0x00000001;
    #     const unsigned long CALIB_STATE_SHIFT = 0;
    #     const unsigned long SERVO_STATE_MASK = 0x00000002;
    #     const unsigned long SERVO_STATE_SHIFT = 1;
    #     const unsigned long POWER_STATE_MASK = 0x00000004;
    #     const unsigned long POWER_STATE_SHIFT = 2;
    #     const unsigned long SERVO_ALARM_MASK = 0x0007fff8;
    #     const unsigned long SERVO_ALARM_SHIFT = 3;
    #     const unsigned long DRIVER_TEMP_MASK = 0xff000000;
    #     const unsigned long DRIVER_TEMP_SHIFT = 24;
    
    Header header
    
    string[] name
    bool[] calib_state
    bool[] servo_state
    bool[] power_state
    int32[] servo_alarm
    int16[] driver_temp
    float64[] temperature
    std_msgs/Float64MultiArray extra_data
    
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: std_msgs/Float64MultiArray
    # Please look at the MultiArrayLayout message definition for
    # documentation on all multiarrays.
    
    MultiArrayLayout  layout        # specification of data layout
    float64[]         data          # array of data
    
    
    ================================================================================
    MSG: std_msgs/MultiArrayLayout
    # The multiarray declares a generic multi-dimensional array of a
    # particular data type.  Dimensions are ordered from outer most
    # to inner most.
    
    MultiArrayDimension[] dim # Array of dimension properties
    uint32 data_offset        # padding elements at front of data
    
    # Accessors should ALWAYS be written in terms of dimension stride
    # and specified outer-most dimension first.
    # 
    # multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]
    #
    # A standard, 3-channel 640x480 image with interleaved color channels
    # would be specified as:
    #
    # dim[0].label  = "height"
    # dim[0].size   = 480
    # dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)
    # dim[1].label  = "width"
    # dim[1].size   = 640
    # dim[1].stride = 3*640 = 1920
    # dim[2].label  = "channel"
    # dim[2].size   = 3
    # dim[2].stride = 3
    #
    # multiarray(i,j,k) refers to the ith row, jth column, and kth channel.
    
    ================================================================================
    MSG: std_msgs/MultiArrayDimension
    string label   # label of given dimension
    uint32 size    # size of given dimension (in type units)
    uint32 stride  # stride of given dimension
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MotorStates(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = []
    }

    if (msg.calib_state !== undefined) {
      resolved.calib_state = msg.calib_state;
    }
    else {
      resolved.calib_state = []
    }

    if (msg.servo_state !== undefined) {
      resolved.servo_state = msg.servo_state;
    }
    else {
      resolved.servo_state = []
    }

    if (msg.power_state !== undefined) {
      resolved.power_state = msg.power_state;
    }
    else {
      resolved.power_state = []
    }

    if (msg.servo_alarm !== undefined) {
      resolved.servo_alarm = msg.servo_alarm;
    }
    else {
      resolved.servo_alarm = []
    }

    if (msg.driver_temp !== undefined) {
      resolved.driver_temp = msg.driver_temp;
    }
    else {
      resolved.driver_temp = []
    }

    if (msg.temperature !== undefined) {
      resolved.temperature = msg.temperature;
    }
    else {
      resolved.temperature = []
    }

    if (msg.extra_data !== undefined) {
      resolved.extra_data = std_msgs.msg.Float64MultiArray.Resolve(msg.extra_data)
    }
    else {
      resolved.extra_data = new std_msgs.msg.Float64MultiArray()
    }

    return resolved;
    }
};

module.exports = MotorStates;
