;;
;; DO NOT EDIT THIS FILE
;;
;; this file is automatically generated from /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/models/pa10.l on (Linux ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:24:17 PST
;;
;; /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/obj-arm-linux-gnueabihf $ ;;

;;
;; copy euscollada-robot class definition from euscollada/src/euscollada-robot.l
;;
(defclass euscollada-robot
;; This euscollada-robot class is for robots converted from collada files.
;; This class provides :init-ending override.
  :super robot-model
  :slots ()
  )
(defmethod euscollada-robot
  (:init-ending
   (&optional (type :urdf))
   (when (eq type :collada)
     ;; fix all links' mass properties ;; root link relative (collada) -> link local (euslisp)
     (dolist (l (append links
                        (mapcan #'(lambda (x) (if (and (derivedp (cdr x) bodyset-link)
                                                       (not (memq (cdr x) links)))
                                                  (list (cdr x)))) (send self :slots))))
       (unless (= (send l :weight) 0.0)
       (setq (l . acentroid) (send l :inverse-transform-vector
                                   (send (send (car links) :worldcoords) :transform-vector
                                         (l . acentroid))))
       (setq (l . inertia-tensor) (m* (transpose (send l :worldrot))
                                      (m* (send (car links) :worldrot)
                                          (l . inertia-tensor))))
       )))
   (send-super :init-ending)
   (send self :make-collision-model-for-links)
   ;;
   (dolist (j (mapcan #'(lambda (x) (if (and (derivedp (cdr x) joint)
                                             (not (memq (cdr x) (send self :joint-list))))
                                        (list (cdr x)))) (send self :slots)))
     (send (send j :child-link) :add-joint j)
     (send (send j :child-link) :add-parent-link (send j :parent-link))
     (send (send j :parent-link) :add-child-links (send j :child-link)))
   )
  (:change-visual
   (&optional (visual :convex))
   (dolist (lk (send self :links))
     (dolist (bd (send lk :bodies))
       (when (derivedp bd collada-body)
         (send bd :change-visual visual)))))
  ;; fullbody-inverse-kinematics overwrite
  ;;  reduce root-link's weight based on leg's joint limit
  ;;  increase stop and cog-gain
  (:fullbody-inverse-kinematics
   (target-coords &rest args &key (stop 250) (cog-gain 2.0) (additional-weight-list) (use-6dof-joint-leg-gain nil) &allow-other-keys)
   (let* ((leg-ul (send self :calc-union-link-list (send self :legs :links))))
     (send self :reset-joint-angle-limit-weight-old leg-ul)
     (send-message* self robot-model :fullbody-inverse-kinematics
                    target-coords
                    :stop stop :cog-gain cog-gain
                    :additional-weight-list
                    (append
                     additional-weight-list
                     (if use-6dof-joint-leg-gain
                         (list
                          (list (car (send self :links))
                                #'(lambda ()
                                    ;; set root-link 6dof-joint's weight based on legs' joint limit
                                    (let* ((min-weight
                                            (reduce #'(lambda (x y) (min x y))
                                                    (coerce (send self :calc-inverse-kinematics-weight-from-link-list
                                                                  leg-ul :union-link-list leg-ul) cons))))
                                      (fill (instantiate float-vector 6) min-weight)))
                                )
                          )))
                    args)
     ))
  ;; make collision model from faces or gl-vertices
  (:make-collision-model-for-links
   (&key (fat 0) (collision-func 'pqp-collision-check) ((:links ls) (send self :links)))
   (dolist (ll ls)
     (let (fs glv usefs)
       (dolist (bd (send ll :bodies))
         (if (derivedp bd collada-body)
             (push (send bd :glvertices) glv)
           (push (send bd :faces) fs)))
       (setq fs (flatten fs))
       (cond
        ((and (not fs) glv) ;; if there is no faces, use glvertices for creating pqpmodel
         (setq usefs (instance gl::glvertices :init nil))
         (send usefs :transform (send ll :worldcoords))
         (send usefs :append-glvertices glv)
         (let ((m (send usefs (read-from-string
                               (format nil ":make-~Amodel"
                                       (string-right-trim "-COLLISION-CHECK" (string collision-func))))
                        :fat fat)))
           (setf (get ll :pqpmodel) m)
           ))
        (fs
         (setq usefs
               (append fs
                       (mapcar #'(lambda (gv) (send gv :convert-to-faces :wrt :world)) glv)))
         (send ll
               (read-from-string
                (format nil ":make-~Amodel"
                        (string-right-trim "-COLLISION-CHECK" (string collision-func))))
               :fat fat
               :faces usefs))
        ))
     ))
  )

;; copy euscollada-body class definition from euscollada/src/euscollada-robot.l
;; This euscollada-body class is for bodies in robot model converted from collada files.
(defclass collada-body
  :super gl::glbody
  :slots (glvertices) ;; glvertices slot for backward compatibility
  )
(defmethod collada-body
  (:init (&key (name) (replace-obj))
    (if replace-obj
        (replace-object self replace-obj)
      (replace-object self (make-cube 10 10 10)))
    (if name (send self :name name))
    (setq glvertices gl::aglvertices)
    self)
  (:change-visual
   (&optional (visual :convex))
   (case visual
     ((list :convex :hull :convex-hull)
      (unless (send self :get :original-mesh)
        (send self :put :original-mesh gl::aglvertices)) ;; store original mesh
      (let* ((org-mesh (send self :get :original-mesh))
             (org-cds (send org-mesh :copy-worldcoords))
             (glv (gl::make-glvertices-from-faces (send self :faces))))
        (send glv :set-offset (send org-cds :inverse-transformation))
        (send glv :transform org-cds)
        (send org-mesh :assoc glv)
        (setq gl::aglvertices glv)
        glv))
     ((list :original :mesh :glvertices :original-mesh)
      (let ((org-mesh (send self :get :original-mesh)))
        (when org-mesh
          (dolist (d (send org-mesh :descendants)) ;; dissoc all discendants
            (send org-mesh :dissoc d))
          (setq gl::aglvertices org-mesh)
          org-mesh)))
     ))
  )
;;
;; end of copy from /opt/ros/melodic/share/euscollada/src/euscollada-robot.l
;;
(defun HRP1 () (setq *HRP1* (instance HRP1-robot :init)))

(defclass HRP1-robot
  :super euscollada-robot
  :slots ( ;; link names
          BASE_LINK_lk HAND_L_LINK_lk HAND_R_LINK_lk J1_LINK_lk J2_LINK_lk J3_LINK_lk J4_LINK_lk J5_LINK_lk J6_LINK_lk J7_LINK_lk
         ;; joint names
          HAND_L_jt HAND_R_jt J1_jt J2_jt J3_jt J4_jt J5_jt J6_jt J7_jt
         ;; sensor names
         
         )
  )
(defmethod HRP1-robot
  (:init
   (&rest args)
   (let ()
     (send-super* :init :name "HRP1" args)

     ;; link: BASE_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_BASE_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq BASE_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "BASE_LINK"))
       ;; inertial parameter for BASE_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.5000000000000000e+01))
                      ))
         (send BASE_LINK_lk :weight 3040.000)
         (setq (BASE_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (BASE_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for BASE_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                        ))
         (send BASE_LINK_lk :transform world-cds))
       )

     ;; link: J1_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J1_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J1_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J1_LINK"))
       ;; inertial parameter for J1_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.4818000000000004e+02))
                      ))
         (send J1_LINK_lk :weight 9780.000)
         (setq (J1_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J1_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J1_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.0000000000000000e+02))
                        ))
         (send J1_LINK_lk :transform world-cds))
       )

     ;; link: J2_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J2_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J2_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J2_LINK"))
       ;; inertial parameter for J2_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.7675000000000000e+02))
                      ))
         (send J2_LINK_lk :weight 8410.000)
         (setq (J2_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J2_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J2_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.1500000000000000e+02))
                        ))
         (send J2_LINK_lk :transform world-cds))
       )

     ;; link: J3_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J3_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J3_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J3_LINK"))
       ;; inertial parameter for J3_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 6.7214100000000008e+02))
                      ))
         (send J3_LINK_lk :weight 3520.000)
         (setq (J3_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J3_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J3_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.9500000000000000e+02))
                        ))
         (send J3_LINK_lk :transform world-cds))
       )

     ;; link: J4_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J4_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J4_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J4_LINK"))
       ;; inertial parameter for J4_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.0959000000000015e+02))
                      ))
         (send J4_LINK_lk :weight 4310.000)
         (setq (J4_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J4_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J4_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.6500000000000000e+02))
                        ))
         (send J4_LINK_lk :transform world-cds))
       )

     ;; link: J5_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J5_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J5_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J5_LINK"))
       ;; inertial parameter for J5_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0987500000000000e+03))
                      ))
         (send J5_LINK_lk :weight 3450.000)
         (setq (J5_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J5_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J5_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0150000000000001e+03))
                        ))
         (send J5_LINK_lk :transform world-cds))
       )

     ;; link: J6_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J6_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J6_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J6_LINK"))
       ;; inertial parameter for J6_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2334999999999998e+03))
                      ))
         (send J6_LINK_lk :weight 1460.000)
         (setq (J6_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J6_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J6_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector -2.5000000000000000e+00 0.0000000000000000e+00 1.2650000000000002e+03))
                        ))
         (send J6_LINK_lk :transform world-cds))
       )

     ;; link: J7_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_J7_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq J7_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "J7_LINK"))
       ;; inertial parameter for J7_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3145000000000002e+03))
                      ))
         (send J7_LINK_lk :weight 240.000)
         (setq (J7_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (J7_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for J7_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector -2.5000000000000000e+00 0.0000000000000000e+00 1.3450000000000002e+03))
                        ))
         (send J7_LINK_lk :transform world-cds))
       )

     ;; link: HAND_L_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_HAND_L_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq HAND_L_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "HAND_L_LINK"))
       ;; inertial parameter for HAND_L_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send HAND_L_LINK_lk :weight 500.000)
         (setq (HAND_L_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (HAND_L_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for HAND_L_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector -2.5000000000000000e+00 0.0000000000000000e+00 1.3450000000000002e+03))
                        ))
         (send HAND_L_LINK_lk :transform world-cds))
       )

     ;; link: HAND_R_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_HAND_R_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq HAND_R_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "HAND_R_LINK"))
       ;; inertial parameter for HAND_R_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send HAND_R_LINK_lk :weight 500.000)
         (setq (HAND_R_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+09))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (HAND_R_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for HAND_R_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector -2.5000000000000000e+00 0.0000000000000000e+00 1.3450000000000002e+03))
                        ))
         (send HAND_R_LINK_lk :transform world-cds))
       )

     (send J7_LINK_lk :assoc HAND_L_LINK_lk)
     (send J7_LINK_lk :assoc HAND_R_LINK_lk)
     (send BASE_LINK_lk :assoc J1_LINK_lk)
     (send J1_LINK_lk :assoc J2_LINK_lk)
     (send J2_LINK_lk :assoc J3_LINK_lk)
     (send J3_LINK_lk :assoc J4_LINK_lk)
     (send J4_LINK_lk :assoc J5_LINK_lk)
     (send J5_LINK_lk :assoc J6_LINK_lk)
     (send J6_LINK_lk :assoc J7_LINK_lk)
     (send self :assoc BASE_LINK_lk)

     ;; joint models
     ;; joint: HAND_L_jt
     (setq HAND_L_jt
           (instance linear-joint :init
                     :name "HAND_L"
                     :parent-link J7_LINK_lk :child-link HAND_L_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -100000000.000000 :max 100000000.000000
                     :max-joint-velocity 0.010000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: HAND_R_jt
     (setq HAND_R_jt
           (instance linear-joint :init
                     :name "HAND_R"
                     :parent-link J7_LINK_lk :child-link HAND_R_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -100000000.000000 :max 100000000.000000
                     :max-joint-velocity 0.010000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J1_jt
     (setq J1_jt
           (instance rotational-joint :init
                     :name "J1"
                     :parent-link BASE_LINK_lk :child-link J1_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -176.999995 :max 176.999995
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J2_jt
     (setq J2_jt
           (instance rotational-joint :init
                     :name "J2"
                     :parent-link J1_LINK_lk :child-link J2_LINK_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -94.000000 :max 94.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J3_jt
     (setq J3_jt
           (instance rotational-joint :init
                     :name "J3"
                     :parent-link J2_LINK_lk :child-link J3_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -173.999998 :max 173.999998
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J4_jt
     (setq J4_jt
           (instance rotational-joint :init
                     :name "J4"
                     :parent-link J3_LINK_lk :child-link J4_LINK_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -137.000003 :max 137.000003
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J5_jt
     (setq J5_jt
           (instance rotational-joint :init
                     :name "J5"
                     :parent-link J4_LINK_lk :child-link J5_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -255.000004 :max 255.000004
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J6_jt
     (setq J6_jt
           (instance rotational-joint :init
                     :name "J6"
                     :parent-link J5_LINK_lk :child-link J6_LINK_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -164.999994 :max 164.999994
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: J7_jt
     (setq J7_jt
           (instance rotational-joint :init
                     :name "J7"
                     :parent-link J6_LINK_lk :child-link J7_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -255.000004 :max 255.000004
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; end coords from yaml file

     ;; limbs

     ;; links
     (setq links (list BASE_LINK_lk))

     ;; joint-list
     (setq joint-list (list))

     ;; sensor-coords

     ;; attach_sensor lists
     (setq force-sensors (list ))
     (setq imu-sensors (list ))
     (setq cameras (list ))

     ;; init-ending
     (send self :init-ending) ;; :urdf

     ;; overwrite bodies to return draw-things links not (send link :bodies)
     (setq bodies (flatten (mapcar #'(lambda (b) (if (find-method b :bodies) (send b :bodies))) (list BASE_LINK_lk HAND_L_LINK_lk HAND_R_LINK_lk J1_LINK_lk J2_LINK_lk J3_LINK_lk J4_LINK_lk J5_LINK_lk J6_LINK_lk J7_LINK_lk))))

     (when (member :reset-pose (send self :methods))           (send self :reset-pose)) ;; :set reset-pose

     self)) ;; end of :init


  ;; all joints
  (:HAND_L (&rest args) (forward-message-to HAND_L_jt args))
  (:HAND_R (&rest args) (forward-message-to HAND_R_jt args))
  (:J1 (&rest args) (forward-message-to J1_jt args))
  (:J2 (&rest args) (forward-message-to J2_jt args))
  (:J3 (&rest args) (forward-message-to J3_jt args))
  (:J4 (&rest args) (forward-message-to J4_jt args))
  (:J5 (&rest args) (forward-message-to J5_jt args))
  (:J6 (&rest args) (forward-message-to J6_jt args))
  (:J7 (&rest args) (forward-message-to J7_jt args))

  ;; all links forwarding
  (:links (&rest args)
   (if (null args) (return-from :links (send-super :links)))
   (let ((key (car args))
           (nargs (cdr args)))
     (unless (keywordp key)
         (return-from :links (send-super* :links args)))
       (case key
       (:BASE_LINK (forward-message-to BASE_LINK_lk nargs))
       (:HAND_L_LINK (forward-message-to HAND_L_LINK_lk nargs))
       (:HAND_R_LINK (forward-message-to HAND_R_LINK_lk nargs))
       (:J1_LINK (forward-message-to J1_LINK_lk nargs))
       (:J2_LINK (forward-message-to J2_LINK_lk nargs))
       (:J3_LINK (forward-message-to J3_LINK_lk nargs))
       (:J4_LINK (forward-message-to J4_LINK_lk nargs))
       (:J5_LINK (forward-message-to J5_LINK_lk nargs))
       (:J6_LINK (forward-message-to J6_LINK_lk nargs))
       (:J7_LINK (forward-message-to J7_LINK_lk nargs))
       (t (send-super* :links args)))))

  ;; all links
  (:BASE_LINK_lk (&rest args) (forward-message-to BASE_LINK_lk args))
  (:HAND_L_LINK_lk (&rest args) (forward-message-to HAND_L_LINK_lk args))
  (:HAND_R_LINK_lk (&rest args) (forward-message-to HAND_R_LINK_lk args))
  (:J1_LINK_lk (&rest args) (forward-message-to J1_LINK_lk args))
  (:J2_LINK_lk (&rest args) (forward-message-to J2_LINK_lk args))
  (:J3_LINK_lk (&rest args) (forward-message-to J3_LINK_lk args))
  (:J4_LINK_lk (&rest args) (forward-message-to J4_LINK_lk args))
  (:J5_LINK_lk (&rest args) (forward-message-to J5_LINK_lk args))
  (:J6_LINK_lk (&rest args) (forward-message-to J6_LINK_lk args))
  (:J7_LINK_lk (&rest args) (forward-message-to J7_LINK_lk args))

  ;; user-defined joint

  ;; attach_sensor methods

  ;; geometries
  (:_make_instance_BASE_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 0 3 23 0 23 22 0 22 14 12 0 14 1 0 12 15 23 3 15 3 13 13 3 2 22 23 21 16 21 23 16 23 15 12 14 15 12 15 13 16 15 14 16 14 17 14 22 17 22 21 20 22 20 17 20 21 18 16 18 21 18 16 17 18 17 19 20 19 17 20 18 19 12 13 11 13 2 11 10 11 9 12 11 10 11 2 5 11 5 9 1 5 2 1 4 5 4 7 5 9 5 7 8 9 7 10 9 8 4 6 7 8 7 6 4 1 10 8 4 10 6 4 8 10 1 12))
                   (list :vertices (let ((mat (make-matrix 24 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 -1.1700000000000000e+02 -1.2106298602487797e-11 5.8500000000000000e+01 -1.0132499694824219e+02 -1.0484398939303308e-11 5.8500000000000000e+01 -1.0132499694824219e+02 2.0000000000000000e+02 0.0000000000000000e+00 -1.1700000000000000e+02 2.0000000000000000e+02 1.0132499694824219e+02 -5.8500000000000000e+01 -6.0531601432656235e-12 1.0132499694824219e+02 -5.8500000000000000e+01 2.0000000000000000e+02 1.1700000000000000e+02 -3.8785197830293328e-05 -4.0132098440469854e-18 1.1700000000000000e+02 -3.8785197830293328e-05 2.0000000000000000e+02 1.0132499694824219e+02 5.8500000000000000e+01 6.0531601432656235e-12 1.0132499694824219e+02 5.8500000000000000e+01 2.0000000000000000e+02 5.8500000000000000e+01 1.0132499694824219e+02 1.0484398939303308e-11 5.8500000000000000e+01 1.0132499694824219e+02 2.0000000000000000e+02 7.6658303441945463e-05 1.1700000000000000e+02 1.2106298602487797e-11 7.6658303441945463e-05 1.1700000000000000e+02 2.0000000000000000e+02 -5.8500000000000000e+01 1.0132499694824219e+02 1.0484398939303308e-11 -5.8500000000000000e+01 1.0132499694824219e+02 2.0000000000000000e+02 -1.0132499694824219e+02 5.8500000000000000e+01 2.0000000000000000e+02 -1.0132499694824219e+02 5.8500000000000000e+01 6.0531601432656235e-12 -1.1700000000000000e+02 1.1453100159997120e-04 2.0000000000000000e+02 -1.1700000000000000e+02 1.1453100159997120e-04 1.1850799914726739e-17 -1.0132499694824219e+02 -5.8500000000000000e+01 -6.0531601432656235e-12 -1.0132499694824219e+02 -5.8500000000000000e+01 2.0000000000000000e+02 -5.8500000000000000e+01 -1.0132499694824219e+02 -1.0484398939303308e-11 -5.8500000000000000e+01 -1.0132499694824219e+02 2.0000000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 132 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1699999868869781e+02 1.1453100512426317e-04 2.0000000298023224e+02) (float-vector -1.0132499784231186e+02 -5.8499999344348907e+01 2.0000000298023224e+02) (float-vector -1.0132499784231186e+02 -5.8499999344348907e+01 -6.0531600212928791e-12) (float-vector -1.1699999868869781e+02 1.1453100512426317e-04 1.1850800147371286e-17)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 1.0484399332326595e-11) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 1.2106298866762077e-11)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.0484399332326595e-11) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.2106298866762077e-11) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0132499784231186e+02 5.8499999344348907e+01 6.0531600212928791e-12) (float-vector 1.1699999868869781e+02 -3.8785199052426833e-05 -4.0132097212623633e-18) (float-vector 1.1699999868869781e+02 -3.8785199052426833e-05 2.0000000298023224e+02) (float-vector 1.0132499784231186e+02 5.8499999344348907e+01 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 2.0000000298023224e+02) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 2.0000000298023224e+02) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.2106298866762077e-11) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.0484399332326595e-11)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.0484399332326595e-11) (float-vector -1.0132499784231186e+02 -5.8499999344348907e+01 -6.0531600212928791e-12) (float-vector -1.0132499784231186e+02 -5.8499999344348907e+01 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 2.0000000298023224e+02) (float-vector -1.0132499784231186e+02 -5.8499999344348907e+01 2.0000000298023224e+02) (float-vector -1.1699999868869781e+02 1.1453100512426317e-04 2.0000000298023224e+02) (float-vector -1.0132499784231186e+02 5.8499999344348907e+01 2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 2.0000000298023224e+02) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 2.0000000298023224e+02) (float-vector 1.0132499784231186e+02 5.8499999344348907e+01 2.0000000298023224e+02) (float-vector 1.1699999868869781e+02 -3.8785199052426833e-05 2.0000000298023224e+02) (float-vector 1.0132499784231186e+02 -5.8499999344348907e+01 2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0132499784231186e+02 5.8499999344348907e+01 6.0531600212928791e-12) (float-vector -1.0132499784231186e+02 5.8499999344348907e+01 2.0000000298023224e+02) (float-vector -1.1699999868869781e+02 1.1453100512426317e-04 2.0000000298023224e+02) (float-vector -1.1699999868869781e+02 1.1453100512426317e-04 1.1850800147371286e-17)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 2.0000000298023224e+02) (float-vector -1.0132499784231186e+02 5.8499999344348907e+01 2.0000000298023224e+02) (float-vector -1.0132499784231186e+02 5.8499999344348907e+01 6.0531600212928791e-12) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 1.0484399332326595e-11)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1699999868869781e+02 -3.8785199052426833e-05 -4.0132097212623633e-18) (float-vector 1.0132499784231186e+02 -5.8499999344348907e+01 -6.0531600212928791e-12) (float-vector 1.0132499784231186e+02 -5.8499999344348907e+01 2.0000000298023224e+02) (float-vector 1.1699999868869781e+02 -3.8785199052426833e-05 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0132499784231186e+02 -5.8499999344348907e+01 -6.0531600212928791e-12) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.0484399332326595e-11) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 2.0000000298023224e+02) (float-vector 1.0132499784231186e+02 -5.8499999344348907e+01 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.2106298866762077e-11) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.0484399332326595e-11) (float-vector 1.0132499784231186e+02 -5.8499999344348907e+01 -6.0531600212928791e-12) (float-vector 1.1699999868869781e+02 -3.8785199052426833e-05 -4.0132097212623633e-18) (float-vector 1.0132499784231186e+02 5.8499999344348907e+01 6.0531600212928791e-12) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 1.0484399332326595e-11) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 1.2106298866762077e-11) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 1.0484399332326595e-11) (float-vector -1.0132499784231186e+02 5.8499999344348907e+01 6.0531600212928791e-12) (float-vector -1.1699999868869781e+02 1.1453100512426317e-04 1.1850800147371286e-17) (float-vector -1.0132499784231186e+02 -5.8499999344348907e+01 -6.0531600212928791e-12) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.0484399332326595e-11)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 1.2106298866762077e-11) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 1.0484399332326595e-11) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 2.0000000298023224e+02) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 1.0484399332326595e-11) (float-vector 1.0132499784231186e+02 5.8499999344348907e+01 6.0531600212928791e-12) (float-vector 1.0132499784231186e+02 5.8499999344348907e+01 2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 2.0000000298023224e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_BASE_LINK_8cHDOs.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J1_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 1 0 14 0 3 5 0 5 14 1 14 15 4 2 1 4 1 15 4 5 2 5 3 2 6 5 4 6 14 5 15 14 16 6 16 14 15 16 12 15 12 7 15 7 4 7 6 4 8 6 7 6 8 17 6 17 16 12 16 17 7 12 13 12 17 13 9 8 7 7 13 9 8 9 10 8 10 18 8 18 17 18 13 17 18 19 13 9 13 19 9 11 10 9 19 11 18 10 11 18 11 19))
                   (list :vertices (let ((mat (make-matrix 20 3))) (fvector-replace (array-entity mat) #f(9.3000000000000000e+01 6.6825004577636719e+01 -1.8000000000000000e+02 9.3000000000000000e+01 -6.6825004577636719e+01 -1.8000000000000000e+02 9.3000000000000000e+01 -6.6825004577636719e+01 -2.0000000000000000e+02 9.3000000000000000e+01 6.6825004577636719e+01 -2.0000000000000000e+02 5.8500000000000000e+01 -1.0132499694824219e+02 -2.0000000000000000e+02 5.8500000000000000e+01 1.0132499694824219e+02 -2.0000000000000000e+02 7.6658303441945463e-05 1.1700000000000000e+02 -2.0000000000000000e+02 0.0000000000000000e+00 -1.1700000000000000e+02 -2.0000000000000000e+02 -5.8500000000000000e+01 1.0132499694824219e+02 -2.0000000000000000e+02 -5.8500000000000000e+01 -1.0132499694824219e+02 -2.0000000000000000e+02 -9.3000000000000000e+01 6.6825004577636719e+01 -2.0000000000000000e+02 -9.3000000000000000e+01 -6.6825004577636719e+01 -2.0000000000000000e+02 0.0000000000000000e+00 -1.1700000000000000e+02 -1.8000000000000000e+02 -5.8500000000000000e+01 -1.0132499694824219e+02 -1.8000000000000000e+02 5.8500000000000000e+01 1.0132499694824219e+02 -1.8000000000000000e+02 5.8500000000000000e+01 -1.0132499694824219e+02 -1.8000000000000000e+02 7.6658303441945463e-05 1.1700000000000000e+02 -1.8000000000000000e+02 -5.8500000000000000e+01 1.0132499694824219e+02 -1.8000000000000000e+02 -9.3000000000000000e+01 6.6825004577636719e+01 -1.8000000000000000e+02 -9.3000000000000000e+01 -6.6825004577636719e+01 -1.8000000000000000e+02 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 0.900000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 0 3 4 4 27 0 27 14 0 14 1 0 1 14 2 14 15 2 15 3 2 4 3 5 15 16 3 16 5 3 4 5 6 6 26 4 4 26 27 6 5 7 16 17 5 17 7 5 29 30 16 15 29 16 30 17 16 17 18 7 30 31 17 31 18 17 6 7 8 8 7 9 18 9 7 18 19 9 31 32 18 18 32 33 18 33 19 30 40 31 31 40 39 31 39 32 32 39 38 32 38 33 19 33 34 33 38 37 33 37 34 23 37 38 23 38 24 24 38 39 24 39 25 25 39 40 10 23 24 10 24 8 8 24 25 12 22 23 12 23 10 22 37 23 22 36 37 34 37 36 13 21 22 13 22 12 21 36 22 10 11 12 12 11 13 8 9 10 10 9 11 8 25 6 6 25 26 25 40 26 26 40 41 26 41 27 30 41 40 41 28 27 29 28 41 29 41 30 28 14 27 28 29 15 14 28 15 19 20 11 19 11 9 11 20 21 11 21 13 19 34 20 20 34 35 20 35 21 21 35 36 34 36 35 42 43 44 42 44 45 42 45 46 62 42 46 62 63 42 63 43 42 43 63 44 63 64 44 64 45 44 46 45 47 64 65 45 65 47 45 46 47 48 61 46 48 62 46 61 48 47 49 65 66 47 66 49 47 78 79 65 64 78 65 79 66 65 66 67 49 79 80 66 80 67 66 48 49 50 50 49 51 67 51 49 67 68 51 80 81 67 81 68 67 74 81 80 74 80 75 75 80 79 81 82 68 73 82 81 73 81 74 68 69 53 68 53 51 82 69 68 82 83 69 72 83 82 72 82 73 73 59 58 73 58 72 74 59 73 72 58 56 72 56 70 70 83 72 71 69 83 70 71 83 70 56 57 70 57 71 56 54 55 56 55 57 58 54 56 58 52 54 59 52 58 52 53 54 54 53 55 57 55 53 57 53 69 71 57 69 52 51 53 50 51 52 59 50 52 60 48 50 60 50 59 74 60 59 61 48 60 75 61 60 75 60 74 76 62 61 76 61 75 75 79 76 62 76 77 76 79 78 76 78 77 63 62 77 77 78 64 63 77 64))
                   (list :vertices (let ((mat (make-matrix 84 3))) (fvector-replace (array-entity mat) #f(1.3500000000000000e+02 -2.2500999450683594e+01 -1.7647099304199219e+02 1.3500000000000000e+02 -1.8107700668762439e-12 -1.8250000000000000e+02 1.3500000000000000e+02 2.2500000000000000e+01 -1.7647099304199219e+02 1.3500000000000000e+02 3.8971000671386719e+01 -1.6000000000000000e+02 1.3500000000000000e+02 -3.8971000671386719e+01 -1.6000000000000000e+02 1.3500000000000000e+02 4.5000000000000000e+01 -1.3750000000000000e+02 1.3500000000000000e+02 -4.5000000000000000e+01 -1.3750000000000000e+02 1.3500000000000000e+02 4.5000000000000000e+01 -8.2500000000000000e+01 1.3500000000000000e+02 -4.5000000000000000e+01 -8.2500000000000000e+01 1.3500000000000000e+02 3.8971000671386719e+01 -6.0000000000000000e+01 1.3500000000000000e+02 -3.8971000671386719e+01 -6.0000000000000000e+01 1.3500000000000000e+02 2.2500000000000000e+01 -4.3528999328613281e+01 1.3500000000000000e+02 -2.2500000000000000e+01 -4.3528999328613281e+01 1.3500000000000000e+02 1.8316500063519925e-04 -3.7500000000000000e+01 9.5000000000000000e+01 -2.5868201894777010e-13 -1.9750000000000000e+02 9.5000000000000000e+01 3.0000000000000000e+01 -1.8946200561523438e+02 9.5000000000000000e+01 5.1961002349853516e+01 -1.6750000000000000e+02 9.5000000000000000e+01 6.0000000000000000e+01 -1.3750000000000000e+02 9.5000000000000000e+01 6.0000000000000000e+01 -8.2500000000000000e+01 9.5000000000000000e+01 5.1961997985839844e+01 -5.2500000000000000e+01 9.5000000000000000e+01 3.0000000000000000e+01 -3.0538999557495117e+01 9.5000000000000000e+01 2.4421999114565551e-04 -2.2500000000000000e+01 9.5000000000000000e+01 -3.0000000000000000e+01 -3.0538000106811523e+01 9.5000000000000000e+01 -5.1961002349853516e+01 -5.2500000000000000e+01 9.5000000000000000e+01 -6.0000000000000000e+01 -8.2499000549316406e+01 9.5000000000000000e+01 -6.0000000000000000e+01 -1.3749900817871094e+02 9.5000000000000000e+01 -5.1961997985839844e+01 -1.6749900817871094e+02 9.5000000000000000e+01 -3.0000999450683594e+01 -1.8946099853515625e+02 7.5000000000000000e+01 -2.5868201894777010e-13 -1.9750000000000000e+02 7.5000000000000000e+01 3.0000000000000000e+01 -1.8946200561523438e+02 7.5000000000000000e+01 5.1961002349853516e+01 -1.6750000000000000e+02 7.5000000000000000e+01 6.0000000000000000e+01 -1.3750000000000000e+02 7.5000000000000000e+01 6.0000000000000000e+01 -8.2500000000000000e+01 7.5000000000000000e+01 5.1961997985839844e+01 -5.2500000000000000e+01 7.5000000000000000e+01 3.0000000000000000e+01 -3.0538999557495117e+01 7.5000000000000000e+01 2.4421999114565551e-04 -2.2500000000000000e+01 7.5000000000000000e+01 -3.0000000000000000e+01 -3.0538000106811523e+01 7.5000000000000000e+01 -5.1961002349853516e+01 -5.2500000000000000e+01 7.5000000000000000e+01 -6.0000000000000000e+01 -8.2499000549316406e+01 7.5000000000000000e+01 -6.0000000000000000e+01 -1.3749900817871094e+02 7.5000000000000000e+01 -5.1961997985839844e+01 -1.6749900817871094e+02 7.5000000000000000e+01 -3.0000999450683594e+01 -1.8946099853515625e+02 -1.4000000000000000e+02 2.2500000000000000e+01 -1.7647099304199219e+02 -1.4000000000000000e+02 1.8316500063519925e-04 -1.8250000000000000e+02 -1.4000000000000000e+02 -2.2500000000000000e+01 -1.7647099304199219e+02 -1.4000000000000000e+02 -3.8971000671386719e+01 -1.6000000000000000e+02 -1.4000000000000000e+02 3.8971000671386719e+01 -1.6000000000000000e+02 -1.4000000000000000e+02 -4.5000000000000000e+01 -1.3750000000000000e+02 -1.4000000000000000e+02 4.5000000000000000e+01 -1.3750000000000000e+02 -1.4000000000000000e+02 -4.5000000000000000e+01 -8.2500000000000000e+01 -1.4000000000000000e+02 4.5000000000000000e+01 -8.2500000000000000e+01 -1.4000000000000000e+02 -3.8971000671386719e+01 -6.0000999450683594e+01 -1.4000000000000000e+02 3.8971000671386719e+01 -6.0000000000000000e+01 -1.4000000000000000e+02 -2.2500999450683594e+01 -4.3528999328613281e+01 -1.4000000000000000e+02 2.2500000000000000e+01 -4.3528999328613281e+01 -1.4000000000000000e+02 -1.6814299952372380e-11 -3.7500000000000000e+01 -1.0000000000000000e+02 3.0000000000000000e+01 -3.0538999557495117e+01 -1.0000000000000000e+02 -1.8366400414415729e-11 -2.2500000000000000e+01 -1.0000000000000000e+02 5.1961002349853516e+01 -5.2500000000000000e+01 -1.0000000000000000e+02 6.0000000000000000e+01 -8.2500000000000000e+01 -1.0000000000000000e+02 6.0000000000000000e+01 -1.3750000000000000e+02 -1.0000000000000000e+02 5.1961997985839844e+01 -1.6750000000000000e+02 -1.0000000000000000e+02 3.0000000000000000e+01 -1.8946099853515625e+02 -1.0000000000000000e+02 2.4421999114565551e-04 -1.9750000000000000e+02 -1.0000000000000000e+02 -3.0000000000000000e+01 -1.8946200561523438e+02 -1.0000000000000000e+02 -5.1961002349853516e+01 -1.6750000000000000e+02 -1.0000000000000000e+02 -6.0000000000000000e+01 -1.3750100708007812e+02 -1.0000000000000000e+02 -6.0000000000000000e+01 -8.2500999450683594e+01 -1.0000000000000000e+02 -5.1961997985839844e+01 -5.2500999450683594e+01 -1.0000000000000000e+02 -3.0000999450683594e+01 -3.0538999557495117e+01 -8.0000000000000000e+01 3.0000000000000000e+01 -3.0538999557495117e+01 -8.0000000000000000e+01 -1.8366400414415729e-11 -2.2500000000000000e+01 -8.0000000000000000e+01 5.1961002349853516e+01 -5.2500000000000000e+01 -8.0000000000000000e+01 6.0000000000000000e+01 -8.2500000000000000e+01 -8.0000000000000000e+01 6.0000000000000000e+01 -1.3750000000000000e+02 -8.0000000000000000e+01 5.1961997985839844e+01 -1.6750000000000000e+02 -8.0000000000000000e+01 3.0000000000000000e+01 -1.8946099853515625e+02 -8.0000000000000000e+01 2.4421999114565551e-04 -1.9750000000000000e+02 -8.0000000000000000e+01 -3.0000000000000000e+01 -1.8946200561523438e+02 -8.0000000000000000e+01 -5.1961002349853516e+01 -1.6750000000000000e+02 -8.0000000000000000e+01 -6.0000000000000000e+01 -1.3750100708007812e+02 -8.0000000000000000e+01 -6.0000000000000000e+01 -8.2500999450683594e+01 -8.0000000000000000e+01 -5.1961997985839844e+01 -5.2500999450683594e+01 -8.0000000000000000e+01 -3.0000999450683594e+01 -3.0538999557495117e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 588 -> 47 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -1.8107700939812982e-12 -1.8250000476837158e+02) (float-vector 9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 1.3500000536441803e+02 -2.2500999271869659e+01 -1.7647099494934082e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -2.0000000298023224e+02) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 1.8316499961201771e-04 -1.8250000476837158e+02) (float-vector -9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 1.8316499961201771e-04 -1.8250000476837158e+02) (float-vector -9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -1.4000000059604645e+02 2.2500000894069672e+01 -1.7647099494934082e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -1.8107700939812982e-12 -1.8250000476837158e+02) (float-vector 9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector 1.3500000536441803e+02 4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector 9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 1.3500000536441803e+02 3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector 1.3500000536441803e+02 4.5000001788139343e+01 -1.3750000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -1.4000000059604645e+02 3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector -1.4000000059604645e+02 2.2500000894069672e+01 -1.7647099494934082e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector -9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector -1.4000000059604645e+02 4.5000001788139343e+01 -1.3750000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector -1.4000000059604645e+02 4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 1.3500000536441803e+02 2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector 1.3500000536441803e+02 3.8970999419689178e+01 -1.5999999642372131e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector 9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 1.3500000536441803e+02 -1.8107700939812982e-12 -1.8250000476837158e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector 9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector -9.3000002205371857e+01 6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.4999998807907104e+01 -2.9999999329447746e+01 -3.0538000166416168e+01) (float-vector 9.4999998807907104e+01 2.4421999000878714e-04 -2.2500000894069672e+01) (float-vector 1.3500000536441803e+02 1.8316499961201771e-04 -3.7500001490116119e+01) (float-vector 1.3500000536441803e+02 -2.2500000894069672e+01 -4.3529000133275986e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector 9.4999998807907104e+01 -5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector 9.4999998807907104e+01 -2.9999999329447746e+01 -3.0538000166416168e+01) (float-vector 1.3500000536441803e+02 -2.2500000894069672e+01 -4.3529000133275986e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 1.3500000536441803e+02 -3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector 1.3500000536441803e+02 -2.2500999271869659e+01 -1.7647099494934082e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector 1.3500000536441803e+02 -3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector 9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 1.8316499961201771e-04 -1.8250000476837158e+02) (float-vector -1.4000000059604645e+02 -2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector -9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 -2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector -1.4000000059604645e+02 -3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector -9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector -1.4000000059604645e+02 -4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector -1.4000000059604645e+02 -4.5000001788139343e+01 -8.2500003278255463e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector -9.3000002205371857e+01 -6.6825002431869507e+01 -2.0000000298023224e+02) (float-vector -1.4000000059604645e+02 -3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector -1.4000000059604645e+02 -4.5000001788139343e+01 -1.3750000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 -3.8970999419689178e+01 -6.0001000761985779e+01) (float-vector -1.4000000059604645e+02 -4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector -1.4000000059604645e+02 -4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector -1.4000000059604645e+02 -3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector -1.4000000059604645e+02 -2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector -1.4000000059604645e+02 1.8316499961201771e-04 -1.8250000476837158e+02) (float-vector -1.4000000059604645e+02 2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector -1.4000000059604645e+02 3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector -1.4000000059604645e+02 4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector -1.4000000059604645e+02 4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector -1.4000000059604645e+02 3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector -1.4000000059604645e+02 2.2500000894069672e+01 -4.3529000133275986e+01) (float-vector -1.4000000059604645e+02 -1.6814300264080505e-11 -3.7500001490116119e+01) (float-vector -1.4000000059604645e+02 -2.2500999271869659e+01 -4.3529000133275986e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 9.4999998807907104e+01 -5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector 1.3500000536441803e+02 -3.8970999419689178e+01 -5.9999998658895493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -2.2500999271869659e+01 -1.7647099494934082e+02) (float-vector 1.3500000536441803e+02 -3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector 1.3500000536441803e+02 -4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector 1.3500000536441803e+02 -4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector 1.3500000536441803e+02 -3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector 1.3500000536441803e+02 -2.2500000894069672e+01 -4.3529000133275986e+01) (float-vector 1.3500000536441803e+02 1.8316499961201771e-04 -3.7500001490116119e+01) (float-vector 1.3500000536441803e+02 2.2500000894069672e+01 -4.3529000133275986e+01) (float-vector 1.3500000536441803e+02 3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector 1.3500000536441803e+02 4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector 1.3500000536441803e+02 4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector 1.3500000536441803e+02 3.8970999419689178e+01 -1.5999999642372131e+02) (float-vector 1.3500000536441803e+02 2.2500000894069672e+01 -1.7647099494934082e+02) (float-vector 1.3500000536441803e+02 -1.8107700939812982e-12 -1.8250000476837158e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 -4.5000001788139343e+01 -1.3750000298023224e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 1.3500000536441803e+02 -4.5000001788139343e+01 -8.2500003278255463e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -1.8366400048497496e-11 -2.2500000894069672e+01) (float-vector -1.0000000149011612e+02 -3.0000999569892883e+01 -3.0539000406861305e+01) (float-vector -1.4000000059604645e+02 -2.2500999271869659e+01 -4.3529000133275986e+01) (float-vector -1.4000000059604645e+02 -1.6814300264080505e-11 -3.7500001490116119e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -3.0000999569892883e+01 -3.0539000406861305e+01) (float-vector -1.0000000149011612e+02 -1.8366400048497496e-11 -2.2500000894069672e+01) (float-vector 9.4999998807907104e+01 2.4421999000878714e-04 -2.2500000894069672e+01) (float-vector 9.4999998807907104e+01 -2.9999999329447746e+01 -3.0538000166416168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.4999998807907104e+01 2.4421999000878714e-04 -2.2500000894069672e+01) (float-vector 9.4999998807907104e+01 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector 1.3500000536441803e+02 2.2500000894069672e+01 -4.3529000133275986e+01) (float-vector 1.3500000536441803e+02 1.8316499961201771e-04 -3.7500001490116119e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector 9.4999998807907104e+01 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector 9.4999998807907104e+01 2.4421999000878714e-04 -2.2500000894069672e+01) (float-vector -1.0000000149011612e+02 -1.8366400048497496e-11 -2.2500000894069672e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector -1.0000000149011612e+02 -1.8366400048497496e-11 -2.2500000894069672e+01) (float-vector -1.4000000059604645e+02 -1.6814300264080505e-11 -3.7500001490116119e+01) (float-vector -1.4000000059604645e+02 2.2500000894069672e+01 -4.3529000133275986e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector 9.4999998807907104e+01 -5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -2.0000000298023224e+02) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 5.8499999344348907e+01 -1.0132499784231186e+02 -2.0000000298023224e+02) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.4999998807907104e+01 5.1961999386548996e+01 -5.2499998360872269e+01) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.4999998807907104e+01 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector 9.4999998807907104e+01 5.1961999386548996e+01 -5.2499998360872269e+01) (float-vector 1.3500000536441803e+02 3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector 1.3500000536441803e+02 2.2500000894069672e+01 -4.3529000133275986e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3500000536441803e+02 3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector 9.4999998807907104e+01 5.1961999386548996e+01 -5.2499998360872269e+01) (float-vector 5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector 1.3500000536441803e+02 4.5000001788139343e+01 -8.2500003278255463e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.4999998807907104e+01 5.1961999386548996e+01 -5.2499998360872269e+01) (float-vector -1.0000000149011612e+02 5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.6658302816667856e-05 1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector -1.0000000149011612e+02 5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector -1.0000000149011612e+02 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector -1.4000000059604645e+02 2.2500000894069672e+01 -4.3529000133275986e+01) (float-vector -1.4000000059604645e+02 3.8970999419689178e+01 -5.9999998658895493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector 9.4999998807907104e+01 5.1961999386548996e+01 -5.2499998360872269e+01) (float-vector 9.4999998807907104e+01 2.9999999329447746e+01 -3.0539000406861305e+01) (float-vector -1.0000000149011612e+02 2.9999999329447746e+01 -3.0539000406861305e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 5.1961001008749008e+01 -5.2499998360872269e+01) (float-vector -1.4000000059604645e+02 3.8970999419689178e+01 -5.9999998658895493e+01) (float-vector -1.4000000059604645e+02 4.5000001788139343e+01 -8.2500003278255463e+01) (float-vector -5.8499999344348907e+01 1.0132499784231186e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -5.1961999386548996e+01 -5.2501000463962555e+01) (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -5.1961999386548996e+01 -5.2501000463962555e+01) (float-vector -1.0000000149011612e+02 -3.0000999569892883e+01 -3.0539000406861305e+01) (float-vector 9.4999998807907104e+01 -2.9999999329447746e+01 -3.0538000166416168e+01) (float-vector 9.4999998807907104e+01 -5.1961001008749008e+01 -5.2499998360872269e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -3.0000999569892883e+01 -3.0539000406861305e+01) (float-vector -1.0000000149011612e+02 -5.1961999386548996e+01 -5.2501000463962555e+01) (float-vector -1.4000000059604645e+02 -3.8970999419689178e+01 -6.0001000761985779e+01) (float-vector -1.4000000059604645e+02 -2.2500999271869659e+01 -4.3529000133275986e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -1.1699999868869781e+02 -1.8000000715255737e+02) (float-vector -1.0000000149011612e+02 -5.1961999386548996e+01 -5.2501000463962555e+01) (float-vector 9.4999998807907104e+01 -5.1961001008749008e+01 -5.2499998360872269e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4000000059604645e+02 -3.8970999419689178e+01 -6.0001000761985779e+01) (float-vector -1.0000000149011612e+02 -5.1961999386548996e+01 -5.2501000463962555e+01) (float-vector -5.8499999344348907e+01 -1.0132499784231186e+02 -1.8000000715255737e+02) (float-vector -1.4000000059604645e+02 -4.5000001788139343e+01 -8.2500003278255463e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J1_LINK_2yrdM0.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J2_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1500000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 3 1 10 3 0 10 0 11 11 0 12 0 2 12 9 8 3 9 3 10 19 3 8 19 1 3 11 17 10 10 17 18 10 18 9 7 8 9 9 18 20 9 20 7 7 6 8 6 19 8 4 6 7 7 20 22 7 22 4 18 19 20 21 20 19 21 22 20 17 1 18 18 1 19 6 21 19 22 21 23 25 23 21 6 25 21 22 24 4 22 25 24 22 23 25 4 5 6 24 5 4 6 5 24 6 24 25 30 31 25 32 30 25 41 25 31 41 32 25 27 30 32 42 30 27 41 31 30 41 30 42 33 27 32 41 40 32 33 32 40 40 41 42 40 42 26 42 27 26 26 27 28 28 27 33 34 28 33 33 40 43 34 33 43 40 26 43 26 28 29 43 26 29 35 28 34 28 35 45 28 45 29 43 29 44 44 29 45 34 43 44 36 35 34 34 44 46 34 46 36 37 35 36 35 37 47 35 47 45 44 45 46 46 45 47 46 47 48 36 46 48 38 37 36 36 48 38 37 24 39 37 38 24 37 39 49 37 49 47 48 47 49 49 38 48 24 38 49 39 24 49 17 2 1 14 2 17 11 14 17 14 16 2 2 16 12 14 15 16 15 14 11 11 12 13 13 15 11 12 16 13 16 15 13))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(7.5000000000000000e+01 -4.6960998535156250e+01 -1.4500000000000000e+02 -7.5000000000000000e+01 -5.5000000000000000e+01 -1.1500000000000000e+02 -7.5000000000000000e+01 -4.6960998535156250e+01 -1.4500000000000000e+02 7.5000000000000000e+01 -5.5000000000000000e+01 -1.1500000000000000e+02 7.5000000000000000e+01 3.5000000000000000e+01 -6.3038997650146484e+01 7.5000000000000000e+01 5.0000000000000000e+00 -5.5000000000000000e+01 7.5000000000000000e+01 -2.5000000000000000e+01 -6.3038997650146484e+01 7.5000000000000000e+01 5.6960998535156250e+01 -8.5000000000000000e+01 7.5000000000000000e+01 -4.6962001800537109e+01 -8.5000000000000000e+01 7.5000000000000000e+01 6.5000000000000000e+01 -1.1500000000000000e+02 7.5000000000000000e+01 5.6961997985839844e+01 -1.4500000000000000e+02 7.5000000000000000e+01 3.5000000000000000e+01 -1.6696099853515625e+02 7.5000000000000000e+01 -2.5000000000000000e+01 -1.6696199035644531e+02 7.5000000000000000e+01 5.0000000000000000e+00 -1.7500000000000000e+02 -7.5000000000000000e+01 3.5000000000000000e+01 -1.6696099853515625e+02 -7.5000000000000000e+01 5.0000000000000000e+00 -1.7500000000000000e+02 -7.5000000000000000e+01 -2.5000000000000000e+01 -1.6696099853515625e+02 -7.5000000000000000e+01 5.6961997985839844e+01 -1.4500000000000000e+02 -7.5000000000000000e+01 6.5000000000000000e+01 -1.1500000000000000e+02 -7.5000000000000000e+01 -4.6962001800537109e+01 -8.5000000000000000e+01 -7.5000000000000000e+01 5.6960998535156250e+01 -8.5000000000000000e+01 -7.5000000000000000e+01 -2.5000000000000000e+01 -6.3037998199462891e+01 -7.5000000000000000e+01 3.5000000000000000e+01 -6.3037998199462891e+01 -7.5000000000000000e+01 5.0000000000000000e+00 -5.5000000000000000e+01 5.8659999847412109e+01 5.0000000000000000e+00 -5.5000000000000000e+01 -5.8659999847412109e+01 5.0000000000000000e+00 -5.5000000000000000e+01 -3.0000000000000000e+01 -5.1961002349853516e+01 1.6500000000000000e+02 -3.0000000000000000e+01 -5.1961002349853516e+01 -5.5000000000000000e+01 0.0000000000000000e+00 -6.0000000000000000e+01 -5.5000000000000000e+01 0.0000000000000000e+00 -6.0000000000000000e+01 1.6500000000000000e+02 -5.1961997985839844e+01 -3.0000000000000000e+01 -5.5000000000000000e+01 -6.0000000000000000e+01 5.7508801546646282e-05 -5.5000000000000000e+01 -5.1961002349853516e+01 3.0000000000000000e+01 -5.5000000000000000e+01 -3.0000000000000000e+01 5.1961997985839844e+01 -5.5000000000000000e+01 3.8572299672523513e-05 6.0000000000000000e+01 -5.5000000000000000e+01 3.0000000000000000e+01 -5.1961002349853516e+01 -5.5000000000000000e+01 3.0000000000000000e+01 5.1961002349853516e+01 -5.5000000000000000e+01 5.1961002349853516e+01 -3.0000000000000000e+01 -5.5000000000000000e+01 5.1961997985839844e+01 3.0000000000000000e+01 -5.5000000000000000e+01 6.0000000000000000e+01 -1.9635699572972953e-05 -5.5000000000000000e+01 -5.1961002349853516e+01 3.0000000000000000e+01 1.6500000000000000e+02 -6.0000000000000000e+01 5.7508801546646282e-05 1.6500000000000000e+02 -5.1961997985839844e+01 -3.0000000000000000e+01 1.6500000000000000e+02 -3.0000000000000000e+01 5.1961997985839844e+01 1.6500000000000000e+02 3.8572299672523513e-05 6.0000000000000000e+01 1.6500000000000000e+02 3.0000000000000000e+01 -5.1961002349853516e+01 1.6500000000000000e+02 3.0000000000000000e+01 5.1961002349853516e+01 1.6500000000000000e+02 5.1961002349853516e+01 -3.0000000000000000e+01 1.6500000000000000e+02 5.1961997985839844e+01 3.0000000000000000e+01 1.6500000000000000e+02 6.0000000000000000e+01 -1.9635699572972953e-05 1.6500000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 288 -> 28 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1961999386548996e+01 2.9999999329447746e+01 1.6500000655651093e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 5.7508803052996882e-05 1.6500000655651093e+02) (float-vector -5.1961999386548996e+01 -2.9999999329447746e+01 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -4.6960998326539993e+01 -1.4499999582767487e+02) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector 7.5000002980232239e+01 -4.6960998326539993e+01 -1.4499999582767487e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -4.6960998326539993e+01 -1.4499999582767487e+02) (float-vector 7.5000002980232239e+01 -2.5000000372529030e+01 -1.6696199774742126e+02) (float-vector -7.5000002980232239e+01 -2.5000000372529030e+01 -1.6696099936962128e+02) (float-vector -7.5000002980232239e+01 -4.6960998326539993e+01 -1.4499999582767487e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -2.5000000372529030e+01 -1.6696099936962128e+02) (float-vector 7.5000002980232239e+01 -2.5000000372529030e+01 -1.6696199774742126e+02) (float-vector 7.5000002980232239e+01 4.9999998882412910e+00 -1.7499999701976776e+02) (float-vector -7.5000002980232239e+01 4.9999998882412910e+00 -1.7499999701976776e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -5.4999999701976776e+01) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 1.6500000655651093e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -5.4999999701976776e+01) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -5.4999999701976776e+01) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1961999386548996e+01 -2.9999999329447746e+01 1.6500000655651093e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 4.9999998882412910e+00 -5.4999999701976776e+01) (float-vector -5.9999998658895493e+01 5.7508803052996882e-05 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 4.9999998882412910e+00 -5.4999999701976776e+01) (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector -5.9999998658895493e+01 5.7508803052996882e-05 1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 5.1961001008749008e+01 -2.9999999329447746e+01 1.6500000655651093e+02) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1961001008749008e+01 -2.9999999329447746e+01 1.6500000655651093e+02) (float-vector 5.9999998658895493e+01 -1.9635699288755859e-05 1.6500000655651093e+02) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 -1.9635699288755859e-05 1.6500000655651093e+02) (float-vector 7.5000002980232239e+01 3.5000000149011612e+01 -6.3038997352123260e+01) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector 7.5000002980232239e+01 3.5000000149011612e+01 -6.3038997352123260e+01) (float-vector 5.9999998658895493e+01 -1.9635699288755859e-05 1.6500000655651093e+02) (float-vector 5.1961999386548996e+01 2.9999999329447746e+01 1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 1.6500000655651093e+02) (float-vector -5.1961001008749008e+01 2.9999999329447746e+01 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector -5.1961001008749008e+01 2.9999999329447746e+01 1.6500000655651093e+02) (float-vector -5.9999998658895493e+01 5.7508803052996882e-05 1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector 7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 1.6500000655651093e+02) (float-vector 7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 1.6500000655651093e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 1.6500000655651093e+02) (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 1.6500000655651093e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 5.1961999386548996e+01 2.9999999329447746e+01 1.6500000655651093e+02) (float-vector 5.9999998658895493e+01 -1.9635699288755859e-05 1.6500000655651093e+02) (float-vector 5.1961001008749008e+01 -2.9999999329447746e+01 1.6500000655651093e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 1.6500000655651093e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 1.6500000655651093e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 1.6500000655651093e+02) (float-vector -5.1961999386548996e+01 -2.9999999329447746e+01 1.6500000655651093e+02) (float-vector -5.9999998658895493e+01 5.7508803052996882e-05 1.6500000655651093e+02) (float-vector -5.1961001008749008e+01 2.9999999329447746e+01 1.6500000655651093e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector 7.5000002980232239e+01 5.6961998343467712e+01 -1.4499999582767487e+02) (float-vector 7.5000002980232239e+01 3.5000000149011612e+01 -1.6696099936962128e+02) (float-vector 7.5000002980232239e+01 4.9999998882412910e+00 -1.7499999701976776e+02) (float-vector 7.5000002980232239e+01 -2.5000000372529030e+01 -1.6696199774742126e+02) (float-vector 7.5000002980232239e+01 -4.6960998326539993e+01 -1.4499999582767487e+02) (float-vector 7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector 7.5000002980232239e+01 3.5000000149011612e+01 -6.3038997352123260e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector -7.5000002980232239e+01 5.6961998343467712e+01 -1.4499999582767487e+02) (float-vector 7.5000002980232239e+01 5.6961998343467712e+01 -1.4499999582767487e+02) (float-vector 7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 3.5000000149011612e+01 -1.6696099936962128e+02) (float-vector -7.5000002980232239e+01 5.6961998343467712e+01 -1.4499999582767487e+02) (float-vector -7.5000002980232239e+01 6.4999997615814209e+01 -1.1500000208616257e+02) (float-vector -7.5000002980232239e+01 4.9999998882412910e+00 -5.4999999701976776e+01) (float-vector -7.5000002980232239e+01 -5.4999999701976776e+01 -1.1500000208616257e+02) (float-vector -7.5000002980232239e+01 -4.6960998326539993e+01 -1.4499999582767487e+02) (float-vector -7.5000002980232239e+01 -2.5000000372529030e+01 -1.6696099936962128e+02) (float-vector -7.5000002980232239e+01 4.9999998882412910e+00 -1.7499999701976776e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 3.5000000149011612e+01 -1.6696099936962128e+02) (float-vector -7.5000002980232239e+01 3.5000000149011612e+01 -1.6696099936962128e+02) (float-vector -7.5000002980232239e+01 4.9999998882412910e+00 -1.7499999701976776e+02) (float-vector 7.5000002980232239e+01 4.9999998882412910e+00 -1.7499999701976776e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 5.6961998343467712e+01 -1.4499999582767487e+02) (float-vector -7.5000002980232239e+01 3.5000000149011612e+01 -1.6696099936962128e+02) (float-vector 7.5000002980232239e+01 3.5000000149011612e+01 -1.6696099936962128e+02) (float-vector 7.5000002980232239e+01 5.6961998343467712e+01 -1.4499999582767487e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J2_LINK_GeOxLy.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J3_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.8000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 5 0 3 0 5 10 0 10 1 2 1 10 2 10 11 4 3 2 4 2 11 4 5 3 18 5 19 5 16 19 5 4 16 18 10 5 11 10 17 18 17 10 16 11 17 16 4 11 20 21 16 21 19 16 17 20 16 21 18 19 17 18 30 21 30 18 17 30 31 17 31 20 22 21 20 23 22 20 23 20 31 30 21 22 31 30 32 30 22 32 31 32 29 23 31 29 24 22 23 25 24 23 28 25 23 28 23 29 33 32 22 33 22 24 29 32 33 29 33 28 34 28 33 34 35 28 35 25 28 24 25 26 25 27 26 35 27 25 34 33 24 34 24 26 26 14 34 14 13 34 35 34 13 35 7 27 35 13 7 7 26 27 26 6 14 7 6 26 12 13 14 6 12 14 12 15 13 9 7 13 9 13 15 6 7 8 7 9 8 6 8 12 12 8 9 12 9 15))
                   (list :vertices (let ((mat (make-matrix 36 3))) (fvector-replace (array-entity mat) #f(6.5000000000000000e+01 5.0000000000000000e+00 -2.4500000000000000e+02 6.5000000000000000e+01 5.0000000000000000e+00 -2.3500000000000000e+02 6.5000000000000000e+01 -5.0000000000000000e+00 -2.3500000000000000e+02 6.5000000000000000e+01 -5.0000000000000000e+00 -2.4500000000000000e+02 4.5000000000000000e+01 -5.0000000000000000e+00 -2.4500000000000000e+02 4.5000000000000000e+01 5.0000000000000000e+00 -2.4500000000000000e+02 -4.5000000000000000e+01 5.0000000000000000e+00 -2.4500000000000000e+02 -4.5000000000000000e+01 -5.0000000000000000e+00 -2.4500000000000000e+02 -6.5000000000000000e+01 5.0000000000000000e+00 -2.4500000000000000e+02 -6.5000000000000000e+01 -5.0000000000000000e+00 -2.4500000000000000e+02 4.5000000000000000e+01 5.0000000000000000e+00 -2.3500000000000000e+02 4.5000000000000000e+01 -5.0000000000000000e+00 -2.3500000000000000e+02 -6.5000000000000000e+01 5.0000000000000000e+00 -2.3500000000000000e+02 -4.5000000000000000e+01 -5.0000000000000000e+00 -2.3500000000000000e+02 -4.5000000000000000e+01 5.0000000000000000e+00 -2.3500000000000000e+02 -6.5000000000000000e+01 -5.0000000000000000e+00 -2.3500000000000000e+02 4.5000000000000000e+01 -3.6960998535156250e+01 -2.8000000000000000e+02 4.5000000000000000e+01 -3.6960998535156250e+01 -2.1000000000000000e+02 4.5000000000000000e+01 3.6960998535156250e+01 -2.1000000000000000e+02 4.5000000000000000e+01 3.6960998535156250e+01 -2.8000000000000000e+02 3.0000000000000000e+01 -5.1961002349853516e+01 -2.8000000000000000e+02 3.0000000000000000e+01 5.1961002349853516e+01 -2.8000000000000000e+02 3.8572299672523513e-05 6.0000000000000000e+01 -2.8000000000000000e+02 0.0000000000000000e+00 -6.0000000000000000e+01 -2.8000000000000000e+02 -3.0000000000000000e+01 5.1961997985839844e+01 -2.8000000000000000e+02 -3.0000000000000000e+01 -5.1961002349853516e+01 -2.8000000000000000e+02 -4.5000000000000000e+01 3.6960998535156250e+01 -2.8000000000000000e+02 -4.5000000000000000e+01 -3.6960998535156250e+01 -2.8000000000000000e+02 -3.0000000000000000e+01 -5.1961002349853516e+01 -2.1000000000000000e+02 0.0000000000000000e+00 -6.0000000000000000e+01 -2.1000000000000000e+02 3.0000000000000000e+01 5.1961002349853516e+01 -2.1000000000000000e+02 3.0000000000000000e+01 -5.1961002349853516e+01 -2.1000000000000000e+02 3.8572299672523513e-05 6.0000000000000000e+01 -2.1000000000000000e+02 -3.0000000000000000e+01 5.1961997985839844e+01 -2.1000000000000000e+02 -4.5000000000000000e+01 3.6960998535156250e+01 -2.1000000000000000e+02 -4.5000000000000000e+01 -3.6960998535156250e+01 -2.1000000000000000e+02 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 0.900000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 0 3 4 19 20 0 19 0 4 21 1 0 21 0 20 22 2 1 22 1 21 23 3 2 23 2 22 36 22 21 37 23 22 37 22 36 35 21 20 36 21 35 34 20 19 35 20 34 34 36 35 34 37 36 38 23 37 33 38 37 33 37 34 24 3 23 38 24 23 39 24 38 32 39 38 32 38 33 19 32 33 34 19 33 31 32 18 19 18 32 31 39 32 39 25 24 40 25 39 31 40 39 17 30 31 31 18 17 30 40 31 17 18 6 18 19 4 18 4 6 16 17 8 17 6 8 17 16 30 29 30 16 29 41 30 30 41 40 15 16 10 16 8 10 29 16 15 6 7 8 8 7 9 8 9 10 10 9 11 10 11 12 15 10 12 14 15 12 28 29 15 14 28 15 29 28 41 41 28 14 13 14 12 13 11 14 11 27 14 27 41 14 12 11 13 27 11 9 26 9 7 27 9 26 41 27 26 26 7 25 40 26 25 41 26 40 25 7 5 25 5 24 4 3 5 4 5 6 6 5 7 24 5 3 42 43 44 42 44 45 42 45 46 46 62 42 43 42 63 42 62 63 44 43 63 64 44 63 45 44 64 46 45 47 45 64 65 47 45 65 46 47 48 48 61 46 46 61 62 61 76 62 63 62 76 77 63 76 64 63 77 78 64 77 65 64 78 47 65 66 79 65 78 66 65 79 78 77 76 78 76 79 61 75 76 79 76 75 48 60 61 60 75 61 60 74 75 79 75 80 80 75 74 66 79 80 49 47 66 49 66 67 67 66 80 67 80 81 80 74 81 59 73 74 59 74 60 81 74 73 68 81 82 68 67 81 81 73 82 51 49 67 51 67 68 53 51 68 53 68 69 68 82 83 68 83 69 82 73 72 82 72 83 58 72 73 58 73 59 57 71 72 57 72 58 83 72 71 69 83 70 83 71 70 53 69 56 69 70 56 56 70 71 56 71 57 55 56 57 55 57 54 54 57 58 54 58 52 52 58 59 52 53 54 54 53 55 53 56 55 52 51 53 50 51 52 52 59 50 50 59 60 48 49 50 50 49 51 50 60 48 48 47 49))
                   (list :vertices (let ((mat (make-matrix 84 3))) (fvector-replace (array-entity mat) #f(1.0000000000000000e+02 2.0000000000000000e+01 -8.5359001159667969e+01 1.0000000000000000e+02 1.6281299758702517e-04 -8.0000000000000000e+01 1.0000000000000000e+02 -2.0000000000000000e+01 -8.5359001159667969e+01 1.0000000000000000e+02 -3.4641002655029297e+01 -1.0000000000000000e+02 1.0000000000000000e+02 3.4641002655029297e+01 -1.0000000000000000e+02 1.0000000000000000e+02 -4.0000000000000000e+01 -1.2000000000000000e+02 1.0000000000000000e+02 4.0000000000000000e+01 -1.2000000000000000e+02 1.0000000000000000e+02 -4.0000000000000000e+01 -2.0000000000000000e+02 1.0000000000000000e+02 4.0000000000000000e+01 -2.0000000000000000e+02 1.0000000000000000e+02 -3.4641002655029297e+01 -2.2000000000000000e+02 1.0000000000000000e+02 3.4641002655029297e+01 -2.2000000000000000e+02 1.0000000000000000e+02 -2.0000000000000000e+01 -2.3464100646972656e+02 1.0000000000000000e+02 2.0000000000000000e+01 -2.3464100646972656e+02 1.0000000000000000e+02 -4.1389101347599766e-12 -2.4000000000000000e+02 7.5000000000000000e+01 -2.0694598378695472e-12 -2.6000000000000000e+02 7.5000000000000000e+01 3.0000000000000000e+01 -2.5196200561523438e+02 7.5000000000000000e+01 5.1961002349853516e+01 -2.3000000000000000e+02 7.5000000000000000e+01 6.0000000000000000e+01 -2.0000000000000000e+02 7.5000000000000000e+01 6.0000000000000000e+01 -1.2000000000000000e+02 7.5000000000000000e+01 5.1961997985839844e+01 -9.0000000000000000e+01 7.5000000000000000e+01 3.0000000000000000e+01 -6.8039001464843750e+01 7.5000000000000000e+01 2.4421999114565551e-04 -6.0000000000000000e+01 7.5000000000000000e+01 -3.0000000000000000e+01 -6.8038002014160156e+01 7.5000000000000000e+01 -5.1961002349853516e+01 -9.0000000000000000e+01 7.5000000000000000e+01 -6.0000000000000000e+01 -1.1999900054931641e+02 7.5000000000000000e+01 -6.0000000000000000e+01 -1.9999900817871094e+02 7.5000000000000000e+01 -5.1961997985839844e+01 -2.2999900817871094e+02 7.5000000000000000e+01 -3.0000999450683594e+01 -2.5196099853515625e+02 5.0000000000000000e+01 -2.0694598378695472e-12 -2.6000000000000000e+02 5.0000000000000000e+01 3.0000000000000000e+01 -2.5196200561523438e+02 5.0000000000000000e+01 5.1961002349853516e+01 -2.3000000000000000e+02 5.0000000000000000e+01 6.0000000000000000e+01 -2.0000000000000000e+02 5.0000000000000000e+01 6.0000000000000000e+01 -1.2000000000000000e+02 5.0000000000000000e+01 5.1961997985839844e+01 -9.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+01 -6.8039001464843750e+01 5.0000000000000000e+01 2.4421999114565551e-04 -6.0000000000000000e+01 5.0000000000000000e+01 -3.0000000000000000e+01 -6.8038002014160156e+01 5.0000000000000000e+01 -5.1961002349853516e+01 -9.0000000000000000e+01 5.0000000000000000e+01 -6.0000000000000000e+01 -1.1999900054931641e+02 5.0000000000000000e+01 -6.0000000000000000e+01 -1.9999900817871094e+02 5.0000000000000000e+01 -5.1961997985839844e+01 -2.2999900817871094e+02 5.0000000000000000e+01 -3.0000999450683594e+01 -2.5196099853515625e+02 -1.0000000000000000e+02 2.0000000000000000e+01 -2.3464100646972656e+02 -1.0000000000000000e+02 1.6281299758702517e-04 -2.4000000000000000e+02 -1.0000000000000000e+02 -2.0000000000000000e+01 -2.3464100646972656e+02 -1.0000000000000000e+02 -3.4641002655029297e+01 -2.2000000000000000e+02 -1.0000000000000000e+02 3.4641002655029297e+01 -2.2000000000000000e+02 -1.0000000000000000e+02 -4.0000000000000000e+01 -2.0000000000000000e+02 -1.0000000000000000e+02 4.0000000000000000e+01 -2.0000000000000000e+02 -1.0000000000000000e+02 -4.0000000000000000e+01 -1.2000099945068359e+02 -1.0000000000000000e+02 4.0000000000000000e+01 -1.2000000000000000e+02 -1.0000000000000000e+02 -3.4641002655029297e+01 -1.0000099945068359e+02 -1.0000000000000000e+02 3.4641002655029297e+01 -1.0000000000000000e+02 -1.0000000000000000e+02 -2.0000000000000000e+01 -8.5359001159667969e+01 -1.0000000000000000e+02 2.0000000000000000e+01 -8.5359001159667969e+01 -1.0000000000000000e+02 -2.0694598812376341e-11 -8.0000000000000000e+01 -7.5000000000000000e+01 -2.2764000753849878e-11 -6.0000000000000000e+01 -7.5000000000000000e+01 3.0000000000000000e+01 -6.8039001464843750e+01 -7.5000000000000000e+01 5.1961002349853516e+01 -9.0000000000000000e+01 -7.5000000000000000e+01 6.0000000000000000e+01 -1.2000000000000000e+02 -7.5000000000000000e+01 6.0000000000000000e+01 -2.0000000000000000e+02 -7.5000000000000000e+01 5.1961997985839844e+01 -2.3000000000000000e+02 -7.5000000000000000e+01 3.0000000000000000e+01 -2.5196099853515625e+02 -7.5000000000000000e+01 2.4421999114565551e-04 -2.6000000000000000e+02 -7.5000000000000000e+01 -3.0000000000000000e+01 -2.5196200561523438e+02 -7.5000000000000000e+01 -5.1961002349853516e+01 -2.3000000000000000e+02 -7.5000000000000000e+01 -6.0000000000000000e+01 -2.0000100708007812e+02 -7.5000000000000000e+01 -6.0000000000000000e+01 -1.2000099945068359e+02 -7.5000000000000000e+01 -5.1961997985839844e+01 -9.0000999450683594e+01 -7.5000000000000000e+01 -3.0000999450683594e+01 -6.8039001464843750e+01 -5.0000000000000000e+01 -2.2764000753849878e-11 -6.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+01 -6.8039001464843750e+01 -5.0000000000000000e+01 5.1961002349853516e+01 -9.0000000000000000e+01 -5.0000000000000000e+01 6.0000000000000000e+01 -1.2000000000000000e+02 -5.0000000000000000e+01 6.0000000000000000e+01 -2.0000000000000000e+02 -5.0000000000000000e+01 5.1961997985839844e+01 -2.3000000000000000e+02 -5.0000000000000000e+01 3.0000000000000000e+01 -2.5196099853515625e+02 -5.0000000000000000e+01 2.4421999114565551e-04 -2.6000000000000000e+02 -5.0000000000000000e+01 -3.0000000000000000e+01 -2.5196200561523438e+02 -5.0000000000000000e+01 -5.1961002349853516e+01 -2.3000000000000000e+02 -5.0000000000000000e+01 -6.0000000000000000e+01 -2.0000100708007812e+02 -5.0000000000000000e+01 -6.0000000000000000e+01 -1.2000099945068359e+02 -5.0000000000000000e+01 -5.1961997985839844e+01 -9.0000999450683594e+01 -5.0000000000000000e+01 -3.0000999450683594e+01 -6.8039001464843750e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 684 -> 45 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 1.0000000149011612e+02 -4.1389100297278911e-12 -2.3999999463558197e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector -7.5000002980232239e+01 5.1961999386548996e+01 -2.3000000417232513e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.8000000119209290e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.8000000119209290e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 1.0000000149011612e+02 -1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector 1.0000000149011612e+02 -4.1389100297278911e-12 -2.3999999463558197e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 1.6281299508591474e-04 -2.3999999463558197e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector -1.0000000149011612e+02 1.9999999552965164e+01 -2.3464100062847137e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 1.6281299508591474e-04 -2.3999999463558197e+02) (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 1.6281299508591474e-04 -2.3999999463558197e+02) (float-vector -1.0000000149011612e+02 -1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -1.2000100314617157e+02) (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -2.0000100135803223e+02) (float-vector -1.0000000149011612e+02 -3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector -1.0000000149011612e+02 -3.9999999105930328e+01 -1.2000100314617157e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -1.2000100314617157e+02) (float-vector -7.5000002980232239e+01 -5.1961999386548996e+01 -9.0001001954078674e+01) (float-vector 7.5000002980232239e+01 -5.1961001008749008e+01 -9.0000003576278687e+01) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.1999899893999100e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.9999900460243225e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -2.0000100135803223e+02) (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -1.2000100314617157e+02) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.1999899893999100e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector -1.0000000149011612e+02 -3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector -7.5000002980232239e+01 -5.1961001008749008e+01 -2.3000000417232513e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -2.0000100135803223e+02) (float-vector -7.5000002980232239e+01 -5.1961001008749008e+01 -2.3000000417232513e+02) (float-vector -1.0000000149011612e+02 -3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector -1.0000000149011612e+02 -3.9999999105930328e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -5.1961001008749008e+01 -2.3000000417232513e+02) (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -2.0000100135803223e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 -3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector 1.0000000149011612e+02 -3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.1999899893999100e+02) (float-vector 7.5000002980232239e+01 -5.1961001008749008e+01 -9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -2.9999999329447746e+01 -6.8038001656532288e+01) (float-vector 1.0000000149011612e+02 -1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector 1.0000000149011612e+02 -3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector 7.5000002980232239e+01 -5.1961001008749008e+01 -9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector 7.5000002980232239e+01 5.1961999386548996e+01 -9.0000003576278687e+01) (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02) (float-vector 1.0000000149011612e+02 3.9999999105930328e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector -1.0000000149011612e+02 3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.8000000119209290e+02) (float-vector -7.5000002980232239e+01 5.1961999386548996e+01 -2.3000000417232513e+02) (float-vector -1.0000000149011612e+02 3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector -1.0000000149011612e+02 1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector -1.0000000149011612e+02 3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector -7.5000002980232239e+01 5.1961999386548996e+01 -2.3000000417232513e+02) (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 -3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector 1.0000000149011612e+02 -3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.9999900460243225e+02) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.1999899893999100e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -2.9999999329447746e+01 -6.8038001656532288e+01) (float-vector 7.5000002980232239e+01 2.4421999000878714e-04 -5.9999998658895493e+01) (float-vector 1.0000000149011612e+02 1.6281299508591474e-04 -7.9999998211860657e+01) (float-vector 1.0000000149011612e+02 -1.9999999552965164e+01 -8.5358999669551849e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -3.4641001373529434e+01 -1.0000099986791611e+02) (float-vector -7.5000002980232239e+01 -5.1961999386548996e+01 -9.0001001954078674e+01) (float-vector -7.5000002980232239e+01 -5.9999998658895493e+01 -1.2000100314617157e+02) (float-vector -1.0000000149011612e+02 -3.9999999105930328e+01 -1.2000100314617157e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 5.1961999386548996e+01 -9.0000003576278687e+01) (float-vector -7.5000002980232239e+01 5.1961001008749008e+01 -9.0000003576278687e+01) (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02) (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -5.1961999386548996e+01 -2.2999900579452515e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.9999900460243225e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector 7.5000002980232239e+01 5.1961999386548996e+01 -9.0000003576278687e+01) (float-vector 1.0000000149011612e+02 3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector 1.0000000149011612e+02 1.9999999552965164e+01 -8.5358999669551849e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 2.4421999000878714e-04 -5.9999998658895493e+01) (float-vector 7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector 1.0000000149011612e+02 1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector 1.0000000149011612e+02 1.6281299508591474e-04 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 5.1961001008749008e+01 -9.0000003576278687e+01) (float-vector -1.0000000149011612e+02 3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector -1.0000000149011612e+02 3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -3.0000999569892883e+01 -6.8039000034332275e+01) (float-vector 7.5000002980232239e+01 -2.9999999329447746e+01 -6.8038001656532288e+01) (float-vector 7.5000002980232239e+01 -5.1961001008749008e+01 -9.0000003576278687e+01) (float-vector -7.5000002980232239e+01 -5.1961999386548996e+01 -9.0001001954078674e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 1.0000000149011612e+02 -4.1389100297278911e-12 -2.3999999463558197e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector 1.0000000149011612e+02 3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector 1.0000000149011612e+02 1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector 1.0000000149011612e+02 -4.1389100297278911e-12 -2.3999999463558197e+02) (float-vector 1.0000000149011612e+02 -1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector 1.0000000149011612e+02 -3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector 1.0000000149011612e+02 -3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector 1.0000000149011612e+02 -3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector 1.0000000149011612e+02 -3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector 1.0000000149011612e+02 -1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector 1.0000000149011612e+02 1.6281299508591474e-04 -7.9999998211860657e+01) (float-vector 1.0000000149011612e+02 1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector 1.0000000149011612e+02 3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector 1.0000000149011612e+02 3.9999999105930328e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 -3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector 1.0000000149011612e+02 -1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.8000000119209290e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector 7.5000002980232239e+01 -5.1961999386548996e+01 -2.2999900579452515e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 -3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector 7.5000002980232239e+01 -5.1961999386548996e+01 -2.2999900579452515e+02) (float-vector 7.5000002980232239e+01 -5.9999998658895493e+01 -1.9999900460243225e+02) (float-vector 1.0000000149011612e+02 -3.9999999105930328e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector 1.0000000149011612e+02 3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector 1.0000000149011612e+02 3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02) (float-vector -7.5000002980232239e+01 5.9999998658895493e+01 -1.1999999731779099e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector -1.0000000149011612e+02 3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector -1.0000000149011612e+02 3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector -1.0000000149011612e+02 3.9999999105930328e+01 -1.1999999731779099e+02) (float-vector -1.0000000149011612e+02 3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector -1.0000000149011612e+02 1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector -1.0000000149011612e+02 -2.0694598853033923e-11 -7.9999998211860657e+01) (float-vector -1.0000000149011612e+02 -1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector -1.0000000149011612e+02 -3.4641001373529434e+01 -1.0000099986791611e+02) (float-vector -1.0000000149011612e+02 -3.9999999105930328e+01 -1.2000100314617157e+02) (float-vector -1.0000000149011612e+02 -3.9999999105930328e+01 -2.0000000298023224e+02) (float-vector -1.0000000149011612e+02 -3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector -1.0000000149011612e+02 -1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector -1.0000000149011612e+02 1.6281299508591474e-04 -2.3999999463558197e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector -7.5000002980232239e+01 -3.0000999569892883e+01 -6.8039000034332275e+01) (float-vector -7.5000002980232239e+01 -5.1961999386548996e+01 -9.0001001954078674e+01) (float-vector -1.0000000149011612e+02 -3.4641001373529434e+01 -1.0000099986791611e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 1.9999999552965164e+01 -2.3464100062847137e+02) (float-vector 1.0000000149011612e+02 3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector 7.5000002980232239e+01 5.1961001008749008e+01 -2.3000000417232513e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.8000000119209290e+02) (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 5.1961001008749008e+01 -2.3000000417232513e+02) (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.8000000119209290e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.8000000119209290e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 5.9999998658895493e+01 -2.0000000298023224e+02) (float-vector 7.5000002980232239e+01 5.1961001008749008e+01 -2.3000000417232513e+02) (float-vector 1.0000000149011612e+02 3.4641001373529434e+01 -2.1999999880790710e+02) (float-vector 1.0000000149011612e+02 3.9999999105930328e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector -7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector -7.5000002980232239e+01 5.1961001008749008e+01 -9.0000003576278687e+01) (float-vector 7.5000002980232239e+01 5.1961999386548996e+01 -9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector -1.0000000149011612e+02 1.9999999552965164e+01 -8.5358999669551849e+01) (float-vector -1.0000000149011612e+02 3.4641001373529434e+01 -1.0000000149011612e+02) (float-vector -7.5000002980232239e+01 5.1961001008749008e+01 -9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -2.2764000293063955e-11 -5.9999998658895493e+01) (float-vector 7.5000002980232239e+01 2.4421999000878714e-04 -5.9999998658895493e+01) (float-vector 7.5000002980232239e+01 -2.9999999329447746e+01 -6.8038001656532288e+01) (float-vector -7.5000002980232239e+01 -3.0000999569892883e+01 -6.8039000034332275e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector 7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector 7.5000002980232239e+01 2.4421999000878714e-04 -5.9999998658895493e+01) (float-vector -7.5000002980232239e+01 -2.2764000293063955e-11 -5.9999998658895493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -2.0694598853033923e-11 -7.9999998211860657e+01) (float-vector -7.5000002980232239e+01 -2.2764000293063955e-11 -5.9999998658895493e+01) (float-vector -7.5000002980232239e+01 -3.0000999569892883e+01 -6.8039000034332275e+01) (float-vector -1.0000000149011612e+02 -1.9999999552965164e+01 -8.5358999669551849e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 2.9999999329447746e+01 -6.8039000034332275e+01) (float-vector -7.5000002980232239e+01 -2.2764000293063955e-11 -5.9999998658895493e+01) (float-vector -1.0000000149011612e+02 -2.0694598853033923e-11 -7.9999998211860657e+01) (float-vector -1.0000000149011612e+02 1.9999999552965164e+01 -8.5358999669551849e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J3_LINK_StYgR6.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J4_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 18 1 0 32 0 3 34 18 0 34 0 32 31 3 2 32 3 33 47 33 3 47 3 31 48 32 33 50 34 32 50 32 48 35 18 34 51 35 34 51 34 50 66 50 48 67 51 50 67 50 66 48 33 49 64 48 49 66 48 64 69 67 66 69 66 70 70 66 64 68 51 67 69 68 67 52 35 51 68 52 51 68 69 53 68 53 52 69 70 54 69 54 53 70 71 55 70 55 54 70 64 71 53 54 38 54 55 39 54 39 38 52 53 37 53 38 37 52 36 35 52 37 36 36 37 21 37 38 22 37 22 21 38 39 23 38 23 22 21 22 8 22 23 9 22 9 8 20 21 6 21 8 6 36 21 20 8 7 6 1 7 8 9 1 8 2 1 9 10 2 9 23 10 9 18 7 1 7 4 6 19 4 7 19 7 18 4 5 6 20 6 5 20 5 4 20 4 19 36 20 19 35 19 18 36 19 35 11 2 10 12 11 10 23 24 10 10 24 25 10 25 12 13 11 12 14 13 12 12 25 26 12 26 14 24 41 25 25 41 42 25 42 26 14 26 27 26 42 43 26 43 27 15 13 14 16 15 14 14 27 16 16 27 28 27 43 44 27 44 28 42 59 43 43 59 60 43 60 44 29 28 44 29 44 45 45 44 60 16 28 17 15 17 28 15 28 29 17 15 16 13 15 29 13 29 30 30 29 45 30 45 46 45 60 61 46 45 61 59 76 60 61 60 76 46 61 62 61 76 77 62 61 77 31 30 46 31 46 47 47 46 62 11 13 30 11 30 31 31 2 11 47 62 63 62 77 78 63 62 78 63 33 47 63 49 33 63 78 79 79 49 63 73 79 78 73 78 74 74 78 77 79 65 49 72 65 79 72 79 73 64 49 65 71 64 65 71 65 72 71 72 56 56 72 73 56 73 57 57 73 74 55 56 40 40 56 57 71 56 55 40 57 41 41 57 58 57 74 58 39 40 24 24 40 41 55 40 39 41 58 42 42 58 59 58 74 75 58 75 59 59 75 76 74 77 75 75 77 76 39 24 23 80 81 82 80 83 81 97 83 80 97 80 98 98 80 99 82 99 80 94 96 83 94 83 97 92 81 83 96 92 83 91 94 97 91 97 90 90 97 98 94 95 96 94 91 95 93 92 96 95 93 96 91 81 92 91 92 93 90 81 91 91 93 95 81 90 89 90 98 89 81 89 82 88 82 89 89 98 100 89 100 88 88 87 82 82 87 99 84 87 88 88 100 102 88 102 84 98 99 100 101 100 99 101 102 100 101 99 87 84 86 87 101 87 86 84 85 86 84 102 103 84 103 85 102 101 103 85 103 101 85 101 86))
                   (list :vertices (let ((mat (make-matrix 104 3))) (fvector-replace (array-entity mat) #f(-1.1480999946594238e+01 -2.7715999603271484e+01 -7.0000000000000000e+01 -1.9135000228881836e+01 -4.6193996429443359e+01 -1.2000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 -1.2000000000000000e+02 0.0000000000000000e+00 -3.0000000000000000e+01 -7.0000000000000000e+01 -4.6193996429443359e+01 -1.9134000778198242e+01 -1.2000000000000000e+02 -5.0000000000000000e+01 2.8550601564347744e-04 -1.2000000000000000e+02 -4.6193996429443359e+01 1.9134000778198242e+01 -1.2000000000000000e+02 -3.5355998992919922e+01 -3.5355003356933594e+01 -1.2000000000000000e+02 -3.5355003356933594e+01 3.5355003356933594e+01 -1.2000000000000000e+02 -1.9134000778198242e+01 4.6193996429443359e+01 -1.2000000000000000e+02 1.7444300465285778e-04 5.0000000000000000e+01 -1.2000000000000000e+02 1.9134000778198242e+01 -4.6193996429443359e+01 -1.2000000000000000e+02 1.9134000778198242e+01 4.6193996429443359e+01 -1.2000000000000000e+02 3.5355003356933594e+01 -3.5355003356933594e+01 -1.2000000000000000e+02 3.5355003356933594e+01 3.5355003356933594e+01 -1.2000000000000000e+02 4.6193996429443359e+01 -1.9134000778198242e+01 -1.2000000000000000e+02 4.6193996429443359e+01 1.9134000778198242e+01 -1.2000000000000000e+02 5.0000000000000000e+01 -3.9537600969197229e-05 -1.2000000000000000e+02 -2.1213001251220703e+01 -2.1213001251220703e+01 -7.0000000000000000e+01 -2.7715999603271484e+01 -1.1479999542236328e+01 -7.0000000000000000e+01 -3.0000000000000000e+01 1.7130399646703154e-04 -7.0000000000000000e+01 -2.7715999603271484e+01 1.1480999946594238e+01 -7.0000000000000000e+01 -2.1213001251220703e+01 2.1213001251220703e+01 -7.0000000000000000e+01 -1.1479999542236328e+01 2.7715999603271484e+01 -7.0000000000000000e+01 1.0466599633218721e-04 3.0000000000000000e+01 -7.0000000000000000e+01 1.1480999946594238e+01 2.7715999603271484e+01 -7.0000000000000000e+01 2.1213001251220703e+01 2.1213001251220703e+01 -7.0000000000000000e+01 2.7715999603271484e+01 1.1479999542236328e+01 -7.0000000000000000e+01 3.0000000000000000e+01 -2.3722601326880977e-05 -7.0000000000000000e+01 2.7715999603271484e+01 -1.1480999946594238e+01 -7.0000000000000000e+01 2.1213001251220703e+01 -2.1213001251220703e+01 -7.0000000000000000e+01 1.1479999542236328e+01 -2.7715999603271484e+01 -7.0000000000000000e+01 -1.5308000564575195e+01 -3.6954998016357422e+01 -2.0000000000000000e+01 0.0000000000000000e+00 -4.0000000000000000e+01 -2.0000000000000000e+01 -2.8284000396728516e+01 -2.8284000396728516e+01 -2.0000000000000000e+01 -3.6954998016357422e+01 -1.5307000160217285e+01 -2.0000000000000000e+01 -4.0000000000000000e+01 2.2840499877929688e-04 -2.0000000000000000e+01 -3.6954998016357422e+01 1.5308000564575195e+01 -2.0000000000000000e+01 -2.8284000396728516e+01 2.8284000396728516e+01 -2.0000000000000000e+01 -1.5307000160217285e+01 3.6954998016357422e+01 -2.0000000000000000e+01 1.3955400208942592e-04 4.0000000000000000e+01 -2.0000000000000000e+01 1.5307000160217285e+01 3.6954998016357422e+01 -2.0000000000000000e+01 2.8284000396728516e+01 2.8284000396728516e+01 -2.0000000000000000e+01 3.6954998016357422e+01 1.5307000160217285e+01 -2.0000000000000000e+01 4.0000000000000000e+01 -3.1630101148039103e-05 -2.0000000000000000e+01 3.6954998016357422e+01 -1.5307000160217285e+01 -2.0000000000000000e+01 2.8284000396728516e+01 -2.8284000396728516e+01 -2.0000000000000000e+01 1.5307000160217285e+01 -3.6954998016357422e+01 -2.0000000000000000e+01 -1.9135000228881836e+01 -4.6193996429443359e+01 3.0000000000000000e+01 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+01 -3.5355998992919922e+01 -3.5355003356933594e+01 3.0000000000000000e+01 -4.6193996429443359e+01 -1.9134000778198242e+01 3.0000000000000000e+01 -5.0000000000000000e+01 2.8550601564347744e-04 3.0000000000000000e+01 -4.6193996429443359e+01 1.9134000778198242e+01 3.0000000000000000e+01 -3.5355003356933594e+01 3.5355003356933594e+01 3.0000000000000000e+01 -1.9134000778198242e+01 4.6193996429443359e+01 3.0000000000000000e+01 1.7444300465285778e-04 5.0000000000000000e+01 3.0000000000000000e+01 1.9134000778198242e+01 4.6193996429443359e+01 3.0000000000000000e+01 3.5355003356933594e+01 3.5355003356933594e+01 3.0000000000000000e+01 4.6193996429443359e+01 1.9134000778198242e+01 3.0000000000000000e+01 5.0000000000000000e+01 -3.9537600969197229e-05 3.0000000000000000e+01 4.6193996429443359e+01 -1.9134000778198242e+01 3.0000000000000000e+01 3.5355003356933594e+01 -3.5355003356933594e+01 3.0000000000000000e+01 1.9134000778198242e+01 -4.6193996429443359e+01 3.0000000000000000e+01 -1.9135000228881836e+01 -4.6193996429443359e+01 8.0000000000000000e+01 0.0000000000000000e+00 -5.0000000000000000e+01 8.0000000000000000e+01 -3.5355998992919922e+01 -3.5355003356933594e+01 8.0000000000000000e+01 -4.6193996429443359e+01 -1.9134000778198242e+01 8.0000000000000000e+01 -5.0000000000000000e+01 2.8550601564347744e-04 8.0000000000000000e+01 -4.6193996429443359e+01 1.9134000778198242e+01 8.0000000000000000e+01 -3.5355003356933594e+01 3.5355003356933594e+01 8.0000000000000000e+01 -1.9134000778198242e+01 4.6193996429443359e+01 8.0000000000000000e+01 1.7444300465285778e-04 5.0000000000000000e+01 8.0000000000000000e+01 1.9134000778198242e+01 4.6193996429443359e+01 8.0000000000000000e+01 3.5355003356933594e+01 3.5355003356933594e+01 8.0000000000000000e+01 4.6193996429443359e+01 1.9134000778198242e+01 8.0000000000000000e+01 5.0000000000000000e+01 -3.9537600969197229e-05 8.0000000000000000e+01 4.6193996429443359e+01 -1.9134000778198242e+01 8.0000000000000000e+01 3.5355003356933594e+01 -3.5355003356933594e+01 8.0000000000000000e+01 1.9134000778198242e+01 -4.6193996429443359e+01 8.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -1.7000000000000000e+02 5.0000000000000000e+01 -4.3301002502441406e+01 -1.9500000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -1.7000000000000000e+02 -5.0000000000000000e+01 -4.3301002502441406e+01 -1.9500000000000000e+02 5.0000000000000000e+01 2.5000000000000000e+01 -1.2669899749755859e+02 5.0000000000000000e+01 -1.5727300706203096e-05 -1.2000000000000000e+02 5.0000000000000000e+01 -2.5000000000000000e+01 -1.2669899749755859e+02 5.0000000000000000e+01 -4.3301002502441406e+01 -1.4500000000000000e+02 5.0000000000000000e+01 4.3301002502441406e+01 -1.4500000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -1.7000000000000000e+02 5.0000000000000000e+01 4.3301002502441406e+01 -1.9500000000000000e+02 5.0000000000000000e+01 2.5000000000000000e+01 -2.1330101013183594e+02 5.0000000000000000e+01 -2.5000000000000000e+01 -2.1330101013183594e+02 5.0000000000000000e+01 4.6482098696287721e-05 -2.2000000000000000e+02 -5.0000000000000000e+01 2.5000000000000000e+01 -2.1330101013183594e+02 -5.0000000000000000e+01 4.6482098696287721e-05 -2.2000000000000000e+02 -5.0000000000000000e+01 -2.5000000000000000e+01 -2.1330101013183594e+02 -5.0000000000000000e+01 4.3301002502441406e+01 -1.9500000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 -1.7000000000000000e+02 -5.0000000000000000e+01 -4.3301002502441406e+01 -1.4500000000000000e+02 -5.0000000000000000e+01 4.3301002502441406e+01 -1.4500000000000000e+02 -5.0000000000000000e+01 -2.5000000000000000e+01 -1.2669899749755859e+02 -5.0000000000000000e+01 2.5000000000000000e+01 -1.2669899749755859e+02 -5.0000000000000000e+01 -1.5727300706203096e-05 -1.2000000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 600 -> 27 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 1.7444300226543419e-04 5.0000000745058060e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 0.0000000000000000e+00 -5.0000000745058060e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6193998306989670e+01 -1.9133999943733215e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -3.9537599860750561e-05 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5355001688003540e+01 -3.5355001688003540e+01 7.9999998211860657e+01) (float-vector 4.6193998306989670e+01 -1.9133999943733215e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9133999943733215e+01 -4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 0.0000000000000000e+00 -5.0000000745058060e+01 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9133999943733215e+01 -4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 3.5355001688003540e+01 -3.5355001688003540e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector -4.6193998306989670e+01 1.9133999943733215e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 2.8550601882670890e-04 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5355001688003540e+01 3.5355001688003540e+01 7.9999998211860657e+01) (float-vector -4.6193998306989670e+01 1.9133999943733215e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9133999943733215e+01 4.6193998306989670e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 1.7444300226543419e-04 5.0000000745058060e+01 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9133999943733215e+01 4.6193998306989670e+01 7.9999998211860657e+01) (float-vector -3.5355001688003540e+01 3.5355001688003540e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector -5.0000000745058060e+01 -4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 4.6482099946842936e-05 -2.1999999880790710e+02) (float-vector -5.0000000745058060e+01 -2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector 5.0000000745058060e+01 -2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector 5.0000000745058060e+01 4.6482099946842936e-05 -2.1999999880790710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector -5.0000000745058060e+01 -4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector 5.0000000745058060e+01 -4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector 5.0000000745058060e+01 -2.5000000372529030e+01 -2.1330100297927856e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6193998306989670e+01 1.9133999943733215e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 5.0000000745058060e+01 -3.9537599860750561e-05 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6193998306989670e+01 1.9133999943733215e+01 7.9999998211860657e+01) (float-vector 3.5355001688003540e+01 3.5355001688003540e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 1.9133999943733215e+01 4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 1.7444300226543419e-04 5.0000000745058060e+01 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5355001688003540e+01 3.5355001688003540e+01 7.9999998211860657e+01) (float-vector 1.9133999943733215e+01 4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector -5.0000000745058060e+01 4.6482099946842936e-05 -2.1999999880790710e+02) (float-vector -5.0000000745058060e+01 2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector -5.0000000745058060e+01 4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector -5.0000000745058060e+01 2.8550601882670890e-04 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector -5.0000000745058060e+01 -4.3301001191139221e+01 -1.9499999284744263e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector -1.9135000184178352e+01 -4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 0.0000000000000000e+00 -5.0000000745058060e+01 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5356000065803528e+01 -3.5355001688003540e+01 7.9999998211860657e+01) (float-vector -1.9135000184178352e+01 -4.6193998306989670e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6193998306989670e+01 -1.9133999943733215e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector -5.0000000745058060e+01 2.8550601882670890e-04 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6193998306989670e+01 -1.9133999943733215e+01 7.9999998211860657e+01) (float-vector -3.5356000065803528e+01 -3.5355001688003540e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7444300226543419e-04 5.0000000745058060e+01 7.9999998211860657e+01) (float-vector 1.9133999943733215e+01 4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 3.5355001688003540e+01 3.5355001688003540e+01 7.9999998211860657e+01) (float-vector 4.6193998306989670e+01 1.9133999943733215e+01 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 -3.9537599860750561e-05 7.9999998211860657e+01) (float-vector 4.6193998306989670e+01 -1.9133999943733215e+01 7.9999998211860657e+01) (float-vector 3.5355001688003540e+01 -3.5355001688003540e+01 7.9999998211860657e+01) (float-vector 1.9133999943733215e+01 -4.6193998306989670e+01 7.9999998211860657e+01) (float-vector 0.0000000000000000e+00 -5.0000000745058060e+01 7.9999998211860657e+01) (float-vector -1.9135000184178352e+01 -4.6193998306989670e+01 7.9999998211860657e+01) (float-vector -3.5356000065803528e+01 -3.5355001688003540e+01 7.9999998211860657e+01) (float-vector -4.6193998306989670e+01 -1.9133999943733215e+01 7.9999998211860657e+01) (float-vector -5.0000000745058060e+01 2.8550601882670890e-04 7.9999998211860657e+01) (float-vector -4.6193998306989670e+01 1.9133999943733215e+01 7.9999998211860657e+01) (float-vector -3.5355001688003540e+01 3.5355001688003540e+01 7.9999998211860657e+01) (float-vector -1.9133999943733215e+01 4.6193998306989670e+01 7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector 5.0000000745058060e+01 4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector 5.0000000745058060e+01 2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector 5.0000000745058060e+01 4.6482099946842936e-05 -2.1999999880790710e+02) (float-vector 5.0000000745058060e+01 -2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector 5.0000000745058060e+01 -4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.7000000178813934e+02) (float-vector 5.0000000745058060e+01 -3.9537599860750561e-05 7.9999998211860657e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.7000000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector -5.0000000745058060e+01 2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector -5.0000000745058060e+01 4.6482099946842936e-05 -2.1999999880790710e+02) (float-vector 5.0000000745058060e+01 4.6482099946842936e-05 -2.1999999880790710e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 2.5000000372529030e+01 -2.1330100297927856e+02) (float-vector 5.0000000745058060e+01 4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector -5.0000000745058060e+01 4.3301001191139221e+01 -1.9499999284744263e+02) (float-vector -5.0000000745058060e+01 2.5000000372529030e+01 -2.1330100297927856e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J4_LINK_4y9SZE.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J5_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.5000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 4 1 6 0 7 6 4 0 14 15 0 15 7 0 14 0 2 4 6 29 28 1 4 28 4 29 28 29 30 6 30 29 28 30 31 28 3 1 28 31 3 3 31 30 3 30 6 1 3 2 5 3 6 5 2 3 5 6 7 5 7 15 2 5 18 5 15 18 15 14 13 13 18 15 2 18 19 19 18 20 13 20 18 13 12 8 14 12 13 13 8 21 13 21 20 19 20 16 16 20 21 16 21 17 22 17 21 8 22 21 8 9 10 12 9 8 8 10 22 22 23 17 10 24 22 24 25 22 23 22 25 9 11 10 10 26 24 27 10 11 27 26 10 34 25 24 26 34 24 26 27 32 26 32 34 23 27 11 23 25 27 27 33 32 25 33 27 34 35 25 25 35 33 33 35 34 33 34 32 9 17 23 9 23 11 12 16 17 12 17 9 19 16 12 19 12 14 14 2 19))
                   (list :vertices (let ((mat (make-matrix 36 3))) (fvector-replace (array-entity mat) #f(4.5000000000000000e+01 -3.6960998535156250e+01 -2.5000000000000000e+02 4.5000000000000000e+01 -5.0000000000000000e+00 -2.1500000000000000e+02 4.5000000000000000e+01 -3.6960998535156250e+01 -1.8000000000000000e+02 4.5000000000000000e+01 5.0000000000000000e+00 -2.1500000000000000e+02 4.5000000000000000e+01 -5.0000000000000000e+00 -2.2500000000000000e+02 4.5000000000000000e+01 3.6960998535156250e+01 -1.8000000000000000e+02 4.5000000000000000e+01 5.0000000000000000e+00 -2.2500000000000000e+02 4.5000000000000000e+01 3.6960998535156250e+01 -2.5000000000000000e+02 -3.0000000000000000e+01 5.1961997985839844e+01 -2.5000000000000000e+02 -3.0000000000000000e+01 -5.1961002349853516e+01 -2.5000000000000000e+02 -4.5000000000000000e+01 3.6960998535156250e+01 -2.5000000000000000e+02 -4.5000000000000000e+01 -3.6960998535156250e+01 -2.5000000000000000e+02 0.0000000000000000e+00 -6.0000000000000000e+01 -2.5000000000000000e+02 3.8572299672523513e-05 6.0000000000000000e+01 -2.5000000000000000e+02 3.0000000000000000e+01 -5.1961002349853516e+01 -2.5000000000000000e+02 3.0000000000000000e+01 5.1961002349853516e+01 -2.5000000000000000e+02 0.0000000000000000e+00 -6.0000000000000000e+01 -1.8000000000000000e+02 -3.0000000000000000e+01 -5.1961002349853516e+01 -1.8000000000000000e+02 3.0000000000000000e+01 5.1961002349853516e+01 -1.8000000000000000e+02 3.0000000000000000e+01 -5.1961002349853516e+01 -1.8000000000000000e+02 3.8572299672523513e-05 6.0000000000000000e+01 -1.8000000000000000e+02 -3.0000000000000000e+01 5.1961997985839844e+01 -1.8000000000000000e+02 -4.5000000000000000e+01 3.6960998535156250e+01 -1.8000000000000000e+02 -4.5000000000000000e+01 -3.6960998535156250e+01 -1.8000000000000000e+02 -4.5000000000000000e+01 5.0000000000000000e+00 -2.1500000000000000e+02 -4.5000000000000000e+01 -5.0000000000000000e+00 -2.1500000000000000e+02 -4.5000000000000000e+01 5.0000000000000000e+00 -2.2500000000000000e+02 -4.5000000000000000e+01 -5.0000000000000000e+00 -2.2500000000000000e+02 6.5000000000000000e+01 -5.0000000000000000e+00 -2.1500000000000000e+02 6.5000000000000000e+01 -5.0000000000000000e+00 -2.2500000000000000e+02 6.5000000000000000e+01 5.0000000000000000e+00 -2.2500000000000000e+02 6.5000000000000000e+01 5.0000000000000000e+00 -2.1500000000000000e+02 -6.5000000000000000e+01 5.0000000000000000e+00 -2.2500000000000000e+02 -6.5000000000000000e+01 -5.0000000000000000e+00 -2.2500000000000000e+02 -6.5000000000000000e+01 5.0000000000000000e+00 -2.1500000000000000e+02 -6.5000000000000000e+01 -5.0000000000000000e+00 -2.1500000000000000e+02 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 0.900000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 0 3 4 27 0 4 27 14 0 14 1 0 1 14 2 14 15 2 15 3 2 4 3 5 15 16 3 5 3 16 4 5 6 26 4 6 27 4 26 6 5 7 5 16 17 17 7 5 6 7 8 25 6 8 26 6 25 40 26 25 41 27 26 41 26 40 25 8 24 39 25 24 40 25 39 30 41 40 30 40 31 31 40 39 27 41 28 29 28 41 29 41 30 14 27 28 28 29 15 14 28 15 29 30 16 15 29 16 31 16 30 31 17 16 17 18 7 18 17 31 9 7 18 9 18 19 18 31 32 19 18 32 8 7 9 8 9 10 10 9 11 11 9 19 24 8 10 10 11 12 23 10 12 24 10 23 12 11 13 11 19 20 21 13 11 21 11 20 22 12 13 23 12 22 37 23 22 38 24 23 38 23 37 39 24 38 32 39 38 32 38 33 33 38 37 37 22 36 33 37 34 34 37 36 22 13 21 36 22 21 36 21 35 34 36 35 35 21 20 35 20 34 34 20 19 34 19 33 19 32 33 31 39 32 42 43 44 42 44 45 42 45 46 42 46 68 42 68 69 57 43 42 57 42 69 56 44 43 56 43 57 58 45 44 58 44 56 70 56 57 72 58 56 72 56 70 70 57 71 71 57 69 83 69 68 71 69 83 70 71 83 70 83 72 73 58 72 72 83 82 72 82 73 59 45 58 73 59 58 74 59 73 73 82 81 73 81 74 68 81 82 83 68 82 67 80 81 68 67 81 74 81 80 74 60 59 75 60 74 74 80 75 80 66 65 80 65 79 67 66 80 75 80 79 75 61 60 76 61 75 75 79 76 79 65 78 76 79 78 76 62 61 62 76 77 76 78 77 61 51 49 61 49 60 62 51 61 62 53 51 62 63 53 63 62 77 64 63 77 78 64 77 65 64 78 64 54 63 52 54 64 52 64 65 63 55 53 54 55 63 52 53 54 54 53 55 52 51 53 50 51 52 50 52 65 50 49 51 48 49 50 50 65 66 48 50 66 46 47 48 48 47 49 48 66 67 46 48 67 46 45 47 46 67 68 59 47 45 60 49 47 60 47 59))
                   (list :vertices (let ((mat (make-matrix 84 3))) (fvector-replace (array-entity mat) #f(8.0000000000000000e+01 -1.5000000000000000e+01 -2.3598100280761719e+02 8.0000000000000000e+01 -1.0347299189347736e-12 -2.4000000000000000e+02 8.0000000000000000e+01 1.5000000000000000e+01 -2.3598100280761719e+02 8.0000000000000000e+01 2.5980998992919922e+01 -2.2500000000000000e+02 8.0000000000000000e+01 -2.5980998992919922e+01 -2.2500000000000000e+02 8.0000000000000000e+01 3.0000000000000000e+01 -2.1000000000000000e+02 8.0000000000000000e+01 -3.0000000000000000e+01 -2.1000000000000000e+02 8.0000000000000000e+01 3.0000000000000000e+01 -1.0000000000000000e+01 8.0000000000000000e+01 -3.0000000000000000e+01 -1.0000000000000000e+01 8.0000000000000000e+01 2.5980998992919922e+01 5.0000000000000000e+00 8.0000000000000000e+01 -2.5980998992919922e+01 5.0000000000000000e+00 8.0000000000000000e+01 1.5000000000000000e+01 1.5980999946594238e+01 8.0000000000000000e+01 -1.5000000000000000e+01 1.5980999946594238e+01 8.0000000000000000e+01 1.2210999557282776e-04 2.0000000000000000e+01 6.0000000000000000e+01 0.0000000000000000e+00 -2.5000000000000000e+02 6.0000000000000000e+01 2.0000000000000000e+01 -2.4464100646972656e+02 6.0000000000000000e+01 3.4641002655029297e+01 -2.3000000000000000e+02 6.0000000000000000e+01 4.0000000000000000e+01 -2.1000000000000000e+02 6.0000000000000000e+01 4.0000000000000000e+01 -1.0000000000000000e+01 6.0000000000000000e+01 3.4641002655029297e+01 9.9999904632568359e+00 6.0000000000000000e+01 2.0000000000000000e+01 2.4640998840332031e+01 6.0000000000000000e+01 1.6281299758702517e-04 3.0000000000000000e+01 6.0000000000000000e+01 -2.0000000000000000e+01 2.4640998840332031e+01 6.0000000000000000e+01 -3.4641002655029297e+01 9.9999904632568359e+00 6.0000000000000000e+01 -4.0000000000000000e+01 -1.0000000000000000e+01 6.0000000000000000e+01 -4.0000000000000000e+01 -2.1000000000000000e+02 6.0000000000000000e+01 -3.4641002655029297e+01 -2.3000000000000000e+02 6.0000000000000000e+01 -2.0000000000000000e+01 -2.4464100646972656e+02 5.0000000000000000e+01 0.0000000000000000e+00 -2.5000000000000000e+02 5.0000000000000000e+01 2.0000000000000000e+01 -2.4464100646972656e+02 5.0000000000000000e+01 3.4641002655029297e+01 -2.3000000000000000e+02 5.0000000000000000e+01 4.0000000000000000e+01 -2.1000000000000000e+02 5.0000000000000000e+01 4.0000000000000000e+01 -1.0000000000000000e+01 5.0000000000000000e+01 3.4641002655029297e+01 9.9999904632568359e+00 5.0000000000000000e+01 2.0000000000000000e+01 2.4640998840332031e+01 5.0000000000000000e+01 1.6281299758702517e-04 3.0000000000000000e+01 5.0000000000000000e+01 -2.0000000000000000e+01 2.4640998840332031e+01 5.0000000000000000e+01 -3.4641002655029297e+01 9.9999904632568359e+00 5.0000000000000000e+01 -4.0000000000000000e+01 -1.0000000000000000e+01 5.0000000000000000e+01 -4.0000000000000000e+01 -2.1000000000000000e+02 5.0000000000000000e+01 -3.4641002655029297e+01 -2.3000000000000000e+02 5.0000000000000000e+01 -2.0000000000000000e+01 -2.4464100646972656e+02 -8.0000000000000000e+01 -1.5000000000000000e+01 1.5979999542236328e+01 -8.0000000000000000e+01 -2.7937699029201291e-11 2.0000000000000000e+01 -8.0000000000000000e+01 1.5000000000000000e+01 1.5980999946594238e+01 -8.0000000000000000e+01 2.5980998992919922e+01 5.0000000000000000e+00 -8.0000000000000000e+01 -2.5980998992919922e+01 5.0000000000000000e+00 -8.0000000000000000e+01 3.0000000000000000e+01 -1.0000000000000000e+01 -8.0000000000000000e+01 -3.0000000000000000e+01 -1.0000000000000000e+01 -8.0000000000000000e+01 3.0000000000000000e+01 -2.1000000000000000e+02 -8.0000000000000000e+01 -3.0000000000000000e+01 -2.1000000000000000e+02 -8.0000000000000000e+01 2.5980998992919922e+01 -2.2500000000000000e+02 -8.0000000000000000e+01 -2.5980998992919922e+01 -2.2500000000000000e+02 -8.0000000000000000e+01 1.5000000000000000e+01 -2.3598100280761719e+02 -8.0000000000000000e+01 -1.5000000000000000e+01 -2.3598100280761719e+02 -8.0000000000000000e+01 1.2210999557282776e-04 -2.4000000000000000e+02 -6.0000000000000000e+01 2.0000000000000000e+01 2.4640998840332031e+01 -6.0000000000000000e+01 -2.8972399132576321e-11 3.0000000000000000e+01 -6.0000000000000000e+01 3.4641002655029297e+01 9.9999904632568359e+00 -6.0000000000000000e+01 4.0000000000000000e+01 -1.0000000000000000e+01 -6.0000000000000000e+01 4.0000000000000000e+01 -2.1000000000000000e+02 -6.0000000000000000e+01 3.4641002655029297e+01 -2.3000000000000000e+02 -6.0000000000000000e+01 2.0000000000000000e+01 -2.4464100646972656e+02 -6.0000000000000000e+01 1.6281299758702517e-04 -2.5000000000000000e+02 -6.0000000000000000e+01 -2.0000000000000000e+01 -2.4464100646972656e+02 -6.0000000000000000e+01 -3.4641002655029297e+01 -2.3000000000000000e+02 -6.0000000000000000e+01 -4.0000000000000000e+01 -2.1000000000000000e+02 -6.0000000000000000e+01 -4.0000000000000000e+01 -1.0001000404357910e+01 -6.0000000000000000e+01 -3.4641002655029297e+01 9.9990100860595703e+00 -6.0000000000000000e+01 -2.0000000000000000e+01 2.4639999389648438e+01 -5.0000000000000000e+01 2.0000000000000000e+01 2.4640998840332031e+01 -5.0000000000000000e+01 -2.8972399132576321e-11 3.0000000000000000e+01 -5.0000000000000000e+01 3.4641002655029297e+01 9.9999904632568359e+00 -5.0000000000000000e+01 4.0000000000000000e+01 -1.0000000000000000e+01 -5.0000000000000000e+01 4.0000000000000000e+01 -2.1000000000000000e+02 -5.0000000000000000e+01 3.4641002655029297e+01 -2.3000000000000000e+02 -5.0000000000000000e+01 2.0000000000000000e+01 -2.4464100646972656e+02 -5.0000000000000000e+01 1.6281299758702517e-04 -2.5000000000000000e+02 -5.0000000000000000e+01 -2.0000000000000000e+01 -2.4464100646972656e+02 -5.0000000000000000e+01 -3.4641002655029297e+01 -2.3000000000000000e+02 -5.0000000000000000e+01 -4.0000000000000000e+01 -2.1000000000000000e+02 -5.0000000000000000e+01 -4.0000000000000000e+01 -1.0001000404357910e+01 -5.0000000000000000e+01 -3.4641002655029297e+01 9.9990100860595703e+00 -5.0000000000000000e+01 -2.0000000000000000e+01 2.4639999389648438e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 684 -> 43 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01) (float-vector -5.9999998658895493e+01 -2.8972399430731918e-11 2.9999999329447746e+01) (float-vector -7.9999998211860657e+01 -2.7937699557749850e-11 1.9999999552965164e+01) (float-vector -7.9999998211860657e+01 1.4999999664723873e+01 1.5980999916791916e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -1.8000000715255737e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector -5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector -5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 7.9999998211860657e+01 2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector 7.9999998211860657e+01 2.9999999329447746e+01 -2.0999999344348907e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector 7.9999998211860657e+01 1.4999999664723873e+01 -2.3598100244998932e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector 7.9999998211860657e+01 2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector 5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 1.4999999664723873e+01 1.5980999916791916e+01) (float-vector -7.9999998211860657e+01 2.5980999693274498e+01 4.9999998882412910e+00) (float-vector -5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector -5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector -7.9999998211860657e+01 2.5980999693274498e+01 4.9999998882412910e+00) (float-vector -7.9999998211860657e+01 2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector -5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector -5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector 7.9999998211860657e+01 2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector 7.9999998211860657e+01 2.5980999693274498e+01 4.9999998882412910e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector -7.9999998211860657e+01 2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.5000000000000000e+02) (float-vector -5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.5000000000000000e+02) (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -1.8000000715255737e+02) (float-vector -5.9999998658895493e+01 3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector -7.9999998211860657e+01 -1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector -7.9999998211860657e+01 -2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -1.8000000715255737e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.5000000000000000e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector -5.9999998658895493e+01 -3.9999999105930328e+01 -1.0001000016927719e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -3.9999999105930328e+01 -1.0001000016927719e+01) (float-vector -5.9999998658895493e+01 -3.4641001373529434e+01 9.9990097805857658e+00) (float-vector 5.9999998658895493e+01 -3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 -1.9999999552965164e+01 2.4640999734401703e+01) (float-vector -5.9999998658895493e+01 -1.9999999552965164e+01 2.4639999493956566e+01) (float-vector -5.9999998658895493e+01 -2.8972399430731918e-11 2.9999999329447746e+01) (float-vector 5.9999998658895493e+01 1.6281299508591474e-04 2.9999999329447746e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -2.8972399430731918e-11 2.9999999329447746e+01) (float-vector -5.9999998658895493e+01 -1.9999999552965164e+01 2.4639999493956566e+01) (float-vector -7.9999998211860657e+01 -1.4999999664723873e+01 1.5979999676346779e+01) (float-vector -7.9999998211860657e+01 -2.7937699557749850e-11 1.9999999552965164e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -3.4641001373529434e+01 9.9990097805857658e+00) (float-vector -7.9999998211860657e+01 -2.5980999693274498e+01 4.9999998882412910e+00) (float-vector -7.9999998211860657e+01 -1.4999999664723873e+01 1.5979999676346779e+01) (float-vector -5.9999998658895493e+01 -1.9999999552965164e+01 2.4639999493956566e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 -2.5980999693274498e+01 4.9999998882412910e+00) (float-vector -5.9999998658895493e+01 -3.4641001373529434e+01 9.9990097805857658e+00) (float-vector -5.9999998658895493e+01 -3.9999999105930328e+01 -1.0001000016927719e+01) (float-vector -7.9999998211860657e+01 -2.9999999329447746e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -3.4641001373529434e+01 9.9990097805857658e+00) (float-vector 5.9999998658895493e+01 -3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 5.9999998658895493e+01 -3.9999999105930328e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 -3.4641001373529434e+01 9.9999904632568359e+00) (float-vector -5.9999998658895493e+01 -3.4641001373529434e+01 9.9990097805857658e+00) (float-vector -5.9999998658895493e+01 -1.9999999552965164e+01 2.4639999493956566e+01) (float-vector 5.9999998658895493e+01 -1.9999999552965164e+01 2.4640999734401703e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 7.9999998211860657e+01 -2.9999999329447746e+01 -2.0999999344348907e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 7.9999998211860657e+01 -2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector 7.9999998211860657e+01 -1.4999999664723873e+01 -2.3598100244998932e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 -3.9999999105930328e+01 -9.9999997764825821e+00) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.5000000000000000e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -1.8000000715255737e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector 7.9999998211860657e+01 -1.0347299426516961e-12 -2.3999999463558197e+02) (float-vector 5.9999998658895493e+01 0.0000000000000000e+00 -2.5000000000000000e+02) (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 0.0000000000000000e+00 -2.5000000000000000e+02) (float-vector 7.9999998211860657e+01 -1.0347299426516961e-12 -2.3999999463558197e+02) (float-vector 7.9999998211860657e+01 1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01) (float-vector 5.9999998658895493e+01 1.6281299508591474e-04 2.9999999329447746e+01) (float-vector -5.9999998658895493e+01 -2.8972399430731918e-11 2.9999999329447746e+01) (float-vector -5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01) (float-vector -5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01) (float-vector -5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01) (float-vector 5.9999998658895493e+01 3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 7.9999998211860657e+01 2.5980999693274498e+01 4.9999998882412910e+00) (float-vector 7.9999998211860657e+01 1.4999999664723873e+01 1.5980999916791916e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 -2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector -7.9999998211860657e+01 -2.5980999693274498e+01 -2.2499999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 -2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector -7.9999998211860657e+01 -2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector -5.9999998658895493e+01 -3.9999999105930328e+01 -1.0001000016927719e+01) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.8572299132511034e-05 5.9999998658895493e+01 -2.5000000000000000e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.5000000000000000e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector -5.9999998658895493e+01 1.6281299508591474e-04 -2.5000000000000000e+02) (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector -2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 0.0000000000000000e+00 -5.9999998658895493e+01 -2.5000000000000000e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 4.5000001788139343e+01 -3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector 5.9999998658895493e+01 0.0000000000000000e+00 -2.5000000000000000e+02) (float-vector 4.5000001788139343e+01 3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector 2.9999999329447746e+01 5.1961001008749008e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector -7.9999998211860657e+01 1.2210999500439357e-04 -2.3999999463558197e+02) (float-vector -5.9999998658895493e+01 1.6281299508591474e-04 -2.5000000000000000e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 1.2210999500439357e-04 -2.3999999463558197e+02) (float-vector -7.9999998211860657e+01 -1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector -4.5000001788139343e+01 -3.6961000412702560e+01 -2.5000000000000000e+02) (float-vector -5.9999998658895493e+01 1.6281299508591474e-04 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 1.4999999664723873e+01 1.5980999916791916e+01) (float-vector 7.9999998211860657e+01 1.2210999500439357e-04 1.9999999552965164e+01) (float-vector 5.9999998658895493e+01 1.6281299508591474e-04 2.9999999329447746e+01) (float-vector 5.9999998658895493e+01 1.9999999552965164e+01 2.4640999734401703e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 1.2210999500439357e-04 1.9999999552965164e+01) (float-vector 7.9999998211860657e+01 -1.4999999664723873e+01 1.5980999916791916e+01) (float-vector 5.9999998658895493e+01 -1.9999999552965164e+01 2.4640999734401703e+01) (float-vector 5.9999998658895493e+01 1.6281299508591474e-04 2.9999999329447746e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector 7.9999998211860657e+01 -2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector 2.9999999329447746e+01 -5.1961001008749008e+01 -2.5000000000000000e+02) (float-vector 5.9999998658895493e+01 -3.9999999105930328e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.5000000000000000e+02) (float-vector -7.9999998211860657e+01 2.9999999329447746e+01 -2.0999999344348907e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 -2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector -7.9999998211860657e+01 -2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector -7.9999998211860657e+01 -1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector -7.9999998211860657e+01 1.2210999500439357e-04 -2.3999999463558197e+02) (float-vector -7.9999998211860657e+01 1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector -7.9999998211860657e+01 2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector -7.9999998211860657e+01 2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector -7.9999998211860657e+01 2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector -7.9999998211860657e+01 2.5980999693274498e+01 4.9999998882412910e+00) (float-vector -7.9999998211860657e+01 1.4999999664723873e+01 1.5980999916791916e+01) (float-vector -7.9999998211860657e+01 -2.7937699557749850e-11 1.9999999552965164e+01) (float-vector -7.9999998211860657e+01 -1.4999999664723873e+01 1.5979999676346779e+01) (float-vector -7.9999998211860657e+01 -2.5980999693274498e+01 4.9999998882412910e+00) (float-vector -7.9999998211860657e+01 -2.9999999329447746e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9999999329447746e+01 5.1961999386548996e+01 -2.5000000000000000e+02) (float-vector -7.9999998211860657e+01 2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector -7.9999998211860657e+01 1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector -4.5000001788139343e+01 3.6961000412702560e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector 7.9999998211860657e+01 2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector 7.9999998211860657e+01 1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector 7.9999998211860657e+01 -1.0347299426516961e-12 -2.3999999463558197e+02) (float-vector 7.9999998211860657e+01 -1.4999999664723873e+01 -2.3598100244998932e+02) (float-vector 7.9999998211860657e+01 -2.5980999693274498e+01 -2.2499999403953552e+02) (float-vector 7.9999998211860657e+01 -2.9999999329447746e+01 -2.0999999344348907e+02) (float-vector 7.9999998211860657e+01 -2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector 7.9999998211860657e+01 -2.5980999693274498e+01 4.9999998882412910e+00) (float-vector 7.9999998211860657e+01 -1.4999999664723873e+01 1.5980999916791916e+01) (float-vector 7.9999998211860657e+01 1.2210999500439357e-04 1.9999999552965164e+01) (float-vector 7.9999998211860657e+01 1.4999999664723873e+01 1.5980999916791916e+01) (float-vector 7.9999998211860657e+01 2.5980999693274498e+01 4.9999998882412910e+00) (float-vector 7.9999998211860657e+01 2.9999999329447746e+01 -9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -1.4999999664723873e+01 1.5980999916791916e+01) (float-vector 7.9999998211860657e+01 -2.5980999693274498e+01 4.9999998882412910e+00) (float-vector 5.9999998658895493e+01 -3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 5.9999998658895493e+01 -1.9999999552965164e+01 2.4640999734401703e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9999998658895493e+01 -3.4641001373529434e+01 9.9999904632568359e+00) (float-vector 7.9999998211860657e+01 -2.5980999693274498e+01 4.9999998882412910e+00) (float-vector 7.9999998211860657e+01 -2.9999999329447746e+01 -9.9999997764825821e+00) (float-vector 5.9999998658895493e+01 -3.9999999105930328e+01 -9.9999997764825821e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J5_LINK_sOiXfd.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J6_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -2.5000000000000000e+00 0.0000000000000000e+00 2.5000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 18 1 0 32 0 3 34 18 0 34 0 32 31 3 2 32 3 33 47 33 3 47 3 31 33 39 32 32 39 38 32 38 34 35 18 34 34 38 37 34 37 35 37 38 22 38 39 23 38 23 22 39 40 24 39 24 23 33 40 39 47 40 33 24 40 41 47 41 40 23 24 11 11 24 25 24 41 25 22 23 12 23 11 12 11 9 10 2 11 10 12 11 2 11 25 9 9 25 26 25 41 42 25 42 26 9 7 8 10 9 8 9 26 7 10 8 30 10 30 31 31 2 10 1 12 2 13 12 1 14 13 1 18 14 1 15 13 14 21 22 13 21 13 15 22 12 13 16 15 14 19 16 14 19 14 18 35 19 18 20 16 19 36 20 19 36 19 35 17 15 16 20 17 16 20 21 15 20 15 17 36 21 20 36 37 21 35 37 36 37 22 21 31 30 46 31 46 47 8 29 30 30 29 45 30 45 46 45 42 46 46 42 41 46 41 47 29 44 45 45 44 43 45 43 42 6 28 29 8 6 29 29 28 44 8 7 6 4 5 6 7 4 6 6 5 28 4 27 28 4 28 5 27 44 28 27 43 44 26 42 43 26 43 27 7 26 27 7 27 4 48 49 50 48 51 49 74 62 48 60 48 62 60 51 48 50 74 48 49 51 52 51 60 52 59 58 60 59 60 61 61 60 62 52 60 58 61 62 63 63 62 64 74 64 62 63 50 61 61 50 49 61 49 59 63 64 65 65 75 63 63 75 50 65 64 66 73 66 64 73 64 74 65 66 67 67 72 65 65 72 75 72 74 75 50 75 74 72 73 74 72 69 73 69 68 73 68 71 73 73 71 66 66 68 67 71 68 66 68 69 67 69 70 67 67 70 72 72 70 69 59 56 58 59 54 56 59 55 54 59 49 53 59 53 55 52 56 54 52 57 56 56 57 58 52 58 57 49 52 53 52 54 53 54 55 53 76 77 78 76 78 79 76 79 80 94 95 76 94 76 80 95 77 76 95 96 77 97 78 77 97 77 96 98 79 78 98 78 97 113 97 96 114 98 97 114 97 113 111 112 96 111 96 95 113 96 112 110 111 95 110 95 94 126 127 111 126 111 110 127 112 111 127 128 112 129 113 112 129 112 128 129 128 127 130 129 127 126 130 127 125 126 110 131 130 126 125 131 126 109 110 94 125 110 109 124 125 109 132 131 125 124 132 125 131 115 114 131 114 130 132 115 131 132 116 115 117 116 132 117 132 133 133 132 124 115 99 98 115 98 114 116 99 115 130 114 113 130 113 129 99 81 79 99 79 98 100 81 99 116 100 99 80 79 81 80 81 82 82 81 83 100 83 81 85 83 100 85 100 101 101 100 116 82 83 84 84 83 85 92 93 82 92 82 84 93 80 82 93 94 80 108 109 93 108 93 92 109 94 93 92 84 86 92 86 107 108 92 107 84 85 86 86 85 87 86 87 88 88 107 86 88 106 107 106 123 107 108 107 123 124 109 108 123 124 108 106 122 123 122 139 123 123 139 124 90 105 106 90 106 88 105 122 106 88 87 89 88 89 90 90 89 91 91 105 90 91 104 105 104 121 105 105 121 122 121 138 122 122 138 139 104 120 121 120 137 121 121 137 138 91 103 104 104 103 119 104 119 120 91 89 103 89 102 103 103 102 118 103 118 119 119 118 134 119 134 135 120 119 135 120 135 136 120 136 137 137 135 138 136 135 137 135 134 138 138 134 139 118 133 134 134 133 139 102 117 118 118 117 133 139 133 124 101 116 117 102 101 117 87 85 101 87 101 102 89 87 102))
                   (list :vertices (let ((mat (make-matrix 140 3))) (fvector-replace (array-entity mat) #f(-1.1277000427246094e+01 -3.3259998321533203e+01 -1.8500000000000000e+02 -7.0669999122619629e+00 -2.3096998214721680e+01 -2.1500000000000000e+02 2.5000000000000000e+00 -2.5000000000000000e+01 -2.1500000000000000e+02 2.5000000000000000e+00 -3.6000000000000000e+01 -1.8500000000000000e+02 2.5597000122070312e+01 9.5670003890991211e+00 -2.1500000000000000e+02 2.7500000000000000e+01 -1.9768800484598614e-05 -2.1500000000000000e+02 2.5597000122070312e+01 -9.5670003890991211e+00 -2.1500000000000000e+02 2.0177999496459961e+01 1.7677999496459961e+01 -2.1500000000000000e+02 2.0177999496459961e+01 -1.7677999496459961e+01 -2.1500000000000000e+02 1.2067000389099121e+01 2.3096998214721680e+01 -2.1500000000000000e+02 1.2067000389099121e+01 -2.3096998214721680e+01 -2.1500000000000000e+02 2.5000901222229004e+00 2.5000000000000000e+01 -2.1500000000000000e+02 -7.0669999122619629e+00 2.3096998214721680e+01 -2.1500000000000000e+02 -1.5177999496459961e+01 1.7677999496459961e+01 -2.1500000000000000e+02 -1.5177999496459961e+01 -1.7677999496459961e+01 -2.1500000000000000e+02 -2.0597000122070312e+01 9.5670003890991211e+00 -2.1500000000000000e+02 -2.0597000122070312e+01 -9.5670003890991211e+00 -2.1500000000000000e+02 -2.2500000000000000e+01 1.4275300782173872e-04 -2.1500000000000000e+02 -2.2956001281738281e+01 -2.5455999374389648e+01 -1.8500000000000000e+02 -3.0760000228881836e+01 -1.3776000022888184e+01 -1.8500000000000000e+02 -3.3500000000000000e+01 2.0556400704663247e-04 -1.8500000000000000e+02 -3.0760000228881836e+01 1.3776999473571777e+01 -1.8500000000000000e+02 -2.2956001281738281e+01 2.5455999374389648e+01 -1.8500000000000000e+02 -1.1276000022888184e+01 3.3259998321533203e+01 -1.8500000000000000e+02 2.5001301765441895e+00 3.6000000000000000e+01 -1.8500000000000000e+02 1.6277000427246094e+01 3.3259998321533203e+01 -1.8500000000000000e+02 2.7955999374389648e+01 2.5455999374389648e+01 -1.8500000000000000e+02 3.5760002136230469e+01 1.3776999473571777e+01 -1.8500000000000000e+02 3.8500000000000000e+01 -2.8467098672990687e-05 -1.8500000000000000e+02 3.5760002136230469e+01 -1.3776999473571777e+01 -1.8500000000000000e+02 2.7955999374389648e+01 -2.5455999374389648e+01 -1.8500000000000000e+02 1.6277000427246094e+01 -3.3259998321533203e+01 -1.8500000000000000e+02 -1.1277000427246094e+01 -3.3259998321533203e+01 -1.6500000000000000e+02 2.5000000000000000e+00 -3.6000000000000000e+01 -1.6500000000000000e+02 -2.2956001281738281e+01 -2.5455999374389648e+01 -1.6500000000000000e+02 -3.0760000228881836e+01 -1.3776000022888184e+01 -1.6500000000000000e+02 -3.3500000000000000e+01 2.0556400704663247e-04 -1.6500000000000000e+02 -3.0760000228881836e+01 1.3776999473571777e+01 -1.6500000000000000e+02 -2.2956001281738281e+01 2.5455999374389648e+01 -1.6500000000000000e+02 -1.1276000022888184e+01 3.3259998321533203e+01 -1.6500000000000000e+02 2.5001301765441895e+00 3.6000000000000000e+01 -1.6500000000000000e+02 1.6277000427246094e+01 3.3259998321533203e+01 -1.6500000000000000e+02 2.7955999374389648e+01 2.5455999374389648e+01 -1.6500000000000000e+02 3.5760002136230469e+01 1.3776999473571777e+01 -1.6500000000000000e+02 3.8500000000000000e+01 -2.8467098672990687e-05 -1.6500000000000000e+02 3.5760002136230469e+01 -1.3776999473571777e+01 -1.6500000000000000e+02 2.7955999374389648e+01 -2.5455999374389648e+01 -1.6500000000000000e+02 1.6277000427246094e+01 -3.3259998321533203e+01 -1.6500000000000000e+02 4.7500000000000000e+01 -3.5000000000000000e+01 -2.5000000000000000e+02 -4.2500000000000000e+01 -3.0310998916625977e+01 -2.3250000000000000e+02 -4.2500000000000000e+01 -3.5000000000000000e+01 -2.5000000000000000e+02 4.7500000000000000e+01 -3.0310998916625977e+01 -2.3250000000000000e+02 4.7500000000000000e+01 -1.7500000000000000e+01 -2.1968899536132812e+02 -4.2500000000000000e+01 -1.7500000000000000e+01 -2.1968899536132812e+02 -2.2500000000000000e+01 -1.0946199836325832e-05 -2.1500000000000000e+02 -4.2500000000000000e+01 -1.0946199836325832e-05 -2.1500000000000000e+02 2.7500000000000000e+01 -1.0946199836325832e-05 -2.1500000000000000e+02 4.7500000000000000e+01 -1.0946199836325832e-05 -2.1500000000000000e+02 4.7500000000000000e+01 1.7500000000000000e+01 -2.1968899536132812e+02 -4.2500000000000000e+01 1.7500000000000000e+01 -2.1968899536132812e+02 4.7500000000000000e+01 3.0310998916625977e+01 -2.3250000000000000e+02 -4.2500000000000000e+01 3.0310998916625977e+01 -2.3250000000000000e+02 4.7500000000000000e+01 3.5000000000000000e+01 -2.5000000000000000e+02 -4.2500000000000000e+01 3.5000000000000000e+01 -2.5000000000000000e+02 4.7500000000000000e+01 3.0310998916625977e+01 -2.6750000000000000e+02 -4.2500000000000000e+01 3.0310998916625977e+01 -2.6750000000000000e+02 4.7500000000000000e+01 1.7500000000000000e+01 -2.8031097412109375e+02 -4.2500000000000000e+01 1.7500000000000000e+01 -2.8031097412109375e+02 2.7500000000000000e+01 3.3186301152454689e-05 -2.8500000000000000e+02 -2.2500000000000000e+01 3.3186301152454689e-05 -2.8500000000000000e+02 -4.2500000000000000e+01 3.3186301152454689e-05 -2.8500000000000000e+02 4.7500000000000000e+01 3.3186301152454689e-05 -2.8500000000000000e+02 -4.2500000000000000e+01 -1.7500000000000000e+01 -2.8031097412109375e+02 4.7500000000000000e+01 -1.7500000000000000e+01 -2.8031097412109375e+02 4.7500000000000000e+01 -3.0310998916625977e+01 -2.6750000000000000e+02 -4.2500000000000000e+01 -3.0310998916625977e+01 -2.6750000000000000e+02 2.5597000122070312e+01 -9.5670003890991211e+00 -2.8500000000000000e+02 2.7500000000000000e+01 -1.9768800484598614e-05 -2.8500000000000000e+02 2.5597000122070312e+01 9.5670003890991211e+00 -2.8500000000000000e+02 2.0177999496459961e+01 1.7677999496459961e+01 -2.8500000000000000e+02 2.0177999496459961e+01 -1.7677999496459961e+01 -2.8500000000000000e+02 1.2067000389099121e+01 2.3096998214721680e+01 -2.8500000000000000e+02 1.2067000389099121e+01 -2.3096998214721680e+01 -2.8500000000000000e+02 2.5000901222229004e+00 2.5000000000000000e+01 -2.8500000000000000e+02 2.5000000000000000e+00 -2.5000000000000000e+01 -2.8500000000000000e+02 -7.0669999122619629e+00 2.3096998214721680e+01 -2.8500000000000000e+02 -7.0669999122619629e+00 -2.3096998214721680e+01 -2.8500000000000000e+02 -1.5177999496459961e+01 1.7677999496459961e+01 -2.8500000000000000e+02 -1.5177999496459961e+01 -1.7677999496459961e+01 -2.8500000000000000e+02 -2.0597000122070312e+01 9.5670003890991211e+00 -2.8500000000000000e+02 -2.0597000122070312e+01 -9.5670003890991211e+00 -2.8500000000000000e+02 -2.2500000000000000e+01 1.4275300782173872e-04 -2.8500000000000000e+02 2.5000000000000000e+00 -2.5000000000000000e+01 -3.2500000000000000e+02 1.2067000389099121e+01 -2.3096998214721680e+01 -3.2500000000000000e+02 2.0177999496459961e+01 -1.7677999496459961e+01 -3.2500000000000000e+02 2.5597000122070312e+01 -9.5670003890991211e+00 -3.2500000000000000e+02 2.7500000000000000e+01 -1.9768800484598614e-05 -3.2500000000000000e+02 2.5597000122070312e+01 9.5670003890991211e+00 -3.2500000000000000e+02 2.0177999496459961e+01 1.7677999496459961e+01 -3.2500000000000000e+02 1.2067000389099121e+01 2.3096998214721680e+01 -3.2500000000000000e+02 2.5000901222229004e+00 2.5000000000000000e+01 -3.2500000000000000e+02 -7.0669999122619629e+00 2.3096998214721680e+01 -3.2500000000000000e+02 -1.5177999496459961e+01 1.7677999496459961e+01 -3.2500000000000000e+02 -2.0597000122070312e+01 9.5670003890991211e+00 -3.2500000000000000e+02 -2.2500000000000000e+01 1.4275300782173872e-04 -3.2500000000000000e+02 -2.0597000122070312e+01 -9.5670003890991211e+00 -3.2500000000000000e+02 -1.5177999496459961e+01 -1.7677999496459961e+01 -3.2500000000000000e+02 -7.0669999122619629e+00 -2.3096998214721680e+01 -3.2500000000000000e+02 2.5000000000000000e+00 -3.5000000000000000e+01 -3.4500000000000000e+02 1.5893999099731445e+01 -3.2335998535156250e+01 -3.4500000000000000e+02 2.7248998641967773e+01 -2.4749000549316406e+01 -3.4500000000000000e+02 3.4836002349853516e+01 -1.3394000053405762e+01 -3.4500000000000000e+02 3.7500000000000000e+01 -2.7676402169163339e-05 -3.4500000000000000e+02 3.4836002349853516e+01 1.3394000053405762e+01 -3.4500000000000000e+02 2.7248998641967773e+01 2.4749000549316406e+01 -3.4500000000000000e+02 1.5893999099731445e+01 3.2335998535156250e+01 -3.4500000000000000e+02 2.5001201629638672e+00 3.5000000000000000e+01 -3.4500000000000000e+02 -1.0894000053405762e+01 3.2335998535156250e+01 -3.4500000000000000e+02 -2.2249000549316406e+01 2.4749000549316406e+01 -3.4500000000000000e+02 -2.9836000442504883e+01 1.3394000053405762e+01 -3.4500000000000000e+02 -3.2500000000000000e+01 1.9985399558208883e-04 -3.4500000000000000e+02 -2.9836000442504883e+01 -1.3394000053405762e+01 -3.4500000000000000e+02 -2.2249000549316406e+01 -2.4749000549316406e+01 -3.4500000000000000e+02 -1.0894000053405762e+01 -3.2335998535156250e+01 -3.4500000000000000e+02 2.5000000000000000e+00 -3.5000000000000000e+01 -3.9500000000000000e+02 1.5893999099731445e+01 -3.2335998535156250e+01 -3.9500000000000000e+02 2.7248998641967773e+01 -2.4749000549316406e+01 -3.9500000000000000e+02 3.4836002349853516e+01 -1.3394000053405762e+01 -3.9500000000000000e+02 3.7500000000000000e+01 -2.7676402169163339e-05 -3.9500000000000000e+02 3.4836002349853516e+01 1.3394000053405762e+01 -3.9500000000000000e+02 2.7248998641967773e+01 2.4749000549316406e+01 -3.9500000000000000e+02 1.5893999099731445e+01 3.2335998535156250e+01 -3.9500000000000000e+02 2.5001201629638672e+00 3.5000000000000000e+01 -3.9500000000000000e+02 -1.0894000053405762e+01 3.2335998535156250e+01 -3.9500000000000000e+02 -2.2249000549316406e+01 2.4749000549316406e+01 -3.9500000000000000e+02 -2.9836000442504883e+01 1.3394000053405762e+01 -3.9500000000000000e+02 -3.2500000000000000e+01 1.9985399558208883e-04 -3.9500000000000000e+02 -2.9836000442504883e+01 -1.3394000053405762e+01 -3.9500000000000000e+02 -2.2249000549316406e+01 -2.4749000549316406e+01 -3.9500000000000000e+02 -1.0894000053405762e+01 -3.2335998535156250e+01 -3.9500000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 804 -> 33 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4836001694202423e+01 -1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector 2.7248999103903770e+01 -2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 4.7499999403953552e+01 3.3186299930321184e-05 -2.8499999642372131e+02) (float-vector 3.7500001490116119e+01 -2.7676401614940005e-05 -3.9500001072883606e+02) (float-vector 3.4836001694202423e+01 -1.3394000008702278e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0893999598920345e+01 3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -2.2249000146985054e+01 2.4748999625444412e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -2.9836000874638557e+01 1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector -2.2249000146985054e+01 2.4748999625444412e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7248999103903770e+01 -2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector 1.5893999487161636e+01 -3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0759999528527260e+01 -1.3775999657809734e+01 -1.6500000655651093e+02) (float-vector -2.2956000640988350e+01 -2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.3250000178813934e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0759999528527260e+01 -1.3775999657809734e+01 -1.6500000655651093e+02) (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.3250000178813934e+02) (float-vector -4.2500000447034836e+01 1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector -3.3500000834465027e+01 2.0556400670557196e-04 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6277000308036804e+01 -3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 2.7955999597907066e+01 -2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 1.6277000308036804e+01 3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 2.5001300964504480e+00 3.5999998450279236e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7955999597907066e+01 2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector 1.6277000308036804e+01 3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5001200847327709e+00 3.5000000149011612e+01 -3.9500001072883606e+02) (float-vector 1.5893999487161636e+01 3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5893999487161636e+01 3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 2.7248999103903770e+01 2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7248999103903770e+01 2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector 3.4836001694202423e+01 1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 3.4836001694202423e+01 1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector 3.7500001490116119e+01 -2.7676401614940005e-05 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 3.3186299930321184e-05 -2.8499999642372131e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9836000874638557e+01 -1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector -2.9836000874638557e+01 1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.6750001311302185e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2249000146985054e+01 2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector -2.9836000874638557e+01 1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector -2.9836000874638557e+01 -1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector -2.2249000146985054e+01 -2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector -1.0893999598920345e+01 -3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 2.4999999441206455e+00 -3.5000000149011612e+01 -3.9500001072883606e+02) (float-vector 1.5893999487161636e+01 -3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 2.7248999103903770e+01 -2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector 3.4836001694202423e+01 -1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector 3.7500001490116119e+01 -2.7676401614940005e-05 -3.9500001072883606e+02) (float-vector 3.4836001694202423e+01 1.3394000008702278e+01 -3.9500001072883606e+02) (float-vector 2.7248999103903770e+01 2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector 1.5893999487161636e+01 3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 2.5001200847327709e+00 3.5000000149011612e+01 -3.9500001072883606e+02) (float-vector -1.0893999598920345e+01 3.2336000353097916e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1276000179350376e+01 3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector -2.2956000640988350e+01 2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1276000179350376e+01 3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -1.0893999598920345e+01 3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 2.5001200847327709e+00 3.5000000149011612e+01 -3.9500001072883606e+02) (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 2.5001300964504480e+00 3.5999998450279236e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector -3.0759999528527260e+01 1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector -3.3500000834465027e+01 2.0556400670557196e-04 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -2.2956000640988350e+01 2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector -3.0759999528527260e+01 1.3776999898254871e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 -1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 3.5760000348091125e+01 -1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector 3.8499999791383743e+01 -2.8467098900364363e-05 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 -1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 4.7499999403953552e+01 1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 4.7499999403953552e+01 3.3186299930321184e-05 -2.8499999642372131e+02) (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 -1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 2.7955999597907066e+01 -2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector 3.5760000348091125e+01 -1.3776999898254871e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0759999528527260e+01 -1.3775999657809734e+01 -1.6500000655651093e+02) (float-vector -3.3500000834465027e+01 2.0556400670557196e-04 -1.6500000655651093e+02) (float-vector -3.0759999528527260e+01 1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector -2.2956000640988350e+01 2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector -1.1276000179350376e+01 3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 2.5001300964504480e+00 3.5999998450279236e+01 -1.6500000655651093e+02) (float-vector 1.6277000308036804e+01 3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 2.7955999597907066e+01 2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector 3.5760000348091125e+01 1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector 3.8499999791383743e+01 -2.8467098900364363e-05 -1.6500000655651093e+02) (float-vector 3.5760000348091125e+01 -1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector 2.7955999597907066e+01 -2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector 1.6277000308036804e+01 -3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 2.4999999441206455e+00 -3.5999998450279236e+01 -1.6500000655651093e+02) (float-vector -1.1277000419795513e+01 -3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector -2.2956000640988350e+01 -2.5456000119447708e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5760000348091125e+01 1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector 4.7499999403953552e+01 1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 4.7499999403953552e+01 -1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 3.8499999791383743e+01 -2.8467098900364363e-05 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7499999403953552e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 4.7499999403953552e+01 1.7500000074505806e+01 -2.1968899667263031e+02) (float-vector 3.5760000348091125e+01 1.3776999898254871e+01 -1.6500000655651093e+02) (float-vector 2.7955999597907066e+01 2.5456000119447708e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -1.1277000419795513e+01 -3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 2.4999999441206455e+00 -3.5999998450279236e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0893999598920345e+01 -3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 2.4999999441206455e+00 -3.5000000149011612e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -1.0893999598920345e+01 -3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector -2.2249000146985054e+01 -2.4748999625444412e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.3250000178813934e+02) (float-vector -2.2956000640988350e+01 -2.5456000119447708e+01 -1.6500000655651093e+02) (float-vector -1.1277000419795513e+01 -3.3259999006986618e+01 -1.6500000655651093e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.3250000178813934e+02) (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.6750001311302185e+02) (float-vector -4.2500000447034836e+01 3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -4.2500000447034836e+01 1.7500000074505806e+01 -2.1968899667263031e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2500000447034836e+01 -3.0310999602079391e+01 -2.6750001311302185e+02) (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector -2.2249000146985054e+01 -2.4748999625444412e+01 -3.9500001072883606e+02) (float-vector -2.9836000874638557e+01 -1.3394000008702278e+01 -3.9500001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5893999487161636e+01 -3.2336000353097916e+01 -3.9500001072883606e+02) (float-vector 2.4999999441206455e+00 -3.5000000149011612e+01 -3.9500001072883606e+02) (float-vector -4.2500000447034836e+01 -3.5000000149011612e+01 -2.5000000000000000e+02) (float-vector 2.4999999441206455e+00 -3.5999998450279236e+01 -1.6500000655651093e+02) (float-vector 1.6277000308036804e+01 -3.3259999006986618e+01 -1.6500000655651093e+02) (float-vector 4.7499999403953552e+01 -3.5000000149011612e+01 -2.5000000000000000e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J6_LINK_8weBAL.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_J7_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.0000000000000000e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.900000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 4 0 3 13 1 0 13 0 11 11 0 4 2 1 23 15 23 1 15 1 13 11 12 13 12 15 13 9 10 11 11 10 12 11 4 9 12 14 15 12 2 14 3 2 12 10 3 12 14 17 15 17 23 15 14 16 17 14 22 16 2 22 14 16 19 17 17 19 21 17 21 23 16 18 19 20 18 16 22 20 16 22 23 21 22 21 20 2 23 22 20 21 19 20 19 18 4 3 5 5 3 10 6 4 5 9 4 6 6 5 7 8 5 10 7 5 8 9 8 10 6 8 9 6 7 8))
                   (list :vertices (let ((mat (make-matrix 24 3))) (fvector-replace (array-entity mat) #f(1.5000000000000000e+01 -2.5980998992919922e+01 -6.5000000000000000e+01 0.0000000000000000e+00 -3.0000000000000000e+01 -6.5000000000000000e+01 0.0000000000000000e+00 -3.0000000000000000e+01 -9.5000000000000000e+01 1.5000000000000000e+01 -2.5980998992919922e+01 -9.5000000000000000e+01 2.5980998992919922e+01 -1.5000000000000000e+01 -6.5000000000000000e+01 2.5980998992919922e+01 -1.5000000000000000e+01 -9.5000000000000000e+01 3.0000000000000000e+01 -9.8178697953699157e-06 -6.5000000000000000e+01 3.0000000000000000e+01 -9.8178697953699157e-06 -9.5000000000000000e+01 2.5980998992919922e+01 1.5000000000000000e+01 -9.5000000000000000e+01 2.5980998992919922e+01 1.5000000000000000e+01 -6.5000000000000000e+01 1.5000000000000000e+01 2.5980998992919922e+01 -9.5000000000000000e+01 1.5000000000000000e+01 2.5980998992919922e+01 -6.5000000000000000e+01 1.9286100723547861e-05 3.0000000000000000e+01 -9.5000000000000000e+01 1.9286100723547861e-05 3.0000000000000000e+01 -6.5000000000000000e+01 -1.5000000000000000e+01 2.5980998992919922e+01 -9.5000000000000000e+01 -1.5000000000000000e+01 2.5980998992919922e+01 -6.5000000000000000e+01 -2.5980998992919922e+01 1.5000000000000000e+01 -9.5000000000000000e+01 -2.5980998992919922e+01 1.5000000000000000e+01 -6.5000000000000000e+01 -3.0000000000000000e+01 2.8754400773323141e-05 -9.5000000000000000e+01 -3.0000000000000000e+01 2.8754400773323141e-05 -6.5000000000000000e+01 -2.5980998992919922e+01 -1.5000000000000000e+01 -9.5000000000000000e+01 -2.5980998992919922e+01 -1.5000000000000000e+01 -6.5000000000000000e+01 -1.5000000000000000e+01 -2.5980998992919922e+01 -9.5000000000000000e+01 -1.5000000000000000e+01 -2.5980998992919922e+01 -6.5000000000000000e+01 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.850000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 3 0 2 0 22 23 1 0 23 3 13 0 0 13 15 0 15 22 22 20 21 23 22 21 22 15 17 22 17 20 23 14 1 16 14 23 21 16 23 21 20 18 18 16 21 20 19 18 20 17 19 17 15 16 17 16 18 19 17 18 15 13 14 15 14 16 13 12 14 14 12 1 10 12 13 12 10 2 1 12 2 8 10 11 11 10 13 10 8 4 2 10 4 3 2 4 5 3 4 5 4 6 8 6 4 6 8 9 9 8 11 7 5 6 7 6 9 5 7 9 5 9 11 5 11 3 3 11 13))
                   (list :vertices (let ((mat (make-matrix 24 3))) (fvector-replace (array-entity mat) #f(4.0000000000000000e+01 0.0000000000000000e+00 -8.0000000000000000e+01 4.0000000000000000e+01 -9.3125498631940751e-12 1.0000000000000000e+01 3.4641002655029297e+01 -2.0000000000000000e+01 1.0000000000000000e+01 3.4641002655029297e+01 -2.0000000000000000e+01 -8.0000000000000000e+01 2.0000000000000000e+01 -3.4641002655029297e+01 1.0000000000000000e+01 2.0000000000000000e+01 -3.4641002655029297e+01 -8.0000000000000000e+01 1.3726300494454335e-05 -4.0000000000000000e+01 1.0000000000000000e+01 1.3726300494454335e-05 -4.0000000000000000e+01 -8.0000000000000000e+01 -2.0000000000000000e+01 -3.4641002655029297e+01 1.0000000000000000e+01 -2.0000000000000000e+01 -3.4641002655029297e+01 -8.0000000000000000e+01 -3.4641002655029297e+01 -2.0000000000000000e+01 1.0000000000000000e+01 -3.4641002655029297e+01 -2.0000000000000000e+01 -8.0000000000000000e+01 -4.0000000000000000e+01 -2.5544499294483103e-05 1.0000000000000000e+01 -4.0000000000000000e+01 -2.5544499294483103e-05 -8.0000000000000000e+01 -3.4641002655029297e+01 2.0000000000000000e+01 1.0000000000000000e+01 -3.4641002655029297e+01 2.0000000000000000e+01 -8.0000000000000000e+01 -2.0000000000000000e+01 3.4641002655029297e+01 1.0000000000000000e+01 -2.0000000000000000e+01 3.4641002655029297e+01 -8.0000000000000000e+01 -3.5966400901088491e-05 4.0000000000000000e+01 1.0000000000000000e+01 -3.5966400901088491e-05 4.0000000000000000e+01 -8.0000000000000000e+01 2.0000000000000000e+01 3.4641002655029297e+01 -8.0000000000000000e+01 2.0000000000000000e+01 3.4641002655029297e+01 1.0000000000000000e+01 3.4641002655029297e+01 2.0000000000000000e+01 -8.0000000000000000e+01 3.4641002655029297e+01 2.0000000000000000e+01 1.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 264 -> 26 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 -7.9999998211860657e+01) (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 9.9999997764825821e+00) (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4999999664723873e+01 2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 1.9286101604620853e-05 2.9999999329447746e+01 -9.4999998807907104e+01) (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 -7.9999998211860657e+01) (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 9.9999997764825821e+00) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 9.9999997764825821e+00) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 -7.9999998211860657e+01) (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 -7.9999998211860657e+01) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 9.9999997764825821e+00) (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 9.9999997764825821e+00) (float-vector 3.9999999105930328e+01 -9.3125495785910048e-12 9.9999997764825821e+00) (float-vector 3.9999999105930328e+01 0.0000000000000000e+00 -7.9999998211860657e+01) (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 9.9999997764825821e+00) (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 9.9999997764825821e+00) (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 9.9999997764825821e+00) (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 9.9999997764825821e+00) (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector -2.5980999693274498e+01 1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector -1.4999999664723873e+01 2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 9.9999997764825821e+00) (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 -7.9999998211860657e+01) (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 9.9999997764825821e+00) (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 9.9999997764825821e+00) (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 9.9999997764825821e+00) (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector 3.9999999105930328e+01 0.0000000000000000e+00 -7.9999998211860657e+01) (float-vector 3.9999999105930328e+01 -9.3125495785910048e-12 9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 9.9999997764825821e+00) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 9.9999997764825821e+00) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 9.9999997764825821e+00) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 9.9999997764825821e+00) (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 9.9999997764825821e+00) (float-vector 3.9999999105930328e+01 -9.3125495785910048e-12 9.9999997764825821e+00) (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 9.9999997764825821e+00) (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 9.9999997764825821e+00) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 9.9999997764825821e+00) (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 9.9999997764825821e+00) (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 9.9999997764825821e+00) (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 9.9999997764825821e+00) (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 9.9999997764825821e+00) (float-vector -1.9999999552965164e+01 3.4641001373529434e+01 9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 9.9999997764825821e+00) (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 -7.9999998211860657e+01) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 9.9999997764825821e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 9.9999997764825821e+00) (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 9.9999997764825821e+00) (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5980999693274498e+01 1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector 2.9999999329447746e+01 -9.8178700724815826e-06 -9.4999998807907104e+01) (float-vector 3.9999999105930328e+01 0.0000000000000000e+00 -7.9999998211860657e+01) (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector -3.5966401412679261e-05 3.9999999105930328e+01 -7.9999998211860657e+01) (float-vector 1.9286101604620853e-05 2.9999999329447746e+01 -9.4999998807907104e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 2.5980999693274498e+01 1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector 3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector 1.9999999552965164e+01 3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4999999664723873e+01 -2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector -2.5980999693274498e+01 -1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9999999329447746e+01 2.8754401526498441e-05 -9.4999998807907104e+01) (float-vector -2.5980999693274498e+01 1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector -3.4641001373529434e+01 1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5980999693274498e+01 -1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector -2.9999999329447746e+01 2.8754401526498441e-05 -9.4999998807907104e+01) (float-vector -3.9999999105930328e+01 -2.5544499848706437e-05 -7.9999998211860657e+01) (float-vector -3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9999999329447746e+01 -9.8178700724815826e-06 -9.4999998807907104e+01) (float-vector 2.5980999693274498e+01 -1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01) (float-vector 3.9999999105930328e+01 0.0000000000000000e+00 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5980999693274498e+01 -1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector 1.4999999664723873e+01 -2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector 3.4641001373529434e+01 -1.9999999552965164e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5980999693274498e+01 1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector -2.9999999329447746e+01 2.8754401526498441e-05 -9.4999998807907104e+01) (float-vector -2.5980999693274498e+01 -1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector -1.4999999664723873e+01 -2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 0.0000000000000000e+00 -2.9999999329447746e+01 -9.4999998807907104e+01) (float-vector 1.4999999664723873e+01 -2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 2.5980999693274498e+01 -1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector 2.9999999329447746e+01 -9.8178700724815826e-06 -9.4999998807907104e+01) (float-vector 2.5980999693274498e+01 1.4999999664723873e+01 -9.4999998807907104e+01) (float-vector 1.4999999664723873e+01 2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 1.9286101604620853e-05 2.9999999329447746e+01 -9.4999998807907104e+01) (float-vector -1.4999999664723873e+01 2.5980999693274498e+01 -9.4999998807907104e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 0.0000000000000000e+00 -2.9999999329447746e+01 -9.4999998807907104e+01) (float-vector -1.4999999664723873e+01 -2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector -1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 -7.9999998211860657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -2.5980999693274498e+01 -9.4999998807907104e+01) (float-vector 0.0000000000000000e+00 -2.9999999329447746e+01 -9.4999998807907104e+01) (float-vector 1.3726300096550403e-05 -3.9999999105930328e+01 -7.9999998211860657e+01) (float-vector 1.9999999552965164e+01 -3.4641001373529434e+01 -7.9999998211860657e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_J7_LINK_Olzk0j.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_HAND_L_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.850000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 3 0 2 4 3 2 5 4 2 4 5 6 7 4 6 6 1 0 7 6 0 1 6 5 2 1 5 0 3 4 0 4 7))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-1.5000000000000000e+01 -1.0000000000000000e+01 9.0000000000000000e+01 -1.5000000000000000e+01 -1.0000000000000000e+01 1.6000000000000000e+02 -1.5000000000000000e+01 -1.6555598905676483e-11 1.6000000000000000e+02 -1.5000000000000000e+01 -9.3125498631940751e-12 9.0000000000000000e+01 1.5000000000000000e+01 -9.3125498631940751e-12 9.0000000000000000e+01 1.5000000000000000e+01 -1.6555598905676483e-11 1.6000000000000000e+02 1.5000000000000000e+01 -1.0000000000000000e+01 1.6000000000000000e+02 1.5000000000000000e+01 -1.0000000000000000e+01 9.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -9.9999997764825821e+00 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -9.9999997764825821e+00 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -9.9999997764825821e+00 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -9.9999997764825821e+00 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -9.9999997764825821e+00 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 -9.9999997764825821e+00 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -9.9999997764825821e+00 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -9.9999997764825821e+00 1.5999999642372131e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -9.9999997764825821e+00 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 -9.9999997764825821e+00 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 -9.9999997764825821e+00 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -9.9999997764825821e+00 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_HAND_L_LINK_ogq46x.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_HAND_R_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.850000 0.850000 0.850000 1.000000))))
                   (list :indices #i( 0 1 2 3 0 2 4 3 2 5 4 2 4 5 6 7 4 6 6 1 0 7 6 0 1 6 5 2 1 5 0 3 4 0 4 7))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-1.5000000000000000e+01 -9.3125498631940751e-12 9.0000000000000000e+01 -1.5000000000000000e+01 -1.6555598905676483e-11 1.6000000000000000e+02 -1.5000000000000000e+01 1.0000000000000000e+01 1.6000000000000000e+02 -1.5000000000000000e+01 1.0000000000000000e+01 9.0000000000000000e+01 1.5000000000000000e+01 1.0000000000000000e+01 9.0000000000000000e+01 1.5000000000000000e+01 1.0000000000000000e+01 1.6000000000000000e+02 1.5000000000000000e+01 -1.6555598905676483e-11 1.6000000000000000e+02 1.5000000000000000e+01 -9.3125498631940751e-12 9.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4999999664723873e+01 9.9999997764825821e+00 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 9.9999997764825821e+00 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4999999664723873e+01 9.9999997764825821e+00 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 9.9999997764825821e+00 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 9.9999997764825821e+00 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 9.9999997764825821e+00 1.5999999642372131e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector -1.4999999664723873e+01 9.9999997764825821e+00 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 9.9999997764825821e+00 1.5999999642372131e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 9.9999997764825821e+00 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 9.9999997764825821e+00 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector -1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4999999664723873e+01 -9.3125495785910048e-12 9.0000003576278687e+01) (float-vector 1.4999999664723873e+01 -1.6555599461330096e-11 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 9.9999997764825821e+00 1.5999999642372131e+02) (float-vector 1.4999999664723873e+01 9.9999997764825821e+00 9.0000003576278687e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_HAND_R_LINK_4mLw2V.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  )


(provide :HRP1 "(ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:24:17 PST")

