;;
;; DO NOT EDIT THIS FILE
;;
;; this file is automatically generated from /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/models/sample4legrobot.l on (Linux ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:24:16 PST
;;
;; /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/obj-arm-linux-gnueabihf $ ;;

;;
;; copy euscollada-robot class definition from euscollada/src/euscollada-robot.l
;;
(defclass euscollada-robot
;; This euscollada-robot class is for robots converted from collada files.
;; This class provides :init-ending override.
  :super robot-model
  :slots ()
  )
(defmethod euscollada-robot
  (:init-ending
   (&optional (type :urdf))
   (when (eq type :collada)
     ;; fix all links' mass properties ;; root link relative (collada) -> link local (euslisp)
     (dolist (l (append links
                        (mapcan #'(lambda (x) (if (and (derivedp (cdr x) bodyset-link)
                                                       (not (memq (cdr x) links)))
                                                  (list (cdr x)))) (send self :slots))))
       (unless (= (send l :weight) 0.0)
       (setq (l . acentroid) (send l :inverse-transform-vector
                                   (send (send (car links) :worldcoords) :transform-vector
                                         (l . acentroid))))
       (setq (l . inertia-tensor) (m* (transpose (send l :worldrot))
                                      (m* (send (car links) :worldrot)
                                          (l . inertia-tensor))))
       )))
   (send-super :init-ending)
   (send self :make-collision-model-for-links)
   ;;
   (dolist (j (mapcan #'(lambda (x) (if (and (derivedp (cdr x) joint)
                                             (not (memq (cdr x) (send self :joint-list))))
                                        (list (cdr x)))) (send self :slots)))
     (send (send j :child-link) :add-joint j)
     (send (send j :child-link) :add-parent-link (send j :parent-link))
     (send (send j :parent-link) :add-child-links (send j :child-link)))
   )
  (:change-visual
   (&optional (visual :convex))
   (dolist (lk (send self :links))
     (dolist (bd (send lk :bodies))
       (when (derivedp bd collada-body)
         (send bd :change-visual visual)))))
  ;; fullbody-inverse-kinematics overwrite
  ;;  reduce root-link's weight based on leg's joint limit
  ;;  increase stop and cog-gain
  (:fullbody-inverse-kinematics
   (target-coords &rest args &key (stop 250) (cog-gain 2.0) (additional-weight-list) (use-6dof-joint-leg-gain nil) &allow-other-keys)
   (let* ((leg-ul (send self :calc-union-link-list (send self :legs :links))))
     (send self :reset-joint-angle-limit-weight-old leg-ul)
     (send-message* self robot-model :fullbody-inverse-kinematics
                    target-coords
                    :stop stop :cog-gain cog-gain
                    :additional-weight-list
                    (append
                     additional-weight-list
                     (if use-6dof-joint-leg-gain
                         (list
                          (list (car (send self :links))
                                #'(lambda ()
                                    ;; set root-link 6dof-joint's weight based on legs' joint limit
                                    (let* ((min-weight
                                            (reduce #'(lambda (x y) (min x y))
                                                    (coerce (send self :calc-inverse-kinematics-weight-from-link-list
                                                                  leg-ul :union-link-list leg-ul) cons))))
                                      (fill (instantiate float-vector 6) min-weight)))
                                )
                          )))
                    args)
     ))
  ;; make collision model from faces or gl-vertices
  (:make-collision-model-for-links
   (&key (fat 0) (collision-func 'pqp-collision-check) ((:links ls) (send self :links)))
   (dolist (ll ls)
     (let (fs glv usefs)
       (dolist (bd (send ll :bodies))
         (if (derivedp bd collada-body)
             (push (send bd :glvertices) glv)
           (push (send bd :faces) fs)))
       (setq fs (flatten fs))
       (cond
        ((and (not fs) glv) ;; if there is no faces, use glvertices for creating pqpmodel
         (setq usefs (instance gl::glvertices :init nil))
         (send usefs :transform (send ll :worldcoords))
         (send usefs :append-glvertices glv)
         (let ((m (send usefs (read-from-string
                               (format nil ":make-~Amodel"
                                       (string-right-trim "-COLLISION-CHECK" (string collision-func))))
                        :fat fat)))
           (setf (get ll :pqpmodel) m)
           ))
        (fs
         (setq usefs
               (append fs
                       (mapcar #'(lambda (gv) (send gv :convert-to-faces :wrt :world)) glv)))
         (send ll
               (read-from-string
                (format nil ":make-~Amodel"
                        (string-right-trim "-COLLISION-CHECK" (string collision-func))))
               :fat fat
               :faces usefs))
        ))
     ))
  )

;; copy euscollada-body class definition from euscollada/src/euscollada-robot.l
;; This euscollada-body class is for bodies in robot model converted from collada files.
(defclass collada-body
  :super gl::glbody
  :slots (glvertices) ;; glvertices slot for backward compatibility
  )
(defmethod collada-body
  (:init (&key (name) (replace-obj))
    (if replace-obj
        (replace-object self replace-obj)
      (replace-object self (make-cube 10 10 10)))
    (if name (send self :name name))
    (setq glvertices gl::aglvertices)
    self)
  (:change-visual
   (&optional (visual :convex))
   (case visual
     ((list :convex :hull :convex-hull)
      (unless (send self :get :original-mesh)
        (send self :put :original-mesh gl::aglvertices)) ;; store original mesh
      (let* ((org-mesh (send self :get :original-mesh))
             (org-cds (send org-mesh :copy-worldcoords))
             (glv (gl::make-glvertices-from-faces (send self :faces))))
        (send glv :set-offset (send org-cds :inverse-transformation))
        (send glv :transform org-cds)
        (send org-mesh :assoc glv)
        (setq gl::aglvertices glv)
        glv))
     ((list :original :mesh :glvertices :original-mesh)
      (let ((org-mesh (send self :get :original-mesh)))
        (when org-mesh
          (dolist (d (send org-mesh :descendants)) ;; dissoc all discendants
            (send org-mesh :dissoc d))
          (setq gl::aglvertices org-mesh)
          org-mesh)))
     ))
  )
;;
;; end of copy from /opt/ros/melodic/share/euscollada/src/euscollada-robot.l
;;
(defun Sample4LegRobot () (setq *Sample4LegRobot* (instance Sample4LegRobot-robot :init)))

(defclass Sample4LegRobot-robot
  :super euscollada-robot
  :slots ( ;; link names
          LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk WAIST_LINK0_lk
         ;; joint names
          LARM_JOINT0_jt LARM_JOINT1_jt LARM_JOINT2_jt LARM_JOINT3_jt LARM_JOINT4_jt LARM_JOINT5_jt LLEG_JOINT0_jt LLEG_JOINT1_jt LLEG_JOINT2_jt LLEG_JOINT3_jt LLEG_JOINT4_jt LLEG_JOINT5_jt RARM_JOINT0_jt RARM_JOINT1_jt RARM_JOINT2_jt RARM_JOINT3_jt RARM_JOINT4_jt RARM_JOINT5_jt RLEG_JOINT0_jt RLEG_JOINT1_jt RLEG_JOINT2_jt RLEG_JOINT3_jt RLEG_JOINT4_jt RLEG_JOINT5_jt
         ;; sensor names
          gsensor-sensor-coords gyrometer-sensor-coords rfsensor-sensor-coords lfsensor-sensor-coords rasensor-sensor-coords lasensor-sensor-coords
         )
  )
(defmethod Sample4LegRobot-robot
  (:init
   (&rest args)
   (let ()
     (send-super* :init :name "Sample4LegRobot" args)

     ;; link: WAIST_LINK0_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK0_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK0_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK0"))
       ;; inertial parameter for WAIST_LINK0_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.7500000000000000e+01))
                      ))
         (send WAIST_LINK0_lk :weight 27000.000)
         (setq (WAIST_LINK0_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 9.6482000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 9.6482000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.8800000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK0_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK0_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                        ))
         (send WAIST_LINK0_lk :transform world-cds))
       )

     ;; link: RLEG_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK1"))
       ;; inertial parameter for RLEG_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK1_lk :weight 2500.000)
         (setq (RLEG_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send RLEG_LINK1_lk :transform world-cds))
       )

     ;; link: RARM_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK3"))
       ;; inertial parameter for RARM_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send RARM_LINK3_lk :weight 5100.000)
         (setq (RARM_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send RARM_LINK3_lk :transform world-cds))
       )

     ;; link: RLEG_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK2"))
       ;; inertial parameter for RLEG_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK2_lk :weight 2000.000)
         (setq (RLEG_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send RLEG_LINK2_lk :transform world-cds))
       )

     ;; link: LLEG_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK2"))
       ;; inertial parameter for LLEG_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK2_lk :weight 2000.000)
         (setq (LLEG_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send LLEG_LINK2_lk :transform world-cds))
       )

     ;; link: RARM_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK2"))
       ;; inertial parameter for RARM_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RARM_LINK2_lk :weight 2000.000)
         (setq (RARM_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send RARM_LINK2_lk :transform world-cds))
       )

     ;; link: LLEG_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK4"))
       ;; inertial parameter for LLEG_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send LLEG_LINK4_lk :weight 7000.000)
         (setq (LLEG_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send LLEG_LINK4_lk :transform world-cds))
       )

     ;; link: RARM_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK1"))
       ;; inertial parameter for RARM_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RARM_LINK1_lk :weight 2500.000)
         (setq (RARM_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send RARM_LINK1_lk :transform world-cds))
       )

     ;; link: LLEG_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK5"))
       ;; inertial parameter for LLEG_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK5_lk :weight 2500.000)
         (setq (LLEG_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send LLEG_LINK5_lk :transform world-cds))
       )

     ;; link: LLEG_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK6"))
       ;; inertial parameter for LLEG_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 -3.0000000000000028e+01))
                      ))
         (send LLEG_LINK6_lk :weight 1900.000)
         (setq (LLEG_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send LLEG_LINK6_lk :transform world-cds))
       )

     ;; link: RLEG_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK3"))
       ;; inertial parameter for RLEG_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send RLEG_LINK3_lk :weight 5100.000)
         (setq (RLEG_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send RLEG_LINK3_lk :transform world-cds))
       )

     ;; link: LARM_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK6"))
       ;; inertial parameter for LARM_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 7.9999999999999957e+01 0.0000000000000000e+00 -3.0000000000000028e+01))
                      ))
         (send LARM_LINK6_lk :weight 1900.000)
         (setq (LARM_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send LARM_LINK6_lk :transform world-cds))
       )

     ;; link: LLEG_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK1"))
       ;; inertial parameter for LLEG_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK1_lk :weight 2500.000)
         (setq (LLEG_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send LLEG_LINK1_lk :transform world-cds))
       )

     ;; link: RLEG_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK4"))
       ;; inertial parameter for RLEG_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send RLEG_LINK4_lk :weight 7000.000)
         (setq (RLEG_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send RLEG_LINK4_lk :transform world-cds))
       )

     ;; link: LLEG_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK3"))
       ;; inertial parameter for LLEG_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send LLEG_LINK3_lk :weight 5100.000)
         (setq (LLEG_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send LLEG_LINK3_lk :transform world-cds))
       )

     ;; link: RLEG_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK5"))
       ;; inertial parameter for RLEG_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK5_lk :weight 2500.000)
         (setq (RLEG_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send RLEG_LINK5_lk :transform world-cds))
       )

     ;; link: LARM_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK4"))
       ;; inertial parameter for LARM_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send LARM_LINK4_lk :weight 7000.000)
         (setq (LARM_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send LARM_LINK4_lk :transform world-cds))
       )

     ;; link: LARM_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK5"))
       ;; inertial parameter for LARM_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LARM_LINK5_lk :weight 2500.000)
         (setq (LARM_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send LARM_LINK5_lk :transform world-cds))
       )

     ;; link: RLEG_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK6"))
       ;; inertial parameter for RLEG_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 -3.0000000000000028e+01))
                      ))
         (send RLEG_LINK6_lk :weight 1900.000)
         (setq (RLEG_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send RLEG_LINK6_lk :transform world-cds))
       )

     ;; link: LARM_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK3"))
       ;; inertial parameter for LARM_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send LARM_LINK3_lk :weight 5100.000)
         (setq (LARM_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send LARM_LINK3_lk :transform world-cds))
       )

     ;; link: LARM_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK2"))
       ;; inertial parameter for LARM_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LARM_LINK2_lk :weight 2000.000)
         (setq (LARM_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send LARM_LINK2_lk :transform world-cds))
       )

     ;; link: RARM_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK4"))
       ;; inertial parameter for RARM_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send RARM_LINK4_lk :weight 7000.000)
         (setq (RARM_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 -3.5350000000000000e+02))
                        ))
         (send RARM_LINK4_lk :transform world-cds))
       )

     ;; link: RARM_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK5"))
       ;; inertial parameter for RARM_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RARM_LINK5_lk :weight 2500.000)
         (setq (RARM_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send RARM_LINK5_lk :transform world-cds))
       )

     ;; link: RARM_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK6"))
       ;; inertial parameter for RARM_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 7.9999999999999957e+01 0.0000000000000000e+00 -3.0000000000000028e+01))
                      ))
         (send RARM_LINK6_lk :weight 1900.000)
         (setq (RARM_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 -6.5350000000000000e+02))
                        ))
         (send RARM_LINK6_lk :transform world-cds))
       )

     ;; link: LARM_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK1"))
       ;; inertial parameter for LARM_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LARM_LINK1_lk :weight 2500.000)
         (setq (LARM_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 0.0000000000000000e+00))
                        ))
         (send LARM_LINK1_lk :transform world-cds))
       )

     (send WAIST_LINK0_lk :assoc LARM_LINK1_lk)
     (send LARM_LINK1_lk :assoc LARM_LINK2_lk)
     (send LARM_LINK2_lk :assoc LARM_LINK3_lk)
     (send LARM_LINK3_lk :assoc LARM_LINK4_lk)
     (send LARM_LINK4_lk :assoc LARM_LINK5_lk)
     (send LARM_LINK5_lk :assoc LARM_LINK6_lk)
     (send WAIST_LINK0_lk :assoc LLEG_LINK1_lk)
     (send LLEG_LINK1_lk :assoc LLEG_LINK2_lk)
     (send LLEG_LINK2_lk :assoc LLEG_LINK3_lk)
     (send LLEG_LINK3_lk :assoc LLEG_LINK4_lk)
     (send LLEG_LINK4_lk :assoc LLEG_LINK5_lk)
     (send LLEG_LINK5_lk :assoc LLEG_LINK6_lk)
     (send WAIST_LINK0_lk :assoc RARM_LINK1_lk)
     (send RARM_LINK1_lk :assoc RARM_LINK2_lk)
     (send RARM_LINK2_lk :assoc RARM_LINK3_lk)
     (send RARM_LINK3_lk :assoc RARM_LINK4_lk)
     (send RARM_LINK4_lk :assoc RARM_LINK5_lk)
     (send RARM_LINK5_lk :assoc RARM_LINK6_lk)
     (send WAIST_LINK0_lk :assoc RLEG_LINK1_lk)
     (send RLEG_LINK1_lk :assoc RLEG_LINK2_lk)
     (send RLEG_LINK2_lk :assoc RLEG_LINK3_lk)
     (send RLEG_LINK3_lk :assoc RLEG_LINK4_lk)
     (send RLEG_LINK4_lk :assoc RLEG_LINK5_lk)
     (send RLEG_LINK5_lk :assoc RLEG_LINK6_lk)
     (send self :assoc WAIST_LINK0_lk)

     ;; joint models
     ;; joint: LARM_JOINT0_jt
     (setq LARM_JOINT0_jt
           (instance rotational-joint :init
                     :name "LARM_JOINT0"
                     :parent-link WAIST_LINK0_lk :child-link LARM_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_JOINT1_jt
     (setq LARM_JOINT1_jt
           (instance rotational-joint :init
                     :name "LARM_JOINT1"
                     :parent-link LARM_LINK1_lk :child-link LARM_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_JOINT2_jt
     (setq LARM_JOINT2_jt
           (instance rotational-joint :init
                     :name "LARM_JOINT2"
                     :parent-link LARM_LINK2_lk :child-link LARM_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_JOINT3_jt
     (setq LARM_JOINT3_jt
           (instance rotational-joint :init
                     :name "LARM_JOINT3"
                     :parent-link LARM_LINK3_lk :child-link LARM_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_JOINT4_jt
     (setq LARM_JOINT4_jt
           (instance rotational-joint :init
                     :name "LARM_JOINT4"
                     :parent-link LARM_LINK4_lk :child-link LARM_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_JOINT5_jt
     (setq LARM_JOINT5_jt
           (instance rotational-joint :init
                     :name "LARM_JOINT5"
                     :parent-link LARM_LINK5_lk :child-link LARM_LINK6_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_JOINT0_jt
     (setq LLEG_JOINT0_jt
           (instance rotational-joint :init
                     :name "LLEG_JOINT0"
                     :parent-link WAIST_LINK0_lk :child-link LLEG_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_JOINT1_jt
     (setq LLEG_JOINT1_jt
           (instance rotational-joint :init
                     :name "LLEG_JOINT1"
                     :parent-link LLEG_LINK1_lk :child-link LLEG_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_JOINT2_jt
     (setq LLEG_JOINT2_jt
           (instance rotational-joint :init
                     :name "LLEG_JOINT2"
                     :parent-link LLEG_LINK2_lk :child-link LLEG_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_JOINT3_jt
     (setq LLEG_JOINT3_jt
           (instance rotational-joint :init
                     :name "LLEG_JOINT3"
                     :parent-link LLEG_LINK3_lk :child-link LLEG_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_JOINT4_jt
     (setq LLEG_JOINT4_jt
           (instance rotational-joint :init
                     :name "LLEG_JOINT4"
                     :parent-link LLEG_LINK4_lk :child-link LLEG_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_JOINT5_jt
     (setq LLEG_JOINT5_jt
           (instance rotational-joint :init
                     :name "LLEG_JOINT5"
                     :parent-link LLEG_LINK5_lk :child-link LLEG_LINK6_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_JOINT0_jt
     (setq RARM_JOINT0_jt
           (instance rotational-joint :init
                     :name "RARM_JOINT0"
                     :parent-link WAIST_LINK0_lk :child-link RARM_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_JOINT1_jt
     (setq RARM_JOINT1_jt
           (instance rotational-joint :init
                     :name "RARM_JOINT1"
                     :parent-link RARM_LINK1_lk :child-link RARM_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_JOINT2_jt
     (setq RARM_JOINT2_jt
           (instance rotational-joint :init
                     :name "RARM_JOINT2"
                     :parent-link RARM_LINK2_lk :child-link RARM_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_JOINT3_jt
     (setq RARM_JOINT3_jt
           (instance rotational-joint :init
                     :name "RARM_JOINT3"
                     :parent-link RARM_LINK3_lk :child-link RARM_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_JOINT4_jt
     (setq RARM_JOINT4_jt
           (instance rotational-joint :init
                     :name "RARM_JOINT4"
                     :parent-link RARM_LINK4_lk :child-link RARM_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_JOINT5_jt
     (setq RARM_JOINT5_jt
           (instance rotational-joint :init
                     :name "RARM_JOINT5"
                     :parent-link RARM_LINK5_lk :child-link RARM_LINK6_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_JOINT0_jt
     (setq RLEG_JOINT0_jt
           (instance rotational-joint :init
                     :name "RLEG_JOINT0"
                     :parent-link WAIST_LINK0_lk :child-link RLEG_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_JOINT1_jt
     (setq RLEG_JOINT1_jt
           (instance rotational-joint :init
                     :name "RLEG_JOINT1"
                     :parent-link RLEG_LINK1_lk :child-link RLEG_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_JOINT2_jt
     (setq RLEG_JOINT2_jt
           (instance rotational-joint :init
                     :name "RLEG_JOINT2"
                     :parent-link RLEG_LINK2_lk :child-link RLEG_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_JOINT3_jt
     (setq RLEG_JOINT3_jt
           (instance rotational-joint :init
                     :name "RLEG_JOINT3"
                     :parent-link RLEG_LINK3_lk :child-link RLEG_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_JOINT4_jt
     (setq RLEG_JOINT4_jt
           (instance rotational-joint :init
                     :name "RLEG_JOINT4"
                     :parent-link RLEG_LINK4_lk :child-link RLEG_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_JOINT5_jt
     (setq RLEG_JOINT5_jt
           (instance rotational-joint :init
                     :name "RLEG_JOINT5"
                     :parent-link RLEG_LINK5_lk :child-link RLEG_LINK6_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; end coords from yaml file
     (setq rleg-end-coords (make-cascoords :coords (send RLEG_LINK6_lk :copy-worldcoords) :name :rleg-end-coords))
     (send rleg-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01))
     (send RLEG_LINK6_lk :assoc rleg-end-coords)
     (setq lleg-end-coords (make-cascoords :coords (send LLEG_LINK6_lk :copy-worldcoords) :name :lleg-end-coords))
     (send lleg-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01))
     (send LLEG_LINK6_lk :assoc lleg-end-coords)
     (setq rarm-end-coords (make-cascoords :coords (send RARM_LINK6_lk :copy-worldcoords) :name :rarm-end-coords))
     (send rarm-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01))
     (send RARM_LINK6_lk :assoc rarm-end-coords)
     (setq larm-end-coords (make-cascoords :coords (send LARM_LINK6_lk :copy-worldcoords) :name :larm-end-coords))
     (send larm-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01))
     (send LARM_LINK6_lk :assoc larm-end-coords)

     ;; limbs
     (setq rleg (list RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk))

     (setq rleg-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rleg) (find-parent (send l :parent)) l)))
             (find-parent (car rleg))))
     (setq lleg (list LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk))

     (setq lleg-root-link
           (labels ((find-parent (l) (if (find (send l :parent) lleg) (find-parent (send l :parent)) l)))
             (find-parent (car lleg))))
     (setq rarm (list RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk))

     (setq rarm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rarm) (find-parent (send l :parent)) l)))
             (find-parent (car rarm))))
     (setq larm (list LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk))

     (setq larm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) larm) (find-parent (send l :parent)) l)))
             (find-parent (car larm))))

     ;; links
     (setq links (list WAIST_LINK0_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk))

     ;; joint-list
     (setq joint-list (list RLEG_JOINT0_jt RLEG_JOINT1_jt RLEG_JOINT2_jt RLEG_JOINT3_jt RLEG_JOINT4_jt RLEG_JOINT5_jt LLEG_JOINT0_jt LLEG_JOINT1_jt LLEG_JOINT2_jt LLEG_JOINT3_jt LLEG_JOINT4_jt LLEG_JOINT5_jt RARM_JOINT0_jt RARM_JOINT1_jt RARM_JOINT2_jt RARM_JOINT3_jt RARM_JOINT4_jt RARM_JOINT5_jt LARM_JOINT0_jt LARM_JOINT1_jt LARM_JOINT2_jt LARM_JOINT3_jt LARM_JOINT4_jt LARM_JOINT5_jt))

     ;; sensor-coords
     ;;
     (setq gsensor-sensor-coords (make-cascoords :name "gsensor" :coords (send WAIST_LINK0_lk :copy-worldcoords)))
     (send gsensor-sensor-coords :put :sensor-type :base_imu)
     (send gsensor-sensor-coords :put :sensor-id 1)
     (send gsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send WAIST_LINK0_lk :assoc gsensor-sensor-coords)
     ;;
     (setq gyrometer-sensor-coords (make-cascoords :name "gyrometer" :coords (send WAIST_LINK0_lk :copy-worldcoords)))
     (send gyrometer-sensor-coords :put :sensor-type :base_imu)
     (send gyrometer-sensor-coords :put :sensor-id 2)
     (send gyrometer-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send WAIST_LINK0_lk :assoc gyrometer-sensor-coords)
     ;;
     (setq rfsensor-sensor-coords (make-cascoords :name "rfsensor" :coords (send RLEG_LINK6_lk :copy-worldcoords)))
     (send rfsensor-sensor-coords :put :sensor-type :base_force6d)
     (send rfsensor-sensor-coords :put :sensor-id 3)
     (send rfsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send RLEG_LINK6_lk :assoc rfsensor-sensor-coords)
     ;;
     (setq lfsensor-sensor-coords (make-cascoords :name "lfsensor" :coords (send LLEG_LINK6_lk :copy-worldcoords)))
     (send lfsensor-sensor-coords :put :sensor-type :base_force6d)
     (send lfsensor-sensor-coords :put :sensor-id 4)
     (send lfsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send LLEG_LINK6_lk :assoc lfsensor-sensor-coords)
     ;;
     (setq rasensor-sensor-coords (make-cascoords :name "rasensor" :coords (send RARM_LINK6_lk :copy-worldcoords)))
     (send rasensor-sensor-coords :put :sensor-type :base_force6d)
     (send rasensor-sensor-coords :put :sensor-id 5)
     (send rasensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send RARM_LINK6_lk :assoc rasensor-sensor-coords)
     ;;
     (setq lasensor-sensor-coords (make-cascoords :name "lasensor" :coords (send LARM_LINK6_lk :copy-worldcoords)))
     (send lasensor-sensor-coords :put :sensor-type :base_force6d)
     (send lasensor-sensor-coords :put :sensor-id 6)
     (send lasensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send LARM_LINK6_lk :assoc lasensor-sensor-coords)

     ;; attach_sensor lists
     (setq force-sensors (list rfsensor-sensor-coords lfsensor-sensor-coords rasensor-sensor-coords lasensor-sensor-coords ))
     (setq imu-sensors (list gsensor-sensor-coords gyrometer-sensor-coords ))
     (setq cameras (list ))

     ;; init-ending
     (send self :init-ending) ;; :urdf

     ;; overwrite bodies to return draw-things links not (send link :bodies)
     (setq bodies (flatten (mapcar #'(lambda (b) (if (find-method b :bodies) (send b :bodies))) (list LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk WAIST_LINK0_lk))))

     (when (member :reset-pose (send self :methods))           (send self :reset-pose)) ;; :set reset-pose

     self)) ;; end of :init

  ;; pre-defined pose methods

    (:reset-pose (&optional (limbs '(:rleg :lleg :rarm :larm)))
      "Predefined pose named reset-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:rleg (send self limb :angle-vector (float-vector -0.004457 -21.692900 -0.012020 47.672300 -25.930000 0.014025)))
          (:lleg (send self limb :angle-vector (float-vector -0.004457 -21.692900 -0.012020 47.672300 -25.930000 0.014025)))
          (:rarm (send self limb :angle-vector (float-vector -0.004457 -21.692900 -0.012020 47.672300 -25.930000 0.014025)))
          (:larm (send self limb :angle-vector (float-vector -0.004457 -21.692900 -0.012020 47.672300 -25.930000 0.014025)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
  ;; all joints
  (:LARM_JOINT0 (&rest args) (forward-message-to LARM_JOINT0_jt args))
  (:LARM_JOINT1 (&rest args) (forward-message-to LARM_JOINT1_jt args))
  (:LARM_JOINT2 (&rest args) (forward-message-to LARM_JOINT2_jt args))
  (:LARM_JOINT3 (&rest args) (forward-message-to LARM_JOINT3_jt args))
  (:LARM_JOINT4 (&rest args) (forward-message-to LARM_JOINT4_jt args))
  (:LARM_JOINT5 (&rest args) (forward-message-to LARM_JOINT5_jt args))
  (:LLEG_JOINT0 (&rest args) (forward-message-to LLEG_JOINT0_jt args))
  (:LLEG_JOINT1 (&rest args) (forward-message-to LLEG_JOINT1_jt args))
  (:LLEG_JOINT2 (&rest args) (forward-message-to LLEG_JOINT2_jt args))
  (:LLEG_JOINT3 (&rest args) (forward-message-to LLEG_JOINT3_jt args))
  (:LLEG_JOINT4 (&rest args) (forward-message-to LLEG_JOINT4_jt args))
  (:LLEG_JOINT5 (&rest args) (forward-message-to LLEG_JOINT5_jt args))
  (:RARM_JOINT0 (&rest args) (forward-message-to RARM_JOINT0_jt args))
  (:RARM_JOINT1 (&rest args) (forward-message-to RARM_JOINT1_jt args))
  (:RARM_JOINT2 (&rest args) (forward-message-to RARM_JOINT2_jt args))
  (:RARM_JOINT3 (&rest args) (forward-message-to RARM_JOINT3_jt args))
  (:RARM_JOINT4 (&rest args) (forward-message-to RARM_JOINT4_jt args))
  (:RARM_JOINT5 (&rest args) (forward-message-to RARM_JOINT5_jt args))
  (:RLEG_JOINT0 (&rest args) (forward-message-to RLEG_JOINT0_jt args))
  (:RLEG_JOINT1 (&rest args) (forward-message-to RLEG_JOINT1_jt args))
  (:RLEG_JOINT2 (&rest args) (forward-message-to RLEG_JOINT2_jt args))
  (:RLEG_JOINT3 (&rest args) (forward-message-to RLEG_JOINT3_jt args))
  (:RLEG_JOINT4 (&rest args) (forward-message-to RLEG_JOINT4_jt args))
  (:RLEG_JOINT5 (&rest args) (forward-message-to RLEG_JOINT5_jt args))

  ;; all links forwarding
  (:links (&rest args)
   (if (null args) (return-from :links (send-super :links)))
   (let ((key (car args))
           (nargs (cdr args)))
     (unless (keywordp key)
         (return-from :links (send-super* :links args)))
       (case key
       (:LARM_LINK1 (forward-message-to LARM_LINK1_lk nargs))
       (:LARM_LINK2 (forward-message-to LARM_LINK2_lk nargs))
       (:LARM_LINK3 (forward-message-to LARM_LINK3_lk nargs))
       (:LARM_LINK4 (forward-message-to LARM_LINK4_lk nargs))
       (:LARM_LINK5 (forward-message-to LARM_LINK5_lk nargs))
       (:LARM_LINK6 (forward-message-to LARM_LINK6_lk nargs))
       (:LLEG_LINK1 (forward-message-to LLEG_LINK1_lk nargs))
       (:LLEG_LINK2 (forward-message-to LLEG_LINK2_lk nargs))
       (:LLEG_LINK3 (forward-message-to LLEG_LINK3_lk nargs))
       (:LLEG_LINK4 (forward-message-to LLEG_LINK4_lk nargs))
       (:LLEG_LINK5 (forward-message-to LLEG_LINK5_lk nargs))
       (:LLEG_LINK6 (forward-message-to LLEG_LINK6_lk nargs))
       (:RARM_LINK1 (forward-message-to RARM_LINK1_lk nargs))
       (:RARM_LINK2 (forward-message-to RARM_LINK2_lk nargs))
       (:RARM_LINK3 (forward-message-to RARM_LINK3_lk nargs))
       (:RARM_LINK4 (forward-message-to RARM_LINK4_lk nargs))
       (:RARM_LINK5 (forward-message-to RARM_LINK5_lk nargs))
       (:RARM_LINK6 (forward-message-to RARM_LINK6_lk nargs))
       (:RLEG_LINK1 (forward-message-to RLEG_LINK1_lk nargs))
       (:RLEG_LINK2 (forward-message-to RLEG_LINK2_lk nargs))
       (:RLEG_LINK3 (forward-message-to RLEG_LINK3_lk nargs))
       (:RLEG_LINK4 (forward-message-to RLEG_LINK4_lk nargs))
       (:RLEG_LINK5 (forward-message-to RLEG_LINK5_lk nargs))
       (:RLEG_LINK6 (forward-message-to RLEG_LINK6_lk nargs))
       (:WAIST_LINK0 (forward-message-to WAIST_LINK0_lk nargs))
       (t (send-super* :links args)))))

  ;; all links
  (:LARM_LINK1_lk (&rest args) (forward-message-to LARM_LINK1_lk args))
  (:LARM_LINK2_lk (&rest args) (forward-message-to LARM_LINK2_lk args))
  (:LARM_LINK3_lk (&rest args) (forward-message-to LARM_LINK3_lk args))
  (:LARM_LINK4_lk (&rest args) (forward-message-to LARM_LINK4_lk args))
  (:LARM_LINK5_lk (&rest args) (forward-message-to LARM_LINK5_lk args))
  (:LARM_LINK6_lk (&rest args) (forward-message-to LARM_LINK6_lk args))
  (:LLEG_LINK1_lk (&rest args) (forward-message-to LLEG_LINK1_lk args))
  (:LLEG_LINK2_lk (&rest args) (forward-message-to LLEG_LINK2_lk args))
  (:LLEG_LINK3_lk (&rest args) (forward-message-to LLEG_LINK3_lk args))
  (:LLEG_LINK4_lk (&rest args) (forward-message-to LLEG_LINK4_lk args))
  (:LLEG_LINK5_lk (&rest args) (forward-message-to LLEG_LINK5_lk args))
  (:LLEG_LINK6_lk (&rest args) (forward-message-to LLEG_LINK6_lk args))
  (:RARM_LINK1_lk (&rest args) (forward-message-to RARM_LINK1_lk args))
  (:RARM_LINK2_lk (&rest args) (forward-message-to RARM_LINK2_lk args))
  (:RARM_LINK3_lk (&rest args) (forward-message-to RARM_LINK3_lk args))
  (:RARM_LINK4_lk (&rest args) (forward-message-to RARM_LINK4_lk args))
  (:RARM_LINK5_lk (&rest args) (forward-message-to RARM_LINK5_lk args))
  (:RARM_LINK6_lk (&rest args) (forward-message-to RARM_LINK6_lk args))
  (:RLEG_LINK1_lk (&rest args) (forward-message-to RLEG_LINK1_lk args))
  (:RLEG_LINK2_lk (&rest args) (forward-message-to RLEG_LINK2_lk args))
  (:RLEG_LINK3_lk (&rest args) (forward-message-to RLEG_LINK3_lk args))
  (:RLEG_LINK4_lk (&rest args) (forward-message-to RLEG_LINK4_lk args))
  (:RLEG_LINK5_lk (&rest args) (forward-message-to RLEG_LINK5_lk args))
  (:RLEG_LINK6_lk (&rest args) (forward-message-to RLEG_LINK6_lk args))
  (:WAIST_LINK0_lk (&rest args) (forward-message-to WAIST_LINK0_lk args))

  ;; user-defined joint
  (:rleg-crotch-y (&rest args) (forward-message-to RLEG_JOINT0_jt args))
  (:rleg-crotch-r (&rest args) (forward-message-to RLEG_JOINT1_jt args))
  (:rleg-crotch-p (&rest args) (forward-message-to RLEG_JOINT2_jt args))
  (:rleg-knee-p (&rest args) (forward-message-to RLEG_JOINT3_jt args))
  (:rleg-ankle-p (&rest args) (forward-message-to RLEG_JOINT4_jt args))
  (:rleg-ankle-r (&rest args) (forward-message-to RLEG_JOINT5_jt args))
  (:lleg-crotch-y (&rest args) (forward-message-to LLEG_JOINT0_jt args))
  (:lleg-crotch-r (&rest args) (forward-message-to LLEG_JOINT1_jt args))
  (:lleg-crotch-p (&rest args) (forward-message-to LLEG_JOINT2_jt args))
  (:lleg-knee-p (&rest args) (forward-message-to LLEG_JOINT3_jt args))
  (:lleg-ankle-p (&rest args) (forward-message-to LLEG_JOINT4_jt args))
  (:lleg-ankle-r (&rest args) (forward-message-to LLEG_JOINT5_jt args))
  (:rarm-crotch-y (&rest args) (forward-message-to RARM_JOINT0_jt args))
  (:rarm-crotch-r (&rest args) (forward-message-to RARM_JOINT1_jt args))
  (:rarm-crotch-p (&rest args) (forward-message-to RARM_JOINT2_jt args))
  (:rarm-knee-p (&rest args) (forward-message-to RARM_JOINT3_jt args))
  (:rarm-ankle-p (&rest args) (forward-message-to RARM_JOINT4_jt args))
  (:rarm-ankle-r (&rest args) (forward-message-to RARM_JOINT5_jt args))
  (:larm-crotch-y (&rest args) (forward-message-to LARM_JOINT0_jt args))
  (:larm-crotch-r (&rest args) (forward-message-to LARM_JOINT1_jt args))
  (:larm-crotch-p (&rest args) (forward-message-to LARM_JOINT2_jt args))
  (:larm-knee-p (&rest args) (forward-message-to LARM_JOINT3_jt args))
  (:larm-ankle-p (&rest args) (forward-message-to LARM_JOINT4_jt args))
  (:larm-ankle-r (&rest args) (forward-message-to LARM_JOINT5_jt args))

  ;; attach_sensor methods
  (:gsensor (&rest args) (forward-message-to gsensor-sensor-coords args))
  (:gyrometer (&rest args) (forward-message-to gyrometer-sensor-coords args))
  (:rfsensor (&rest args) (forward-message-to rfsensor-sensor-coords args))
  (:lfsensor (&rest args) (forward-message-to lfsensor-sensor-coords args))
  (:rasensor (&rest args) (forward-message-to rasensor-sensor-coords args))
  (:lasensor (&rest args) (forward-message-to lasensor-sensor-coords args))

  ;; geometries
  (:_make_instance_WAIST_LINK0_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.2350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 3 2 4 3 4 5 4 2 1 1 6 4 1 0 6 6 0 7 6 7 4 4 7 5 5 7 0 0 3 5))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-1.0000000000000000e+02 -1.4000000000000000e+02 -8.1350000000000000e+02 -1.0000000000000000e+02 -1.4000000000000000e+02 -6.3350000000000000e+02 -1.0000000000000000e+02 1.4000000000000000e+02 -6.3350000000000000e+02 -1.0000000000000000e+02 1.4000000000000000e+02 -8.1350000000000000e+02 7.8000000000000000e+02 1.4000000000000000e+02 -6.3350000000000000e+02 7.8000000000000000e+02 1.4000000000000000e+02 -8.1350000000000000e+02 7.8000000000000000e+02 -1.4000000000000000e+02 -6.3350000000000000e+02 7.8000000000000000e+02 -1.4000000000000000e+02 -8.1350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7999997138977051e+02 1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector 7.7999997138977051e+02 -1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector -1.0000000149011612e+02 -1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector -1.0000000149011612e+02 1.4000000059604645e+02 -6.3349997997283936e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 -1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector -1.0000000149011612e+02 1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector -1.0000000149011612e+02 1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector -1.0000000149011612e+02 -1.4000000059604645e+02 -6.3349997997283936e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7999997138977051e+02 -1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector -1.0000000149011612e+02 -1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector -1.0000000149011612e+02 -1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector 7.7999997138977051e+02 -1.4000000059604645e+02 -6.3349997997283936e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0000000149011612e+02 1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector 7.7999997138977051e+02 1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector 7.7999997138977051e+02 1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector -1.0000000149011612e+02 1.4000000059604645e+02 -6.3349997997283936e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7999997138977051e+02 1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector 7.7999997138977051e+02 -1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector 7.7999997138977051e+02 -1.4000000059604645e+02 -6.3349997997283936e+02) (float-vector 7.7999997138977051e+02 1.4000000059604645e+02 -6.3349997997283936e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7999997138977051e+02 -1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector 7.7999997138977051e+02 1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector -1.0000000149011612e+02 1.4000000059604645e+02 -8.1349998712539673e+02) (float-vector -1.0000000149011612e+02 -1.4000000059604645e+02 -8.1349998712539673e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK0_WgTgjw.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.9000000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 1.9000000000000000e+02 0.0000000000000000e+00 -5.0000198364257812e+01 2.3755299377441406e+02 1.5450900077819824e+01 -5.0000198364257812e+01 2.4000000000000000e+02 0.0000000000000000e+00 4.9999797821044922e+01 2.3755299377441406e+02 1.5450900077819824e+01 4.9999797821044922e+01 2.4000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 1.9000000000000000e+02 0.0000000000000000e+00 -5.0000102996826172e+01 2.3045100402832031e+02 2.9389299392700195e+01 4.9999900817871094e+01 2.3045100402832031e+02 2.9389299392700195e+01 -5.0000102996826172e+01 2.1938900756835938e+02 4.0450801849365234e+01 4.9999900817871094e+01 2.1938900756835938e+02 4.0450801849365234e+01 -5.0000102996826172e+01 2.0545100402832031e+02 4.7552803039550781e+01 4.9999900817871094e+01 2.0545100402832031e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.9000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.9000000000000000e+02 5.0000000000000000e+01 -4.9999900817871094e+01 1.7454899597167969e+02 4.7552803039550781e+01 5.0000102996826172e+01 1.7454899597167969e+02 4.7552803039550781e+01 -4.9999900817871094e+01 1.6061100769042969e+02 4.0450801849365234e+01 5.0000102996826172e+01 1.6061100769042969e+02 4.0450801849365234e+01 -4.9999900817871094e+01 1.4954901123046875e+02 2.9389299392700195e+01 5.0000102996826172e+01 1.4954901123046875e+02 2.9389299392700195e+01 -4.9999797821044922e+01 1.4244699096679688e+02 1.5450900077819824e+01 5.0000198364257812e+01 1.4244699096679688e+02 1.5450900077819824e+01 -4.9999797821044922e+01 1.4000000000000000e+02 6.1232299748215438e-15 5.0000198364257812e+01 1.4000000000000000e+02 6.1232299748215438e-15 -4.9999797821044922e+01 1.4244699096679688e+02 -1.5450900077819824e+01 5.0000198364257812e+01 1.4244699096679688e+02 -1.5450900077819824e+01 -4.9999900817871094e+01 1.4954901123046875e+02 -2.9389299392700195e+01 5.0000102996826172e+01 1.4954901123046875e+02 -2.9389299392700195e+01 -4.9999900817871094e+01 1.6061100769042969e+02 -4.0450801849365234e+01 5.0000102996826172e+01 1.6061100769042969e+02 -4.0450801849365234e+01 -4.9999900817871094e+01 1.7454899597167969e+02 -4.7552803039550781e+01 5.0000102996826172e+01 1.7454899597167969e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.9000000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.9000000000000000e+02 -5.0000000000000000e+01 -5.0000102996826172e+01 2.0545100402832031e+02 -4.7552803039550781e+01 4.9999900817871094e+01 2.0545100402832031e+02 -4.7552803039550781e+01 -5.0000102996826172e+01 2.1938900756835938e+02 -4.0450801849365234e+01 4.9999900817871094e+01 2.1938900756835938e+02 -4.0450801849365234e+01 -5.0000102996826172e+01 2.3045100402832031e+02 -2.9389299392700195e+01 4.9999900817871094e+01 2.3045100402832031e+02 -2.9389299392700195e+01 -5.0000198364257812e+01 2.3755299377441406e+02 -1.5450900077819824e+01 4.9999797821044922e+01 2.3755299377441406e+02 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 1.4954900741577148e+02 2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 1.4954900741577148e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 1.4000000059604645e+02 6.1232301270227765e-15) (float-vector -4.9999799579381943e+01 1.4000000059604645e+02 6.1232301270227765e-15) (float-vector -4.9999799579381943e+01 1.4244699478149414e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 2.1938900649547577e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 1.4000000059604645e+02 6.1232301270227765e-15) (float-vector -4.9999900162220001e+01 1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 1.4954900741577148e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 2.3755300045013428e+02 1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -5.0000198185443878e+01 2.3755300045013428e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 1.4000000059604645e+02 6.1232301270227765e-15) (float-vector 5.0000101327896118e+01 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 1.4000000059604645e+02 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000101327896118e+01 2.1938900649547577e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.1938900649547577e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -5.0000000745058060e+01 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 1.7454899847507477e+02 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 2.1938900649547577e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 2.1938900649547577e+02 -4.0450800210237503e+01) (float-vector -5.0000000745058060e+01 1.8999999761581421e+02 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 2.1938900649547577e+02 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.1938900649547577e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 1.7454899847507477e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 1.7454899847507477e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 1.6061100363731384e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 2.0545099675655365e+02 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 1.4000000059604645e+02 6.1232301270227765e-15) (float-vector 5.0000198185443878e+01 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 1.4954900741577148e+02 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 1.7454899847507477e+02 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 2.1938900649547577e+02 4.0450800210237503e+01) (float-vector 4.9999799579381943e+01 2.3755300045013428e+02 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.1938900649547577e+02 -4.0450800210237503e+01) (float-vector 5.0000000745058060e+01 1.8999999761581421e+02 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 2.3755300045013428e+02 -1.5450900420546532e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK1_4SS2zR.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK3_mIAuF2.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK2_czupff.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK2_eoiGKX.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK2_gVaSdE.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK4_S6quMI.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 7.0000000000000000e+02 -1.9000000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-7.5000000000000000e+02 1.9000000000000000e+02 0.0000000000000000e+00 -7.5000000000000000e+02 2.3755299377441406e+02 1.5450900077819824e+01 -7.5000000000000000e+02 2.4000000000000000e+02 0.0000000000000000e+00 -6.5000000000000000e+02 2.3755299377441406e+02 1.5450900077819824e+01 -6.5000000000000000e+02 2.4000000000000000e+02 0.0000000000000000e+00 -6.5000000000000000e+02 1.9000000000000000e+02 0.0000000000000000e+00 -7.5000000000000000e+02 2.3045100402832031e+02 2.9389299392700195e+01 -6.5000000000000000e+02 2.3045100402832031e+02 2.9389299392700195e+01 -7.5000000000000000e+02 2.1938900756835938e+02 4.0450801849365234e+01 -6.5000000000000000e+02 2.1938900756835938e+02 4.0450801849365234e+01 -7.5000000000000000e+02 2.0545100402832031e+02 4.7552803039550781e+01 -6.5000000000000000e+02 2.0545100402832031e+02 4.7552803039550781e+01 -7.5000000000000000e+02 1.9000000000000000e+02 5.0000000000000000e+01 -6.5000000000000000e+02 1.9000000000000000e+02 5.0000000000000000e+01 -7.5000000000000000e+02 1.7454899597167969e+02 4.7552803039550781e+01 -6.5000000000000000e+02 1.7454899597167969e+02 4.7552803039550781e+01 -7.5000000000000000e+02 1.6061100769042969e+02 4.0450801849365234e+01 -6.5000000000000000e+02 1.6061100769042969e+02 4.0450801849365234e+01 -7.5000000000000000e+02 1.4954901123046875e+02 2.9389299392700195e+01 -6.5000000000000000e+02 1.4954901123046875e+02 2.9389299392700195e+01 -7.5000000000000000e+02 1.4244699096679688e+02 1.5450900077819824e+01 -6.5000000000000000e+02 1.4244699096679688e+02 1.5450900077819824e+01 -7.5000000000000000e+02 1.4000000000000000e+02 6.1232299748215438e-15 -6.5000000000000000e+02 1.4000000000000000e+02 6.1232299748215438e-15 -7.5000000000000000e+02 1.4244699096679688e+02 -1.5450900077819824e+01 -6.5000000000000000e+02 1.4244699096679688e+02 -1.5450900077819824e+01 -7.5000000000000000e+02 1.4954901123046875e+02 -2.9389299392700195e+01 -6.5000000000000000e+02 1.4954901123046875e+02 -2.9389299392700195e+01 -7.5000000000000000e+02 1.6061100769042969e+02 -4.0450801849365234e+01 -6.5000000000000000e+02 1.6061100769042969e+02 -4.0450801849365234e+01 -7.5000000000000000e+02 1.7454899597167969e+02 -4.7552803039550781e+01 -6.5000000000000000e+02 1.7454899597167969e+02 -4.7552803039550781e+01 -7.5000000000000000e+02 1.9000000000000000e+02 -5.0000000000000000e+01 -6.5000000000000000e+02 1.9000000000000000e+02 -5.0000000000000000e+01 -7.5000000000000000e+02 2.0545100402832031e+02 -4.7552803039550781e+01 -6.5000000000000000e+02 2.0545100402832031e+02 -4.7552803039550781e+01 -7.5000000000000000e+02 2.1938900756835938e+02 -4.0450801849365234e+01 -6.5000000000000000e+02 2.1938900756835938e+02 -4.0450801849365234e+01 -7.5000000000000000e+02 2.3045100402832031e+02 -2.9389299392700195e+01 -6.5000000000000000e+02 2.3045100402832031e+02 -2.9389299392700195e+01 -7.5000000000000000e+02 2.3755299377441406e+02 -1.5450900077819824e+01 -6.5000000000000000e+02 2.3755299377441406e+02 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 1.8999999761581421e+02 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 2.3999999463558197e+02 0.0000000000000000e+00) (float-vector -6.4999997615814209e+02 2.3999999463558197e+02 0.0000000000000000e+00) (float-vector -6.4999997615814209e+02 2.3045100271701813e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 2.0545099675655365e+02 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 2.3999999463558197e+02 0.0000000000000000e+00) (float-vector -7.5000000000000000e+02 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 2.3999999463558197e+02 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 2.0545099675655365e+02 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 1.4244699478149414e+02 -1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 1.8999999761581421e+02 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 1.4244699478149414e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -6.4999997615814209e+02 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 1.6061100363731384e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -6.4999997615814209e+02 1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 2.3999999463558197e+02 0.0000000000000000e+00) (float-vector -6.4999997615814209e+02 2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -7.5000000000000000e+02 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -7.5000000000000000e+02 1.8999999761581421e+02 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 2.3999999463558197e+02 0.0000000000000000e+00) (float-vector -7.5000000000000000e+02 2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -7.5000000000000000e+02 1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 1.7454899847507477e+02 -4.7552801668643951e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK1_A3LMOf.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK5_wNgkl6.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -1.8366001313552260e-04 0.0000000000000000e+00 4.9999797821044922e+01 4.7552600860595703e+01 1.5450900077819824e+01 4.9999797821044922e+01 4.9999797821044922e+01 0.0000000000000000e+00 1.5000000000000000e+02 4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 5.0000198364257812e+01 0.0000000000000000e+00 1.5000000000000000e+02 1.8366001313552260e-04 0.0000000000000000e+00 4.9999900817871094e+01 4.0450698852539062e+01 2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 2.9389299392700195e+01 4.9999900817871094e+01 2.9389101028442383e+01 4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 4.0450801849365234e+01 4.9999900817871094e+01 1.5450699806213379e+01 4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 5.0000000000000000e+01 5.0000102996826172e+01 -1.5451000213623047e+01 4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 4.7552803039550781e+01 5.0000102996826172e+01 -2.9389400482177734e+01 4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 4.0450801849365234e+01 5.0000102996826172e+01 -4.0451000213623047e+01 2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 2.9389299392700195e+01 5.0000198364257812e+01 -4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 1.5450900077819824e+01 5.0000198364257812e+01 -5.0000198364257812e+01 6.1232299748215438e-15 1.5000000000000000e+02 -4.9999797821044922e+01 6.1232299748215438e-15 5.0000198364257812e+01 -4.7552997589111328e+01 -1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 -1.5450900077819824e+01 5.0000102996826172e+01 -4.0451000213623047e+01 -2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 -2.9389299392700195e+01 5.0000102996826172e+01 -2.9389400482177734e+01 -4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 -4.0450801849365234e+01 5.0000102996826172e+01 -1.5451000213623047e+01 -4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 -4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 -5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 -5.0000000000000000e+01 4.9999900817871094e+01 1.5450699806213379e+01 -4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 -4.7552803039550781e+01 4.9999900817871094e+01 2.9389101028442383e+01 -4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 -4.0450801849365234e+01 4.9999900817871094e+01 4.0450698852539062e+01 -2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 -2.9389299392700195e+01 4.9999797821044922e+01 4.7552600860595703e+01 -1.5450900077819824e+01 1.5000000000000000e+02 4.7552997589111328e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK6_IzarWt.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK3_UPRDWC.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -1.8366001313552260e-04 0.0000000000000000e+00 4.9999797821044922e+01 4.7552600860595703e+01 1.5450900077819824e+01 4.9999797821044922e+01 4.9999797821044922e+01 0.0000000000000000e+00 1.5000000000000000e+02 4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 5.0000198364257812e+01 0.0000000000000000e+00 1.5000000000000000e+02 1.8366001313552260e-04 0.0000000000000000e+00 4.9999900817871094e+01 4.0450698852539062e+01 2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 2.9389299392700195e+01 4.9999900817871094e+01 2.9389101028442383e+01 4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 4.0450801849365234e+01 4.9999900817871094e+01 1.5450699806213379e+01 4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 5.0000000000000000e+01 5.0000102996826172e+01 -1.5451000213623047e+01 4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 4.7552803039550781e+01 5.0000102996826172e+01 -2.9389400482177734e+01 4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 4.0450801849365234e+01 5.0000102996826172e+01 -4.0451000213623047e+01 2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 2.9389299392700195e+01 5.0000198364257812e+01 -4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 1.5450900077819824e+01 5.0000198364257812e+01 -5.0000198364257812e+01 6.1232299748215438e-15 1.5000000000000000e+02 -4.9999797821044922e+01 6.1232299748215438e-15 5.0000198364257812e+01 -4.7552997589111328e+01 -1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 -1.5450900077819824e+01 5.0000102996826172e+01 -4.0451000213623047e+01 -2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 -2.9389299392700195e+01 5.0000102996826172e+01 -2.9389400482177734e+01 -4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 -4.0450801849365234e+01 5.0000102996826172e+01 -1.5451000213623047e+01 -4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 -4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 -5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 -5.0000000000000000e+01 4.9999900817871094e+01 1.5450699806213379e+01 -4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 -4.7552803039550781e+01 4.9999900817871094e+01 2.9389101028442383e+01 -4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 -4.0450801849365234e+01 4.9999900817871094e+01 4.0450698852539062e+01 -2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 -2.9389299392700195e+01 4.9999797821044922e+01 4.7552600860595703e+01 -1.5450900077819824e+01 1.5000000000000000e+02 4.7552997589111328e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK6_4oXHtR.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.9000000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -1.9000000000000000e+02 0.0000000000000000e+00 -5.0000198364257812e+01 -1.4244699096679688e+02 1.5450900077819824e+01 -5.0000198364257812e+01 -1.4000000000000000e+02 0.0000000000000000e+00 4.9999797821044922e+01 -1.4244699096679688e+02 1.5450900077819824e+01 4.9999797821044922e+01 -1.4000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 -1.9000000000000000e+02 0.0000000000000000e+00 -5.0000102996826172e+01 -1.4954901123046875e+02 2.9389299392700195e+01 4.9999900817871094e+01 -1.4954901123046875e+02 2.9389299392700195e+01 -5.0000102996826172e+01 -1.6061100769042969e+02 4.0450801849365234e+01 4.9999900817871094e+01 -1.6061100769042969e+02 4.0450801849365234e+01 -5.0000102996826172e+01 -1.7454899597167969e+02 4.7552803039550781e+01 4.9999900817871094e+01 -1.7454899597167969e+02 4.7552803039550781e+01 -5.0000000000000000e+01 -1.9000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -1.9000000000000000e+02 5.0000000000000000e+01 -4.9999900817871094e+01 -2.0545100402832031e+02 4.7552803039550781e+01 5.0000102996826172e+01 -2.0545100402832031e+02 4.7552803039550781e+01 -4.9999900817871094e+01 -2.1938900756835938e+02 4.0450801849365234e+01 5.0000102996826172e+01 -2.1938900756835938e+02 4.0450801849365234e+01 -4.9999900817871094e+01 -2.3045100402832031e+02 2.9389299392700195e+01 5.0000102996826172e+01 -2.3045100402832031e+02 2.9389299392700195e+01 -4.9999797821044922e+01 -2.3755299377441406e+02 1.5450900077819824e+01 5.0000198364257812e+01 -2.3755299377441406e+02 1.5450900077819824e+01 -4.9999797821044922e+01 -2.4000000000000000e+02 6.1232299748215438e-15 5.0000198364257812e+01 -2.4000000000000000e+02 6.1232299748215438e-15 -4.9999797821044922e+01 -2.3755299377441406e+02 -1.5450900077819824e+01 5.0000198364257812e+01 -2.3755299377441406e+02 -1.5450900077819824e+01 -4.9999900817871094e+01 -2.3045100402832031e+02 -2.9389299392700195e+01 5.0000102996826172e+01 -2.3045100402832031e+02 -2.9389299392700195e+01 -4.9999900817871094e+01 -2.1938900756835938e+02 -4.0450801849365234e+01 5.0000102996826172e+01 -2.1938900756835938e+02 -4.0450801849365234e+01 -4.9999900817871094e+01 -2.0545100402832031e+02 -4.7552803039550781e+01 5.0000102996826172e+01 -2.0545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.9000000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 -1.9000000000000000e+02 -5.0000000000000000e+01 -5.0000102996826172e+01 -1.7454899597167969e+02 -4.7552803039550781e+01 4.9999900817871094e+01 -1.7454899597167969e+02 -4.7552803039550781e+01 -5.0000102996826172e+01 -1.6061100769042969e+02 -4.0450801849365234e+01 4.9999900817871094e+01 -1.6061100769042969e+02 -4.0450801849365234e+01 -5.0000102996826172e+01 -1.4954901123046875e+02 -2.9389299392700195e+01 4.9999900817871094e+01 -1.4954901123046875e+02 -2.9389299392700195e+01 -5.0000198364257812e+01 -1.4244699096679688e+02 -1.5450900077819824e+01 4.9999797821044922e+01 -1.4244699096679688e+02 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999799579381943e+01 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 -2.3045100271701813e+02 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.3045100271701813e+02 2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 -2.3755300045013428e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 -2.3755300045013428e+02 -1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 -1.6061100363731384e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 -1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 -1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 -2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 -2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -2.3045100271701813e+02 2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 -2.3045100271701813e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 -1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 -1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 -1.4244699478149414e+02 1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 -1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 -1.6061100363731384e+02 4.0450800210237503e+01) (float-vector -5.0000198185443878e+01 -1.4244699478149414e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -2.3755300045013428e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000101327896118e+01 -1.6061100363731384e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 -1.6061100363731384e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -5.0000000745058060e+01 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.0545099675655365e+02 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 -1.6061100363731384e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 -1.6061100363731384e+02 -4.0450800210237503e+01) (float-vector -5.0000000745058060e+01 -1.8999999761581421e+02 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -2.0545099675655365e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.0545099675655365e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 -2.1938900649547577e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -1.6061100363731384e+02 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 -1.6061100363731384e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -2.0545099675655365e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -1.7454899847507477e+02 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 -2.3045100271701813e+02 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -2.0545099675655365e+02 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 -1.6061100363731384e+02 4.0450800210237503e+01) (float-vector 4.9999799579381943e+01 -1.4244699478149414e+02 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 -1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 -1.6061100363731384e+02 -4.0450800210237503e+01) (float-vector 5.0000000745058060e+01 -1.8999999761581421e+02 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 -1.4244699478149414e+02 -1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 -1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -1.4244699478149414e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -1.4244699478149414e+02 -1.5450900420546532e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK1_CsOThA.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK4_8ihwH0.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK3_YNjXfl.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK5_cNHzuo.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK4_EDJ7W4.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK5_klnjct.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -1.8366001313552260e-04 0.0000000000000000e+00 4.9999797821044922e+01 4.7552600860595703e+01 1.5450900077819824e+01 4.9999797821044922e+01 4.9999797821044922e+01 0.0000000000000000e+00 1.5000000000000000e+02 4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 5.0000198364257812e+01 0.0000000000000000e+00 1.5000000000000000e+02 1.8366001313552260e-04 0.0000000000000000e+00 4.9999900817871094e+01 4.0450698852539062e+01 2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 2.9389299392700195e+01 4.9999900817871094e+01 2.9389101028442383e+01 4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 4.0450801849365234e+01 4.9999900817871094e+01 1.5450699806213379e+01 4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 5.0000000000000000e+01 5.0000102996826172e+01 -1.5451000213623047e+01 4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 4.7552803039550781e+01 5.0000102996826172e+01 -2.9389400482177734e+01 4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 4.0450801849365234e+01 5.0000102996826172e+01 -4.0451000213623047e+01 2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 2.9389299392700195e+01 5.0000198364257812e+01 -4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 1.5450900077819824e+01 5.0000198364257812e+01 -5.0000198364257812e+01 6.1232299748215438e-15 1.5000000000000000e+02 -4.9999797821044922e+01 6.1232299748215438e-15 5.0000198364257812e+01 -4.7552997589111328e+01 -1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 -1.5450900077819824e+01 5.0000102996826172e+01 -4.0451000213623047e+01 -2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 -2.9389299392700195e+01 5.0000102996826172e+01 -2.9389400482177734e+01 -4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 -4.0450801849365234e+01 5.0000102996826172e+01 -1.5451000213623047e+01 -4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 -4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 -5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 -5.0000000000000000e+01 4.9999900817871094e+01 1.5450699806213379e+01 -4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 -4.7552803039550781e+01 4.9999900817871094e+01 2.9389101028442383e+01 -4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 -4.0450801849365234e+01 4.9999900817871094e+01 4.0450698852539062e+01 -2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 -2.9389299392700195e+01 4.9999797821044922e+01 4.7552600860595703e+01 -1.5450900077819824e+01 1.5000000000000000e+02 4.7552997589111328e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK6_EDl1jM.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK3_8WniKG.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK2_8OlSzi.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK4_QxJK6q.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK5_C4JfAP.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -1.8366001313552260e-04 0.0000000000000000e+00 4.9999797821044922e+01 4.7552600860595703e+01 1.5450900077819824e+01 4.9999797821044922e+01 4.9999797821044922e+01 0.0000000000000000e+00 1.5000000000000000e+02 4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 5.0000198364257812e+01 0.0000000000000000e+00 1.5000000000000000e+02 1.8366001313552260e-04 0.0000000000000000e+00 4.9999900817871094e+01 4.0450698852539062e+01 2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 2.9389299392700195e+01 4.9999900817871094e+01 2.9389101028442383e+01 4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 4.0450801849365234e+01 4.9999900817871094e+01 1.5450699806213379e+01 4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 5.0000000000000000e+01 5.0000102996826172e+01 -1.5451000213623047e+01 4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 4.7552803039550781e+01 5.0000102996826172e+01 -2.9389400482177734e+01 4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 4.0450801849365234e+01 5.0000102996826172e+01 -4.0451000213623047e+01 2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 2.9389299392700195e+01 5.0000198364257812e+01 -4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 1.5450900077819824e+01 5.0000198364257812e+01 -5.0000198364257812e+01 6.1232299748215438e-15 1.5000000000000000e+02 -4.9999797821044922e+01 6.1232299748215438e-15 5.0000198364257812e+01 -4.7552997589111328e+01 -1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 -1.5450900077819824e+01 5.0000102996826172e+01 -4.0451000213623047e+01 -2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 -2.9389299392700195e+01 5.0000102996826172e+01 -2.9389400482177734e+01 -4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 -4.0450801849365234e+01 5.0000102996826172e+01 -1.5451000213623047e+01 -4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 -4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 -5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 -5.0000000000000000e+01 4.9999900817871094e+01 1.5450699806213379e+01 -4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 -4.7552803039550781e+01 4.9999900817871094e+01 2.9389101028442383e+01 -4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 -4.0450801849365234e+01 4.9999900817871094e+01 4.0450698852539062e+01 -2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 -2.9389299392700195e+01 4.9999797821044922e+01 4.7552600860595703e+01 -1.5450900077819824e+01 1.5000000000000000e+02 4.7552997589111328e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK6_kfGlVc.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 7.0000000000000000e+02 1.9000000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-7.5000000000000000e+02 -1.9000000000000000e+02 0.0000000000000000e+00 -7.5000000000000000e+02 -1.4244699096679688e+02 1.5450900077819824e+01 -7.5000000000000000e+02 -1.4000000000000000e+02 0.0000000000000000e+00 -6.5000000000000000e+02 -1.4244699096679688e+02 1.5450900077819824e+01 -6.5000000000000000e+02 -1.4000000000000000e+02 0.0000000000000000e+00 -6.5000000000000000e+02 -1.9000000000000000e+02 0.0000000000000000e+00 -7.5000000000000000e+02 -1.4954901123046875e+02 2.9389299392700195e+01 -6.5000000000000000e+02 -1.4954901123046875e+02 2.9389299392700195e+01 -7.5000000000000000e+02 -1.6061100769042969e+02 4.0450801849365234e+01 -6.5000000000000000e+02 -1.6061100769042969e+02 4.0450801849365234e+01 -7.5000000000000000e+02 -1.7454899597167969e+02 4.7552803039550781e+01 -6.5000000000000000e+02 -1.7454899597167969e+02 4.7552803039550781e+01 -7.5000000000000000e+02 -1.9000000000000000e+02 5.0000000000000000e+01 -6.5000000000000000e+02 -1.9000000000000000e+02 5.0000000000000000e+01 -7.5000000000000000e+02 -2.0545100402832031e+02 4.7552803039550781e+01 -6.5000000000000000e+02 -2.0545100402832031e+02 4.7552803039550781e+01 -7.5000000000000000e+02 -2.1938900756835938e+02 4.0450801849365234e+01 -6.5000000000000000e+02 -2.1938900756835938e+02 4.0450801849365234e+01 -7.5000000000000000e+02 -2.3045100402832031e+02 2.9389299392700195e+01 -6.5000000000000000e+02 -2.3045100402832031e+02 2.9389299392700195e+01 -7.5000000000000000e+02 -2.3755299377441406e+02 1.5450900077819824e+01 -6.5000000000000000e+02 -2.3755299377441406e+02 1.5450900077819824e+01 -7.5000000000000000e+02 -2.4000000000000000e+02 6.1232299748215438e-15 -6.5000000000000000e+02 -2.4000000000000000e+02 6.1232299748215438e-15 -7.5000000000000000e+02 -2.3755299377441406e+02 -1.5450900077819824e+01 -6.5000000000000000e+02 -2.3755299377441406e+02 -1.5450900077819824e+01 -7.5000000000000000e+02 -2.3045100402832031e+02 -2.9389299392700195e+01 -6.5000000000000000e+02 -2.3045100402832031e+02 -2.9389299392700195e+01 -7.5000000000000000e+02 -2.1938900756835938e+02 -4.0450801849365234e+01 -6.5000000000000000e+02 -2.1938900756835938e+02 -4.0450801849365234e+01 -7.5000000000000000e+02 -2.0545100402832031e+02 -4.7552803039550781e+01 -6.5000000000000000e+02 -2.0545100402832031e+02 -4.7552803039550781e+01 -7.5000000000000000e+02 -1.9000000000000000e+02 -5.0000000000000000e+01 -6.5000000000000000e+02 -1.9000000000000000e+02 -5.0000000000000000e+01 -7.5000000000000000e+02 -1.7454899597167969e+02 -4.7552803039550781e+01 -6.5000000000000000e+02 -1.7454899597167969e+02 -4.7552803039550781e+01 -7.5000000000000000e+02 -1.6061100769042969e+02 -4.0450801849365234e+01 -6.5000000000000000e+02 -1.6061100769042969e+02 -4.0450801849365234e+01 -7.5000000000000000e+02 -1.4954901123046875e+02 -2.9389299392700195e+01 -6.5000000000000000e+02 -1.4954901123046875e+02 -2.9389299392700195e+01 -7.5000000000000000e+02 -1.4244699096679688e+02 -1.5450900077819824e+01 -6.5000000000000000e+02 -1.4244699096679688e+02 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.8999999761581421e+02 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 -1.4000000059604645e+02 0.0000000000000000e+00) (float-vector -6.4999997615814209e+02 -1.4000000059604645e+02 0.0000000000000000e+00) (float-vector -6.4999997615814209e+02 -1.4954900741577148e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 -1.7454899847507477e+02 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -1.4000000059604645e+02 0.0000000000000000e+00) (float-vector -7.5000000000000000e+02 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -1.4000000059604645e+02 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 -1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -1.7454899847507477e+02 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 -1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 -2.3755300045013428e+02 -1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 -1.8999999761581421e+02 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 -2.3755300045013428e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 -1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -7.5000000000000000e+02 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -7.5000000000000000e+02 -1.8999999761581421e+02 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 -1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -6.4999997615814209e+02 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -6.4999997615814209e+02 -1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -6.4999997615814209e+02 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -6.4999997615814209e+02 -1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -1.4000000059604645e+02 0.0000000000000000e+00) (float-vector -6.4999997615814209e+02 -1.4954900741577148e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4999997615814209e+02 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -6.4999997615814209e+02 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 -2.1938900649547577e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 -1.8999999761581421e+02 -5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 -1.7454899847507477e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 -1.4954900741577148e+02 -2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 -1.4000000059604645e+02 0.0000000000000000e+00) (float-vector -7.5000000000000000e+02 -1.4954900741577148e+02 2.9389299452304840e+01) (float-vector -7.5000000000000000e+02 -1.7454899847507477e+02 4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 -1.8999999761581421e+02 5.0000000745058060e+01) (float-vector -7.5000000000000000e+02 -2.1938900649547577e+02 4.0450800210237503e+01) (float-vector -7.5000000000000000e+02 -2.3755300045013428e+02 1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 -2.3755300045013428e+02 -1.5450900420546532e+01) (float-vector -7.5000000000000000e+02 -2.3045100271701813e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000000000000000e+02 -2.0545099675655365e+02 -4.7552801668643951e+01) (float-vector -7.5000000000000000e+02 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -2.3045100271701813e+02 -2.9389299452304840e+01) (float-vector -6.4999997615814209e+02 -2.0545099675655365e+02 -4.7552801668643951e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK1_oNkhrU.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  )


(provide :Sample4LegRobot "(ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:24:16 PST")

