;;
;; DO NOT EDIT THIS FILE
;;
;; this file is automatically generated from /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/models/samplerobot.l on (Linux ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:34:37 PST
;;
;; /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/obj-arm-linux-gnueabihf $ ;;

;;
;; copy euscollada-robot class definition from euscollada/src/euscollada-robot.l
;;
(defclass euscollada-robot
;; This euscollada-robot class is for robots converted from collada files.
;; This class provides :init-ending override.
  :super robot-model
  :slots ()
  )
(defmethod euscollada-robot
  (:init-ending
   (&optional (type :urdf))
   (when (eq type :collada)
     ;; fix all links' mass properties ;; root link relative (collada) -> link local (euslisp)
     (dolist (l (append links
                        (mapcan #'(lambda (x) (if (and (derivedp (cdr x) bodyset-link)
                                                       (not (memq (cdr x) links)))
                                                  (list (cdr x)))) (send self :slots))))
       (unless (= (send l :weight) 0.0)
       (setq (l . acentroid) (send l :inverse-transform-vector
                                   (send (send (car links) :worldcoords) :transform-vector
                                         (l . acentroid))))
       (setq (l . inertia-tensor) (m* (transpose (send l :worldrot))
                                      (m* (send (car links) :worldrot)
                                          (l . inertia-tensor))))
       )))
   (send-super :init-ending)
   (send self :make-collision-model-for-links)
   ;;
   (dolist (j (mapcan #'(lambda (x) (if (and (derivedp (cdr x) joint)
                                             (not (memq (cdr x) (send self :joint-list))))
                                        (list (cdr x)))) (send self :slots)))
     (send (send j :child-link) :add-joint j)
     (send (send j :child-link) :add-parent-link (send j :parent-link))
     (send (send j :parent-link) :add-child-links (send j :child-link)))
   )
  (:change-visual
   (&optional (visual :convex))
   (dolist (lk (send self :links))
     (dolist (bd (send lk :bodies))
       (when (derivedp bd collada-body)
         (send bd :change-visual visual)))))
  ;; fullbody-inverse-kinematics overwrite
  ;;  reduce root-link's weight based on leg's joint limit
  ;;  increase stop and cog-gain
  (:fullbody-inverse-kinematics
   (target-coords &rest args &key (stop 250) (cog-gain 2.0) (additional-weight-list) (use-6dof-joint-leg-gain nil) &allow-other-keys)
   (let* ((leg-ul (send self :calc-union-link-list (send self :legs :links))))
     (send self :reset-joint-angle-limit-weight-old leg-ul)
     (send-message* self robot-model :fullbody-inverse-kinematics
                    target-coords
                    :stop stop :cog-gain cog-gain
                    :additional-weight-list
                    (append
                     additional-weight-list
                     (if use-6dof-joint-leg-gain
                         (list
                          (list (car (send self :links))
                                #'(lambda ()
                                    ;; set root-link 6dof-joint's weight based on legs' joint limit
                                    (let* ((min-weight
                                            (reduce #'(lambda (x y) (min x y))
                                                    (coerce (send self :calc-inverse-kinematics-weight-from-link-list
                                                                  leg-ul :union-link-list leg-ul) cons))))
                                      (fill (instantiate float-vector 6) min-weight)))
                                )
                          )))
                    args)
     ))
  ;; make collision model from faces or gl-vertices
  (:make-collision-model-for-links
   (&key (fat 0) (collision-func 'pqp-collision-check) ((:links ls) (send self :links)))
   (dolist (ll ls)
     (let (fs glv usefs)
       (dolist (bd (send ll :bodies))
         (if (derivedp bd collada-body)
             (push (send bd :glvertices) glv)
           (push (send bd :faces) fs)))
       (setq fs (flatten fs))
       (cond
        ((and (not fs) glv) ;; if there is no faces, use glvertices for creating pqpmodel
         (setq usefs (instance gl::glvertices :init nil))
         (send usefs :transform (send ll :worldcoords))
         (send usefs :append-glvertices glv)
         (let ((m (send usefs (read-from-string
                               (format nil ":make-~Amodel"
                                       (string-right-trim "-COLLISION-CHECK" (string collision-func))))
                        :fat fat)))
           (setf (get ll :pqpmodel) m)
           ))
        (fs
         (setq usefs
               (append fs
                       (mapcar #'(lambda (gv) (send gv :convert-to-faces :wrt :world)) glv)))
         (send ll
               (read-from-string
                (format nil ":make-~Amodel"
                        (string-right-trim "-COLLISION-CHECK" (string collision-func))))
               :fat fat
               :faces usefs))
        ))
     ))
  )

;; copy euscollada-body class definition from euscollada/src/euscollada-robot.l
;; This euscollada-body class is for bodies in robot model converted from collada files.
(defclass collada-body
  :super gl::glbody
  :slots (glvertices) ;; glvertices slot for backward compatibility
  )
(defmethod collada-body
  (:init (&key (name) (replace-obj))
    (if replace-obj
        (replace-object self replace-obj)
      (replace-object self (make-cube 10 10 10)))
    (if name (send self :name name))
    (setq glvertices gl::aglvertices)
    self)
  (:change-visual
   (&optional (visual :convex))
   (case visual
     ((list :convex :hull :convex-hull)
      (unless (send self :get :original-mesh)
        (send self :put :original-mesh gl::aglvertices)) ;; store original mesh
      (let* ((org-mesh (send self :get :original-mesh))
             (org-cds (send org-mesh :copy-worldcoords))
             (glv (gl::make-glvertices-from-faces (send self :faces))))
        (send glv :set-offset (send org-cds :inverse-transformation))
        (send glv :transform org-cds)
        (send org-mesh :assoc glv)
        (setq gl::aglvertices glv)
        glv))
     ((list :original :mesh :glvertices :original-mesh)
      (let ((org-mesh (send self :get :original-mesh)))
        (when org-mesh
          (dolist (d (send org-mesh :descendants)) ;; dissoc all discendants
            (send org-mesh :dissoc d))
          (setq gl::aglvertices org-mesh)
          org-mesh)))
     ))
  )
;;
;; end of copy from /opt/ros/melodic/share/euscollada/src/euscollada-robot.l
;;
(defun SampleRobot () (setq *SampleRobot* (instance SampleRobot-robot :init)))

(defclass SampleRobot-robot
  :super euscollada-robot
  :slots ( ;; link names
          LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk LARM_LINK7_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk RARM_LINK7_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk WAIST_LINK0_lk WAIST_LINK1_lk WAIST_LINK2_lk WAIST_LINK3_lk
         ;; joint names
          CHEST_jt LARM_ELBOW_jt LARM_SHOULDER_P_jt LARM_SHOULDER_R_jt LARM_SHOULDER_Y_jt LARM_WRIST_P_jt LARM_WRIST_R_jt LARM_WRIST_Y_jt LLEG_ANKLE_P_jt LLEG_ANKLE_R_jt LLEG_HIP_P_jt LLEG_HIP_R_jt LLEG_HIP_Y_jt LLEG_KNEE_jt RARM_ELBOW_jt RARM_SHOULDER_P_jt RARM_SHOULDER_R_jt RARM_SHOULDER_Y_jt RARM_WRIST_P_jt RARM_WRIST_R_jt RARM_WRIST_Y_jt RLEG_ANKLE_P_jt RLEG_ANKLE_R_jt RLEG_HIP_P_jt RLEG_HIP_R_jt RLEG_HIP_Y_jt RLEG_KNEE_jt WAIST_P_jt WAIST_R_jt
         ;; sensor names
          gsensor-sensor-coords gyrometer-sensor-coords VISION_SENSOR1-sensor-coords VISION_SENSOR2-sensor-coords lhsensor-sensor-coords rhsensor-sensor-coords lfsensor-sensor-coords rfsensor-sensor-coords
         )
  )
(defmethod SampleRobot-robot
  (:init
   (&rest args)
   (let ()
     (send-super* :init :name "SampleRobot" args)

     ;; link: WAIST_LINK0_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK0_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK0_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK0"))
       ;; inertial parameter for WAIST_LINK0_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.7500000000000000e+01))
                      ))
         (send WAIST_LINK0_lk :weight 27000.000)
         (setq (WAIST_LINK0_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 9.6482000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 9.6482000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.8800000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK0_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK0_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                        ))
         (send WAIST_LINK0_lk :transform world-cds))
       )

     ;; link: WAIST_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK1"))
       ;; inertial parameter for WAIST_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.5511151231257827e-14))
                      ))
         (send WAIST_LINK1_lk :weight 6000.000)
         (setq (WAIST_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.1870000000000005e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.8750000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.1870000000000005e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7600000000000000e+02))
                        ))
         (send WAIST_LINK1_lk :transform world-cds))
       )

     ;; link: WAIST_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK2"))
       ;; inertial parameter for WAIST_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.6000000000000003e+02))
                      ))
         (send WAIST_LINK2_lk :weight 30000.000)
         (setq (WAIST_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.7000000000000000e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.7000000000000000e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7600000000000000e+02))
                        ))
         (send WAIST_LINK2_lk :transform world-cds))
       )

     ;; link: WAIST_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK3"))
       ;; inertial parameter for WAIST_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.0000000000000185e+01))
                      ))
         (send WAIST_LINK3_lk :weight 13000.000)
         (setq (WAIST_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.7000000000000000e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.1500000000000000e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.0260000000000000e+08))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.2600000000000000e+02))
                        ))
         (send WAIST_LINK3_lk :transform world-cds))
       )

     ;; link: LARM_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK1"))
       ;; inertial parameter for LARM_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -5.0000000000000014e+01 2.2204460492503131e-13))
                      ))
         (send LARM_LINK1_lk :weight 400.000)
         (setq (LARM_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2500000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.4600000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 5.2600000000000000e+02))
                        ))
         (send LARM_LINK1_lk :transform world-cds))
       )

     ;; link: RARM_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK4"))
       ;; inertial parameter for RARM_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -9.9999999999999787e+01))
                      ))
         (send RARM_LINK4_lk :weight 2200.000)
         (setq (RARM_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.5729999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 7.5729999999999991e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 9.1699999999999988e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 2.6300000000000000e+02))
                        ))
         (send RARM_LINK4_lk :transform world-cds))
       )

     ;; link: LARM_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK2"))
       ;; inertial parameter for LARM_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -9.9999999999999758e+01))
                      ))
         (send LARM_LINK2_lk :weight 2200.000)
         (setq (LARM_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 8.7760000000000019e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.7760000000000019e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 9.1699999999999988e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 5.2600000000000000e+02))
                        ))
         (send LARM_LINK2_lk :transform world-cds))
       )

     ;; link: RLEG_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK6"))
       ;; inertial parameter for RLEG_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 -3.0000000000000028e+01))
                      ))
         (send RLEG_LINK6_lk :weight 1900.000)
         (setq (RLEG_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -6.5350000000000000e+02))
                        ))
         (send RLEG_LINK6_lk :transform world-cds))
       )

     ;; link: RARM_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK6"))
       ;; inertial parameter for RARM_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.0000000000000009e+01 -8.9999999999999758e+01))
                      ))
         (send RARM_LINK6_lk :weight 400.000)
         (setq (RARM_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.8510000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.7710000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.4700000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 1.6000000000000014e+01))
                        ))
         (send RARM_LINK6_lk :transform world-cds))
       )

     ;; link: RARM_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK2"))
       ;; inertial parameter for RARM_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -9.9999999999999758e+01))
                      ))
         (send RARM_LINK2_lk :weight 2200.000)
         (setq (RARM_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 8.7760000000000019e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.7760000000000019e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 9.1699999999999988e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 5.2600000000000000e+02))
                        ))
         (send RARM_LINK2_lk :transform world-cds))
       )

     ;; link: LARM_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK3"))
       ;; inertial parameter for LARM_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.0000000000000213e+01))
                      ))
         (send LARM_LINK3_lk :weight 400.000)
         (setq (LARM_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.4600000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.4600000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 2.6300000000000000e+02))
                        ))
         (send LARM_LINK3_lk :transform world-cds))
       )

     ;; link: LARM_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK4"))
       ;; inertial parameter for LARM_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -9.9999999999999787e+01))
                      ))
         (send LARM_LINK4_lk :weight 2200.000)
         (setq (LARM_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.5729999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 7.5729999999999991e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 9.1699999999999988e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 2.6300000000000000e+02))
                        ))
         (send LARM_LINK4_lk :transform world-cds))
       )

     ;; link: RARM_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK1"))
       ;; inertial parameter for RARM_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 5.0000000000000014e+01 2.2204460492503131e-13))
                      ))
         (send RARM_LINK1_lk :weight 400.000)
         (setq (RARM_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2500000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.4600000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 5.2600000000000000e+02))
                        ))
         (send RARM_LINK1_lk :transform world-cds))
       )

     ;; link: LARM_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK5"))
       ;; inertial parameter for LARM_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.0000000000000242e+01))
                      ))
         (send LARM_LINK5_lk :weight 400.000)
         (setq (LARM_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.4600000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.4600000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 1.6000000000000014e+01))
                        ))
         (send LARM_LINK5_lk :transform world-cds))
       )

     ;; link: LLEG_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK6"))
       ;; inertial parameter for LLEG_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 -3.0000000000000028e+01))
                      ))
         (send LLEG_LINK6_lk :weight 1900.000)
         (setq (LLEG_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -6.5350000000000000e+02))
                        ))
         (send LLEG_LINK6_lk :transform world-cds))
       )

     ;; link: LARM_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK6"))
       ;; inertial parameter for LARM_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.0000000000000009e+01 -8.9999999999999758e+01))
                      ))
         (send LARM_LINK6_lk :weight 400.000)
         (setq (LARM_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.8510000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.7710000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.4700000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 1.6000000000000014e+01))
                        ))
         (send LARM_LINK6_lk :transform world-cds))
       )

     ;; link: RLEG_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK3"))
       ;; inertial parameter for RLEG_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send RLEG_LINK3_lk :weight 5100.000)
         (setq (RLEG_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -3.5350000000000000e+02))
                        ))
         (send RLEG_LINK3_lk :transform world-cds))
       )

     ;; link: RARM_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK5"))
       ;; inertial parameter for RARM_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.0000000000000242e+01))
                      ))
         (send RARM_LINK5_lk :weight 400.000)
         (setq (RARM_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.4600000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.4600000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 1.6000000000000014e+01))
                        ))
         (send RARM_LINK5_lk :transform world-cds))
       )

     ;; link: LLEG_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK2"))
       ;; inertial parameter for LLEG_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK2_lk :weight 2000.000)
         (setq (LLEG_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send LLEG_LINK2_lk :transform world-cds))
       )

     ;; link: LLEG_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK1"))
       ;; inertial parameter for LLEG_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK1_lk :weight 2500.000)
         (setq (LLEG_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send LLEG_LINK1_lk :transform world-cds))
       )

     ;; link: LARM_LINK7_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LARM_LINK7_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LARM_LINK7_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LARM_LINK7"))
       ;; inertial parameter for LARM_LINK7_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -3.0000000000000000e+01 -9.9999999999999787e+01))
                      ))
         (send LARM_LINK7_lk :weight 400.000)
         (setq (LARM_LINK7_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.8000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.3300000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1299999999999999e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LARM_LINK7_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LARM_LINK7_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 1.6000000000000014e+01))
                        ))
         (send LARM_LINK7_lk :transform world-cds))
       )

     ;; link: RARM_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK3"))
       ;; inertial parameter for RARM_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.0000000000000213e+01))
                      ))
         (send RARM_LINK3_lk :weight 400.000)
         (setq (RARM_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.4600000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.4600000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 2.6300000000000000e+02))
                        ))
         (send RARM_LINK3_lk :transform world-cds))
       )

     ;; link: RLEG_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK2"))
       ;; inertial parameter for RLEG_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK2_lk :weight 2000.000)
         (setq (RLEG_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send RLEG_LINK2_lk :transform world-cds))
       )

     ;; link: RARM_LINK7_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RARM_LINK7_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RARM_LINK7_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RARM_LINK7"))
       ;; inertial parameter for RARM_LINK7_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 3.0000000000000000e+01 -9.9999999999999787e+01))
                      ))
         (send RARM_LINK7_lk :weight 400.000)
         (setq (RARM_LINK7_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 7.8000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.3300000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1299999999999999e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RARM_LINK7_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RARM_LINK7_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 1.6000000000000014e+01))
                        ))
         (send RARM_LINK7_lk :transform world-cds))
       )

     ;; link: LLEG_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK3"))
       ;; inertial parameter for LLEG_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send LLEG_LINK3_lk :weight 5100.000)
         (setq (LLEG_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -3.5350000000000000e+02))
                        ))
         (send LLEG_LINK3_lk :transform world-cds))
       )

     ;; link: RLEG_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK4"))
       ;; inertial parameter for RLEG_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send RLEG_LINK4_lk :weight 7000.000)
         (setq (RLEG_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -3.5350000000000000e+02))
                        ))
         (send RLEG_LINK4_lk :transform world-cds))
       )

     ;; link: RLEG_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK1"))
       ;; inertial parameter for RLEG_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK1_lk :weight 2500.000)
         (setq (RLEG_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send RLEG_LINK1_lk :transform world-cds))
       )

     ;; link: LLEG_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK4"))
       ;; inertial parameter for LLEG_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send LLEG_LINK4_lk :weight 7000.000)
         (setq (LLEG_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -3.5350000000000000e+02))
                        ))
         (send LLEG_LINK4_lk :transform world-cds))
       )

     ;; link: LLEG_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK5"))
       ;; inertial parameter for LLEG_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK5_lk :weight 2500.000)
         (setq (LLEG_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -6.5350000000000000e+02))
                        ))
         (send LLEG_LINK5_lk :transform world-cds))
       )

     ;; link: RLEG_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK5"))
       ;; inertial parameter for RLEG_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK5_lk :weight 2500.000)
         (setq (RLEG_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -6.5350000000000000e+02))
                        ))
         (send RLEG_LINK5_lk :transform world-cds))
       )

     (send WAIST_LINK2_lk :assoc WAIST_LINK3_lk)
     (send LARM_LINK3_lk :assoc LARM_LINK4_lk)
     (send WAIST_LINK3_lk :assoc LARM_LINK1_lk)
     (send LARM_LINK1_lk :assoc LARM_LINK2_lk)
     (send LARM_LINK2_lk :assoc LARM_LINK3_lk)
     (send LARM_LINK5_lk :assoc LARM_LINK6_lk)
     (send LARM_LINK6_lk :assoc LARM_LINK7_lk)
     (send LARM_LINK4_lk :assoc LARM_LINK5_lk)
     (send LLEG_LINK4_lk :assoc LLEG_LINK5_lk)
     (send LLEG_LINK5_lk :assoc LLEG_LINK6_lk)
     (send LLEG_LINK1_lk :assoc LLEG_LINK2_lk)
     (send WAIST_LINK0_lk :assoc LLEG_LINK1_lk)
     (send LLEG_LINK2_lk :assoc LLEG_LINK3_lk)
     (send LLEG_LINK3_lk :assoc LLEG_LINK4_lk)
     (send RARM_LINK3_lk :assoc RARM_LINK4_lk)
     (send WAIST_LINK3_lk :assoc RARM_LINK1_lk)
     (send RARM_LINK1_lk :assoc RARM_LINK2_lk)
     (send RARM_LINK2_lk :assoc RARM_LINK3_lk)
     (send RARM_LINK5_lk :assoc RARM_LINK6_lk)
     (send RARM_LINK6_lk :assoc RARM_LINK7_lk)
     (send RARM_LINK4_lk :assoc RARM_LINK5_lk)
     (send RLEG_LINK4_lk :assoc RLEG_LINK5_lk)
     (send RLEG_LINK5_lk :assoc RLEG_LINK6_lk)
     (send RLEG_LINK1_lk :assoc RLEG_LINK2_lk)
     (send WAIST_LINK0_lk :assoc RLEG_LINK1_lk)
     (send RLEG_LINK2_lk :assoc RLEG_LINK3_lk)
     (send RLEG_LINK3_lk :assoc RLEG_LINK4_lk)
     (send WAIST_LINK0_lk :assoc WAIST_LINK1_lk)
     (send WAIST_LINK1_lk :assoc WAIST_LINK2_lk)
     (send self :assoc WAIST_LINK0_lk)

     ;; joint models
     ;; joint: CHEST_jt
     (setq CHEST_jt
           (instance rotational-joint :init
                     :name "CHEST"
                     :parent-link WAIST_LINK2_lk :child-link WAIST_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_ELBOW_jt
     (setq LARM_ELBOW_jt
           (instance rotational-joint :init
                     :name "LARM_ELBOW"
                     :parent-link LARM_LINK3_lk :child-link LARM_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -149.999779 :max 10.000004
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_SHOULDER_P_jt
     (setq LARM_SHOULDER_P_jt
           (instance rotational-joint :init
                     :name "LARM_SHOULDER_P"
                     :parent-link WAIST_LINK3_lk :child-link LARM_LINK1_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -179.999855 :max 90.000207
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_SHOULDER_R_jt
     (setq LARM_SHOULDER_R_jt
           (instance rotational-joint :init
                     :name "LARM_SHOULDER_R"
                     :parent-link LARM_LINK1_lk :child-link LARM_LINK2_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -14.999978 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_SHOULDER_Y_jt
     (setq LARM_SHOULDER_Y_jt
           (instance rotational-joint :init
                     :name "LARM_SHOULDER_Y"
                     :parent-link LARM_LINK2_lk :child-link LARM_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -120.000277 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_WRIST_P_jt
     (setq LARM_WRIST_P_jt
           (instance rotational-joint :init
                     :name "LARM_WRIST_P"
                     :parent-link LARM_LINK5_lk :child-link LARM_LINK6_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -120.000277 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_WRIST_R_jt
     (setq LARM_WRIST_R_jt
           (instance rotational-joint :init
                     :name "LARM_WRIST_R"
                     :parent-link LARM_LINK6_lk :child-link LARM_LINK7_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -75.000176 :max 6.999997
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LARM_WRIST_Y_jt
     (setq LARM_WRIST_Y_jt
           (instance rotational-joint :init
                     :name "LARM_WRIST_Y"
                     :parent-link LARM_LINK4_lk :child-link LARM_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -120.000277 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_ANKLE_P_jt
     (setq LLEG_ANKLE_P_jt
           (instance rotational-joint :init
                     :name "LLEG_ANKLE_P"
                     :parent-link LLEG_LINK4_lk :child-link LLEG_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_ANKLE_R_jt
     (setq LLEG_ANKLE_R_jt
           (instance rotational-joint :init
                     :name "LLEG_ANKLE_R"
                     :parent-link LLEG_LINK5_lk :child-link LLEG_LINK6_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_P_jt
     (setq LLEG_HIP_P_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_P"
                     :parent-link LLEG_LINK1_lk :child-link LLEG_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_R_jt
     (setq LLEG_HIP_R_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_R"
                     :parent-link WAIST_LINK0_lk :child-link LLEG_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_Y_jt
     (setq LLEG_HIP_Y_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_Y"
                     :parent-link LLEG_LINK2_lk :child-link LLEG_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_KNEE_jt
     (setq LLEG_KNEE_jt
           (instance rotational-joint :init
                     :name "LLEG_KNEE"
                     :parent-link LLEG_LINK3_lk :child-link LLEG_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_ELBOW_jt
     (setq RARM_ELBOW_jt
           (instance rotational-joint :init
                     :name "RARM_ELBOW"
                     :parent-link RARM_LINK3_lk :child-link RARM_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -149.999779 :max 10.000004
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_SHOULDER_P_jt
     (setq RARM_SHOULDER_P_jt
           (instance rotational-joint :init
                     :name "RARM_SHOULDER_P"
                     :parent-link WAIST_LINK3_lk :child-link RARM_LINK1_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -179.999855 :max 90.000207
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_SHOULDER_R_jt
     (setq RARM_SHOULDER_R_jt
           (instance rotational-joint :init
                     :name "RARM_SHOULDER_R"
                     :parent-link RARM_LINK1_lk :child-link RARM_LINK2_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -120.000277 :max 14.999978
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_SHOULDER_Y_jt
     (setq RARM_SHOULDER_Y_jt
           (instance rotational-joint :init
                     :name "RARM_SHOULDER_Y"
                     :parent-link RARM_LINK2_lk :child-link RARM_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -120.000277 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_WRIST_P_jt
     (setq RARM_WRIST_P_jt
           (instance rotational-joint :init
                     :name "RARM_WRIST_P"
                     :parent-link RARM_LINK5_lk :child-link RARM_LINK6_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -120.000277 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_WRIST_R_jt
     (setq RARM_WRIST_R_jt
           (instance rotational-joint :init
                     :name "RARM_WRIST_R"
                     :parent-link RARM_LINK6_lk :child-link RARM_LINK7_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                     :min -6.999997 :max 75.000176
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RARM_WRIST_Y_jt
     (setq RARM_WRIST_Y_jt
           (instance rotational-joint :init
                     :name "RARM_WRIST_Y"
                     :parent-link RARM_LINK4_lk :child-link RARM_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -120.000277 :max 120.000277
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_ANKLE_P_jt
     (setq RLEG_ANKLE_P_jt
           (instance rotational-joint :init
                     :name "RLEG_ANKLE_P"
                     :parent-link RLEG_LINK4_lk :child-link RLEG_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_ANKLE_R_jt
     (setq RLEG_ANKLE_R_jt
           (instance rotational-joint :init
                     :name "RLEG_ANKLE_R"
                     :parent-link RLEG_LINK5_lk :child-link RLEG_LINK6_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_P_jt
     (setq RLEG_HIP_P_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_P"
                     :parent-link RLEG_LINK1_lk :child-link RLEG_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_R_jt
     (setq RLEG_HIP_R_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_R"
                     :parent-link WAIST_LINK0_lk :child-link RLEG_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_Y_jt
     (setq RLEG_HIP_Y_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_Y"
                     :parent-link RLEG_LINK2_lk :child-link RLEG_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_KNEE_jt
     (setq RLEG_KNEE_jt
           (instance rotational-joint :init
                     :name "RLEG_KNEE"
                     :parent-link RLEG_LINK3_lk :child-link RLEG_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: WAIST_P_jt
     (setq WAIST_P_jt
           (instance rotational-joint :init
                     :name "WAIST_P"
                     :parent-link WAIST_LINK0_lk :child-link WAIST_LINK1_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: WAIST_R_jt
     (setq WAIST_R_jt
           (instance rotational-joint :init
                     :name "WAIST_R"
                     :parent-link WAIST_LINK1_lk :child-link WAIST_LINK2_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; end coords from yaml file
     (setq rleg-end-coords (make-cascoords :coords (send RLEG_LINK6_lk :copy-worldcoords) :name :rleg-end-coords))
     (send rleg-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01))
     (send RLEG_LINK6_lk :assoc rleg-end-coords)
     (setq rarm-end-coords (make-cascoords :coords (send RARM_LINK6_lk :copy-worldcoords) :name :rarm-end-coords))
     (send rarm-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
     (send rarm-end-coords :rotate 1.5707963267948966e+00 (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00))
     (send RARM_LINK6_lk :assoc rarm-end-coords)
     (setq lleg-end-coords (make-cascoords :coords (send LLEG_LINK6_lk :copy-worldcoords) :name :lleg-end-coords))
     (send lleg-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01))
     (send LLEG_LINK6_lk :assoc lleg-end-coords)
     (setq larm-end-coords (make-cascoords :coords (send LARM_LINK6_lk :copy-worldcoords) :name :larm-end-coords))
     (send larm-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
     (send larm-end-coords :rotate 1.5707963267948966e+00 (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00))
     (send LARM_LINK6_lk :assoc larm-end-coords)
     (setq torso-end-coords (make-cascoords :coords (send WAIST_LINK3_lk :copy-worldcoords) :name :torso-end-coords))
     (send WAIST_LINK3_lk :assoc torso-end-coords)

     ;; limbs
     (setq rleg (list RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk))

     (setq rleg-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rleg) (find-parent (send l :parent)) l)))
             (find-parent (car rleg))))
     (setq rarm (list RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk RARM_LINK7_lk))

     (setq rarm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rarm) (find-parent (send l :parent)) l)))
             (find-parent (car rarm))))
     (setq lleg (list LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk))

     (setq lleg-root-link
           (labels ((find-parent (l) (if (find (send l :parent) lleg) (find-parent (send l :parent)) l)))
             (find-parent (car lleg))))
     (setq larm (list LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk LARM_LINK7_lk))

     (setq larm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) larm) (find-parent (send l :parent)) l)))
             (find-parent (car larm))))
     (setq torso (list WAIST_LINK1_lk WAIST_LINK2_lk WAIST_LINK3_lk))

     (setq torso-root-link
           (labels ((find-parent (l) (if (find (send l :parent) torso) (find-parent (send l :parent)) l)))
             (find-parent (car torso))))

     ;; links
     (setq links (list WAIST_LINK0_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk RARM_LINK7_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk LARM_LINK7_lk WAIST_LINK1_lk WAIST_LINK2_lk WAIST_LINK3_lk))

     ;; joint-list
     (setq joint-list (list RLEG_HIP_R_jt RLEG_HIP_P_jt RLEG_HIP_Y_jt RLEG_KNEE_jt RLEG_ANKLE_P_jt RLEG_ANKLE_R_jt RARM_SHOULDER_P_jt RARM_SHOULDER_R_jt RARM_SHOULDER_Y_jt RARM_ELBOW_jt RARM_WRIST_Y_jt RARM_WRIST_P_jt RARM_WRIST_R_jt LLEG_HIP_R_jt LLEG_HIP_P_jt LLEG_HIP_Y_jt LLEG_KNEE_jt LLEG_ANKLE_P_jt LLEG_ANKLE_R_jt LARM_SHOULDER_P_jt LARM_SHOULDER_R_jt LARM_SHOULDER_Y_jt LARM_ELBOW_jt LARM_WRIST_Y_jt LARM_WRIST_P_jt LARM_WRIST_R_jt WAIST_P_jt WAIST_R_jt CHEST_jt))

     ;; sensor-coords
     ;;
     (setq gsensor-sensor-coords (make-cascoords :name "gsensor" :coords (send WAIST_LINK3_lk :copy-worldcoords)))
     (send gsensor-sensor-coords :put :sensor-type :base_imu)
     (send gsensor-sensor-coords :put :sensor-id 1)
     (send gsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 0.0000000000000000e+00 7.0710678118654746e-01 7.0710678118654746e-01))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 3.1415899999999999e+00))
                                               ))
     (send WAIST_LINK3_lk :assoc gsensor-sensor-coords)
     ;;
     (setq gyrometer-sensor-coords (make-cascoords :name "gyrometer" :coords (send WAIST_LINK3_lk :copy-worldcoords)))
     (send gyrometer-sensor-coords :put :sensor-type :base_imu)
     (send gyrometer-sensor-coords :put :sensor-id 2)
     (send gyrometer-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 0.0000000000000000e+00 7.0710678118654746e-01 7.0710678118654746e-01))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 3.1415899999999999e+00))
                                               ))
     (send WAIST_LINK3_lk :assoc gyrometer-sensor-coords)
     ;;
     (setq VISION_SENSOR1-sensor-coords (make-cascoords :name "VISION_SENSOR1" :coords (send WAIST_LINK3_lk :copy-worldcoords)))
     (send VISION_SENSOR1-sensor-coords :put :sensor-type :base_pinhole_camera)
     (send VISION_SENSOR1-sensor-coords :put :sensor-id 3)
     (send VISION_SENSOR1-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  1.5000000000000000e+02 5.0000000000000000e+01 1.5000000000000000e+02)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 4.4720428423756459e-01 -4.4720428423756459e-01 -7.7460742077463673e-01))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 1.8234999999999997e+00))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 3.1415926535897931e+00))
                                               ))
     (send WAIST_LINK3_lk :assoc VISION_SENSOR1-sensor-coords)
     ;;
     (setq VISION_SENSOR2-sensor-coords (make-cascoords :name "VISION_SENSOR2" :coords (send WAIST_LINK3_lk :copy-worldcoords)))
     (send VISION_SENSOR2-sensor-coords :put :sensor-type :base_pinhole_camera)
     (send VISION_SENSOR2-sensor-coords :put :sensor-id 4)
     (send VISION_SENSOR2-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  1.5000000000000000e+02 -5.0000000000000000e+01 1.5000000000000000e+02)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 4.4720428423756459e-01 -4.4720428423756459e-01 -7.7460742077463673e-01))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 1.8234999999999997e+00))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 3.1415926535897931e+00))
                                               ))
     (send WAIST_LINK3_lk :assoc VISION_SENSOR2-sensor-coords)
     ;;
     (setq lhsensor-sensor-coords (make-cascoords :name "lhsensor" :coords (send LARM_LINK6_lk :copy-worldcoords)))
     (send lhsensor-sensor-coords :put :sensor-type :base_force6d)
     (send lhsensor-sensor-coords :put :sensor-id 5)
     (send lhsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send LARM_LINK6_lk :assoc lhsensor-sensor-coords)
     ;;
     (setq rhsensor-sensor-coords (make-cascoords :name "rhsensor" :coords (send RARM_LINK6_lk :copy-worldcoords)))
     (send rhsensor-sensor-coords :put :sensor-type :base_force6d)
     (send rhsensor-sensor-coords :put :sensor-id 6)
     (send rhsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send RARM_LINK6_lk :assoc rhsensor-sensor-coords)
     ;;
     (setq lfsensor-sensor-coords (make-cascoords :name "lfsensor" :coords (send LLEG_LINK6_lk :copy-worldcoords)))
     (send lfsensor-sensor-coords :put :sensor-type :base_force6d)
     (send lfsensor-sensor-coords :put :sensor-id 7)
     (send lfsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send LLEG_LINK6_lk :assoc lfsensor-sensor-coords)
     ;;
     (setq rfsensor-sensor-coords (make-cascoords :name "rfsensor" :coords (send RLEG_LINK6_lk :copy-worldcoords)))
     (send rfsensor-sensor-coords :put :sensor-type :base_force6d)
     (send rfsensor-sensor-coords :put :sensor-id 8)
     (send rfsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send RLEG_LINK6_lk :assoc rfsensor-sensor-coords)

     ;; attach_sensor lists
     (setq force-sensors (list lhsensor-sensor-coords rhsensor-sensor-coords lfsensor-sensor-coords rfsensor-sensor-coords ))
     (setq imu-sensors (list gsensor-sensor-coords gyrometer-sensor-coords ))
     (setq cameras (list VISION_SENSOR1-sensor-coords VISION_SENSOR2-sensor-coords ))

     ;; init-ending
     (send self :init-ending) ;; :urdf

     ;; overwrite bodies to return draw-things links not (send link :bodies)
     (setq bodies (flatten (mapcar #'(lambda (b) (if (find-method b :bodies) (send b :bodies))) (list LARM_LINK1_lk LARM_LINK2_lk LARM_LINK3_lk LARM_LINK4_lk LARM_LINK5_lk LARM_LINK6_lk LARM_LINK7_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk RARM_LINK1_lk RARM_LINK2_lk RARM_LINK3_lk RARM_LINK4_lk RARM_LINK5_lk RARM_LINK6_lk RARM_LINK7_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk WAIST_LINK0_lk WAIST_LINK1_lk WAIST_LINK2_lk WAIST_LINK3_lk))))

     (when (member :reset-pose (send self :methods))           (send self :reset-pose)) ;; :set reset-pose

     self)) ;; end of :init

  ;; pre-defined pose methods

    (:reset-pose (&optional (limbs '(:rleg :rarm :lleg :larm :torso)))
      "Predefined pose named reset-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:rleg (send self limb :angle-vector (float-vector -0.004457 -21.692900 -0.012020 47.672300 -25.930000 0.014025)))
          (:rarm (send self limb :angle-vector (float-vector 17.835600 -9.137590 -6.611880 -36.456000 0.000000 0.000000 0.000000)))
          (:lleg (send self limb :angle-vector (float-vector -0.004457 -21.692900 -0.012020 47.672300 -25.930000 0.014025)))
          (:larm (send self limb :angle-vector (float-vector 17.835600 9.137590 6.611880 -36.456000 0.000000 0.000000 0.000000)))
          (:torso (send self limb :angle-vector (float-vector 0.000000 0.000000 0.000000)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
    (:reset-manip-pose (&optional (limbs '(:rleg :rarm :lleg :larm :torso)))
      "Predefined pose named reset-manip-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:rleg (send self limb :angle-vector (float-vector 0.000000 -20.000000 0.000000 47.000000 -27.000000 0.000000)))
          (:rarm (send self limb :angle-vector (float-vector 30.000000 0.000000 0.000000 -100.000000 9.000000 -6.500000 36.500000)))
          (:lleg (send self limb :angle-vector (float-vector 0.000000 -20.000000 0.000000 47.000000 -27.000000 0.000000)))
          (:larm (send self limb :angle-vector (float-vector 30.000000 0.000000 0.000000 -100.000000 -9.000000 -6.500000 -36.500000)))
          (:torso (send self limb :angle-vector (float-vector 0.000000 0.000000 0.000000)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
  ;; all joints
  (:CHEST (&rest args) (forward-message-to CHEST_jt args))
  (:LARM_ELBOW (&rest args) (forward-message-to LARM_ELBOW_jt args))
  (:LARM_SHOULDER_P (&rest args) (forward-message-to LARM_SHOULDER_P_jt args))
  (:LARM_SHOULDER_R (&rest args) (forward-message-to LARM_SHOULDER_R_jt args))
  (:LARM_SHOULDER_Y (&rest args) (forward-message-to LARM_SHOULDER_Y_jt args))
  (:LARM_WRIST_P (&rest args) (forward-message-to LARM_WRIST_P_jt args))
  (:LARM_WRIST_R (&rest args) (forward-message-to LARM_WRIST_R_jt args))
  (:LARM_WRIST_Y (&rest args) (forward-message-to LARM_WRIST_Y_jt args))
  (:LLEG_ANKLE_P (&rest args) (forward-message-to LLEG_ANKLE_P_jt args))
  (:LLEG_ANKLE_R (&rest args) (forward-message-to LLEG_ANKLE_R_jt args))
  (:LLEG_HIP_P (&rest args) (forward-message-to LLEG_HIP_P_jt args))
  (:LLEG_HIP_R (&rest args) (forward-message-to LLEG_HIP_R_jt args))
  (:LLEG_HIP_Y (&rest args) (forward-message-to LLEG_HIP_Y_jt args))
  (:LLEG_KNEE (&rest args) (forward-message-to LLEG_KNEE_jt args))
  (:RARM_ELBOW (&rest args) (forward-message-to RARM_ELBOW_jt args))
  (:RARM_SHOULDER_P (&rest args) (forward-message-to RARM_SHOULDER_P_jt args))
  (:RARM_SHOULDER_R (&rest args) (forward-message-to RARM_SHOULDER_R_jt args))
  (:RARM_SHOULDER_Y (&rest args) (forward-message-to RARM_SHOULDER_Y_jt args))
  (:RARM_WRIST_P (&rest args) (forward-message-to RARM_WRIST_P_jt args))
  (:RARM_WRIST_R (&rest args) (forward-message-to RARM_WRIST_R_jt args))
  (:RARM_WRIST_Y (&rest args) (forward-message-to RARM_WRIST_Y_jt args))
  (:RLEG_ANKLE_P (&rest args) (forward-message-to RLEG_ANKLE_P_jt args))
  (:RLEG_ANKLE_R (&rest args) (forward-message-to RLEG_ANKLE_R_jt args))
  (:RLEG_HIP_P (&rest args) (forward-message-to RLEG_HIP_P_jt args))
  (:RLEG_HIP_R (&rest args) (forward-message-to RLEG_HIP_R_jt args))
  (:RLEG_HIP_Y (&rest args) (forward-message-to RLEG_HIP_Y_jt args))
  (:RLEG_KNEE (&rest args) (forward-message-to RLEG_KNEE_jt args))
  (:WAIST_P (&rest args) (forward-message-to WAIST_P_jt args))
  (:WAIST_R (&rest args) (forward-message-to WAIST_R_jt args))

  ;; all links forwarding
  (:links (&rest args)
   (if (null args) (return-from :links (send-super :links)))
   (let ((key (car args))
           (nargs (cdr args)))
     (unless (keywordp key)
         (return-from :links (send-super* :links args)))
       (case key
       (:LARM_LINK1 (forward-message-to LARM_LINK1_lk nargs))
       (:LARM_LINK2 (forward-message-to LARM_LINK2_lk nargs))
       (:LARM_LINK3 (forward-message-to LARM_LINK3_lk nargs))
       (:LARM_LINK4 (forward-message-to LARM_LINK4_lk nargs))
       (:LARM_LINK5 (forward-message-to LARM_LINK5_lk nargs))
       (:LARM_LINK6 (forward-message-to LARM_LINK6_lk nargs))
       (:LARM_LINK7 (forward-message-to LARM_LINK7_lk nargs))
       (:LLEG_LINK1 (forward-message-to LLEG_LINK1_lk nargs))
       (:LLEG_LINK2 (forward-message-to LLEG_LINK2_lk nargs))
       (:LLEG_LINK3 (forward-message-to LLEG_LINK3_lk nargs))
       (:LLEG_LINK4 (forward-message-to LLEG_LINK4_lk nargs))
       (:LLEG_LINK5 (forward-message-to LLEG_LINK5_lk nargs))
       (:LLEG_LINK6 (forward-message-to LLEG_LINK6_lk nargs))
       (:RARM_LINK1 (forward-message-to RARM_LINK1_lk nargs))
       (:RARM_LINK2 (forward-message-to RARM_LINK2_lk nargs))
       (:RARM_LINK3 (forward-message-to RARM_LINK3_lk nargs))
       (:RARM_LINK4 (forward-message-to RARM_LINK4_lk nargs))
       (:RARM_LINK5 (forward-message-to RARM_LINK5_lk nargs))
       (:RARM_LINK6 (forward-message-to RARM_LINK6_lk nargs))
       (:RARM_LINK7 (forward-message-to RARM_LINK7_lk nargs))
       (:RLEG_LINK1 (forward-message-to RLEG_LINK1_lk nargs))
       (:RLEG_LINK2 (forward-message-to RLEG_LINK2_lk nargs))
       (:RLEG_LINK3 (forward-message-to RLEG_LINK3_lk nargs))
       (:RLEG_LINK4 (forward-message-to RLEG_LINK4_lk nargs))
       (:RLEG_LINK5 (forward-message-to RLEG_LINK5_lk nargs))
       (:RLEG_LINK6 (forward-message-to RLEG_LINK6_lk nargs))
       (:WAIST_LINK0 (forward-message-to WAIST_LINK0_lk nargs))
       (:WAIST_LINK1 (forward-message-to WAIST_LINK1_lk nargs))
       (:WAIST_LINK2 (forward-message-to WAIST_LINK2_lk nargs))
       (:WAIST_LINK3 (forward-message-to WAIST_LINK3_lk nargs))
       (t (send-super* :links args)))))

  ;; all links
  (:LARM_LINK1_lk (&rest args) (forward-message-to LARM_LINK1_lk args))
  (:LARM_LINK2_lk (&rest args) (forward-message-to LARM_LINK2_lk args))
  (:LARM_LINK3_lk (&rest args) (forward-message-to LARM_LINK3_lk args))
  (:LARM_LINK4_lk (&rest args) (forward-message-to LARM_LINK4_lk args))
  (:LARM_LINK5_lk (&rest args) (forward-message-to LARM_LINK5_lk args))
  (:LARM_LINK6_lk (&rest args) (forward-message-to LARM_LINK6_lk args))
  (:LARM_LINK7_lk (&rest args) (forward-message-to LARM_LINK7_lk args))
  (:LLEG_LINK1_lk (&rest args) (forward-message-to LLEG_LINK1_lk args))
  (:LLEG_LINK2_lk (&rest args) (forward-message-to LLEG_LINK2_lk args))
  (:LLEG_LINK3_lk (&rest args) (forward-message-to LLEG_LINK3_lk args))
  (:LLEG_LINK4_lk (&rest args) (forward-message-to LLEG_LINK4_lk args))
  (:LLEG_LINK5_lk (&rest args) (forward-message-to LLEG_LINK5_lk args))
  (:LLEG_LINK6_lk (&rest args) (forward-message-to LLEG_LINK6_lk args))
  (:RARM_LINK1_lk (&rest args) (forward-message-to RARM_LINK1_lk args))
  (:RARM_LINK2_lk (&rest args) (forward-message-to RARM_LINK2_lk args))
  (:RARM_LINK3_lk (&rest args) (forward-message-to RARM_LINK3_lk args))
  (:RARM_LINK4_lk (&rest args) (forward-message-to RARM_LINK4_lk args))
  (:RARM_LINK5_lk (&rest args) (forward-message-to RARM_LINK5_lk args))
  (:RARM_LINK6_lk (&rest args) (forward-message-to RARM_LINK6_lk args))
  (:RARM_LINK7_lk (&rest args) (forward-message-to RARM_LINK7_lk args))
  (:RLEG_LINK1_lk (&rest args) (forward-message-to RLEG_LINK1_lk args))
  (:RLEG_LINK2_lk (&rest args) (forward-message-to RLEG_LINK2_lk args))
  (:RLEG_LINK3_lk (&rest args) (forward-message-to RLEG_LINK3_lk args))
  (:RLEG_LINK4_lk (&rest args) (forward-message-to RLEG_LINK4_lk args))
  (:RLEG_LINK5_lk (&rest args) (forward-message-to RLEG_LINK5_lk args))
  (:RLEG_LINK6_lk (&rest args) (forward-message-to RLEG_LINK6_lk args))
  (:WAIST_LINK0_lk (&rest args) (forward-message-to WAIST_LINK0_lk args))
  (:WAIST_LINK1_lk (&rest args) (forward-message-to WAIST_LINK1_lk args))
  (:WAIST_LINK2_lk (&rest args) (forward-message-to WAIST_LINK2_lk args))
  (:WAIST_LINK3_lk (&rest args) (forward-message-to WAIST_LINK3_lk args))

  ;; user-defined joint
  (:rleg-crotch-r (&rest args) (forward-message-to RLEG_HIP_R_jt args))
  (:rleg-crotch-p (&rest args) (forward-message-to RLEG_HIP_P_jt args))
  (:rleg-crotch-y (&rest args) (forward-message-to RLEG_HIP_Y_jt args))
  (:rleg-knee-p (&rest args) (forward-message-to RLEG_KNEE_jt args))
  (:rleg-ankle-p (&rest args) (forward-message-to RLEG_ANKLE_P_jt args))
  (:rleg-ankle-r (&rest args) (forward-message-to RLEG_ANKLE_R_jt args))
  (:rarm-shoulder-p (&rest args) (forward-message-to RARM_SHOULDER_P_jt args))
  (:rarm-shoulder-r (&rest args) (forward-message-to RARM_SHOULDER_R_jt args))
  (:rarm-shoulder-y (&rest args) (forward-message-to RARM_SHOULDER_Y_jt args))
  (:rarm-elbow-p (&rest args) (forward-message-to RARM_ELBOW_jt args))
  (:rarm-wrist-y (&rest args) (forward-message-to RARM_WRIST_Y_jt args))
  (:rarm-wrist-p (&rest args) (forward-message-to RARM_WRIST_P_jt args))
  (:rarm-wrist-r (&rest args) (forward-message-to RARM_WRIST_R_jt args))
  (:lleg-crotch-r (&rest args) (forward-message-to LLEG_HIP_R_jt args))
  (:lleg-crotch-p (&rest args) (forward-message-to LLEG_HIP_P_jt args))
  (:lleg-crotch-y (&rest args) (forward-message-to LLEG_HIP_Y_jt args))
  (:lleg-knee-p (&rest args) (forward-message-to LLEG_KNEE_jt args))
  (:lleg-ankle-p (&rest args) (forward-message-to LLEG_ANKLE_P_jt args))
  (:lleg-ankle-r (&rest args) (forward-message-to LLEG_ANKLE_R_jt args))
  (:larm-shoulder-p (&rest args) (forward-message-to LARM_SHOULDER_P_jt args))
  (:larm-shoulder-r (&rest args) (forward-message-to LARM_SHOULDER_R_jt args))
  (:larm-shoulder-y (&rest args) (forward-message-to LARM_SHOULDER_Y_jt args))
  (:larm-elbow-p (&rest args) (forward-message-to LARM_ELBOW_jt args))
  (:larm-wrist-y (&rest args) (forward-message-to LARM_WRIST_Y_jt args))
  (:larm-wrist-p (&rest args) (forward-message-to LARM_WRIST_P_jt args))
  (:larm-wrist-r (&rest args) (forward-message-to LARM_WRIST_R_jt args))
  (:torso-waist-p (&rest args) (forward-message-to WAIST_P_jt args))
  (:torso-waist-r (&rest args) (forward-message-to WAIST_R_jt args))
  (:torso-waist-y (&rest args) (forward-message-to CHEST_jt args))

  ;; attach_sensor methods
  (:gsensor (&rest args) (forward-message-to gsensor-sensor-coords args))
  (:gyrometer (&rest args) (forward-message-to gyrometer-sensor-coords args))
  (:VISION_SENSOR1 (&rest args) (forward-message-to VISION_SENSOR1-sensor-coords args))
  (:VISION_SENSOR2 (&rest args) (forward-message-to VISION_SENSOR2-sensor-coords args))
  (:lhsensor (&rest args) (forward-message-to lhsensor-sensor-coords args))
  (:rhsensor (&rest args) (forward-message-to rhsensor-sensor-coords args))
  (:lfsensor (&rest args) (forward-message-to lfsensor-sensor-coords args))
  (:rfsensor (&rest args) (forward-message-to rfsensor-sensor-coords args))

  ;; geometries
  (:_make_instance_WAIST_LINK0_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 7.2350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 10 11 8 9 8 14 14 8 15 13 15 8 8 11 13 12 10 9 9 14 12 11 10 12 11 12 13 12 15 13 14 15 12))
                   (list :vertices (let ((mat (make-matrix 16 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 -6.8350000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -5.7250000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -5.7250000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -6.8350000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -5.7250000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -6.8350000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -5.7250000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -6.8350000000000000e+02 -4.0000000000000000e+01 -4.0000000000000000e+01 -7.6350000000000000e+02 -4.0000000000000000e+01 -4.0000000000000000e+01 -6.8350000000000000e+02 -4.0000000000000000e+01 4.0000000000000000e+01 -6.8350000000000000e+02 -4.0000000000000000e+01 4.0000000000000000e+01 -7.6350000000000000e+02 4.0000000000000000e+01 4.0000000000000000e+01 -6.8350000000000000e+02 4.0000000000000000e+01 4.0000000000000000e+01 -7.6350000000000000e+02 4.0000000000000000e+01 -4.0000000000000000e+01 -6.8350000000000000e+02 4.0000000000000000e+01 -4.0000000000000000e+01 -7.6350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 72 -> 10 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -7.6349997520446777e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -7.6349997520446777e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -7.6349997520446777e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -7.6349997520446777e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -6.8349999189376831e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -6.8349999189376831e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -5.7249999046325684e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -5.7249999046325684e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK0_ywKbc4.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_WAIST_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7600000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 1.000000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 2.5000000000000000e+01 -1.7600000000000000e+02 2.3776401519775391e+01 2.5000000000000000e+01 -1.6827499389648438e+02 2.5000000000000000e+01 2.5000000000000000e+01 -1.7600000000000000e+02 2.3776401519775391e+01 -2.5000000000000000e+01 -1.6827499389648438e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -1.7600000000000000e+02 0.0000000000000000e+00 -2.5000000000000000e+01 -1.7600000000000000e+02 2.0225400924682617e+01 2.5000000000000000e+01 -1.6130499267578125e+02 2.0225400924682617e+01 -2.5000000000000000e+01 -1.6130499267578125e+02 1.4694600105285645e+01 2.5000000000000000e+01 -1.5577499389648438e+02 1.4694600105285645e+01 -2.5000000000000000e+01 -1.5577499389648438e+02 7.7254300117492676e+00 2.5000000000000000e+01 -1.5222399902343750e+02 7.7254300117492676e+00 -2.5000000000000000e+01 -1.5222399902343750e+02 1.5308101406833461e-15 2.5000000000000000e+01 -1.5100000000000000e+02 1.5308101406833461e-15 -2.5000000000000000e+01 -1.5100000000000000e+02 -7.7254300117492676e+00 2.5000000000000000e+01 -1.5222399902343750e+02 -7.7254300117492676e+00 -2.5000000000000000e+01 -1.5222399902343750e+02 -1.4694600105285645e+01 2.5000000000000000e+01 -1.5577499389648438e+02 -1.4694600105285645e+01 -2.5000000000000000e+01 -1.5577499389648438e+02 -2.0225400924682617e+01 2.5000000000000000e+01 -1.6130499267578125e+02 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.6130499267578125e+02 -2.3776401519775391e+01 2.5000000000000000e+01 -1.6827499389648438e+02 -2.3776401519775391e+01 -2.5000000000000000e+01 -1.6827499389648438e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -1.7600000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -1.7600000000000000e+02 -2.3776401519775391e+01 2.5000000000000000e+01 -1.8372500610351562e+02 -2.3776401519775391e+01 -2.5000000000000000e+01 -1.8372500610351562e+02 -2.0225400924682617e+01 2.5000000000000000e+01 -1.9069500732421875e+02 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.9069500732421875e+02 -1.4694600105285645e+01 2.5000000000000000e+01 -1.9622500610351562e+02 -1.4694600105285645e+01 -2.5000000000000000e+01 -1.9622500610351562e+02 -7.7254300117492676e+00 2.5000000000000000e+01 -1.9977600097656250e+02 -7.7254300117492676e+00 -2.5000000000000000e+01 -1.9977600097656250e+02 -4.5924301044126831e-15 2.5000000000000000e+01 -2.0100000000000000e+02 -4.5924301044126831e-15 -2.5000000000000000e+01 -2.0100000000000000e+02 7.7254300117492676e+00 2.5000000000000000e+01 -1.9977600097656250e+02 7.7254300117492676e+00 -2.5000000000000000e+01 -1.9977600097656250e+02 1.4694600105285645e+01 2.5000000000000000e+01 -1.9622500610351562e+02 1.4694600105285645e+01 -2.5000000000000000e+01 -1.9622500610351562e+02 2.0225400924682617e+01 2.5000000000000000e+01 -1.9069500732421875e+02 2.0225400924682617e+01 -2.5000000000000000e+01 -1.9069500732421875e+02 2.3776401519775391e+01 2.5000000000000000e+01 -1.8372500610351562e+02 2.3776401519775391e+01 -2.5000000000000000e+01 -1.8372500610351562e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 12 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 -1.6827499866485596e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 -2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 2.5000000372529030e+01 -2.0100000500679016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 -2.5000000372529030e+01 -2.0100000500679016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 7.7254301868379116e+00 2.5000000372529030e+01 -1.5222400426864624e+02) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 -1.5099999308586121e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 -1.6827499866485596e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 7.7254301868379116e+00 2.5000000372529030e+01 -1.5222400426864624e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 -1.6827499866485596e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 -2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector 7.7254301868379116e+00 2.5000000372529030e+01 -1.5222400426864624e+02) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 -1.5099999308586121e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK1_et8hQJ.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_WAIST_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 0.800000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 3.0000000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 3.0000000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 3.0000000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 3.0000000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.3776300430297852e+01 7.7254300117492676e+00 -2.5000099182128906e+01 2.4999898910522461e+01 0.0000000000000000e+00 2.4999898910522461e+01 2.3776498794555664e+01 7.7254300117492676e+00 2.4999898910522461e+01 2.5000099182128906e+01 0.0000000000000000e+00 2.5000000000000000e+01 9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.0225299835205078e+01 1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 1.4694600105285645e+01 -2.5000099182128906e+01 1.4694499969482422e+01 2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 2.0225400924682617e+01 -2.5000000000000000e+01 7.7253298759460449e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 2.5000000000000000e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 2.3776401519775391e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 2.0225400924682617e+01 -2.4999898910522461e+01 -2.0225500106811523e+01 1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 1.4694600105285645e+01 -2.4999898910522461e+01 -2.3776498794555664e+01 7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 7.7254300117492676e+00 -2.4999898910522461e+01 -2.5000099182128906e+01 3.0616202813666922e-15 2.5000099182128906e+01 -2.4999898910522461e+01 3.0616202813666922e-15 -2.4999898910522461e+01 -2.3776498794555664e+01 -7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 -7.7254300117492676e+00 -2.4999898910522461e+01 -2.0225500106811523e+01 -1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 -1.4694600105285645e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 -2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 -2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7253298759460449e+00 -2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 -2.3776401519775391e+01 -2.5000099182128906e+01 1.4694499969482422e+01 -2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 -2.0225400924682617e+01 -2.5000099182128906e+01 2.0225299835205078e+01 -1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 -1.4694600105285645e+01 -2.5000099182128906e+01 2.3776300430297852e+01 -7.7254300117492676e+00 2.4999898910522461e+01 2.3776498794555664e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 10 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector 2.5000099092721939e+01 -2.4999899789690971e+01 3.0616202333902167e-15) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector 2.5000099092721939e+01 -2.4999899789690971e+01 3.0616202333902167e-15) (float-vector 2.5000099092721939e+01 -2.0225299522280693e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 -7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector 2.5000099092721939e+01 -2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.4999899789690971e+01 3.0616202333902167e-15) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.0225299522280693e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000099092721939e+01 2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 -7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 -2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000099092721939e+01 2.4999899789690971e+01 0.0000000000000000e+00) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector -2.5000099092721939e+01 2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector -2.5000099092721939e+01 2.4999899789690971e+01 0.0000000000000000e+00) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector -2.5000099092721939e+01 2.4999899789690971e+01 0.0000000000000000e+00) (float-vector -2.5000099092721939e+01 2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 -1.4694600366055965e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK2_8omIeP.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_WAIST_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.5000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.5000000000000000e+01 -1.3500000000000000e+02 -3.7500000000000000e+02 -7.5000000000000000e+01 -1.3500000000000000e+02 -3.2500000000000000e+02 -7.5000000000000000e+01 1.3500000000000000e+02 -3.2500000000000000e+02 -7.5000000000000000e+01 1.3500000000000000e+02 -3.7500000000000000e+02 7.5000000000000000e+01 1.3500000000000000e+02 -3.2500000000000000e+02 7.5000000000000000e+01 1.3500000000000000e+02 -3.7500000000000000e+02 7.5000000000000000e+01 -1.3500000000000000e+02 -3.2500000000000000e+02 7.5000000000000000e+01 -1.3500000000000000e+02 -3.7500000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 -3.0000000000000000e+02 2.3776401519775391e+01 -7.7256097793579102e+00 -3.0000000000000000e+02 2.5000000000000000e+01 -1.8366001313552260e-04 -3.0000000000000000e+02 2.3776401519775391e+01 -7.7252402305603027e+00 -4.0000000000000000e+02 2.5000000000000000e+01 1.8366001313552260e-04 -4.0000000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 -4.0000000000000000e+02 2.0225400924682617e+01 -1.4694799423217773e+01 -3.0000000000000000e+02 2.0225400924682617e+01 -1.4694399833679199e+01 -4.0000000000000000e+02 1.4694600105285645e+01 -2.0225599288940430e+01 -3.0000000000000000e+02 1.4694600105285645e+01 -2.0225200653076172e+01 -4.0000000000000000e+02 7.7254300117492676e+00 -2.3776599884033203e+01 -3.0000000000000000e+02 7.7254300117492676e+00 -2.3776199340820312e+01 -4.0000000000000000e+02 1.5308101406833461e-15 -2.5000200271606445e+01 -3.0000000000000000e+02 1.5308101406833461e-15 -2.4999799728393555e+01 -4.0000000000000000e+02 -7.7254300117492676e+00 -2.3776599884033203e+01 -3.0000000000000000e+02 -7.7254300117492676e+00 -2.3776199340820312e+01 -4.0000000000000000e+02 -1.4694600105285645e+01 -2.0225599288940430e+01 -3.0000000000000000e+02 -1.4694600105285645e+01 -2.0225200653076172e+01 -4.0000000000000000e+02 -2.0225400924682617e+01 -1.4694799423217773e+01 -3.0000000000000000e+02 -2.0225400924682617e+01 -1.4694399833679199e+01 -4.0000000000000000e+02 -2.3776401519775391e+01 -7.7256097793579102e+00 -3.0000000000000000e+02 -2.3776401519775391e+01 -7.7252402305603027e+00 -4.0000000000000000e+02 -2.5000000000000000e+01 -1.8366001313552260e-04 -3.0000000000000000e+02 -2.5000000000000000e+01 1.8366001313552260e-04 -4.0000000000000000e+02 -2.3776401519775391e+01 7.7252402305603027e+00 -3.0000000000000000e+02 -2.3776401519775391e+01 7.7256097793579102e+00 -4.0000000000000000e+02 -2.0225400924682617e+01 1.4694399833679199e+01 -3.0000000000000000e+02 -2.0225400924682617e+01 1.4694799423217773e+01 -4.0000000000000000e+02 -1.4694600105285645e+01 2.0225200653076172e+01 -3.0000000000000000e+02 -1.4694600105285645e+01 2.0225599288940430e+01 -4.0000000000000000e+02 -7.7254300117492676e+00 2.3776199340820312e+01 -3.0000000000000000e+02 -7.7254300117492676e+00 2.3776599884033203e+01 -4.0000000000000000e+02 -4.5924301044126831e-15 2.4999799728393555e+01 -3.0000000000000000e+02 -4.5924301044126831e-15 2.5000200271606445e+01 -4.0000000000000000e+02 7.7254300117492676e+00 2.3776199340820312e+01 -3.0000000000000000e+02 7.7254300117492676e+00 2.3776599884033203e+01 -4.0000000000000000e+02 1.4694600105285645e+01 2.0225200653076172e+01 -3.0000000000000000e+02 1.4694600105285645e+01 2.0225599288940430e+01 -4.0000000000000000e+02 2.0225400924682617e+01 1.4694399833679199e+01 -3.0000000000000000e+02 2.0225400924682617e+01 1.4694799423217773e+01 -4.0000000000000000e+02 2.3776401519775391e+01 7.7252402305603027e+00 -3.0000000000000000e+02 2.3776401519775391e+01 7.7256097793579102e+00 -4.0000000000000000e+02 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 1.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3 42 43 44 42 48 43 42 50 48 42 52 50 42 54 52 42 56 54 42 58 56 42 60 58 42 62 60 42 64 62 42 66 64 42 68 66 42 70 68 42 72 70 42 74 72 42 76 74 42 78 76 42 80 78 42 82 80 42 44 82 72 74 75 74 77 75 74 76 77 76 79 77 76 78 79 78 81 79 78 80 81 80 83 81 80 82 83 82 46 83 82 44 46 44 45 46 44 43 45 47 46 45 47 83 46 47 81 83 47 79 81 47 77 79 47 75 77 47 45 49 47 49 51 47 51 53 47 53 55 47 55 57 47 57 59 47 59 61 47 61 63 47 63 65 47 65 67 47 67 69 47 69 71 47 71 73 47 73 75 64 67 65 64 66 67 66 69 67 66 68 69 68 71 69 68 70 71 70 73 71 70 72 73 72 75 73 62 64 65 60 62 63 62 65 63 58 60 61 60 63 61 56 58 59 58 61 59 54 56 57 56 59 57 52 54 55 54 57 55 50 52 53 52 55 53 48 50 51 50 53 51 43 48 49 48 51 49 43 49 45))
                   (list :vertices (let ((mat (make-matrix 84 3))) (fvector-replace (array-entity mat) #f(1.5779400634765625e+02 4.9999900817871094e+01 -2.0450000000000000e+02 1.6088398742675781e+02 3.0978500366210938e+01 -1.9914799499511719e+02 1.5779400634765625e+02 2.9999900817871094e+01 -2.0450000000000000e+02 1.4529600524902344e+02 3.0978799819946289e+01 -1.9014799499511719e+02 1.4220500183105469e+02 3.0000099182128906e+01 -1.9550000000000000e+02 1.4220599365234375e+02 5.0000102996826172e+01 -1.9550000000000000e+02 1.6367199707031250e+02 3.3819198608398438e+01 -1.9431999206542969e+02 1.4808300781250000e+02 3.3819499969482422e+01 -1.8531900024414062e+02 1.6588400268554688e+02 3.8243698120117188e+01 -1.9048799133300781e+02 1.5029600524902344e+02 3.8244003295898438e+01 -1.8148800659179688e+02 1.6730499267578125e+02 4.3819000244140625e+01 -1.8802799987792969e+02 1.5171701049804688e+02 4.3819301605224609e+01 -1.7902700805664062e+02 1.6779400634765625e+02 4.9999301910400391e+01 -1.8717999267578125e+02 1.5220600891113281e+02 4.9999599456787109e+01 -1.7817999267578125e+02 1.6730499267578125e+02 5.6179603576660156e+01 -1.8802699279785156e+02 1.5171701049804688e+02 5.6179901123046875e+01 -1.7902700805664062e+02 1.6588499450683594e+02 6.1755100250244141e+01 -1.9048699951171875e+02 1.5029699707031250e+02 6.1755401611328125e+01 -1.8148699951171875e+02 1.6367300415039062e+02 6.6179901123046875e+01 -1.9431900024414062e+02 1.4808399963378906e+02 6.6180198669433594e+01 -1.8531900024414062e+02 1.6088500976562500e+02 6.9020797729492188e+01 -1.9914799499511719e+02 1.4529701232910156e+02 6.9021095275878906e+01 -1.9014700317382812e+02 1.5779499816894531e+02 6.9999900817871094e+01 -2.0450000000000000e+02 1.4220599365234375e+02 7.0000099182128906e+01 -1.9550000000000000e+02 1.5470401000976562e+02 6.9021202087402344e+01 -2.0985198974609375e+02 1.3911599731445312e+02 6.9021499633789062e+01 -2.0085200500488281e+02 1.5191699218750000e+02 6.6180496215820312e+01 -2.1468099975585938e+02 1.3632800292968750e+02 6.6180801391601562e+01 -2.0567999267578125e+02 1.4970399475097656e+02 6.1756000518798828e+01 -2.1851199340820312e+02 1.3411599731445312e+02 6.1756301879882812e+01 -2.0951199340820312e+02 1.4828300476074219e+02 5.6180702209472656e+01 -2.2097300720214844e+02 1.3269500732421875e+02 5.6180999755859375e+01 -2.1197200012207031e+02 1.4779399108886719e+02 5.0000400543212891e+01 -2.2181999206542969e+02 1.3220599365234375e+02 5.0000701904296875e+01 -2.1281999206542969e+02 1.4828300476074219e+02 4.3820102691650391e+01 -2.2097300720214844e+02 1.3269500732421875e+02 4.3820400238037109e+01 -2.1197299194335938e+02 1.4970300292968750e+02 3.8244602203369141e+01 -2.1851300048828125e+02 1.3411499023437500e+02 3.8244899749755859e+01 -2.0951300048828125e+02 1.5191600036621094e+02 3.3819797515869141e+01 -2.1468099975585938e+02 1.3632699584960938e+02 3.3820098876953125e+01 -2.0568099975585938e+02 1.5470300292968750e+02 3.0978899002075195e+01 -2.0985299682617188e+02 1.3911500549316406e+02 3.0979198455810547e+01 -2.0085200500488281e+02 1.5779400634765625e+02 -5.0000102996826172e+01 -2.0450000000000000e+02 1.6088398742675781e+02 -6.9021499633789062e+01 -1.9914799499511719e+02 1.5779400634765625e+02 -7.0000099182128906e+01 -2.0450000000000000e+02 1.4529600524902344e+02 -6.9021202087402344e+01 -1.9014799499511719e+02 1.4220500183105469e+02 -6.9999900817871094e+01 -1.9550000000000000e+02 1.4220599365234375e+02 -4.9999900817871094e+01 -1.9550000000000000e+02 1.6367199707031250e+02 -6.6180801391601562e+01 -1.9431999206542969e+02 1.4808300781250000e+02 -6.6180496215820312e+01 -1.8531900024414062e+02 1.6588400268554688e+02 -6.1756301879882812e+01 -1.9048799133300781e+02 1.5029600524902344e+02 -6.1756000518798828e+01 -1.8148800659179688e+02 1.6730499267578125e+02 -5.6180999755859375e+01 -1.8802799987792969e+02 1.5171701049804688e+02 -5.6180702209472656e+01 -1.7902700805664062e+02 1.6779400634765625e+02 -5.0000701904296875e+01 -1.8717999267578125e+02 1.5220600891113281e+02 -5.0000400543212891e+01 -1.7817999267578125e+02 1.6730499267578125e+02 -4.3820400238037109e+01 -1.8802699279785156e+02 1.5171701049804688e+02 -4.3820102691650391e+01 -1.7902700805664062e+02 1.6588499450683594e+02 -3.8244899749755859e+01 -1.9048699951171875e+02 1.5029699707031250e+02 -3.8244602203369141e+01 -1.8148699951171875e+02 1.6367300415039062e+02 -3.3820098876953125e+01 -1.9431900024414062e+02 1.4808399963378906e+02 -3.3819797515869141e+01 -1.8531900024414062e+02 1.6088500976562500e+02 -3.0979198455810547e+01 -1.9914799499511719e+02 1.4529701232910156e+02 -3.0978899002075195e+01 -1.9014700317382812e+02 1.5779499816894531e+02 -3.0000099182128906e+01 -2.0450000000000000e+02 1.4220599365234375e+02 -2.9999900817871094e+01 -1.9550000000000000e+02 1.5470401000976562e+02 -3.0978799819946289e+01 -2.0985198974609375e+02 1.3911599731445312e+02 -3.0978500366210938e+01 -2.0085200500488281e+02 1.5191699218750000e+02 -3.3819499969482422e+01 -2.1468099975585938e+02 1.3632800292968750e+02 -3.3819198608398438e+01 -2.0567999267578125e+02 1.4970399475097656e+02 -3.8244003295898438e+01 -2.1851199340820312e+02 1.3411599731445312e+02 -3.8243698120117188e+01 -2.0951199340820312e+02 1.4828300476074219e+02 -4.3819301605224609e+01 -2.2097300720214844e+02 1.3269500732421875e+02 -4.3819000244140625e+01 -2.1197200012207031e+02 1.4779399108886719e+02 -4.9999599456787109e+01 -2.2181999206542969e+02 1.3220599365234375e+02 -4.9999301910400391e+01 -2.1281999206542969e+02 1.4828300476074219e+02 -5.6179901123046875e+01 -2.2097300720214844e+02 1.3269500732421875e+02 -5.6179603576660156e+01 -2.1197299194335938e+02 1.4970300292968750e+02 -6.1755401611328125e+01 -2.1851300048828125e+02 1.3411499023437500e+02 -6.1755100250244141e+01 -2.0951300048828125e+02 1.5191600036621094e+02 -6.6180198669433594e+01 -2.1468099975585938e+02 1.3632699584960938e+02 -6.6179901123046875e+01 -2.0568099975585938e+02 1.5470300292968750e+02 -6.9021095275878906e+01 -2.0985299682617188e+02 1.3911500549316406e+02 -6.9020797729492188e+01 -2.0085200500488281e+02 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.500000 0.800000 0.500000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 10 11 8 9 8 14 14 8 15 13 15 8 8 11 13 12 10 9 9 14 12 11 10 12 11 12 13 12 15 13 14 15 12))
                   (list :vertices (let ((mat (make-matrix 16 3))) (fvector-replace (array-entity mat) #f(-1.7000000000000000e+02 -8.0000000000000000e+01 -2.7000000000000000e+02 -1.7000000000000000e+02 -8.0000000000000000e+01 -1.1000000000000000e+02 -1.7000000000000000e+02 8.0000000000000000e+01 -1.1000000000000000e+02 -1.7000000000000000e+02 8.0000000000000000e+01 -2.7000000000000000e+02 1.4000000000000000e+02 8.0000000000000000e+01 -1.1000000000000000e+02 1.4000000000000000e+02 8.0000000000000000e+01 -2.7000000000000000e+02 1.4000000000000000e+02 -8.0000000000000000e+01 -1.1000000000000000e+02 1.4000000000000000e+02 -8.0000000000000000e+01 -2.7000000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -3.0000000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.7000000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -2.7000000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -3.0000000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -2.7000000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -3.0000000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -2.7000000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -3.0000000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 828 -> 26 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -2.7000001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector -4.5924302466877485e-15 2.5000199675559998e+01 -4.0000000596046448e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000199675559998e+01 -4.0000000596046448e+02) (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector -1.7000000178813934e+02 -7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6588500142097473e+02 6.1755098402500153e+01 -1.9048699736595154e+02) (float-vector 1.6730499267578125e+02 -5.6180998682975769e+01 -1.8802799284458160e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 1.5308101166951084e-15 -2.4999799206852913e+01 -4.0000000596046448e+02) (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.4999799206852913e+01 -4.0000000596046448e+02) (float-vector -2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector -7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector -1.7000000178813934e+02 7.9999998211860657e+01 -1.0999999940395355e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.2499998807907104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector -7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 1.6588500142097473e+02 6.1755098402500153e+01 -1.9048699736595154e+02) (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector 1.6588500142097473e+02 6.1755098402500153e+01 -1.9048699736595154e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -2.7000001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6088399291038513e+02 -6.9021500647068024e+01 -1.9914799928665161e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6730499267578125e+02 -5.6180998682975769e+01 -1.8802799284458160e+02) (float-vector 1.6088399291038513e+02 -6.9021500647068024e+01 -1.9914799928665161e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6088399291038513e+02 -6.9021500647068024e+01 -1.9914799928665161e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.2499998807907104e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -1.0999999940395355e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6088399291038513e+02 -6.9021500647068024e+01 -1.9914799928665161e+02) (float-vector 1.6730499267578125e+02 -5.6180998682975769e+01 -1.8802799284458160e+02) (float-vector 1.6588500142097473e+02 6.1755098402500153e+01 -1.9048699736595154e+02) (float-vector 1.4000000059604645e+02 7.9999998211860657e+01 -2.7000001072883606e+02) (float-vector 1.4000000059604645e+02 -7.9999998211860657e+01 -2.7000001072883606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector -4.5924302466877485e-15 2.5000199675559998e+01 -4.0000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.5000002980232239e+01 1.3500000536441803e+02 -3.7500000000000000e+02) (float-vector 2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector 1.5308101166951084e-15 -2.4999799206852913e+01 -4.0000000596046448e+02) (float-vector 7.5000002980232239e+01 -1.3500000536441803e+02 -3.7500000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector -4.5924302466877485e-15 2.5000199675559998e+01 -4.0000000596046448e+02) (float-vector -2.5000000372529030e+01 1.8366000631431234e-04 -4.0000000596046448e+02) (float-vector 1.5308101166951084e-15 -2.4999799206852913e+01 -4.0000000596046448e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK3_UiJuEU.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 2.1000000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 -2.3500000000000000e+02 0.0000000000000000e+00 2.3776401519775391e+01 -2.3500000000000000e+02 7.7254300117492676e+00 2.5000000000000000e+01 -2.3500000000000000e+02 0.0000000000000000e+00 2.3776401519775391e+01 -2.8500000000000000e+02 7.7254300117492676e+00 2.5000000000000000e+01 -2.8500000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00 -2.8500000000000000e+02 0.0000000000000000e+00 2.0225400924682617e+01 -2.3500000000000000e+02 1.4694600105285645e+01 2.0225400924682617e+01 -2.8500000000000000e+02 1.4694600105285645e+01 1.4694600105285645e+01 -2.3500000000000000e+02 2.0225400924682617e+01 1.4694600105285645e+01 -2.8500000000000000e+02 2.0225400924682617e+01 7.7254300117492676e+00 -2.3500000000000000e+02 2.3776401519775391e+01 7.7254300117492676e+00 -2.8500000000000000e+02 2.3776401519775391e+01 1.5308101406833461e-15 -2.3500000000000000e+02 2.5000000000000000e+01 1.5308101406833461e-15 -2.8500000000000000e+02 2.5000000000000000e+01 -7.7254300117492676e+00 -2.3500000000000000e+02 2.3776401519775391e+01 -7.7254300117492676e+00 -2.8500000000000000e+02 2.3776401519775391e+01 -1.4694600105285645e+01 -2.3500000000000000e+02 2.0225400924682617e+01 -1.4694600105285645e+01 -2.8500000000000000e+02 2.0225400924682617e+01 -2.0225400924682617e+01 -2.3500000000000000e+02 1.4694600105285645e+01 -2.0225400924682617e+01 -2.8500000000000000e+02 1.4694600105285645e+01 -2.3776401519775391e+01 -2.3500000000000000e+02 7.7254300117492676e+00 -2.3776401519775391e+01 -2.8500000000000000e+02 7.7254300117492676e+00 -2.5000000000000000e+01 -2.3500000000000000e+02 3.0616202813666922e-15 -2.5000000000000000e+01 -2.8500000000000000e+02 3.0616202813666922e-15 -2.3776401519775391e+01 -2.3500000000000000e+02 -7.7254300117492676e+00 -2.3776401519775391e+01 -2.8500000000000000e+02 -7.7254300117492676e+00 -2.0225400924682617e+01 -2.3500000000000000e+02 -1.4694600105285645e+01 -2.0225400924682617e+01 -2.8500000000000000e+02 -1.4694600105285645e+01 -1.4694600105285645e+01 -2.3500000000000000e+02 -2.0225400924682617e+01 -1.4694600105285645e+01 -2.8500000000000000e+02 -2.0225400924682617e+01 -7.7254300117492676e+00 -2.3500000000000000e+02 -2.3776401519775391e+01 -7.7254300117492676e+00 -2.8500000000000000e+02 -2.3776401519775391e+01 -4.5924301044126831e-15 -2.3500000000000000e+02 -2.5000000000000000e+01 -4.5924301044126831e-15 -2.8500000000000000e+02 -2.5000000000000000e+01 7.7254300117492676e+00 -2.3500000000000000e+02 -2.3776401519775391e+01 7.7254300117492676e+00 -2.8500000000000000e+02 -2.3776401519775391e+01 1.4694600105285645e+01 -2.3500000000000000e+02 -2.0225400924682617e+01 1.4694600105285645e+01 -2.8500000000000000e+02 -2.0225400924682617e+01 2.0225400924682617e+01 -2.3500000000000000e+02 -1.4694600105285645e+01 2.0225400924682617e+01 -2.8500000000000000e+02 -1.4694600105285645e+01 2.3776401519775391e+01 -2.3500000000000000e+02 -7.7254300117492676e+00 2.3776401519775391e+01 -2.8500000000000000e+02 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 12 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.8499999642372131e+02 3.0616202333902167e-15) (float-vector -2.0225400105118752e+01 -2.8499999642372131e+02 -1.4694600366055965e+01) (float-vector -2.0225400105118752e+01 -2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -2.3499999940395355e+02 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 -2.8499999642372131e+02 -2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 -2.0225400105118752e+01) (float-vector 1.4694600366055965e+01 -2.3499999940395355e+02 -2.0225400105118752e+01) (float-vector -4.5924302466877485e-15 -2.3499999940395355e+02 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 -2.3499999940395355e+02 1.4694600366055965e+01) (float-vector 7.7254301868379116e+00 -2.3499999940395355e+02 2.3776400834321976e+01) (float-vector 1.5308101166951084e-15 -2.3499999940395355e+02 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 -2.3499999940395355e+02 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 -2.3499999940395355e+02 3.0616202333902167e-15) (float-vector -2.0225400105118752e+01 -2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector -4.5924302466877485e-15 -2.3499999940395355e+02 -2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.3499999940395355e+02 -2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 -2.3499999940395355e+02 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -2.8499999642372131e+02 -1.4694600366055965e+01) (float-vector -4.5924302466877485e-15 -2.8499999642372131e+02 -2.5000000372529030e+01) (float-vector -4.5924302466877485e-15 -2.3499999940395355e+02 -2.5000000372529030e+01) (float-vector -2.0225400105118752e+01 -2.3499999940395355e+02 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.8499999642372131e+02 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector -1.4694600366055965e+01 -2.3499999940395355e+02 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.3499999940395355e+02 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 -2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 -2.8499999642372131e+02 0.0000000000000000e+00) (float-vector 2.5000000372529030e+01 -2.3499999940395355e+02 0.0000000000000000e+00) (float-vector 1.4694600366055965e+01 -2.3499999940395355e+02 -2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector 7.7254301868379116e+00 -2.3499999940395355e+02 2.3776400834321976e+01) (float-vector 2.0225400105118752e+01 -2.3499999940395355e+02 1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.3499999940395355e+02 2.5000000372529030e+01) (float-vector 7.7254301868379116e+00 -2.3499999940395355e+02 2.3776400834321976e+01) (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.8499999642372131e+02 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 -2.8499999642372131e+02 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 -2.3499999940395355e+02 3.0616202333902167e-15) (float-vector -1.4694600366055965e+01 -2.3499999940395355e+02 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3776400834321976e+01 -2.8499999642372131e+02 7.7254301868379116e+00) (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector 2.0225400105118752e+01 -2.3499999940395355e+02 1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.8499999642372131e+02 3.0616202333902167e-15) (float-vector -1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.8499999642372131e+02 2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 2.0225400105118752e+01) (float-vector 2.3776400834321976e+01 -2.8499999642372131e+02 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 -2.8499999642372131e+02 0.0000000000000000e+00) (float-vector 1.4694600366055965e+01 -2.8499999642372131e+02 -2.0225400105118752e+01) (float-vector -4.5924302466877485e-15 -2.8499999642372131e+02 -2.5000000372529030e+01) (float-vector -2.0225400105118752e+01 -2.8499999642372131e+02 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.8499999642372131e+02 0.0000000000000000e+00) (float-vector 2.3776400834321976e+01 -2.8499999642372131e+02 7.7254301868379116e+00) (float-vector 2.0225400105118752e+01 -2.3499999940395355e+02 1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 -2.3499999940395355e+02 0.0000000000000000e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK1_ouz4JC.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 -1.7200000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -1.7200000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 -1.7200000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -1.7200000000000000e+02 0.0000000000000000e+00 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.5000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -2.5000000000000000e+01 0.0000000000000000e+00 2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 1.5308101406833461e-15 2.5000000000000000e+01 2.5000000000000000e+01 1.5308101406833461e-15 -2.5000000000000000e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 -1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 -2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 -2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.5000000000000000e+01 3.0616202813666922e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 3.0616202813666922e-15 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 -2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 -1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 -7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 -4.5924301044126831e-15 2.5000000000000000e+01 -2.5000000000000000e+01 -4.5924301044126831e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 9 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK4_6qWhZg.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 -1.8800000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -1.8800000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 -1.8800000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -1.8800000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.3776300430297852e+01 7.7254300117492676e+00 -2.5000099182128906e+01 2.4999898910522461e+01 0.0000000000000000e+00 2.4999898910522461e+01 2.3776498794555664e+01 7.7254300117492676e+00 2.4999898910522461e+01 2.5000099182128906e+01 0.0000000000000000e+00 2.5000000000000000e+01 9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.0225299835205078e+01 1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 1.4694600105285645e+01 -2.5000099182128906e+01 1.4694499969482422e+01 2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 2.0225400924682617e+01 -2.5000000000000000e+01 7.7253298759460449e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 2.5000000000000000e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 2.3776401519775391e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 2.0225400924682617e+01 -2.4999898910522461e+01 -2.0225500106811523e+01 1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 1.4694600105285645e+01 -2.4999898910522461e+01 -2.3776498794555664e+01 7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 7.7254300117492676e+00 -2.4999898910522461e+01 -2.5000099182128906e+01 3.0616202813666922e-15 2.5000099182128906e+01 -2.4999898910522461e+01 3.0616202813666922e-15 -2.4999898910522461e+01 -2.3776498794555664e+01 -7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 -7.7254300117492676e+00 -2.4999898910522461e+01 -2.0225500106811523e+01 -1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 -1.4694600105285645e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 -2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 -2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7253298759460449e+00 -2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 -2.3776401519775391e+01 -2.5000099182128906e+01 1.4694499969482422e+01 -2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 -2.0225400924682617e+01 -2.5000099182128906e+01 2.0225299835205078e+01 -1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 -1.4694600105285645e+01 -2.5000099182128906e+01 2.3776300430297852e+01 -7.7254300117492676e+00 2.4999898910522461e+01 2.3776498794555664e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.4999899789690971e+01 2.3776499554514885e+01 7.7254301868379116e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.4999899789690971e+01 2.3776499554514885e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 2.3776499554514885e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 2.3776400834321976e+01) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK2_K40ErH.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -1.8366001313552260e-04 0.0000000000000000e+00 4.9999797821044922e+01 4.7552600860595703e+01 1.5450900077819824e+01 4.9999797821044922e+01 4.9999797821044922e+01 0.0000000000000000e+00 1.5000000000000000e+02 4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 5.0000198364257812e+01 0.0000000000000000e+00 1.5000000000000000e+02 1.8366001313552260e-04 0.0000000000000000e+00 4.9999900817871094e+01 4.0450698852539062e+01 2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 2.9389299392700195e+01 4.9999900817871094e+01 2.9389101028442383e+01 4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 4.0450801849365234e+01 4.9999900817871094e+01 1.5450699806213379e+01 4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 5.0000000000000000e+01 5.0000102996826172e+01 -1.5451000213623047e+01 4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 4.7552803039550781e+01 5.0000102996826172e+01 -2.9389400482177734e+01 4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 4.0450801849365234e+01 5.0000102996826172e+01 -4.0451000213623047e+01 2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 2.9389299392700195e+01 5.0000198364257812e+01 -4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 1.5450900077819824e+01 5.0000198364257812e+01 -5.0000198364257812e+01 6.1232299748215438e-15 1.5000000000000000e+02 -4.9999797821044922e+01 6.1232299748215438e-15 5.0000198364257812e+01 -4.7552997589111328e+01 -1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 -1.5450900077819824e+01 5.0000102996826172e+01 -4.0451000213623047e+01 -2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 -2.9389299392700195e+01 5.0000102996826172e+01 -2.9389400482177734e+01 -4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 -4.0450801849365234e+01 5.0000102996826172e+01 -1.5451000213623047e+01 -4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 -4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 -5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 -5.0000000000000000e+01 4.9999900817871094e+01 1.5450699806213379e+01 -4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 -4.7552803039550781e+01 4.9999900817871094e+01 2.9389101028442383e+01 -4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 -4.0450801849365234e+01 4.9999900817871094e+01 4.0450698852539062e+01 -2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 -2.9389299392700195e+01 4.9999797821044922e+01 4.7552600860595703e+01 -1.5450900077819824e+01 1.5000000000000000e+02 4.7552997589111328e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK6_EJGfEc.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.5000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -2.5000000000000000e+01 0.0000000000000000e+00 2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 1.5308101406833461e-15 2.5000000000000000e+01 2.5000000000000000e+01 1.5308101406833461e-15 -2.5000000000000000e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 -1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 -2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 -2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.5000000000000000e+01 3.0616202813666922e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 3.0616202813666922e-15 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 -2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 -1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 -7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 -4.5924301044126831e-15 2.5000000000000000e+01 -2.5000000000000000e+01 -4.5924301044126831e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.900000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -4.5000000000000000e+01 -2.0000000000000000e+02 -2.5000000000000000e+01 -4.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -1.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -1.5000000000000000e+01 -2.0000000000000000e+02 2.5000000000000000e+01 -1.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -1.5000000000000000e+01 -2.0000000000000000e+02 2.5000000000000000e+01 -4.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -4.5000000000000000e+01 -2.0000000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.3776300430297852e+01 7.7254300117492676e+00 -2.5000099182128906e+01 2.4999898910522461e+01 0.0000000000000000e+00 2.4999898910522461e+01 2.3776498794555664e+01 7.7254300117492676e+00 2.4999898910522461e+01 2.5000099182128906e+01 0.0000000000000000e+00 2.5000000000000000e+01 9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.0225299835205078e+01 1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 1.4694600105285645e+01 -2.5000099182128906e+01 1.4694499969482422e+01 2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 2.0225400924682617e+01 -2.5000000000000000e+01 7.7253298759460449e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 2.5000000000000000e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 2.3776401519775391e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 2.0225400924682617e+01 -2.4999898910522461e+01 -2.0225500106811523e+01 1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 1.4694600105285645e+01 -2.4999898910522461e+01 -2.3776498794555664e+01 7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 7.7254300117492676e+00 -2.4999898910522461e+01 -2.5000099182128906e+01 3.0616202813666922e-15 2.5000099182128906e+01 -2.4999898910522461e+01 3.0616202813666922e-15 -2.4999898910522461e+01 -2.3776498794555664e+01 -7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 -7.7254300117492676e+00 -2.4999898910522461e+01 -2.0225500106811523e+01 -1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 -1.4694600105285645e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 -2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 -2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7253298759460449e+00 -2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 -2.3776401519775391e+01 -2.5000099182128906e+01 1.4694499969482422e+01 -2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 -2.0225400924682617e+01 -2.5000099182128906e+01 2.0225299835205078e+01 -1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 -1.4694600105285645e+01 -2.5000099182128906e+01 2.3776300430297852e+01 -7.7254300117492676e+00 2.4999898910522461e+01 2.3776498794555664e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 516 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7254301868379116e+00 2.5000000372529030e+01 -2.3776400834321976e+01) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 -7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 -2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 -2.0225400105118752e+01) (float-vector -7.7254301868379116e+00 2.5000000372529030e+01 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.5000099092721939e+01 1.4694499783217907e+01 2.0225400105118752e+01) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 -7.7254301868379116e+00) (float-vector -7.7254301868379116e+00 2.5000000372529030e+01 -2.3776400834321976e+01) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 -2.0225400105118752e+01) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01) (float-vector -2.5000099092721939e+01 1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 2.3776400834321976e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 -7.7254301868379116e+00) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.5000099092721939e+01 1.4694499783217907e+01 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK6_AYcPps.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 -1.8800000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -1.8800000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 -1.8800000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -1.8800000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.3776300430297852e+01 7.7254300117492676e+00 -2.5000099182128906e+01 2.4999898910522461e+01 0.0000000000000000e+00 2.4999898910522461e+01 2.3776498794555664e+01 7.7254300117492676e+00 2.4999898910522461e+01 2.5000099182128906e+01 0.0000000000000000e+00 2.5000000000000000e+01 9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.0225299835205078e+01 1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 1.4694600105285645e+01 -2.5000099182128906e+01 1.4694499969482422e+01 2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 2.0225400924682617e+01 -2.5000000000000000e+01 7.7253298759460449e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 2.5000000000000000e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 2.3776401519775391e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 2.0225400924682617e+01 -2.4999898910522461e+01 -2.0225500106811523e+01 1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 1.4694600105285645e+01 -2.4999898910522461e+01 -2.3776498794555664e+01 7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 7.7254300117492676e+00 -2.4999898910522461e+01 -2.5000099182128906e+01 3.0616202813666922e-15 2.5000099182128906e+01 -2.4999898910522461e+01 3.0616202813666922e-15 -2.4999898910522461e+01 -2.3776498794555664e+01 -7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 -7.7254300117492676e+00 -2.4999898910522461e+01 -2.0225500106811523e+01 -1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 -1.4694600105285645e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 -2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 -2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7253298759460449e+00 -2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 -2.3776401519775391e+01 -2.5000099182128906e+01 1.4694499969482422e+01 -2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 -2.0225400924682617e+01 -2.5000099182128906e+01 2.0225299835205078e+01 -1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 -1.4694600105285645e+01 -2.5000099182128906e+01 2.3776300430297852e+01 -7.7254300117492676e+00 2.4999898910522461e+01 2.3776498794555664e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.4999899789690971e+01 2.3776499554514885e+01 7.7254301868379116e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.8799999356269836e+02) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector 2.4999899789690971e+01 2.3776499554514885e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.8799999356269836e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 2.3776499554514885e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 2.3776400834321976e+01) (float-vector -2.5000099092721939e+01 2.3776300251483917e+01 7.7254301868379116e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK2_4xZ3G5.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.6300000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 -9.1830101155210286e-05 3.3800000000000000e+02 2.3776401519775391e+01 -7.7255201339721680e+00 3.3800000000000000e+02 2.5000000000000000e+01 -9.1830101155210286e-05 3.3800000000000000e+02 2.3776401519775391e+01 -7.7253298759460449e+00 2.8800000000000000e+02 2.5000000000000000e+01 9.1830101155210286e-05 2.8800000000000000e+02 0.0000000000000000e+00 9.1830101155210286e-05 2.8800000000000000e+02 2.0225400924682617e+01 -1.4694700241088867e+01 3.3800000000000000e+02 2.0225400924682617e+01 -1.4694499969482422e+01 2.8800000000000000e+02 1.4694600105285645e+01 -2.0225500106811523e+01 3.3800000000000000e+02 1.4694600105285645e+01 -2.0225299835205078e+01 2.8800000000000000e+02 7.7254300117492676e+00 -2.3776498794555664e+01 3.3800000000000000e+02 7.7254300117492676e+00 -2.3776300430297852e+01 2.8800000000000000e+02 1.5308101406833461e-15 -2.5000099182128906e+01 3.3800000000000000e+02 1.5308101406833461e-15 -2.4999898910522461e+01 2.8800000000000000e+02 -7.7254300117492676e+00 -2.3776498794555664e+01 3.3800000000000000e+02 -7.7254300117492676e+00 -2.3776300430297852e+01 2.8800000000000000e+02 -1.4694600105285645e+01 -2.0225500106811523e+01 3.3800000000000000e+02 -1.4694600105285645e+01 -2.0225299835205078e+01 2.8800000000000000e+02 -2.0225400924682617e+01 -1.4694700241088867e+01 3.3800000000000000e+02 -2.0225400924682617e+01 -1.4694499969482422e+01 2.8800000000000000e+02 -2.3776401519775391e+01 -7.7255201339721680e+00 3.3800000000000000e+02 -2.3776401519775391e+01 -7.7253298759460449e+00 2.8800000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 3.3800000000000000e+02 -2.5000000000000000e+01 9.1830101155210286e-05 2.8800000000000000e+02 -2.3776401519775391e+01 7.7253298759460449e+00 3.3800000000000000e+02 -2.3776401519775391e+01 7.7255201339721680e+00 2.8800000000000000e+02 -2.0225400924682617e+01 1.4694499969482422e+01 3.3800000000000000e+02 -2.0225400924682617e+01 1.4694700241088867e+01 2.8800000000000000e+02 -1.4694600105285645e+01 2.0225299835205078e+01 3.3800000000000000e+02 -1.4694600105285645e+01 2.0225500106811523e+01 2.8800000000000000e+02 -7.7254300117492676e+00 2.3776300430297852e+01 3.3800000000000000e+02 -7.7254300117492676e+00 2.3776498794555664e+01 2.8800000000000000e+02 -4.5924301044126831e-15 2.4999898910522461e+01 3.3800000000000000e+02 -4.5924301044126831e-15 2.5000099182128906e+01 2.8800000000000000e+02 7.7254300117492676e+00 2.3776300430297852e+01 3.3800000000000000e+02 7.7254300117492676e+00 2.3776498794555664e+01 2.8800000000000000e+02 1.4694600105285645e+01 2.0225299835205078e+01 3.3800000000000000e+02 1.4694600105285645e+01 2.0225500106811523e+01 2.8800000000000000e+02 2.0225400924682617e+01 1.4694499969482422e+01 3.3800000000000000e+02 2.0225400924682617e+01 1.4694700241088867e+01 2.8800000000000000e+02 2.3776401519775391e+01 7.7253298759460449e+00 3.3800000000000000e+02 2.3776401519775391e+01 7.7255201339721680e+00 2.8800000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.8799998760223389e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.8799998760223389e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.8799998760223389e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.3799999952316284e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.3799999952316284e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.8799998760223389e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.8799998760223389e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.3799999952316284e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.3799999952316284e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.3799999952316284e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.3799999952316284e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.8799998760223389e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.8799998760223389e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.3799999952316284e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.3799999952316284e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.8799998760223389e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.8799998760223389e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.8799998760223389e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.8799998760223389e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.8799998760223389e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.3799999952316284e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.3799999952316284e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.8799998760223389e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK3_YqjX8L.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 -1.7200000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -1.7200000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 -1.7200000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -1.7200000000000000e+02 0.0000000000000000e+00 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.5000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -2.5000000000000000e+01 0.0000000000000000e+00 2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 1.5308101406833461e-15 2.5000000000000000e+01 2.5000000000000000e+01 1.5308101406833461e-15 -2.5000000000000000e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 -1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 -2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 -2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.5000000000000000e+01 3.0616202813666922e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 3.0616202813666922e-15 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 -2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 -1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 -7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 -4.5924301044126831e-15 2.5000000000000000e+01 -2.5000000000000000e+01 -4.5924301044126831e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 9 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector -2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3776400834321976e+01 2.5000000372529030e+01 7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7200000584125519e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 7.7254301868379116e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK4_kf6sSQ.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -2.1000000000000000e+02 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 2.8500000000000000e+02 0.0000000000000000e+00 2.3776401519775391e+01 2.8500000000000000e+02 7.7254300117492676e+00 2.5000000000000000e+01 2.8500000000000000e+02 0.0000000000000000e+00 2.3776401519775391e+01 2.3500000000000000e+02 7.7254300117492676e+00 2.5000000000000000e+01 2.3500000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00 2.3500000000000000e+02 0.0000000000000000e+00 2.0225400924682617e+01 2.8500000000000000e+02 1.4694600105285645e+01 2.0225400924682617e+01 2.3500000000000000e+02 1.4694600105285645e+01 1.4694600105285645e+01 2.8500000000000000e+02 2.0225400924682617e+01 1.4694600105285645e+01 2.3500000000000000e+02 2.0225400924682617e+01 7.7254300117492676e+00 2.8500000000000000e+02 2.3776401519775391e+01 7.7254300117492676e+00 2.3500000000000000e+02 2.3776401519775391e+01 1.5308101406833461e-15 2.8500000000000000e+02 2.5000000000000000e+01 1.5308101406833461e-15 2.3500000000000000e+02 2.5000000000000000e+01 -7.7254300117492676e+00 2.8500000000000000e+02 2.3776401519775391e+01 -7.7254300117492676e+00 2.3500000000000000e+02 2.3776401519775391e+01 -1.4694600105285645e+01 2.8500000000000000e+02 2.0225400924682617e+01 -1.4694600105285645e+01 2.3500000000000000e+02 2.0225400924682617e+01 -2.0225400924682617e+01 2.8500000000000000e+02 1.4694600105285645e+01 -2.0225400924682617e+01 2.3500000000000000e+02 1.4694600105285645e+01 -2.3776401519775391e+01 2.8500000000000000e+02 7.7254300117492676e+00 -2.3776401519775391e+01 2.3500000000000000e+02 7.7254300117492676e+00 -2.5000000000000000e+01 2.8500000000000000e+02 3.0616202813666922e-15 -2.5000000000000000e+01 2.3500000000000000e+02 3.0616202813666922e-15 -2.3776401519775391e+01 2.8500000000000000e+02 -7.7254300117492676e+00 -2.3776401519775391e+01 2.3500000000000000e+02 -7.7254300117492676e+00 -2.0225400924682617e+01 2.8500000000000000e+02 -1.4694600105285645e+01 -2.0225400924682617e+01 2.3500000000000000e+02 -1.4694600105285645e+01 -1.4694600105285645e+01 2.8500000000000000e+02 -2.0225400924682617e+01 -1.4694600105285645e+01 2.3500000000000000e+02 -2.0225400924682617e+01 -7.7254300117492676e+00 2.8500000000000000e+02 -2.3776401519775391e+01 -7.7254300117492676e+00 2.3500000000000000e+02 -2.3776401519775391e+01 -4.5924301044126831e-15 2.8500000000000000e+02 -2.5000000000000000e+01 -4.5924301044126831e-15 2.3500000000000000e+02 -2.5000000000000000e+01 7.7254300117492676e+00 2.8500000000000000e+02 -2.3776401519775391e+01 7.7254300117492676e+00 2.3500000000000000e+02 -2.3776401519775391e+01 1.4694600105285645e+01 2.8500000000000000e+02 -2.0225400924682617e+01 1.4694600105285645e+01 2.3500000000000000e+02 -2.0225400924682617e+01 2.0225400924682617e+01 2.8500000000000000e+02 -1.4694600105285645e+01 2.0225400924682617e+01 2.3500000000000000e+02 -1.4694600105285645e+01 2.3776401519775391e+01 2.8500000000000000e+02 -7.7254300117492676e+00 2.3776401519775391e+01 2.3500000000000000e+02 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 12 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.3499999940395355e+02 3.0616202333902167e-15) (float-vector -2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector -2.0225400105118752e+01 2.8499999642372131e+02 -1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 2.8499999642372131e+02 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector 2.3776400834321976e+01 2.8499999642372131e+02 -7.7254301868379116e+00) (float-vector 1.4694600366055965e+01 2.8499999642372131e+02 -2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.8499999642372131e+02 0.0000000000000000e+00) (float-vector 2.3776400834321976e+01 2.8499999642372131e+02 -7.7254301868379116e+00) (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 2.3499999940395355e+02 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.8499999642372131e+02 0.0000000000000000e+00) (float-vector 2.0225400105118752e+01 2.8499999642372131e+02 1.4694600366055965e+01) (float-vector 1.5308101166951084e-15 2.8499999642372131e+02 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 2.8499999642372131e+02 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 2.8499999642372131e+02 3.0616202333902167e-15) (float-vector -2.0225400105118752e+01 2.8499999642372131e+02 -1.4694600366055965e+01) (float-vector -4.5924302466877485e-15 2.8499999642372131e+02 -2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 2.8499999642372131e+02 -2.0225400105118752e+01) (float-vector 2.3776400834321976e+01 2.8499999642372131e+02 -7.7254301868379116e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector -4.5924302466877485e-15 2.3499999940395355e+02 -2.5000000372529030e+01) (float-vector -4.5924302466877485e-15 2.8499999642372131e+02 -2.5000000372529030e+01) (float-vector -2.0225400105118752e+01 2.8499999642372131e+02 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 2.3499999940395355e+02 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 2.3499999940395355e+02 2.0225400105118752e+01) (float-vector -1.4694600366055965e+01 2.8499999642372131e+02 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.8499999642372131e+02 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7254301868379116e+00 2.3499999940395355e+02 -2.3776400834321976e+01) (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector 1.4694600366055965e+01 2.8499999642372131e+02 -2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.3499999940395355e+02 -2.5000000372529030e+01) (float-vector 7.7254301868379116e+00 2.3499999940395355e+02 -2.3776400834321976e+01) (float-vector 1.4694600366055965e+01 2.8499999642372131e+02 -2.0225400105118752e+01) (float-vector -4.5924302466877485e-15 2.8499999642372131e+02 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.3499999940395355e+02 0.0000000000000000e+00) (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 1.4694600366055965e+01) (float-vector 2.0225400105118752e+01 2.8499999642372131e+02 1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 2.8499999642372131e+02 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.3499999940395355e+02 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 2.3499999940395355e+02 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 2.8499999642372131e+02 3.0616202333902167e-15) (float-vector -1.4694600366055965e+01 2.8499999642372131e+02 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.3499999940395355e+02 3.0616202333902167e-15) (float-vector -1.4694600366055965e+01 2.3499999940395355e+02 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.3499999940395355e+02 2.5000000372529030e+01) (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 2.3499999940395355e+02 0.0000000000000000e+00) (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01) (float-vector 7.7254301868379116e+00 2.3499999940395355e+02 -2.3776400834321976e+01) (float-vector -4.5924302466877485e-15 2.3499999940395355e+02 -2.5000000372529030e+01) (float-vector -2.0225400105118752e+01 2.3499999940395355e+02 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 2.3499999940395355e+02 1.4694600366055965e+01) (float-vector 1.5308101166951084e-15 2.3499999940395355e+02 2.5000000372529030e+01) (float-vector 1.5308101166951084e-15 2.8499999642372131e+02 2.5000000372529030e+01) (float-vector 2.0225400105118752e+01 2.8499999642372131e+02 1.4694600366055965e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK1_qAOz6Z.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.4700000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 -9.1830101155210286e-05 3.2200000000000000e+02 2.3776401519775391e+01 -7.7255201339721680e+00 3.2200000000000000e+02 2.5000000000000000e+01 -9.1830101155210286e-05 3.2200000000000000e+02 2.3776401519775391e+01 -7.7253298759460449e+00 2.7200000000000000e+02 2.5000000000000000e+01 9.1830101155210286e-05 2.7200000000000000e+02 0.0000000000000000e+00 9.1830101155210286e-05 2.7200000000000000e+02 2.0225400924682617e+01 -1.4694700241088867e+01 3.2200000000000000e+02 2.0225400924682617e+01 -1.4694499969482422e+01 2.7200000000000000e+02 1.4694600105285645e+01 -2.0225500106811523e+01 3.2200000000000000e+02 1.4694600105285645e+01 -2.0225299835205078e+01 2.7200000000000000e+02 7.7254300117492676e+00 -2.3776498794555664e+01 3.2200000000000000e+02 7.7254300117492676e+00 -2.3776300430297852e+01 2.7200000000000000e+02 1.5308101406833461e-15 -2.5000099182128906e+01 3.2200000000000000e+02 1.5308101406833461e-15 -2.4999898910522461e+01 2.7200000000000000e+02 -7.7254300117492676e+00 -2.3776498794555664e+01 3.2200000000000000e+02 -7.7254300117492676e+00 -2.3776300430297852e+01 2.7200000000000000e+02 -1.4694600105285645e+01 -2.0225500106811523e+01 3.2200000000000000e+02 -1.4694600105285645e+01 -2.0225299835205078e+01 2.7200000000000000e+02 -2.0225400924682617e+01 -1.4694700241088867e+01 3.2200000000000000e+02 -2.0225400924682617e+01 -1.4694499969482422e+01 2.7200000000000000e+02 -2.3776401519775391e+01 -7.7255201339721680e+00 3.2200000000000000e+02 -2.3776401519775391e+01 -7.7253298759460449e+00 2.7200000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 3.2200000000000000e+02 -2.5000000000000000e+01 9.1830101155210286e-05 2.7200000000000000e+02 -2.3776401519775391e+01 7.7253298759460449e+00 3.2200000000000000e+02 -2.3776401519775391e+01 7.7255201339721680e+00 2.7200000000000000e+02 -2.0225400924682617e+01 1.4694499969482422e+01 3.2200000000000000e+02 -2.0225400924682617e+01 1.4694700241088867e+01 2.7200000000000000e+02 -1.4694600105285645e+01 2.0225299835205078e+01 3.2200000000000000e+02 -1.4694600105285645e+01 2.0225500106811523e+01 2.7200000000000000e+02 -7.7254300117492676e+00 2.3776300430297852e+01 3.2200000000000000e+02 -7.7254300117492676e+00 2.3776498794555664e+01 2.7200000000000000e+02 -4.5924301044126831e-15 2.4999898910522461e+01 3.2200000000000000e+02 -4.5924301044126831e-15 2.5000099182128906e+01 2.7200000000000000e+02 7.7254300117492676e+00 2.3776300430297852e+01 3.2200000000000000e+02 7.7254300117492676e+00 2.3776498794555664e+01 2.7200000000000000e+02 1.4694600105285645e+01 2.0225299835205078e+01 3.2200000000000000e+02 1.4694600105285645e+01 2.0225500106811523e+01 2.7200000000000000e+02 2.0225400924682617e+01 1.4694499969482422e+01 3.2200000000000000e+02 2.0225400924682617e+01 1.4694700241088867e+01 2.7200000000000000e+02 2.3776401519775391e+01 7.7253298759460449e+00 3.2200000000000000e+02 2.3776401519775391e+01 7.7255201339721680e+00 2.7200000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.7200001478195190e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.7200001478195190e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.7200001478195190e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.2199999690055847e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.2199999690055847e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.7200001478195190e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.7200001478195190e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.2199999690055847e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.2199999690055847e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.2199999690055847e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.2199999690055847e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.7200001478195190e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.7200001478195190e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.2199999690055847e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.2199999690055847e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.7200001478195190e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.7200001478195190e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.7200001478195190e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.7200001478195190e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.7200001478195190e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.2199999690055847e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.2199999690055847e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.7200001478195190e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK5_8TYpDV.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 7.0000000000000000e+01 -7.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -5.0000000000000000e+01 1.8000000000000000e+02 -7.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -1.8366001313552260e-04 0.0000000000000000e+00 4.9999797821044922e+01 4.7552600860595703e+01 1.5450900077819824e+01 4.9999797821044922e+01 4.9999797821044922e+01 0.0000000000000000e+00 1.5000000000000000e+02 4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 5.0000198364257812e+01 0.0000000000000000e+00 1.5000000000000000e+02 1.8366001313552260e-04 0.0000000000000000e+00 4.9999900817871094e+01 4.0450698852539062e+01 2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 2.9389299392700195e+01 4.9999900817871094e+01 2.9389101028442383e+01 4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 4.0450801849365234e+01 4.9999900817871094e+01 1.5450699806213379e+01 4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 5.0000000000000000e+01 5.0000102996826172e+01 -1.5451000213623047e+01 4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 4.7552803039550781e+01 5.0000102996826172e+01 -2.9389400482177734e+01 4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 4.0450801849365234e+01 5.0000102996826172e+01 -4.0451000213623047e+01 2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 2.9389299392700195e+01 5.0000198364257812e+01 -4.7552997589111328e+01 1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 1.5450900077819824e+01 5.0000198364257812e+01 -5.0000198364257812e+01 6.1232299748215438e-15 1.5000000000000000e+02 -4.9999797821044922e+01 6.1232299748215438e-15 5.0000198364257812e+01 -4.7552997589111328e+01 -1.5450900077819824e+01 1.5000000000000000e+02 -4.7552600860595703e+01 -1.5450900077819824e+01 5.0000102996826172e+01 -4.0451000213623047e+01 -2.9389299392700195e+01 1.5000000000000000e+02 -4.0450698852539062e+01 -2.9389299392700195e+01 5.0000102996826172e+01 -2.9389400482177734e+01 -4.0450801849365234e+01 1.5000000000000000e+02 -2.9389101028442383e+01 -4.0450801849365234e+01 5.0000102996826172e+01 -1.5451000213623047e+01 -4.7552803039550781e+01 1.5000000000000000e+02 -1.5450699806213379e+01 -4.7552803039550781e+01 5.0000000000000000e+01 -1.8366001313552260e-04 -5.0000000000000000e+01 1.5000000000000000e+02 1.8366001313552260e-04 -5.0000000000000000e+01 4.9999900817871094e+01 1.5450699806213379e+01 -4.7552803039550781e+01 1.5000000000000000e+02 1.5451000213623047e+01 -4.7552803039550781e+01 4.9999900817871094e+01 2.9389101028442383e+01 -4.0450801849365234e+01 1.5000000000000000e+02 2.9389400482177734e+01 -4.0450801849365234e+01 4.9999900817871094e+01 4.0450698852539062e+01 -2.9389299392700195e+01 1.5000000000000000e+02 4.0451000213623047e+01 -2.9389299392700195e+01 4.9999797821044922e+01 4.7552600860595703e+01 -1.5450900077819824e+01 1.5000000000000000e+02 4.7552997589111328e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.8000000715255737e+02 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -1.8366000631431234e-04 5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.5450700186192989e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 2.9389100149273872e+01 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 4.0450699627399445e+01 2.9389299452304840e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5000000596046448e+02 2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 1.5000000596046448e+02 4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 1.8000000715255737e+02 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 1.5000000596046448e+02 1.5451000072062016e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -4.0451001375913620e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -2.9389400035142899e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 -1.5451000072062016e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -1.5450700186192989e+01 4.7552801668643951e+01) (float-vector 1.5000000596046448e+02 -4.0450699627399445e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK6_Q17ItE.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.5000000000000000e+01 0.0000000000000000e+00 2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.5000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -2.5000000000000000e+01 0.0000000000000000e+00 2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 1.5308101406833461e-15 2.5000000000000000e+01 2.5000000000000000e+01 1.5308101406833461e-15 -2.5000000000000000e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.5000000000000000e+01 2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 2.3776401519775391e+01 -1.4694600105285645e+01 2.5000000000000000e+01 2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 2.0225400924682617e+01 -2.0225400924682617e+01 2.5000000000000000e+01 1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 1.4694600105285645e+01 -2.3776401519775391e+01 2.5000000000000000e+01 7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 7.7254300117492676e+00 -2.5000000000000000e+01 2.5000000000000000e+01 3.0616202813666922e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 3.0616202813666922e-15 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 -2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 -1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 -1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 -7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 -7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 -4.5924301044126831e-15 2.5000000000000000e+01 -2.5000000000000000e+01 -4.5924301044126831e-15 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7254300117492676e+00 2.5000000000000000e+01 -2.3776401519775391e+01 7.7254300117492676e+00 -2.5000000000000000e+01 -2.3776401519775391e+01 1.4694600105285645e+01 2.5000000000000000e+01 -2.0225400924682617e+01 1.4694600105285645e+01 -2.5000000000000000e+01 -2.0225400924682617e+01 2.0225400924682617e+01 2.5000000000000000e+01 -1.4694600105285645e+01 2.0225400924682617e+01 -2.5000000000000000e+01 -1.4694600105285645e+01 2.3776401519775391e+01 2.5000000000000000e+01 -7.7254300117492676e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -7.7254300117492676e+00 )) mat)))
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.900000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 1.5000000000000000e+01 -2.0000000000000000e+02 -2.5000000000000000e+01 1.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 4.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 4.5000000000000000e+01 -2.0000000000000000e+02 2.5000000000000000e+01 4.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 4.5000000000000000e+01 -2.0000000000000000e+02 2.5000000000000000e+01 1.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 1.5000000000000000e+01 -2.0000000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.3776300430297852e+01 7.7254300117492676e+00 -2.5000099182128906e+01 2.4999898910522461e+01 0.0000000000000000e+00 2.4999898910522461e+01 2.3776498794555664e+01 7.7254300117492676e+00 2.4999898910522461e+01 2.5000099182128906e+01 0.0000000000000000e+00 2.5000000000000000e+01 9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.0225299835205078e+01 1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 1.4694600105285645e+01 -2.5000099182128906e+01 1.4694499969482422e+01 2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 2.0225400924682617e+01 -2.5000000000000000e+01 7.7253298759460449e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 2.5000000000000000e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 2.3776401519775391e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 2.0225400924682617e+01 -2.4999898910522461e+01 -2.0225500106811523e+01 1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 1.4694600105285645e+01 -2.4999898910522461e+01 -2.3776498794555664e+01 7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 7.7254300117492676e+00 -2.4999898910522461e+01 -2.5000099182128906e+01 3.0616202813666922e-15 2.5000099182128906e+01 -2.4999898910522461e+01 3.0616202813666922e-15 -2.4999898910522461e+01 -2.3776498794555664e+01 -7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 -7.7254300117492676e+00 -2.4999898910522461e+01 -2.0225500106811523e+01 -1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 -1.4694600105285645e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 -2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 -2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7253298759460449e+00 -2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 -2.3776401519775391e+01 -2.5000099182128906e+01 1.4694499969482422e+01 -2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 -2.0225400924682617e+01 -2.5000099182128906e+01 2.0225299835205078e+01 -1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 -1.4694600105285645e+01 -2.5000099182128906e+01 2.3776300430297852e+01 -7.7254300117492676e+00 2.4999898910522461e+01 2.3776498794555664e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 516 -> 20 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 1.4694600366055965e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 -7.7254301868379116e+00) (float-vector 2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 -2.3776400834321976e+01) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.5000099092721939e+01 1.4694499783217907e+01 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000099092721939e+01 1.4694499783217907e+01 2.0225400105118752e+01) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 1.4694700017571449e+01 2.0225400105118752e+01) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.0000000298023224e+02) (float-vector -2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector -2.5000099092721939e+01 1.4694499783217907e+01 2.0225400105118752e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 1.4694600366055965e+01) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector -1.4694600366055965e+01 -2.5000000372529030e+01 2.0225400105118752e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 -7.7254301868379116e+00) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.4694600366055965e+01) (float-vector -7.7254301868379116e+00 -2.5000000372529030e+01 -2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 1.4999999664723873e+01 -2.0000000298023224e+02) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 -7.7254301868379116e+00) (float-vector 2.5000099092721939e+01 -2.3776300251483917e+01 7.7254301868379116e+00) (float-vector 2.5000099092721939e+01 -1.4694499783217907e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 2.4999899789690971e+01 1.4694700017571449e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 4.5000001788139343e+01 -2.0000000298023224e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 1.4694700017571449e+01 2.0225400105118752e+01) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.5000000372529030e+01) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 2.5000000372529030e+01) (float-vector 1.4694600366055965e+01 2.5000000372529030e+01 2.0225400105118752e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK6_imhCq0.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK3_ImCB77.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.4700000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 -9.1830101155210286e-05 3.2200000000000000e+02 2.3776401519775391e+01 -7.7255201339721680e+00 3.2200000000000000e+02 2.5000000000000000e+01 -9.1830101155210286e-05 3.2200000000000000e+02 2.3776401519775391e+01 -7.7253298759460449e+00 2.7200000000000000e+02 2.5000000000000000e+01 9.1830101155210286e-05 2.7200000000000000e+02 0.0000000000000000e+00 9.1830101155210286e-05 2.7200000000000000e+02 2.0225400924682617e+01 -1.4694700241088867e+01 3.2200000000000000e+02 2.0225400924682617e+01 -1.4694499969482422e+01 2.7200000000000000e+02 1.4694600105285645e+01 -2.0225500106811523e+01 3.2200000000000000e+02 1.4694600105285645e+01 -2.0225299835205078e+01 2.7200000000000000e+02 7.7254300117492676e+00 -2.3776498794555664e+01 3.2200000000000000e+02 7.7254300117492676e+00 -2.3776300430297852e+01 2.7200000000000000e+02 1.5308101406833461e-15 -2.5000099182128906e+01 3.2200000000000000e+02 1.5308101406833461e-15 -2.4999898910522461e+01 2.7200000000000000e+02 -7.7254300117492676e+00 -2.3776498794555664e+01 3.2200000000000000e+02 -7.7254300117492676e+00 -2.3776300430297852e+01 2.7200000000000000e+02 -1.4694600105285645e+01 -2.0225500106811523e+01 3.2200000000000000e+02 -1.4694600105285645e+01 -2.0225299835205078e+01 2.7200000000000000e+02 -2.0225400924682617e+01 -1.4694700241088867e+01 3.2200000000000000e+02 -2.0225400924682617e+01 -1.4694499969482422e+01 2.7200000000000000e+02 -2.3776401519775391e+01 -7.7255201339721680e+00 3.2200000000000000e+02 -2.3776401519775391e+01 -7.7253298759460449e+00 2.7200000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 3.2200000000000000e+02 -2.5000000000000000e+01 9.1830101155210286e-05 2.7200000000000000e+02 -2.3776401519775391e+01 7.7253298759460449e+00 3.2200000000000000e+02 -2.3776401519775391e+01 7.7255201339721680e+00 2.7200000000000000e+02 -2.0225400924682617e+01 1.4694499969482422e+01 3.2200000000000000e+02 -2.0225400924682617e+01 1.4694700241088867e+01 2.7200000000000000e+02 -1.4694600105285645e+01 2.0225299835205078e+01 3.2200000000000000e+02 -1.4694600105285645e+01 2.0225500106811523e+01 2.7200000000000000e+02 -7.7254300117492676e+00 2.3776300430297852e+01 3.2200000000000000e+02 -7.7254300117492676e+00 2.3776498794555664e+01 2.7200000000000000e+02 -4.5924301044126831e-15 2.4999898910522461e+01 3.2200000000000000e+02 -4.5924301044126831e-15 2.5000099182128906e+01 2.7200000000000000e+02 7.7254300117492676e+00 2.3776300430297852e+01 3.2200000000000000e+02 7.7254300117492676e+00 2.3776498794555664e+01 2.7200000000000000e+02 1.4694600105285645e+01 2.0225299835205078e+01 3.2200000000000000e+02 1.4694600105285645e+01 2.0225500106811523e+01 2.7200000000000000e+02 2.0225400924682617e+01 1.4694499969482422e+01 3.2200000000000000e+02 2.0225400924682617e+01 1.4694700241088867e+01 2.7200000000000000e+02 2.3776401519775391e+01 7.7253298759460449e+00 3.2200000000000000e+02 2.3776401519775391e+01 7.7255201339721680e+00 2.7200000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.7200001478195190e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.7200001478195190e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.7200001478195190e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.2199999690055847e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.2199999690055847e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.7200001478195190e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.7200001478195190e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.2199999690055847e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.2199999690055847e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.2199999690055847e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.2199999690055847e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.2199999690055847e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.7200001478195190e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.7200001478195190e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.2199999690055847e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.2199999690055847e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.2199999690055847e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.2199999690055847e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.7200001478195190e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.7200001478195190e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.7200001478195190e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.7200001478195190e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.7200001478195190e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.7200001478195190e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.7200001478195190e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.7200001478195190e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.2199999690055847e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.2199999690055847e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.7200001478195190e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.7200001478195190e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK5_o9MsGm.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK2_EZHtoj.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -9.0000198364257812e+01 0.0000000000000000e+00 -5.0000198364257812e+01 -4.2447399139404297e+01 1.5450900077819824e+01 -5.0000198364257812e+01 -4.0000198364257812e+01 0.0000000000000000e+00 4.9999797821044922e+01 -4.2447002410888672e+01 1.5450900077819824e+01 4.9999797821044922e+01 -3.9999801635742188e+01 0.0000000000000000e+00 5.0000000000000000e+01 -8.9999801635742188e+01 0.0000000000000000e+00 -5.0000102996826172e+01 -4.9549301147460938e+01 2.9389299392700195e+01 4.9999900817871094e+01 -4.9548999786376953e+01 2.9389299392700195e+01 -5.0000102996826172e+01 -6.0610900878906250e+01 4.0450801849365234e+01 4.9999900817871094e+01 -6.0610599517822266e+01 4.0450801849365234e+01 -5.0000102996826172e+01 -7.4549301147460938e+01 4.7552803039550781e+01 4.9999900817871094e+01 -7.4548995971679688e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -9.0000198364257812e+01 5.0000000000000000e+01 5.0000000000000000e+01 -8.9999801635742188e+01 5.0000000000000000e+01 -4.9999900817871094e+01 -1.0545100402832031e+02 4.7552803039550781e+01 5.0000102996826172e+01 -1.0545100402832031e+02 4.7552803039550781e+01 -4.9999900817871094e+01 -1.1938899993896484e+02 4.0450801849365234e+01 5.0000102996826172e+01 -1.1938899993896484e+02 4.0450801849365234e+01 -4.9999900817871094e+01 -1.3045098876953125e+02 2.9389299392700195e+01 5.0000102996826172e+01 -1.3045098876953125e+02 2.9389299392700195e+01 -4.9999797821044922e+01 -1.3755300903320312e+02 1.5450900077819824e+01 5.0000198364257812e+01 -1.3755300903320312e+02 1.5450900077819824e+01 -4.9999797821044922e+01 -1.4000000000000000e+02 6.1232299748215438e-15 5.0000198364257812e+01 -1.4000000000000000e+02 6.1232299748215438e-15 -4.9999797821044922e+01 -1.3755300903320312e+02 -1.5450900077819824e+01 5.0000198364257812e+01 -1.3755300903320312e+02 -1.5450900077819824e+01 -4.9999900817871094e+01 -1.3045098876953125e+02 -2.9389299392700195e+01 5.0000102996826172e+01 -1.3045098876953125e+02 -2.9389299392700195e+01 -4.9999900817871094e+01 -1.1938899993896484e+02 -4.0450801849365234e+01 5.0000102996826172e+01 -1.1938899993896484e+02 -4.0450801849365234e+01 -4.9999900817871094e+01 -1.0545100402832031e+02 -4.7552803039550781e+01 5.0000102996826172e+01 -1.0545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 -9.0000198364257812e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -8.9999801635742188e+01 -5.0000000000000000e+01 -5.0000102996826172e+01 -7.4549301147460938e+01 -4.7552803039550781e+01 4.9999900817871094e+01 -7.4548995971679688e+01 -4.7552803039550781e+01 -5.0000102996826172e+01 -6.0610900878906250e+01 -4.0450801849365234e+01 4.9999900817871094e+01 -6.0610599517822266e+01 -4.0450801849365234e+01 -5.0000102996826172e+01 -4.9549301147460938e+01 -2.9389299392700195e+01 4.9999900817871094e+01 -4.9548999786376953e+01 -2.9389299392700195e+01 -5.0000198364257812e+01 -4.2447399139404297e+01 -1.5450900077819824e+01 4.9999797821044922e+01 -4.2447002410888672e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 -3.9999801665544510e+01 0.0000000000000000e+00) (float-vector 4.9999799579381943e+01 -4.2447000741958618e+01 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -4.2447399348020554e+01 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -4.0000200271606445e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 5.0000000745058060e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 -4.2447399348020554e+01 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 -4.2447000741958618e+01 1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 -3.9999801665544510e+01 0.0000000000000000e+00) (float-vector -5.0000198185443878e+01 -4.0000200271606445e+01 0.0000000000000000e+00) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 -4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 -4.0000200271606445e+01 0.0000000000000000e+00) (float-vector -5.0000198185443878e+01 -4.2447399348020554e+01 1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 -4.2447000741958618e+01 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 -3.9999801665544510e+01 0.0000000000000000e+00) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK1_0BHfee.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LARM_LINK7_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.900000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 3 2 4 3 4 5 4 2 1 1 6 4 1 0 6 6 0 7 6 7 4 4 7 5 5 7 0 0 3 5))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -4.5000000000000000e+01 -1.7500000000000000e+02 -2.5000000000000000e+01 -4.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -1.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 -1.5000000000000000e+01 -1.7500000000000000e+02 2.5000000000000000e+01 -1.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -1.5000000000000000e+01 -1.7500000000000000e+02 2.5000000000000000e+01 -4.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -4.5000000000000000e+01 -1.7500000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -1.7499999701976776e+02) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -1.7499999701976776e+02) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -1.7499999701976776e+02) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -2.5000000372529030e+01) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -1.7499999701976776e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -1.7499999701976776e+02) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -1.7499999701976776e+02) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -1.7499999701976776e+02) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -1.7499999701976776e+02) (float-vector -2.5000000372529030e+01 -1.4999999664723873e+01 -1.7499999701976776e+02) (float-vector -2.5000000372529030e+01 -4.5000001788139343e+01 -1.7499999701976776e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -1.7499999701976776e+02) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -1.7499999701976776e+02) (float-vector 2.5000000372529030e+01 -4.5000001788139343e+01 -2.5000000372529030e+01) (float-vector 2.5000000372529030e+01 -1.4999999664723873e+01 -2.5000000372529030e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LARM_LINK7_IWDUf5.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.6300000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 -9.1830101155210286e-05 3.3800000000000000e+02 2.3776401519775391e+01 -7.7255201339721680e+00 3.3800000000000000e+02 2.5000000000000000e+01 -9.1830101155210286e-05 3.3800000000000000e+02 2.3776401519775391e+01 -7.7253298759460449e+00 2.8800000000000000e+02 2.5000000000000000e+01 9.1830101155210286e-05 2.8800000000000000e+02 0.0000000000000000e+00 9.1830101155210286e-05 2.8800000000000000e+02 2.0225400924682617e+01 -1.4694700241088867e+01 3.3800000000000000e+02 2.0225400924682617e+01 -1.4694499969482422e+01 2.8800000000000000e+02 1.4694600105285645e+01 -2.0225500106811523e+01 3.3800000000000000e+02 1.4694600105285645e+01 -2.0225299835205078e+01 2.8800000000000000e+02 7.7254300117492676e+00 -2.3776498794555664e+01 3.3800000000000000e+02 7.7254300117492676e+00 -2.3776300430297852e+01 2.8800000000000000e+02 1.5308101406833461e-15 -2.5000099182128906e+01 3.3800000000000000e+02 1.5308101406833461e-15 -2.4999898910522461e+01 2.8800000000000000e+02 -7.7254300117492676e+00 -2.3776498794555664e+01 3.3800000000000000e+02 -7.7254300117492676e+00 -2.3776300430297852e+01 2.8800000000000000e+02 -1.4694600105285645e+01 -2.0225500106811523e+01 3.3800000000000000e+02 -1.4694600105285645e+01 -2.0225299835205078e+01 2.8800000000000000e+02 -2.0225400924682617e+01 -1.4694700241088867e+01 3.3800000000000000e+02 -2.0225400924682617e+01 -1.4694499969482422e+01 2.8800000000000000e+02 -2.3776401519775391e+01 -7.7255201339721680e+00 3.3800000000000000e+02 -2.3776401519775391e+01 -7.7253298759460449e+00 2.8800000000000000e+02 -2.5000000000000000e+01 -9.1830101155210286e-05 3.3800000000000000e+02 -2.5000000000000000e+01 9.1830101155210286e-05 2.8800000000000000e+02 -2.3776401519775391e+01 7.7253298759460449e+00 3.3800000000000000e+02 -2.3776401519775391e+01 7.7255201339721680e+00 2.8800000000000000e+02 -2.0225400924682617e+01 1.4694499969482422e+01 3.3800000000000000e+02 -2.0225400924682617e+01 1.4694700241088867e+01 2.8800000000000000e+02 -1.4694600105285645e+01 2.0225299835205078e+01 3.3800000000000000e+02 -1.4694600105285645e+01 2.0225500106811523e+01 2.8800000000000000e+02 -7.7254300117492676e+00 2.3776300430297852e+01 3.3800000000000000e+02 -7.7254300117492676e+00 2.3776498794555664e+01 2.8800000000000000e+02 -4.5924301044126831e-15 2.4999898910522461e+01 3.3800000000000000e+02 -4.5924301044126831e-15 2.5000099182128906e+01 2.8800000000000000e+02 7.7254300117492676e+00 2.3776300430297852e+01 3.3800000000000000e+02 7.7254300117492676e+00 2.3776498794555664e+01 2.8800000000000000e+02 1.4694600105285645e+01 2.0225299835205078e+01 3.3800000000000000e+02 1.4694600105285645e+01 2.0225500106811523e+01 2.8800000000000000e+02 2.0225400924682617e+01 1.4694499969482422e+01 3.3800000000000000e+02 2.0225400924682617e+01 1.4694700241088867e+01 2.8800000000000000e+02 2.3776401519775391e+01 7.7253298759460449e+00 3.3800000000000000e+02 2.3776401519775391e+01 7.7255201339721680e+00 2.8800000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.8799998760223389e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.8799998760223389e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.8799998760223389e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.3799999952316284e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.3799999952316284e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.8799998760223389e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.8799998760223389e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector -1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector -4.5924302466877485e-15 2.4999899789690971e+01 3.3799999952316284e+02) (float-vector 1.4694600366055965e+01 2.0225299522280693e+01 3.3799999952316284e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.3799999952316284e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.3799999952316284e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.3799999952316284e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.8799998760223389e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.8799998760223389e+02) (float-vector -2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -9.1830102633139177e-05 3.3799999952316284e+02) (float-vector 2.3776400834321976e+01 7.7253300696611404e+00 3.3799999952316284e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.3799999952316284e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 -1.4694700017571449e+01 3.3799999952316284e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector -2.0225400105118752e+01 -1.4694499783217907e+01 2.8799998760223389e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.8799998760223389e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 2.3776400834321976e+01 -7.7253300696611404e+00 2.8799998760223389e+02) (float-vector 2.5000000372529030e+01 9.1830102633139177e-05 2.8799998760223389e+02) (float-vector 2.0225400105118752e+01 1.4694700017571449e+01 2.8799998760223389e+02) (float-vector 7.7254301868379116e+00 2.3776499554514885e+01 2.8799998760223389e+02) (float-vector -4.5924302466877485e-15 2.5000099092721939e+01 2.8799998760223389e+02) (float-vector -1.4694600366055965e+01 2.0225500687956810e+01 2.8799998760223389e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000099092721939e+01 3.3799999952316284e+02) (float-vector 7.7254301868379116e+00 -2.3776499554514885e+01 3.3799999952316284e+02) (float-vector 1.4694600366055965e+01 -2.0225299522280693e+01 2.8799998760223389e+02) (float-vector 1.5308101166951084e-15 -2.4999899789690971e+01 2.8799998760223389e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK3_KQS1jb.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK2_C2ONL6.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RARM_LINK7_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.700000 0.900000 0.700000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 10 11 8 9 8 14 14 8 15 13 15 8 8 11 13 12 10 9 9 14 12 11 10 12 11 12 13 12 15 13 14 15 12))
                   (list :vertices (let ((mat (make-matrix 16 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 6.3588800430297852e+00 -1.6612300109863281e+02 -2.5000000000000000e+01 2.4239101409912109e+01 -7.7916999816894531e+01 -2.5000000000000000e+01 5.3641098022460938e+01 -8.3876998901367188e+01 -2.5000000000000000e+01 3.5760898590087891e+01 -1.7208300781250000e+02 2.5000000000000000e+01 5.3641098022460938e+01 -8.3876998901367188e+01 2.5000000000000000e+01 3.5760898590087891e+01 -1.7208300781250000e+02 2.5000000000000000e+01 2.4239101409912109e+01 -7.7916999816894531e+01 2.5000000000000000e+01 6.3588800430297852e+00 -1.6612300109863281e+02 -2.5000000000000000e+01 2.4239101409912109e+01 -1.2208300018310547e+02 -2.5000000000000000e+01 6.3588800430297852e+00 -3.3876998901367188e+01 -2.5000000000000000e+01 3.5760898590087891e+01 -2.7916999816894531e+01 -2.5000000000000000e+01 5.3641098022460938e+01 -1.1612300109863281e+02 2.5000000000000000e+01 3.5760898590087891e+01 -2.7916999816894531e+01 2.5000000000000000e+01 5.3641098022460938e+01 -1.1612300109863281e+02 2.5000000000000000e+01 6.3588800430297852e+00 -3.3876998901367188e+01 2.5000000000000000e+01 2.4239101409912109e+01 -1.2208300018310547e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 72 -> 8 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 3.5760898143053055e+01 -1.7208300530910492e+02) (float-vector -2.5000000372529030e+01 6.3588800840079784e+00 -1.6612300276756287e+02) (float-vector 2.5000000372529030e+01 6.3588800840079784e+00 -1.6612300276756287e+02) (float-vector 2.5000000372529030e+01 3.5760898143053055e+01 -1.7208300530910492e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 5.3641099482774734e+01 -8.3876997232437134e+01) (float-vector 2.5000000372529030e+01 3.5760898143053055e+01 -2.7916999533772469e+01) (float-vector -2.5000000372529030e+01 3.5760898143053055e+01 -2.7916999533772469e+01) (float-vector -2.5000000372529030e+01 5.3641099482774734e+01 -8.3876997232437134e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 3.5760898143053055e+01 -2.7916999533772469e+01) (float-vector 2.5000000372529030e+01 6.3588800840079784e+00 -3.3877000212669373e+01) (float-vector -2.5000000372529030e+01 6.3588800840079784e+00 -3.3877000212669373e+01) (float-vector -2.5000000372529030e+01 3.5760898143053055e+01 -2.7916999533772469e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 6.3588800840079784e+00 -3.3877000212669373e+01) (float-vector 2.5000000372529030e+01 6.3588800840079784e+00 -1.6612300276756287e+02) (float-vector -2.5000000372529030e+01 6.3588800840079784e+00 -1.6612300276756287e+02) (float-vector -2.5000000372529030e+01 6.3588800840079784e+00 -3.3877000212669373e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 6.3588800840079784e+00 -3.3877000212669373e+01) (float-vector -2.5000000372529030e+01 6.3588800840079784e+00 -1.6612300276756287e+02) (float-vector -2.5000000372529030e+01 3.5760898143053055e+01 -1.7208300530910492e+02) (float-vector -2.5000000372529030e+01 5.3641099482774734e+01 -1.1612299829721451e+02) (float-vector -2.5000000372529030e+01 5.3641099482774734e+01 -8.3876997232437134e+01) (float-vector -2.5000000372529030e+01 3.5760898143053055e+01 -2.7916999533772469e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 6.3588800840079784e+00 -3.3877000212669373e+01) (float-vector 2.5000000372529030e+01 3.5760898143053055e+01 -2.7916999533772469e+01) (float-vector 2.5000000372529030e+01 5.3641099482774734e+01 -8.3876997232437134e+01) (float-vector 2.5000000372529030e+01 5.3641099482774734e+01 -1.1612299829721451e+02) (float-vector 2.5000000372529030e+01 3.5760898143053055e+01 -1.7208300530910492e+02) (float-vector 2.5000000372529030e+01 6.3588800840079784e+00 -1.6612300276756287e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 5.3641099482774734e+01 -1.1612299829721451e+02) (float-vector -2.5000000372529030e+01 5.3641099482774734e+01 -1.1612299829721451e+02) (float-vector -2.5000000372529030e+01 3.5760898143053055e+01 -1.7208300530910492e+02) (float-vector 2.5000000372529030e+01 3.5760898143053055e+01 -1.7208300530910492e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 5.3641099482774734e+01 -1.1612299829721451e+02) (float-vector 2.5000000372529030e+01 5.3641099482774734e+01 -1.1612299829721451e+02) (float-vector 2.5000000372529030e+01 5.3641099482774734e+01 -8.3876997232437134e+01) (float-vector -2.5000000372529030e+01 5.3641099482774734e+01 -8.3876997232437134e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RARM_LINK7_GyEl8x.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK3_gK4gCo.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK4_6vJ0A9.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 8.9999801635742188e+01 0.0000000000000000e+00 -5.0000198364257812e+01 1.3755300903320312e+02 1.5450900077819824e+01 -5.0000198364257812e+01 1.4000000000000000e+02 0.0000000000000000e+00 4.9999797821044922e+01 1.3755300903320312e+02 1.5450900077819824e+01 4.9999797821044922e+01 1.4000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 9.0000198364257812e+01 0.0000000000000000e+00 -5.0000102996826172e+01 1.3045098876953125e+02 2.9389299392700195e+01 4.9999900817871094e+01 1.3045098876953125e+02 2.9389299392700195e+01 -5.0000102996826172e+01 1.1938899993896484e+02 4.0450801849365234e+01 4.9999900817871094e+01 1.1938899993896484e+02 4.0450801849365234e+01 -5.0000102996826172e+01 1.0545100402832031e+02 4.7552803039550781e+01 4.9999900817871094e+01 1.0545100402832031e+02 4.7552803039550781e+01 -5.0000000000000000e+01 8.9999801635742188e+01 5.0000000000000000e+01 5.0000000000000000e+01 9.0000198364257812e+01 5.0000000000000000e+01 -4.9999900817871094e+01 7.4548995971679688e+01 4.7552803039550781e+01 5.0000102996826172e+01 7.4549301147460938e+01 4.7552803039550781e+01 -4.9999900817871094e+01 6.0610599517822266e+01 4.0450801849365234e+01 5.0000102996826172e+01 6.0610900878906250e+01 4.0450801849365234e+01 -4.9999900817871094e+01 4.9548999786376953e+01 2.9389299392700195e+01 5.0000102996826172e+01 4.9549301147460938e+01 2.9389299392700195e+01 -4.9999797821044922e+01 4.2447002410888672e+01 1.5450900077819824e+01 5.0000198364257812e+01 4.2447399139404297e+01 1.5450900077819824e+01 -4.9999797821044922e+01 3.9999801635742188e+01 6.1232299748215438e-15 5.0000198364257812e+01 4.0000198364257812e+01 6.1232299748215438e-15 -4.9999797821044922e+01 4.2447002410888672e+01 -1.5450900077819824e+01 5.0000198364257812e+01 4.2447399139404297e+01 -1.5450900077819824e+01 -4.9999900817871094e+01 4.9548999786376953e+01 -2.9389299392700195e+01 5.0000102996826172e+01 4.9549301147460938e+01 -2.9389299392700195e+01 -4.9999900817871094e+01 6.0610599517822266e+01 -4.0450801849365234e+01 5.0000102996826172e+01 6.0610900878906250e+01 -4.0450801849365234e+01 -4.9999900817871094e+01 7.4548995971679688e+01 -4.7552803039550781e+01 5.0000102996826172e+01 7.4549301147460938e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.9999801635742188e+01 -5.0000000000000000e+01 5.0000000000000000e+01 9.0000198364257812e+01 -5.0000000000000000e+01 -5.0000102996826172e+01 1.0545100402832031e+02 -4.7552803039550781e+01 4.9999900817871094e+01 1.0545100402832031e+02 -4.7552803039550781e+01 -5.0000102996826172e+01 1.1938899993896484e+02 -4.0450801849365234e+01 4.9999900817871094e+01 1.1938899993896484e+02 -4.0450801849365234e+01 -5.0000102996826172e+01 1.3045098876953125e+02 -2.9389299392700195e+01 4.9999900817871094e+01 1.3045098876953125e+02 -2.9389299392700195e+01 -5.0000198364257812e+01 1.3755300903320312e+02 -1.5450900077819824e+01 4.9999797821044922e+01 1.3755300903320312e+02 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 4.2447399348020554e+01 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 4.2447000741958618e+01 1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 4.2447399348020554e+01 1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 4.0000200271606445e+01 6.1232301270227765e-15) (float-vector -4.9999799579381943e+01 3.9999801665544510e+01 6.1232301270227765e-15) (float-vector -4.9999799579381943e+01 4.2447000741958618e+01 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 6.0610599815845490e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 6.0610901564359665e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 4.0000200271606445e+01 6.1232301270227765e-15) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 3.9999801665544510e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 6.0610599815845490e+01 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 4.2447000741958618e+01 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 3.9999801665544510e+01 6.1232301270227765e-15) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector -5.0000000745058060e+01 8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector -5.0000000745058060e+01 8.9999802410602570e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 6.0610901564359665e+01 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 6.0610599815845490e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 1.0545100271701813e+02 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 4.0000200271606445e+01 6.1232301270227765e-15) (float-vector 5.0000198185443878e+01 4.2447399348020554e+01 1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 6.0610901564359665e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector 5.0000000745058060e+01 9.0000197291374207e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 -1.5450900420546532e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK1_WD2ws5.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -2.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -2.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK4_6xbTRt.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK5_WBGH9y.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK5_YEmG6a.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  )


(provide :SampleRobot "(ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:34:37 PST")

