;;
;; DO NOT EDIT THIS FILE
;;
;; this file is automatically generated from /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/models/samplespecialjointrobot.l on (Linux ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:24:15 PST
;;
;; /tmp/binarydeb/ros-melodic-hrpsys-ros-bridge-1.4.3/obj-arm-linux-gnueabihf $ ;;

;;
;; copy euscollada-robot class definition from euscollada/src/euscollada-robot.l
;;
(defclass euscollada-robot
;; This euscollada-robot class is for robots converted from collada files.
;; This class provides :init-ending override.
  :super robot-model
  :slots ()
  )
(defmethod euscollada-robot
  (:init-ending
   (&optional (type :urdf))
   (when (eq type :collada)
     ;; fix all links' mass properties ;; root link relative (collada) -> link local (euslisp)
     (dolist (l (append links
                        (mapcan #'(lambda (x) (if (and (derivedp (cdr x) bodyset-link)
                                                       (not (memq (cdr x) links)))
                                                  (list (cdr x)))) (send self :slots))))
       (unless (= (send l :weight) 0.0)
       (setq (l . acentroid) (send l :inverse-transform-vector
                                   (send (send (car links) :worldcoords) :transform-vector
                                         (l . acentroid))))
       (setq (l . inertia-tensor) (m* (transpose (send l :worldrot))
                                      (m* (send (car links) :worldrot)
                                          (l . inertia-tensor))))
       )))
   (send-super :init-ending)
   (send self :make-collision-model-for-links)
   ;;
   (dolist (j (mapcan #'(lambda (x) (if (and (derivedp (cdr x) joint)
                                             (not (memq (cdr x) (send self :joint-list))))
                                        (list (cdr x)))) (send self :slots)))
     (send (send j :child-link) :add-joint j)
     (send (send j :child-link) :add-parent-link (send j :parent-link))
     (send (send j :parent-link) :add-child-links (send j :child-link)))
   )
  (:change-visual
   (&optional (visual :convex))
   (dolist (lk (send self :links))
     (dolist (bd (send lk :bodies))
       (when (derivedp bd collada-body)
         (send bd :change-visual visual)))))
  ;; fullbody-inverse-kinematics overwrite
  ;;  reduce root-link's weight based on leg's joint limit
  ;;  increase stop and cog-gain
  (:fullbody-inverse-kinematics
   (target-coords &rest args &key (stop 250) (cog-gain 2.0) (additional-weight-list) (use-6dof-joint-leg-gain nil) &allow-other-keys)
   (let* ((leg-ul (send self :calc-union-link-list (send self :legs :links))))
     (send self :reset-joint-angle-limit-weight-old leg-ul)
     (send-message* self robot-model :fullbody-inverse-kinematics
                    target-coords
                    :stop stop :cog-gain cog-gain
                    :additional-weight-list
                    (append
                     additional-weight-list
                     (if use-6dof-joint-leg-gain
                         (list
                          (list (car (send self :links))
                                #'(lambda ()
                                    ;; set root-link 6dof-joint's weight based on legs' joint limit
                                    (let* ((min-weight
                                            (reduce #'(lambda (x y) (min x y))
                                                    (coerce (send self :calc-inverse-kinematics-weight-from-link-list
                                                                  leg-ul :union-link-list leg-ul) cons))))
                                      (fill (instantiate float-vector 6) min-weight)))
                                )
                          )))
                    args)
     ))
  ;; make collision model from faces or gl-vertices
  (:make-collision-model-for-links
   (&key (fat 0) (collision-func 'pqp-collision-check) ((:links ls) (send self :links)))
   (dolist (ll ls)
     (let (fs glv usefs)
       (dolist (bd (send ll :bodies))
         (if (derivedp bd collada-body)
             (push (send bd :glvertices) glv)
           (push (send bd :faces) fs)))
       (setq fs (flatten fs))
       (cond
        ((and (not fs) glv) ;; if there is no faces, use glvertices for creating pqpmodel
         (setq usefs (instance gl::glvertices :init nil))
         (send usefs :transform (send ll :worldcoords))
         (send usefs :append-glvertices glv)
         (let ((m (send usefs (read-from-string
                               (format nil ":make-~Amodel"
                                       (string-right-trim "-COLLISION-CHECK" (string collision-func))))
                        :fat fat)))
           (setf (get ll :pqpmodel) m)
           ))
        (fs
         (setq usefs
               (append fs
                       (mapcar #'(lambda (gv) (send gv :convert-to-faces :wrt :world)) glv)))
         (send ll
               (read-from-string
                (format nil ":make-~Amodel"
                        (string-right-trim "-COLLISION-CHECK" (string collision-func))))
               :fat fat
               :faces usefs))
        ))
     ))
  )

;; copy euscollada-body class definition from euscollada/src/euscollada-robot.l
;; This euscollada-body class is for bodies in robot model converted from collada files.
(defclass collada-body
  :super gl::glbody
  :slots (glvertices) ;; glvertices slot for backward compatibility
  )
(defmethod collada-body
  (:init (&key (name) (replace-obj))
    (if replace-obj
        (replace-object self replace-obj)
      (replace-object self (make-cube 10 10 10)))
    (if name (send self :name name))
    (setq glvertices gl::aglvertices)
    self)
  (:change-visual
   (&optional (visual :convex))
   (case visual
     ((list :convex :hull :convex-hull)
      (unless (send self :get :original-mesh)
        (send self :put :original-mesh gl::aglvertices)) ;; store original mesh
      (let* ((org-mesh (send self :get :original-mesh))
             (org-cds (send org-mesh :copy-worldcoords))
             (glv (gl::make-glvertices-from-faces (send self :faces))))
        (send glv :set-offset (send org-cds :inverse-transformation))
        (send glv :transform org-cds)
        (send org-mesh :assoc glv)
        (setq gl::aglvertices glv)
        glv))
     ((list :original :mesh :glvertices :original-mesh)
      (let ((org-mesh (send self :get :original-mesh)))
        (when org-mesh
          (dolist (d (send org-mesh :descendants)) ;; dissoc all discendants
            (send org-mesh :dissoc d))
          (setq gl::aglvertices org-mesh)
          org-mesh)))
     ))
  )
;;
;; end of copy from /opt/ros/melodic/share/euscollada/src/euscollada-robot.l
;;
(defun SampleSpecialJointRobot () (setq *SampleSpecialJointRobot* (instance SampleSpecialJointRobot-robot :init)))

(defclass SampleSpecialJointRobot-robot
  :super euscollada-robot
  :slots ( ;; link names
          FLY_WHEEL_P_LINK_lk LLEG_LINK1_lk LLEG_LINK10_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk LLEG_LINK7_lk LLEG_LINK8_lk LLEG_LINK9_lk RLEG_LINK1_lk RLEG_LINK10_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk RLEG_LINK7_lk RLEG_LINK8_lk RLEG_LINK9_lk WAIST_LINK0_lk WAIST_LINK1_lk WAIST_LINK2_lk
         ;; joint names
          FLY_WHEEL_P_jt LLEG_ANKLE_P0_jt LLEG_ANKLE_P1_jt LLEG_ANKLE_R_jt LLEG_HIP_P0_jt LLEG_HIP_P1_jt LLEG_HIP_R_jt LLEG_HIP_Y_jt LLEG_KNEE_P0_jt LLEG_KNEE_P1_jt LLEG_TOE_P_jt RLEG_ANKLE_P0_jt RLEG_ANKLE_P1_jt RLEG_ANKLE_R_jt RLEG_HIP_P0_jt RLEG_HIP_P1_jt RLEG_HIP_R_jt RLEG_HIP_Y_jt RLEG_KNEE_P0_jt RLEG_KNEE_P1_jt RLEG_TOE_P_jt WAIST_P_jt WAIST_R_jt
         ;; sensor names
          gsensor-sensor-coords gyrometer-sensor-coords rfsensor-sensor-coords lfsensor-sensor-coords
         )
  )
(defmethod SampleSpecialJointRobot-robot
  (:init
   (&rest args)
   (let ()
     (send-super* :init :name "SampleSpecialJointRobot" args)

     ;; link: WAIST_LINK0_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK0_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK0_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK0"))
       ;; inertial parameter for WAIST_LINK0_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.7500000000000000e+01))
                      ))
         (send WAIST_LINK0_lk :weight 27000.000)
         (setq (WAIST_LINK0_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 9.6482000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 9.6482000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.8800000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK0_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK0_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                        ))
         (send WAIST_LINK0_lk :transform world-cds))
       )

     ;; link: WAIST_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK1"))
       ;; inertial parameter for WAIST_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.5511151231257827e-14))
                      ))
         (send WAIST_LINK1_lk :weight 6000.000)
         (setq (WAIST_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.1870000000000005e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.8750000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.1870000000000005e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7600000000000000e+02))
                        ))
         (send WAIST_LINK1_lk :transform world-cds))
       )

     ;; link: RLEG_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK3"))
       ;; inertial parameter for RLEG_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.7755575615628914e-14))
                      ))
         (send RLEG_LINK3_lk :weight 2000.000)
         (setq (RLEG_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -1.0000000000000000e+02))
                        ))
         (send RLEG_LINK3_lk :transform world-cds))
       )

     ;; link: WAIST_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_WAIST_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq WAIST_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "WAIST_LINK2"))
       ;; inertial parameter for WAIST_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.6000000000000003e+02))
                      ))
         (send WAIST_LINK2_lk :weight 30000.000)
         (setq (WAIST_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.7000000000000000e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.7000000000000000e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.2500000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (WAIST_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for WAIST_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7600000000000000e+02))
                        ))
         (send WAIST_LINK2_lk :transform world-cds))
       )

     ;; link: LLEG_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK5"))
       ;; inertial parameter for LLEG_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK5_lk :weight 7000.000)
         (setq (LLEG_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -4.5350000000000000e+02))
                        ))
         (send LLEG_LINK5_lk :transform world-cds))
       )

     ;; link: RLEG_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK4"))
       ;; inertial parameter for RLEG_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send RLEG_LINK4_lk :weight 5100.000)
         (setq (RLEG_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -4.5350000000000000e+02))
                        ))
         (send RLEG_LINK4_lk :transform world-cds))
       )

     ;; link: FLY_WHEEL_P_LINK_lk
     (let ((geom-lst (list
                       (send self :_make_instance_FLY_WHEEL_P_LINK_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq FLY_WHEEL_P_LINK_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "FLY_WHEEL_P_LINK"))
       ;; inertial parameter for FLY_WHEEL_P_LINK_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send FLY_WHEEL_P_LINK_lk :weight 1500.000)
         (setq (FLY_WHEEL_P_LINK_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 8.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.0000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (FLY_WHEEL_P_LINK_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for FLY_WHEEL_P_LINK_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.2600000000000000e+02))
                        ))
         (send FLY_WHEEL_P_LINK_lk :transform world-cds))
       )

     ;; link: RLEG_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK1"))
       ;; inertial parameter for RLEG_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK1_lk :weight 2500.000)
         (setq (RLEG_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send RLEG_LINK1_lk :transform world-cds))
       )

     ;; link: LLEG_LINK4_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK4_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK4_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK4"))
       ;; inertial parameter for LLEG_LINK4_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8000000000000000e+02))
                      ))
         (send LLEG_LINK4_lk :weight 5100.000)
         (setq (LLEG_LINK4_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1560000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1560000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK4_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK4_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -4.5350000000000000e+02))
                        ))
         (send LLEG_LINK4_lk :transform world-cds))
       )

     ;; link: RLEG_LINK5_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK5_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK5_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK5"))
       ;; inertial parameter for RLEG_LINK5_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK5_lk :weight 7000.000)
         (setq (RLEG_LINK5_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK5_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK5_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -4.5350000000000000e+02))
                        ))
         (send RLEG_LINK5_lk :transform world-cds))
       )

     ;; link: RLEG_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK2"))
       ;; inertial parameter for RLEG_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK2_lk :weight 2000.000)
         (setq (RLEG_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send RLEG_LINK2_lk :transform world-cds))
       )

     ;; link: LLEG_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK6"))
       ;; inertial parameter for LLEG_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send LLEG_LINK6_lk :weight 7000.000)
         (setq (LLEG_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -5.5350000000000000e+02))
                        ))
         (send LLEG_LINK6_lk :transform world-cds))
       )

     ;; link: RLEG_LINK6_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK6_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK6_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK6"))
       ;; inertial parameter for RLEG_LINK6_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.2000000000000000e+02))
                      ))
         (send RLEG_LINK6_lk :weight 7000.000)
         (setq (RLEG_LINK6_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.8330000000000000e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.8330000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1670000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK6_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK6_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -5.5350000000000000e+02))
                        ))
         (send RLEG_LINK6_lk :transform world-cds))
       )

     ;; link: LLEG_LINK2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK2"))
       ;; inertial parameter for LLEG_LINK2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK2_lk :weight 2000.000)
         (setq (LLEG_LINK2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK2_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send LLEG_LINK2_lk :transform world-cds))
       )

     ;; link: RLEG_LINK7_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK7_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK7_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK7"))
       ;; inertial parameter for RLEG_LINK7_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send RLEG_LINK7_lk :weight 2500.000)
         (setq (RLEG_LINK7_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK7_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK7_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -8.5349999999999989e+02))
                        ))
         (send RLEG_LINK7_lk :transform world-cds))
       )

     ;; link: RLEG_LINK8_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK8_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK8_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK8"))
       ;; inertial parameter for RLEG_LINK8_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1102230246251565e-13))
                      ))
         (send RLEG_LINK8_lk :weight 2500.000)
         (setq (RLEG_LINK8_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK8_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK8_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -9.5349999999999989e+02))
                        ))
         (send RLEG_LINK8_lk :transform world-cds))
       )

     ;; link: LLEG_LINK7_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK7_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK7_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK7"))
       ;; inertial parameter for LLEG_LINK7_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK7_lk :weight 2500.000)
         (setq (LLEG_LINK7_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK7_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK7_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -8.5349999999999989e+02))
                        ))
         (send LLEG_LINK7_lk :transform world-cds))
       )

     ;; link: RLEG_LINK9_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK9_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK9_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK9"))
       ;; inertial parameter for RLEG_LINK9_lk
       (let ((tmp-cds (make-coords :pos (float-vector 5.0000000000000000e+00 0.0000000000000000e+00 -5.9999999999999829e+01))
                      ))
         (send RLEG_LINK9_lk :weight 1900.000)
         (setq (RLEG_LINK9_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK9_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK9_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 -9.5349999999999989e+02))
                        ))
         (send RLEG_LINK9_lk :transform world-cds))
       )

     ;; link: LLEG_LINK1_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK1_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK1_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK1"))
       ;; inertial parameter for LLEG_LINK1_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send LLEG_LINK1_lk :weight 2500.000)
         (setq (LLEG_LINK1_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.1250000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.6460000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK1_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK1_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 0.0000000000000000e+00))
                        ))
         (send LLEG_LINK1_lk :transform world-cds))
       )

     ;; link: RLEG_LINK10_lk
     (let ((geom-lst (list
                       (send self :_make_instance_RLEG_LINK10_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq RLEG_LINK10_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "RLEG_LINK10"))
       ;; inertial parameter for RLEG_LINK10_lk
       (let ((tmp-cds (make-coords :pos (float-vector 5.0000000000000000e+01 0.0000000000000000e+00 1.0000000000000231e+01))
                      ))
         (send RLEG_LINK10_lk :weight 1000.000)
         (setq (RLEG_LINK10_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (RLEG_LINK10_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for RLEG_LINK10_lk
       (let ((world-cds (make-coords :pos (float-vector 8.0000000000000000e+01 -9.0000000000000000e+01 -1.0134999999999999e+03))
                        ))
         (send RLEG_LINK10_lk :transform world-cds))
       )

     ;; link: LLEG_LINK3_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK3_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK3_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK3"))
       ;; inertial parameter for LLEG_LINK3_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -2.7755575615628914e-14))
                      ))
         (send LLEG_LINK3_lk :weight 2000.000)
         (setq (LLEG_LINK3_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.9170000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.5000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.9170000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK3_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK3_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -1.0000000000000000e+02))
                        ))
         (send LLEG_LINK3_lk :transform world-cds))
       )

     ;; link: LLEG_LINK8_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK8_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK8_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK8"))
       ;; inertial parameter for LLEG_LINK8_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1102230246251565e-13))
                      ))
         (send LLEG_LINK8_lk :weight 2500.000)
         (setq (LLEG_LINK8_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.6460000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.1250000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.6460000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK8_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK8_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -9.5349999999999989e+02))
                        ))
         (send LLEG_LINK8_lk :transform world-cds))
       )

     ;; link: LLEG_LINK9_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK9_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK9_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK9"))
       ;; inertial parameter for LLEG_LINK9_lk
       (let ((tmp-cds (make-coords :pos (float-vector 5.0000000000000000e+00 0.0000000000000000e+00 -5.9999999999999829e+01))
                      ))
         (send LLEG_LINK9_lk :weight 1900.000)
         (setq (LLEG_LINK9_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK9_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK9_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 -9.5349999999999989e+02))
                        ))
         (send LLEG_LINK9_lk :transform world-cds))
       )

     ;; link: LLEG_LINK10_lk
     (let ((geom-lst (list
                       (send self :_make_instance_LLEG_LINK10_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq LLEG_LINK10_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "LLEG_LINK10"))
       ;; inertial parameter for LLEG_LINK10_lk
       (let ((tmp-cds (make-coords :pos (float-vector 5.0000000000000000e+01 0.0000000000000000e+00 1.0000000000000231e+01))
                      ))
         (send LLEG_LINK10_lk :weight 1000.000)
         (setq (LLEG_LINK10_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.2909999999999991e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2084000000000000e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3000000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (LLEG_LINK10_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for LLEG_LINK10_lk
       (let ((world-cds (make-coords :pos (float-vector 8.0000000000000000e+01 9.0000000000000000e+01 -1.0134999999999999e+03))
                        ))
         (send LLEG_LINK10_lk :transform world-cds))
       )

     (send WAIST_LINK2_lk :assoc FLY_WHEEL_P_LINK_lk)
     (send LLEG_LINK6_lk :assoc LLEG_LINK7_lk)
     (send LLEG_LINK7_lk :assoc LLEG_LINK8_lk)
     (send LLEG_LINK8_lk :assoc LLEG_LINK9_lk)
     (send LLEG_LINK1_lk :assoc LLEG_LINK2_lk)
     (send LLEG_LINK2_lk :assoc LLEG_LINK3_lk)
     (send WAIST_LINK0_lk :assoc LLEG_LINK1_lk)
     (send LLEG_LINK3_lk :assoc LLEG_LINK4_lk)
     (send LLEG_LINK4_lk :assoc LLEG_LINK5_lk)
     (send LLEG_LINK5_lk :assoc LLEG_LINK6_lk)
     (send LLEG_LINK9_lk :assoc LLEG_LINK10_lk)
     (send RLEG_LINK6_lk :assoc RLEG_LINK7_lk)
     (send RLEG_LINK7_lk :assoc RLEG_LINK8_lk)
     (send RLEG_LINK8_lk :assoc RLEG_LINK9_lk)
     (send RLEG_LINK1_lk :assoc RLEG_LINK2_lk)
     (send RLEG_LINK2_lk :assoc RLEG_LINK3_lk)
     (send WAIST_LINK0_lk :assoc RLEG_LINK1_lk)
     (send RLEG_LINK3_lk :assoc RLEG_LINK4_lk)
     (send RLEG_LINK4_lk :assoc RLEG_LINK5_lk)
     (send RLEG_LINK5_lk :assoc RLEG_LINK6_lk)
     (send RLEG_LINK9_lk :assoc RLEG_LINK10_lk)
     (send WAIST_LINK0_lk :assoc WAIST_LINK1_lk)
     (send WAIST_LINK1_lk :assoc WAIST_LINK2_lk)
     (send self :assoc WAIST_LINK0_lk)

     ;; joint models
     ;; joint: FLY_WHEEL_P_jt
     (setq FLY_WHEEL_P_jt
           (instance rotational-joint :init
                     :name "FLY_WHEEL_P"
                     :parent-link WAIST_LINK2_lk :child-link FLY_WHEEL_P_LINK_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_ANKLE_P0_jt
     (setq LLEG_ANKLE_P0_jt
           (instance rotational-joint :init
                     :name "LLEG_ANKLE_P0"
                     :parent-link LLEG_LINK6_lk :child-link LLEG_LINK7_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_ANKLE_P1_jt
     (setq LLEG_ANKLE_P1_jt
           (instance rotational-joint :init
                     :name "LLEG_ANKLE_P1"
                     :parent-link LLEG_LINK7_lk :child-link LLEG_LINK8_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_ANKLE_R_jt
     (setq LLEG_ANKLE_R_jt
           (instance rotational-joint :init
                     :name "LLEG_ANKLE_R"
                     :parent-link LLEG_LINK8_lk :child-link LLEG_LINK9_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_P0_jt
     (setq LLEG_HIP_P0_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_P0"
                     :parent-link LLEG_LINK1_lk :child-link LLEG_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_P1_jt
     (setq LLEG_HIP_P1_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_P1"
                     :parent-link LLEG_LINK2_lk :child-link LLEG_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_R_jt
     (setq LLEG_HIP_R_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_R"
                     :parent-link WAIST_LINK0_lk :child-link LLEG_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_HIP_Y_jt
     (setq LLEG_HIP_Y_jt
           (instance rotational-joint :init
                     :name "LLEG_HIP_Y"
                     :parent-link LLEG_LINK3_lk :child-link LLEG_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_KNEE_P0_jt
     (setq LLEG_KNEE_P0_jt
           (instance rotational-joint :init
                     :name "LLEG_KNEE_P0"
                     :parent-link LLEG_LINK4_lk :child-link LLEG_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_KNEE_P1_jt
     (setq LLEG_KNEE_P1_jt
           (instance rotational-joint :init
                     :name "LLEG_KNEE_P1"
                     :parent-link LLEG_LINK5_lk :child-link LLEG_LINK6_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: LLEG_TOE_P_jt
     (setq LLEG_TOE_P_jt
           (instance rotational-joint :init
                     :name "LLEG_TOE_P"
                     :parent-link LLEG_LINK9_lk :child-link LLEG_LINK10_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_ANKLE_P0_jt
     (setq RLEG_ANKLE_P0_jt
           (instance rotational-joint :init
                     :name "RLEG_ANKLE_P0"
                     :parent-link RLEG_LINK6_lk :child-link RLEG_LINK7_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_ANKLE_P1_jt
     (setq RLEG_ANKLE_P1_jt
           (instance rotational-joint :init
                     :name "RLEG_ANKLE_P1"
                     :parent-link RLEG_LINK7_lk :child-link RLEG_LINK8_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_ANKLE_R_jt
     (setq RLEG_ANKLE_R_jt
           (instance rotational-joint :init
                     :name "RLEG_ANKLE_R"
                     :parent-link RLEG_LINK8_lk :child-link RLEG_LINK9_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_P0_jt
     (setq RLEG_HIP_P0_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_P0"
                     :parent-link RLEG_LINK1_lk :child-link RLEG_LINK2_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_P1_jt
     (setq RLEG_HIP_P1_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_P1"
                     :parent-link RLEG_LINK2_lk :child-link RLEG_LINK3_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_R_jt
     (setq RLEG_HIP_R_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_R"
                     :parent-link WAIST_LINK0_lk :child-link RLEG_LINK1_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_HIP_Y_jt
     (setq RLEG_HIP_Y_jt
           (instance rotational-joint :init
                     :name "RLEG_HIP_Y"
                     :parent-link RLEG_LINK3_lk :child-link RLEG_LINK4_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_KNEE_P0_jt
     (setq RLEG_KNEE_P0_jt
           (instance rotational-joint :init
                     :name "RLEG_KNEE_P0"
                     :parent-link RLEG_LINK4_lk :child-link RLEG_LINK5_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_KNEE_P1_jt
     (setq RLEG_KNEE_P1_jt
           (instance rotational-joint :init
                     :name "RLEG_KNEE_P1"
                     :parent-link RLEG_LINK5_lk :child-link RLEG_LINK6_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: RLEG_TOE_P_jt
     (setq RLEG_TOE_P_jt
           (instance rotational-joint :init
                     :name "RLEG_TOE_P"
                     :parent-link RLEG_LINK9_lk :child-link RLEG_LINK10_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: WAIST_P_jt
     (setq WAIST_P_jt
           (instance rotational-joint :init
                     :name "WAIST_P"
                     :parent-link WAIST_LINK0_lk :child-link WAIST_LINK1_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: WAIST_R_jt
     (setq WAIST_R_jt
           (instance rotational-joint :init
                     :name "WAIST_R"
                     :parent-link WAIST_LINK1_lk :child-link WAIST_LINK2_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 40.000000
                     :max-joint-torque 0.000000
                     ))
     ;; end coords from yaml file
     (setq rleg-end-coords (make-cascoords :coords (send RLEG_LINK10_lk :copy-worldcoords) :name :rleg-end-coords))
     (send rleg-end-coords :translate (float-vector -8.0000000000000000e+01 0.0000000000000000e+00 -1.0000000000000000e+01))
     (send RLEG_LINK10_lk :assoc rleg-end-coords)
     (setq lleg-end-coords (make-cascoords :coords (send LLEG_LINK10_lk :copy-worldcoords) :name :lleg-end-coords))
     (send lleg-end-coords :translate (float-vector -8.0000000000000000e+01 0.0000000000000000e+00 -1.0000000000000000e+01))
     (send LLEG_LINK10_lk :assoc lleg-end-coords)
     (setq torso-end-coords (make-cascoords :coords (send FLY_WHEEL_P_LINK_lk :copy-worldcoords) :name :torso-end-coords))
     (send FLY_WHEEL_P_LINK_lk :assoc torso-end-coords)

     ;; limbs
     (setq rleg (list RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk RLEG_LINK7_lk RLEG_LINK8_lk RLEG_LINK9_lk RLEG_LINK10_lk))

     (setq rleg-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rleg) (find-parent (send l :parent)) l)))
             (find-parent (car rleg))))
     (setq lleg (list LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk LLEG_LINK7_lk LLEG_LINK8_lk LLEG_LINK9_lk LLEG_LINK10_lk))

     (setq lleg-root-link
           (labels ((find-parent (l) (if (find (send l :parent) lleg) (find-parent (send l :parent)) l)))
             (find-parent (car lleg))))
     (setq torso (list WAIST_LINK1_lk WAIST_LINK2_lk FLY_WHEEL_P_LINK_lk))

     (setq torso-root-link
           (labels ((find-parent (l) (if (find (send l :parent) torso) (find-parent (send l :parent)) l)))
             (find-parent (car torso))))

     ;; links
     (setq links (list WAIST_LINK0_lk RLEG_LINK1_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk RLEG_LINK7_lk RLEG_LINK8_lk RLEG_LINK9_lk RLEG_LINK10_lk LLEG_LINK1_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk LLEG_LINK7_lk LLEG_LINK8_lk LLEG_LINK9_lk LLEG_LINK10_lk WAIST_LINK1_lk WAIST_LINK2_lk FLY_WHEEL_P_LINK_lk))

     ;; joint-list
     (setq joint-list (list RLEG_HIP_R_jt RLEG_HIP_P0_jt RLEG_HIP_P1_jt RLEG_HIP_Y_jt RLEG_KNEE_P0_jt RLEG_KNEE_P1_jt RLEG_ANKLE_P0_jt RLEG_ANKLE_P1_jt RLEG_ANKLE_R_jt RLEG_TOE_P_jt LLEG_HIP_R_jt LLEG_HIP_P0_jt LLEG_HIP_P1_jt LLEG_HIP_Y_jt LLEG_KNEE_P0_jt LLEG_KNEE_P1_jt LLEG_ANKLE_P0_jt LLEG_ANKLE_P1_jt LLEG_ANKLE_R_jt LLEG_TOE_P_jt WAIST_P_jt WAIST_R_jt FLY_WHEEL_P_jt))

     ;; sensor-coords
     ;;
     (setq gsensor-sensor-coords (make-cascoords :name "gsensor" :coords (send WAIST_LINK0_lk :copy-worldcoords)))
     (send gsensor-sensor-coords :put :sensor-type :base_imu)
     (send gsensor-sensor-coords :put :sensor-id 1)
     (send gsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 0.0000000000000000e+00 7.0710678118654746e-01 7.0710678118654746e-01))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 3.1415899999999999e+00))
                                               ))
     (send WAIST_LINK0_lk :assoc gsensor-sensor-coords)
     ;;
     (setq gyrometer-sensor-coords (make-cascoords :name "gyrometer" :coords (send WAIST_LINK0_lk :copy-worldcoords)))
     (send gyrometer-sensor-coords :put :sensor-type :base_imu)
     (send gyrometer-sensor-coords :put :sensor-id 2)
     (send gyrometer-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 0.0000000000000000e+00 7.0710678118654746e-01 7.0710678118654746e-01))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 3.1415899999999999e+00))
                                               ))
     (send WAIST_LINK0_lk :assoc gyrometer-sensor-coords)
     ;;
     (setq rfsensor-sensor-coords (make-cascoords :name "rfsensor" :coords (send RLEG_LINK9_lk :copy-worldcoords)))
     (send rfsensor-sensor-coords :put :sensor-type :base_force6d)
     (send rfsensor-sensor-coords :put :sensor-id 3)
     (send rfsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send RLEG_LINK9_lk :assoc rfsensor-sensor-coords)
     ;;
     (setq lfsensor-sensor-coords (make-cascoords :name "lfsensor" :coords (send LLEG_LINK9_lk :copy-worldcoords)))
     (send lfsensor-sensor-coords :put :sensor-type :base_force6d)
     (send lfsensor-sensor-coords :put :sensor-id 4)
     (send lfsensor-sensor-coords :transform (let ((cds (make-coords)))
                                               (send cds :transform (make-coords :pos (float-vector  0.0000000000000000e+00 0.0000000000000000e+00 -7.0000000000000000e+01)))
                                               (send cds :transform (make-coords :axis (let ((tmp-axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))) (if (eps= (norm tmp-axis) 0.0) (float-vector 1 0 0) tmp-axis)) :angle 0.0000000000000000e+00))
                                               ))
     (send LLEG_LINK9_lk :assoc lfsensor-sensor-coords)

     ;; attach_sensor lists
     (setq force-sensors (list rfsensor-sensor-coords lfsensor-sensor-coords ))
     (setq imu-sensors (list gsensor-sensor-coords gyrometer-sensor-coords ))
     (setq cameras (list ))

     ;; init-ending
     (send self :init-ending) ;; :urdf

     ;; overwrite bodies to return draw-things links not (send link :bodies)
     (setq bodies (flatten (mapcar #'(lambda (b) (if (find-method b :bodies) (send b :bodies))) (list FLY_WHEEL_P_LINK_lk LLEG_LINK1_lk LLEG_LINK10_lk LLEG_LINK2_lk LLEG_LINK3_lk LLEG_LINK4_lk LLEG_LINK5_lk LLEG_LINK6_lk LLEG_LINK7_lk LLEG_LINK8_lk LLEG_LINK9_lk RLEG_LINK1_lk RLEG_LINK10_lk RLEG_LINK2_lk RLEG_LINK3_lk RLEG_LINK4_lk RLEG_LINK5_lk RLEG_LINK6_lk RLEG_LINK7_lk RLEG_LINK8_lk RLEG_LINK9_lk WAIST_LINK0_lk WAIST_LINK1_lk WAIST_LINK2_lk))))

     (when (member :reset-pose (send self :methods))           (send self :reset-pose)) ;; :set reset-pose

     self)) ;; end of :init

  ;; pre-defined pose methods

    (:reset-pose (&optional (limbs '(:rleg :lleg :torso)))
      "Predefined pose named reset-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:rleg (send self limb :angle-vector (float-vector 0.000000 -12.000000 -12.000000 0.000000 30.000000 30.000000 -18.000000 -18.000000 0.000000 0.000000)))
          (:lleg (send self limb :angle-vector (float-vector 0.000000 -12.000000 -12.000000 0.000000 30.000000 30.000000 -18.000000 -18.000000 0.000000 0.000000)))
          (:torso (send self limb :angle-vector (float-vector 0.000000 0.000000 0.000000)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
  ;; all joints
  (:FLY_WHEEL_P (&rest args) (forward-message-to FLY_WHEEL_P_jt args))
  (:LLEG_ANKLE_P0 (&rest args) (forward-message-to LLEG_ANKLE_P0_jt args))
  (:LLEG_ANKLE_P1 (&rest args) (forward-message-to LLEG_ANKLE_P1_jt args))
  (:LLEG_ANKLE_R (&rest args) (forward-message-to LLEG_ANKLE_R_jt args))
  (:LLEG_HIP_P0 (&rest args) (forward-message-to LLEG_HIP_P0_jt args))
  (:LLEG_HIP_P1 (&rest args) (forward-message-to LLEG_HIP_P1_jt args))
  (:LLEG_HIP_R (&rest args) (forward-message-to LLEG_HIP_R_jt args))
  (:LLEG_HIP_Y (&rest args) (forward-message-to LLEG_HIP_Y_jt args))
  (:LLEG_KNEE_P0 (&rest args) (forward-message-to LLEG_KNEE_P0_jt args))
  (:LLEG_KNEE_P1 (&rest args) (forward-message-to LLEG_KNEE_P1_jt args))
  (:LLEG_TOE_P (&rest args) (forward-message-to LLEG_TOE_P_jt args))
  (:RLEG_ANKLE_P0 (&rest args) (forward-message-to RLEG_ANKLE_P0_jt args))
  (:RLEG_ANKLE_P1 (&rest args) (forward-message-to RLEG_ANKLE_P1_jt args))
  (:RLEG_ANKLE_R (&rest args) (forward-message-to RLEG_ANKLE_R_jt args))
  (:RLEG_HIP_P0 (&rest args) (forward-message-to RLEG_HIP_P0_jt args))
  (:RLEG_HIP_P1 (&rest args) (forward-message-to RLEG_HIP_P1_jt args))
  (:RLEG_HIP_R (&rest args) (forward-message-to RLEG_HIP_R_jt args))
  (:RLEG_HIP_Y (&rest args) (forward-message-to RLEG_HIP_Y_jt args))
  (:RLEG_KNEE_P0 (&rest args) (forward-message-to RLEG_KNEE_P0_jt args))
  (:RLEG_KNEE_P1 (&rest args) (forward-message-to RLEG_KNEE_P1_jt args))
  (:RLEG_TOE_P (&rest args) (forward-message-to RLEG_TOE_P_jt args))
  (:WAIST_P (&rest args) (forward-message-to WAIST_P_jt args))
  (:WAIST_R (&rest args) (forward-message-to WAIST_R_jt args))

  ;; all links forwarding
  (:links (&rest args)
   (if (null args) (return-from :links (send-super :links)))
   (let ((key (car args))
           (nargs (cdr args)))
     (unless (keywordp key)
         (return-from :links (send-super* :links args)))
       (case key
       (:FLY_WHEEL_P_LINK (forward-message-to FLY_WHEEL_P_LINK_lk nargs))
       (:LLEG_LINK1 (forward-message-to LLEG_LINK1_lk nargs))
       (:LLEG_LINK10 (forward-message-to LLEG_LINK10_lk nargs))
       (:LLEG_LINK2 (forward-message-to LLEG_LINK2_lk nargs))
       (:LLEG_LINK3 (forward-message-to LLEG_LINK3_lk nargs))
       (:LLEG_LINK4 (forward-message-to LLEG_LINK4_lk nargs))
       (:LLEG_LINK5 (forward-message-to LLEG_LINK5_lk nargs))
       (:LLEG_LINK6 (forward-message-to LLEG_LINK6_lk nargs))
       (:LLEG_LINK7 (forward-message-to LLEG_LINK7_lk nargs))
       (:LLEG_LINK8 (forward-message-to LLEG_LINK8_lk nargs))
       (:LLEG_LINK9 (forward-message-to LLEG_LINK9_lk nargs))
       (:RLEG_LINK1 (forward-message-to RLEG_LINK1_lk nargs))
       (:RLEG_LINK10 (forward-message-to RLEG_LINK10_lk nargs))
       (:RLEG_LINK2 (forward-message-to RLEG_LINK2_lk nargs))
       (:RLEG_LINK3 (forward-message-to RLEG_LINK3_lk nargs))
       (:RLEG_LINK4 (forward-message-to RLEG_LINK4_lk nargs))
       (:RLEG_LINK5 (forward-message-to RLEG_LINK5_lk nargs))
       (:RLEG_LINK6 (forward-message-to RLEG_LINK6_lk nargs))
       (:RLEG_LINK7 (forward-message-to RLEG_LINK7_lk nargs))
       (:RLEG_LINK8 (forward-message-to RLEG_LINK8_lk nargs))
       (:RLEG_LINK9 (forward-message-to RLEG_LINK9_lk nargs))
       (:WAIST_LINK0 (forward-message-to WAIST_LINK0_lk nargs))
       (:WAIST_LINK1 (forward-message-to WAIST_LINK1_lk nargs))
       (:WAIST_LINK2 (forward-message-to WAIST_LINK2_lk nargs))
       (t (send-super* :links args)))))

  ;; all links
  (:FLY_WHEEL_P_LINK_lk (&rest args) (forward-message-to FLY_WHEEL_P_LINK_lk args))
  (:LLEG_LINK1_lk (&rest args) (forward-message-to LLEG_LINK1_lk args))
  (:LLEG_LINK10_lk (&rest args) (forward-message-to LLEG_LINK10_lk args))
  (:LLEG_LINK2_lk (&rest args) (forward-message-to LLEG_LINK2_lk args))
  (:LLEG_LINK3_lk (&rest args) (forward-message-to LLEG_LINK3_lk args))
  (:LLEG_LINK4_lk (&rest args) (forward-message-to LLEG_LINK4_lk args))
  (:LLEG_LINK5_lk (&rest args) (forward-message-to LLEG_LINK5_lk args))
  (:LLEG_LINK6_lk (&rest args) (forward-message-to LLEG_LINK6_lk args))
  (:LLEG_LINK7_lk (&rest args) (forward-message-to LLEG_LINK7_lk args))
  (:LLEG_LINK8_lk (&rest args) (forward-message-to LLEG_LINK8_lk args))
  (:LLEG_LINK9_lk (&rest args) (forward-message-to LLEG_LINK9_lk args))
  (:RLEG_LINK1_lk (&rest args) (forward-message-to RLEG_LINK1_lk args))
  (:RLEG_LINK10_lk (&rest args) (forward-message-to RLEG_LINK10_lk args))
  (:RLEG_LINK2_lk (&rest args) (forward-message-to RLEG_LINK2_lk args))
  (:RLEG_LINK3_lk (&rest args) (forward-message-to RLEG_LINK3_lk args))
  (:RLEG_LINK4_lk (&rest args) (forward-message-to RLEG_LINK4_lk args))
  (:RLEG_LINK5_lk (&rest args) (forward-message-to RLEG_LINK5_lk args))
  (:RLEG_LINK6_lk (&rest args) (forward-message-to RLEG_LINK6_lk args))
  (:RLEG_LINK7_lk (&rest args) (forward-message-to RLEG_LINK7_lk args))
  (:RLEG_LINK8_lk (&rest args) (forward-message-to RLEG_LINK8_lk args))
  (:RLEG_LINK9_lk (&rest args) (forward-message-to RLEG_LINK9_lk args))
  (:WAIST_LINK0_lk (&rest args) (forward-message-to WAIST_LINK0_lk args))
  (:WAIST_LINK1_lk (&rest args) (forward-message-to WAIST_LINK1_lk args))
  (:WAIST_LINK2_lk (&rest args) (forward-message-to WAIST_LINK2_lk args))

  ;; user-defined joint
  (:rleg-crotch-r (&rest args) (forward-message-to RLEG_HIP_R_jt args))
  (:rleg-crotch-p0 (&rest args) (forward-message-to RLEG_HIP_P0_jt args))
  (:rleg-crotch-p1 (&rest args) (forward-message-to RLEG_HIP_P1_jt args))
  (:rleg-crotch-y (&rest args) (forward-message-to RLEG_HIP_Y_jt args))
  (:rleg-knee-p0 (&rest args) (forward-message-to RLEG_KNEE_P0_jt args))
  (:rleg-knee-p1 (&rest args) (forward-message-to RLEG_KNEE_P1_jt args))
  (:rleg-ankle-p0 (&rest args) (forward-message-to RLEG_ANKLE_P0_jt args))
  (:rleg-ankle-p1 (&rest args) (forward-message-to RLEG_ANKLE_P1_jt args))
  (:rleg-ankle-r (&rest args) (forward-message-to RLEG_ANKLE_R_jt args))
  (:rleg-toe-p (&rest args) (forward-message-to RLEG_TOE_P_jt args))
  (:lleg-crotch-r (&rest args) (forward-message-to LLEG_HIP_R_jt args))
  (:lleg-crotch-p0 (&rest args) (forward-message-to LLEG_HIP_P0_jt args))
  (:lleg-crotch-p1 (&rest args) (forward-message-to LLEG_HIP_P1_jt args))
  (:lleg-crotch-y (&rest args) (forward-message-to LLEG_HIP_Y_jt args))
  (:lleg-knee-p0 (&rest args) (forward-message-to LLEG_KNEE_P0_jt args))
  (:lleg-knee-p1 (&rest args) (forward-message-to LLEG_KNEE_P1_jt args))
  (:lleg-ankle-p0 (&rest args) (forward-message-to LLEG_ANKLE_P0_jt args))
  (:lleg-ankle-p1 (&rest args) (forward-message-to LLEG_ANKLE_P1_jt args))
  (:lleg-ankle-r (&rest args) (forward-message-to LLEG_ANKLE_R_jt args))
  (:lleg-toe-p (&rest args) (forward-message-to LLEG_TOE_P_jt args))
  (:torso-waist-p (&rest args) (forward-message-to WAIST_P_jt args))
  (:torso-waist-r (&rest args) (forward-message-to WAIST_R_jt args))
  (:torso-fly-wheel-p (&rest args) (forward-message-to FLY_WHEEL_P_jt args))

  ;; attach_sensor methods
  (:gsensor (&rest args) (forward-message-to gsensor-sensor-coords args))
  (:gyrometer (&rest args) (forward-message-to gyrometer-sensor-coords args))
  (:rfsensor (&rest args) (forward-message-to rfsensor-sensor-coords args))
  (:lfsensor (&rest args) (forward-message-to lfsensor-sensor-coords args))

  ;; geometries
  (:_make_instance_WAIST_LINK0_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0367000000000000e+03))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 10 11 8 9 8 14 14 8 15 13 15 8 8 11 13 12 10 9 9 14 12 11 10 12 11 12 13 12 15 13 14 15 12))
                   (list :vertices (let ((mat (make-matrix 16 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 -9.9670001220703125e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -8.8570001220703125e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -8.8570001220703125e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -9.9670001220703125e+02 2.5000000000000000e+01 2.5000000000000000e+01 -8.8570001220703125e+02 2.5000000000000000e+01 2.5000000000000000e+01 -9.9670001220703125e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -8.8570001220703125e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -9.9670001220703125e+02 -4.0000000000000000e+01 -4.0000000000000000e+01 -1.0766999511718750e+03 -4.0000000000000000e+01 -4.0000000000000000e+01 -9.9670001220703125e+02 -4.0000000000000000e+01 4.0000000000000000e+01 -9.9670001220703125e+02 -4.0000000000000000e+01 4.0000000000000000e+01 -1.0766999511718750e+03 4.0000000000000000e+01 4.0000000000000000e+01 -9.9670001220703125e+02 4.0000000000000000e+01 4.0000000000000000e+01 -1.0766999511718750e+03 4.0000000000000000e+01 -4.0000000000000000e+01 -9.9670001220703125e+02 4.0000000000000000e+01 -4.0000000000000000e+01 -1.0766999511718750e+03 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 72 -> 10 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -1.0766999721527100e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -1.0766999721527100e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -1.0766999721527100e+03)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector -3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -1.0766999721527100e+03) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector -3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.9999999105930328e+01 -3.9999999105930328e+01 -9.9669998884201050e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector 3.9999999105930328e+01 3.9999999105930328e+01 -9.9669998884201050e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -8.8569998741149902e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -8.8569998741149902e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK0_wJ26YU.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_WAIST_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7600000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 1.000000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 2.5000000000000000e+01 -1.7600000000000000e+02 2.3776401519775391e+01 2.5000000000000000e+01 -1.6827499389648438e+02 2.5000000000000000e+01 2.5000000000000000e+01 -1.7600000000000000e+02 2.3776401519775391e+01 -2.5000000000000000e+01 -1.6827499389648438e+02 2.5000000000000000e+01 -2.5000000000000000e+01 -1.7600000000000000e+02 0.0000000000000000e+00 -2.5000000000000000e+01 -1.7600000000000000e+02 2.0225400924682617e+01 2.5000000000000000e+01 -1.6130499267578125e+02 2.0225400924682617e+01 -2.5000000000000000e+01 -1.6130499267578125e+02 1.4694600105285645e+01 2.5000000000000000e+01 -1.5577499389648438e+02 1.4694600105285645e+01 -2.5000000000000000e+01 -1.5577499389648438e+02 7.7254300117492676e+00 2.5000000000000000e+01 -1.5222399902343750e+02 7.7254300117492676e+00 -2.5000000000000000e+01 -1.5222399902343750e+02 1.5308101406833461e-15 2.5000000000000000e+01 -1.5100000000000000e+02 1.5308101406833461e-15 -2.5000000000000000e+01 -1.5100000000000000e+02 -7.7254300117492676e+00 2.5000000000000000e+01 -1.5222399902343750e+02 -7.7254300117492676e+00 -2.5000000000000000e+01 -1.5222399902343750e+02 -1.4694600105285645e+01 2.5000000000000000e+01 -1.5577499389648438e+02 -1.4694600105285645e+01 -2.5000000000000000e+01 -1.5577499389648438e+02 -2.0225400924682617e+01 2.5000000000000000e+01 -1.6130499267578125e+02 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.6130499267578125e+02 -2.3776401519775391e+01 2.5000000000000000e+01 -1.6827499389648438e+02 -2.3776401519775391e+01 -2.5000000000000000e+01 -1.6827499389648438e+02 -2.5000000000000000e+01 2.5000000000000000e+01 -1.7600000000000000e+02 -2.5000000000000000e+01 -2.5000000000000000e+01 -1.7600000000000000e+02 -2.3776401519775391e+01 2.5000000000000000e+01 -1.8372500610351562e+02 -2.3776401519775391e+01 -2.5000000000000000e+01 -1.8372500610351562e+02 -2.0225400924682617e+01 2.5000000000000000e+01 -1.9069500732421875e+02 -2.0225400924682617e+01 -2.5000000000000000e+01 -1.9069500732421875e+02 -1.4694600105285645e+01 2.5000000000000000e+01 -1.9622500610351562e+02 -1.4694600105285645e+01 -2.5000000000000000e+01 -1.9622500610351562e+02 -7.7254300117492676e+00 2.5000000000000000e+01 -1.9977600097656250e+02 -7.7254300117492676e+00 -2.5000000000000000e+01 -1.9977600097656250e+02 -4.5924301044126831e-15 2.5000000000000000e+01 -2.0100000000000000e+02 -4.5924301044126831e-15 -2.5000000000000000e+01 -2.0100000000000000e+02 7.7254300117492676e+00 2.5000000000000000e+01 -1.9977600097656250e+02 7.7254300117492676e+00 -2.5000000000000000e+01 -1.9977600097656250e+02 1.4694600105285645e+01 2.5000000000000000e+01 -1.9622500610351562e+02 1.4694600105285645e+01 -2.5000000000000000e+01 -1.9622500610351562e+02 2.0225400924682617e+01 2.5000000000000000e+01 -1.9069500732421875e+02 2.0225400924682617e+01 -2.5000000000000000e+01 -1.9069500732421875e+02 2.3776401519775391e+01 2.5000000000000000e+01 -1.8372500610351562e+02 2.3776401519775391e+01 -2.5000000000000000e+01 -1.8372500610351562e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 12 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 -1.6827499866485596e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 -2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 2.5000000372529030e+01 -2.0100000500679016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5924302466877485e-15 2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 -2.5000000372529030e+01 -2.0100000500679016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 7.7254301868379116e+00 2.5000000372529030e+01 -1.5222400426864624e+02) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector -2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 -1.5099999308586121e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 -1.6827499866485596e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 7.7254301868379116e+00 2.5000000372529030e+01 -1.5222400426864624e+02) (float-vector 2.0225400105118752e+01 2.5000000372529030e+01 -1.6130499541759491e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.6130499541759491e+02) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 2.3776400834321976e+01 -2.5000000372529030e+01 -1.6827499866485596e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 -1.7599999904632568e+02) (float-vector 2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02) (float-vector -4.5924302466877485e-15 -2.5000000372529030e+01 -2.0100000500679016e+02) (float-vector -2.0225400105118752e+01 -2.5000000372529030e+01 -1.9069500267505646e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5308101166951084e-15 2.5000000372529030e+01 -1.5099999308586121e+02) (float-vector 7.7254301868379116e+00 2.5000000372529030e+01 -1.5222400426864624e+02) (float-vector 1.4694600366055965e+01 -2.5000000372529030e+01 -1.5577499568462372e+02) (float-vector 1.5308101166951084e-15 -2.5000000372529030e+01 -1.5099999308586121e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK1_N02lJT.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 1.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 3.0616202813666922e-15 5.0000000000000000e+01 1.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 1.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 -2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 -4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 -4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 -2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 -1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 -9.1848508914629465e-15 5.0000000000000000e+01 5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK3_Jsu7wd.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_WAIST_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.600000 0.800000 0.600000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -2.5000000000000000e+01 3.0000000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 3.0000000000000000e+02 -2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 3.0000000000000000e+02 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 3.0000000000000000e+02 2.5000000000000000e+01 -2.5000000000000000e+01 2.5000000000000000e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.3776300430297852e+01 7.7254300117492676e+00 -2.5000099182128906e+01 2.4999898910522461e+01 0.0000000000000000e+00 2.4999898910522461e+01 2.3776498794555664e+01 7.7254300117492676e+00 2.4999898910522461e+01 2.5000099182128906e+01 0.0000000000000000e+00 2.5000000000000000e+01 9.1830101155210286e-05 0.0000000000000000e+00 -2.5000099182128906e+01 2.0225299835205078e+01 1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 1.4694600105285645e+01 -2.5000099182128906e+01 1.4694499969482422e+01 2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 2.0225400924682617e+01 -2.5000000000000000e+01 7.7253298759460449e+00 2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 2.5000000000000000e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 2.3776401519775391e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 2.0225400924682617e+01 -2.4999898910522461e+01 -2.0225500106811523e+01 1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 1.4694600105285645e+01 -2.4999898910522461e+01 -2.3776498794555664e+01 7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 7.7254300117492676e+00 -2.4999898910522461e+01 -2.5000099182128906e+01 3.0616202813666922e-15 2.5000099182128906e+01 -2.4999898910522461e+01 3.0616202813666922e-15 -2.4999898910522461e+01 -2.3776498794555664e+01 -7.7254300117492676e+00 2.5000099182128906e+01 -2.3776300430297852e+01 -7.7254300117492676e+00 -2.4999898910522461e+01 -2.0225500106811523e+01 -1.4694600105285645e+01 2.5000099182128906e+01 -2.0225299835205078e+01 -1.4694600105285645e+01 -2.4999898910522461e+01 -1.4694700241088867e+01 -2.0225400924682617e+01 2.5000099182128906e+01 -1.4694499969482422e+01 -2.0225400924682617e+01 -2.5000000000000000e+01 -7.7255201339721680e+00 -2.3776401519775391e+01 2.5000000000000000e+01 -7.7253298759460449e+00 -2.3776401519775391e+01 -2.5000000000000000e+01 -9.1830101155210286e-05 -2.5000000000000000e+01 2.5000000000000000e+01 9.1830101155210286e-05 -2.5000000000000000e+01 -2.5000000000000000e+01 7.7253298759460449e+00 -2.3776401519775391e+01 2.5000000000000000e+01 7.7255201339721680e+00 -2.3776401519775391e+01 -2.5000099182128906e+01 1.4694499969482422e+01 -2.0225400924682617e+01 2.4999898910522461e+01 1.4694700241088867e+01 -2.0225400924682617e+01 -2.5000099182128906e+01 2.0225299835205078e+01 -1.4694600105285645e+01 2.4999898910522461e+01 2.0225500106811523e+01 -1.4694600105285645e+01 -2.5000099182128906e+01 2.3776300430297852e+01 -7.7254300117492676e+00 2.4999898910522461e+01 2.3776498794555664e+01 -7.7254300117492676e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 10 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector 2.5000099092721939e+01 -2.4999899789690971e+01 3.0616202333902167e-15) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15) (float-vector 2.5000099092721939e+01 -2.4999899789690971e+01 3.0616202333902167e-15) (float-vector 2.5000099092721939e+01 -2.0225299522280693e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 -7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector 2.5000099092721939e+01 -2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.4999899789690971e+01 3.0616202333902167e-15) (float-vector 2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5000000372529030e+01 -7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector 2.5000099092721939e+01 -2.0225299522280693e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000099092721939e+01 2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 -1.4694600366055965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 -7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector 2.5000000372529030e+01 7.7255200594663620e+00 -2.3776400834321976e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000099092721939e+01 2.4999899789690971e+01 0.0000000000000000e+00) (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector 2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4999899789690971e+01 -2.0225500687956810e+01 -1.4694600366055965e+01) (float-vector -2.5000000372529030e+01 -7.7255200594663620e+00 -2.3776400834321976e+01) (float-vector -2.5000000372529030e+01 7.7253300696611404e+00 -2.3776400834321976e+01) (float-vector -2.5000099092721939e+01 2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector -2.5000099092721939e+01 2.4999899789690971e+01 0.0000000000000000e+00) (float-vector -2.5000000372529030e+01 2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.5000000372529030e+01 -2.5000000372529030e+01 3.0000001192092896e+02) (float-vector -2.4999899789690971e+01 -2.5000099092721939e+01 3.0616202333902167e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4999899789690971e+01 2.5000099092721939e+01 0.0000000000000000e+00) (float-vector -2.5000099092721939e+01 2.4999899789690971e+01 0.0000000000000000e+00) (float-vector -2.5000099092721939e+01 2.0225299522280693e+01 -1.4694600366055965e+01) (float-vector 2.4999899789690971e+01 2.0225500687956810e+01 -1.4694600366055965e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_WAIST_LINK2_2ACjaZ.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK5_Xpxks1.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK4_4TFPIi.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_FLY_WHEEL_P_LINK_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.5000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.500000 0.500000 0.500000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 2.5000000000000000e+01 -3.5000000000000000e+02 9.5105606079101562e+01 2.5000000000000000e+01 -3.1909799194335938e+02 1.0000000000000000e+02 2.5000000000000000e+01 -3.5000000000000000e+02 9.5105606079101562e+01 -2.5000000000000000e+01 -3.1909799194335938e+02 1.0000000000000000e+02 -2.5000000000000000e+01 -3.5000000000000000e+02 0.0000000000000000e+00 -2.5000000000000000e+01 -3.5000000000000000e+02 8.0901695251464844e+01 2.5000000000000000e+01 -2.9122097778320312e+02 8.0901695251464844e+01 -2.5000000000000000e+01 -2.9122097778320312e+02 5.8778499603271484e+01 2.5000000000000000e+01 -2.6909802246093750e+02 5.8778499603271484e+01 -2.5000000000000000e+01 -2.6909802246093750e+02 3.0901700973510742e+01 2.5000000000000000e+01 -2.5489398193359375e+02 3.0901700973510742e+01 -2.5000000000000000e+01 -2.5489398193359375e+02 6.1232299748215438e-15 2.5000000000000000e+01 -2.5000000000000000e+02 6.1232299748215438e-15 -2.5000000000000000e+01 -2.5000000000000000e+02 -3.0901700973510742e+01 2.5000000000000000e+01 -2.5489398193359375e+02 -3.0901700973510742e+01 -2.5000000000000000e+01 -2.5489398193359375e+02 -5.8778499603271484e+01 2.5000000000000000e+01 -2.6909802246093750e+02 -5.8778499603271484e+01 -2.5000000000000000e+01 -2.6909802246093750e+02 -8.0901695251464844e+01 2.5000000000000000e+01 -2.9122097778320312e+02 -8.0901695251464844e+01 -2.5000000000000000e+01 -2.9122097778320312e+02 -9.5105606079101562e+01 2.5000000000000000e+01 -3.1909799194335938e+02 -9.5105606079101562e+01 -2.5000000000000000e+01 -3.1909799194335938e+02 -1.0000000000000000e+02 2.5000000000000000e+01 -3.5000000000000000e+02 -1.0000000000000000e+02 -2.5000000000000000e+01 -3.5000000000000000e+02 -9.5105606079101562e+01 2.5000000000000000e+01 -3.8090197753906250e+02 -9.5105606079101562e+01 -2.5000000000000000e+01 -3.8090197753906250e+02 -8.0901695251464844e+01 2.5000000000000000e+01 -4.0877899169921875e+02 -8.0901695251464844e+01 -2.5000000000000000e+01 -4.0877899169921875e+02 -5.8778499603271484e+01 2.5000000000000000e+01 -4.3090200805664062e+02 -5.8778499603271484e+01 -2.5000000000000000e+01 -4.3090200805664062e+02 -3.0901700973510742e+01 2.5000000000000000e+01 -4.4510598754882812e+02 -3.0901700973510742e+01 -2.5000000000000000e+01 -4.4510598754882812e+02 -1.8369700088859998e-14 2.5000000000000000e+01 -4.5000000000000000e+02 -1.8369700088859998e-14 -2.5000000000000000e+01 -4.5000000000000000e+02 3.0901700973510742e+01 2.5000000000000000e+01 -4.4510598754882812e+02 3.0901700973510742e+01 -2.5000000000000000e+01 -4.4510598754882812e+02 5.8778499603271484e+01 2.5000000000000000e+01 -4.3090200805664062e+02 5.8778499603271484e+01 -2.5000000000000000e+01 -4.3090200805664062e+02 8.0901695251464844e+01 2.5000000000000000e+01 -4.0877899169921875e+02 8.0901695251464844e+01 -2.5000000000000000e+01 -4.0877899169921875e+02 9.5105606079101562e+01 2.5000000000000000e+01 -3.8090197753906250e+02 9.5105606079101562e+01 -2.5000000000000000e+01 -3.8090197753906250e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 22 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5105603337287903e+01 2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector -1.0000000149011612e+02 2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector -1.0000000149011612e+02 -2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector -9.5105603337287903e+01 -2.5000000372529030e+01 -3.8090199232101440e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0000000149011612e+02 2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector 9.5105603337287903e+01 2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector 9.5105603337287903e+01 -2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector 1.0000000149011612e+02 -2.5000000372529030e+01 -3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0901700258255005e+01 -2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -1.8369699480055068e-14 -2.5000000372529030e+01 -4.4999998807907104e+02) (float-vector -1.8369699480055068e-14 2.5000000372529030e+01 -4.4999998807907104e+02) (float-vector -3.0901700258255005e+01 2.5000000372529030e+01 -4.4510599970817566e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8778498321771622e+01 -2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector -3.0901700258255005e+01 -2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -3.0901700258255005e+01 2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -5.8778498321771622e+01 2.5000000372529030e+01 -4.3090200424194336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0901697278022766e+01 -2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector -8.0901697278022766e+01 2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector -9.5105603337287903e+01 2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector -9.5105603337287903e+01 -2.5000000372529030e+01 -3.8090199232101440e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0901697278022766e+01 -2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector -5.8778498321771622e+01 -2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector -5.8778498321771622e+01 2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector -8.0901697278022766e+01 2.5000000372529030e+01 -4.0877899527549744e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5105603337287903e+01 2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector -9.5105603337287903e+01 -2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector -1.0000000149011612e+02 -2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector -1.0000000149011612e+02 2.5000000372529030e+01 -3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0901697278022766e+01 -2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector -9.5105603337287903e+01 -2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector -9.5105603337287903e+01 2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector -8.0901697278022766e+01 2.5000000372529030e+01 -2.9122099280357361e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8369699480055068e-14 -2.5000000372529030e+01 -4.4999998807907104e+02) (float-vector 3.0901700258255005e+01 -2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector 3.0901700258255005e+01 2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -1.8369699480055068e-14 2.5000000372529030e+01 -4.4999998807907104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0901700258255005e+01 -2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector 5.8778498321771622e+01 -2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector 5.8778498321771622e+01 2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector 3.0901700258255005e+01 2.5000000372529030e+01 -4.4510599970817566e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.0901697278022766e+01 2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector 8.0901697278022766e+01 -2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector 9.5105603337287903e+01 -2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector 9.5105603337287903e+01 2.5000000372529030e+01 -3.8090199232101440e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8778498321771622e+01 -2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector 8.0901697278022766e+01 -2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector 8.0901697278022766e+01 2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector 5.8778498321771622e+01 2.5000000372529030e+01 -4.3090200424194336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5105603337287903e+01 -2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector 9.5105603337287903e+01 2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector 1.0000000149011612e+02 2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector 1.0000000149011612e+02 -2.5000000372529030e+01 -3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.5105603337287903e+01 -2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector 8.0901697278022766e+01 -2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector 8.0901697278022766e+01 2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector 9.5105603337287903e+01 2.5000000372529030e+01 -3.1909799575805664e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0901697278022766e+01 2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector -5.8778498321771622e+01 2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector -5.8778498321771622e+01 -2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector -8.0901697278022766e+01 -2.5000000372529030e+01 -2.9122099280357361e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.1232301270227765e-15 -2.5000000372529030e+01 -2.5000000000000000e+02) (float-vector -3.0901700258255005e+01 -2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector -3.0901700258255005e+01 2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 6.1232301270227765e-15 2.5000000372529030e+01 -2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0901700258255005e+01 -2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector -5.8778498321771622e+01 -2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector -5.8778498321771622e+01 2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector -3.0901700258255005e+01 2.5000000372529030e+01 -2.5489398837089539e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.8778498321771622e+01 2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector -3.0901700258255005e+01 2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -1.8369699480055068e-14 2.5000000372529030e+01 -4.4999998807907104e+02) (float-vector 3.0901700258255005e+01 2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector 5.8778498321771622e+01 2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector 8.0901697278022766e+01 2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector 9.5105603337287903e+01 2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector 1.0000000149011612e+02 2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector 9.5105603337287903e+01 2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector 8.0901697278022766e+01 2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector 5.8778498321771622e+01 2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector 3.0901700258255005e+01 2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 6.1232301270227765e-15 2.5000000372529030e+01 -2.5000000000000000e+02) (float-vector -3.0901700258255005e+01 2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector -5.8778498321771622e+01 2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector -8.0901697278022766e+01 2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector -9.5105603337287903e+01 2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector -1.0000000149011612e+02 2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector -9.5105603337287903e+01 2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector -8.0901697278022766e+01 2.5000000372529030e+01 -4.0877899527549744e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8778498321771622e+01 2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector 8.0901697278022766e+01 2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector 8.0901697278022766e+01 -2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector 5.8778498321771622e+01 -2.5000000372529030e+01 -2.6909801363945007e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0901697278022766e+01 -2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector -9.5105603337287903e+01 -2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector -1.0000000149011612e+02 -2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector -9.5105603337287903e+01 -2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector -8.0901697278022766e+01 -2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector -5.8778498321771622e+01 -2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector -3.0901700258255005e+01 -2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 6.1232301270227765e-15 -2.5000000372529030e+01 -2.5000000000000000e+02) (float-vector 3.0901700258255005e+01 -2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 5.8778498321771622e+01 -2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector 8.0901697278022766e+01 -2.5000000372529030e+01 -2.9122099280357361e+02) (float-vector 9.5105603337287903e+01 -2.5000000372529030e+01 -3.1909799575805664e+02) (float-vector 1.0000000149011612e+02 -2.5000000372529030e+01 -3.4999999403953552e+02) (float-vector 9.5105603337287903e+01 -2.5000000372529030e+01 -3.8090199232101440e+02) (float-vector 8.0901697278022766e+01 -2.5000000372529030e+01 -4.0877899527549744e+02) (float-vector 5.8778498321771622e+01 -2.5000000372529030e+01 -4.3090200424194336e+02) (float-vector 3.0901700258255005e+01 -2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -1.8369699480055068e-14 -2.5000000372529030e+01 -4.4999998807907104e+02) (float-vector -3.0901700258255005e+01 -2.5000000372529030e+01 -4.4510599970817566e+02) (float-vector -5.8778498321771622e+01 -2.5000000372529030e+01 -4.3090200424194336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0901700258255005e+01 -2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 6.1232301270227765e-15 -2.5000000372529030e+01 -2.5000000000000000e+02) (float-vector 6.1232301270227765e-15 2.5000000372529030e+01 -2.5000000000000000e+02) (float-vector 3.0901700258255005e+01 2.5000000372529030e+01 -2.5489398837089539e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.8778498321771622e+01 -2.5000000372529030e+01 -2.6909801363945007e+02) (float-vector 3.0901700258255005e+01 -2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 3.0901700258255005e+01 2.5000000372529030e+01 -2.5489398837089539e+02) (float-vector 5.8778498321771622e+01 2.5000000372529030e+01 -2.6909801363945007e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_FLY_WHEEL_P_LINK_Vr8PD4.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -9.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 8.9999801635742188e+01 0.0000000000000000e+00 -5.0000198364257812e+01 1.3755300903320312e+02 1.5450900077819824e+01 -5.0000198364257812e+01 1.4000000000000000e+02 0.0000000000000000e+00 4.9999797821044922e+01 1.3755300903320312e+02 1.5450900077819824e+01 4.9999797821044922e+01 1.4000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 9.0000198364257812e+01 0.0000000000000000e+00 -5.0000102996826172e+01 1.3045098876953125e+02 2.9389299392700195e+01 4.9999900817871094e+01 1.3045098876953125e+02 2.9389299392700195e+01 -5.0000102996826172e+01 1.1938899993896484e+02 4.0450801849365234e+01 4.9999900817871094e+01 1.1938899993896484e+02 4.0450801849365234e+01 -5.0000102996826172e+01 1.0545100402832031e+02 4.7552803039550781e+01 4.9999900817871094e+01 1.0545100402832031e+02 4.7552803039550781e+01 -5.0000000000000000e+01 8.9999801635742188e+01 5.0000000000000000e+01 5.0000000000000000e+01 9.0000198364257812e+01 5.0000000000000000e+01 -4.9999900817871094e+01 7.4548995971679688e+01 4.7552803039550781e+01 5.0000102996826172e+01 7.4549301147460938e+01 4.7552803039550781e+01 -4.9999900817871094e+01 6.0610599517822266e+01 4.0450801849365234e+01 5.0000102996826172e+01 6.0610900878906250e+01 4.0450801849365234e+01 -4.9999900817871094e+01 4.9548999786376953e+01 2.9389299392700195e+01 5.0000102996826172e+01 4.9549301147460938e+01 2.9389299392700195e+01 -4.9999797821044922e+01 4.2447002410888672e+01 1.5450900077819824e+01 5.0000198364257812e+01 4.2447399139404297e+01 1.5450900077819824e+01 -4.9999797821044922e+01 3.9999801635742188e+01 6.1232299748215438e-15 5.0000198364257812e+01 4.0000198364257812e+01 6.1232299748215438e-15 -4.9999797821044922e+01 4.2447002410888672e+01 -1.5450900077819824e+01 5.0000198364257812e+01 4.2447399139404297e+01 -1.5450900077819824e+01 -4.9999900817871094e+01 4.9548999786376953e+01 -2.9389299392700195e+01 5.0000102996826172e+01 4.9549301147460938e+01 -2.9389299392700195e+01 -4.9999900817871094e+01 6.0610599517822266e+01 -4.0450801849365234e+01 5.0000102996826172e+01 6.0610900878906250e+01 -4.0450801849365234e+01 -4.9999900817871094e+01 7.4548995971679688e+01 -4.7552803039550781e+01 5.0000102996826172e+01 7.4549301147460938e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.9999801635742188e+01 -5.0000000000000000e+01 5.0000000000000000e+01 9.0000198364257812e+01 -5.0000000000000000e+01 -5.0000102996826172e+01 1.0545100402832031e+02 -4.7552803039550781e+01 4.9999900817871094e+01 1.0545100402832031e+02 -4.7552803039550781e+01 -5.0000102996826172e+01 1.1938899993896484e+02 -4.0450801849365234e+01 4.9999900817871094e+01 1.1938899993896484e+02 -4.0450801849365234e+01 -5.0000102996826172e+01 1.3045098876953125e+02 -2.9389299392700195e+01 4.9999900817871094e+01 1.3045098876953125e+02 -2.9389299392700195e+01 -5.0000198364257812e+01 1.3755300903320312e+02 -1.5450900077819824e+01 4.9999797821044922e+01 1.3755300903320312e+02 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 4.2447399348020554e+01 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 4.2447000741958618e+01 1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 4.2447399348020554e+01 1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 4.0000200271606445e+01 6.1232301270227765e-15) (float-vector -4.9999799579381943e+01 3.9999801665544510e+01 6.1232301270227765e-15) (float-vector -4.9999799579381943e+01 4.2447000741958618e+01 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 6.0610599815845490e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 6.0610901564359665e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 4.0000200271606445e+01 6.1232301270227765e-15) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 3.9999801665544510e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 6.0610599815845490e+01 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 4.2447000741958618e+01 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 3.9999801665544510e+01 6.1232301270227765e-15) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector -5.0000000745058060e+01 8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector -5.0000000745058060e+01 8.9999802410602570e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 6.0610901564359665e+01 4.0450800210237503e+01) (float-vector -4.9999900162220001e+01 6.0610599815845490e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector 4.9999900162220001e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 1.1938899755477905e+02 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 7.4548996984958649e+01 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 1.0545100271701813e+02 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 4.0000200271606445e+01 6.1232301270227765e-15) (float-vector 5.0000198185443878e+01 4.2447399348020554e+01 1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 4.9549300223588943e+01 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 6.0610901564359665e+01 4.0450800210237503e+01) (float-vector 5.0000101327896118e+01 7.4549302458763123e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 4.0450800210237503e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 1.1938899755477905e+02 -4.0450800210237503e+01) (float-vector 5.0000000745058060e+01 9.0000197291374207e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 1.3755300641059875e+02 -1.5450900420546532e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK1_rOYfka.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK4_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.5350000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.900000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 -5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0350000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 6.5700000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0350000000000000e+02 0.0000000000000000e+00 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 0.0000000000000000e+00 1.8366001313552260e-04 4.0350000000000000e+02 4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 3.0616202813666922e-15 -5.0000198364257812e+01 5.0350000000000000e+02 3.0616202813666922e-15 -4.9999797821044922e+01 4.0350000000000000e+02 -1.5450900077819824e+01 -4.7552997589111328e+01 5.0350000000000000e+02 -1.5450900077819824e+01 -4.7552600860595703e+01 4.0350000000000000e+02 -2.9389299392700195e+01 -4.0451000213623047e+01 5.0350000000000000e+02 -2.9389299392700195e+01 -4.0450698852539062e+01 4.0350000000000000e+02 -4.0450801849365234e+01 -2.9389400482177734e+01 5.0350000000000000e+02 -4.0450801849365234e+01 -2.9389101028442383e+01 4.0350000000000000e+02 -4.7552803039550781e+01 -1.5451000213623047e+01 5.0350000000000000e+02 -4.7552803039550781e+01 -1.5450699806213379e+01 4.0350000000000000e+02 -5.0000000000000000e+01 -1.8366001313552260e-04 5.0350000000000000e+02 -5.0000000000000000e+01 1.8366001313552260e-04 4.0350000000000000e+02 -4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 -4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 -4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 -4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 -2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 -2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 -1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 -1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 -9.1848508914629465e-15 4.9999797821044922e+01 5.0350000000000000e+02 -9.1848508914629465e-15 5.0000198364257812e+01 4.0350000000000000e+02 1.5450900077819824e+01 4.7552600860595703e+01 5.0350000000000000e+02 1.5450900077819824e+01 4.7552997589111328e+01 4.0350000000000000e+02 2.9389299392700195e+01 4.0450698852539062e+01 5.0350000000000000e+02 2.9389299392700195e+01 4.0451000213623047e+01 4.0350000000000000e+02 4.0450801849365234e+01 2.9389101028442383e+01 5.0350000000000000e+02 4.0450801849365234e+01 2.9389400482177734e+01 4.0350000000000000e+02 4.7552803039550781e+01 1.5450699806213379e+01 5.0350000000000000e+02 4.7552803039550781e+01 1.5451000213623047e+01 4.0350000000000000e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 18 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.5700000524520874e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector -4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector -4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector -2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector -1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 -4.7552600502967834e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 -4.0450699627399445e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 -2.9389100149273872e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 -1.5450700186192989e+01 4.0349999070167542e+02) (float-vector 4.7552801668643951e+01 1.5451000072062016e+01 4.0349999070167542e+02) (float-vector 4.0450800210237503e+01 2.9389400035142899e+01 4.0349999070167542e+02) (float-vector 2.9389299452304840e+01 4.0451001375913620e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector -1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 1.5450900420546532e+01 4.7552999109029770e+01 4.0349999070167542e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 5.0349998474121094e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.5700000524520874e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK4_CIp64Z.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK5_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK5_BlkmWn.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK2_ayBUTb.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -1.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -1.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -1.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 1.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 3.0616202813666922e-15 5.0000000000000000e+01 1.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 1.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 -2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 -4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 -4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 -2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 -1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 -9.1848508914629465e-15 5.0000000000000000e+01 5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK6_oAYjS2.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK6_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 1.000000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 1 0 6 6 0 7 5 7 0 0 3 5 4 2 1 1 6 4 3 2 4 3 4 5 4 7 5 6 7 4 8 9 10 8 14 9 8 16 14 8 18 16 8 20 18 8 22 20 8 24 22 8 26 24 8 28 26 8 30 28 8 32 30 8 34 32 8 36 34 8 38 36 8 40 38 8 42 40 8 44 42 8 46 44 8 48 46 8 10 48 38 40 41 40 43 41 40 42 43 42 45 43 42 44 45 44 47 45 44 46 47 46 49 47 46 48 49 48 12 49 48 10 12 10 11 12 10 9 11 13 12 11 13 49 12 13 47 49 13 45 47 13 43 45 13 41 43 13 11 15 13 15 17 13 17 19 13 19 21 13 21 23 13 23 25 13 25 27 13 27 29 13 29 31 13 31 33 13 33 35 13 35 37 13 37 39 13 39 41 30 33 31 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 28 30 31 26 28 29 28 31 29 24 26 27 26 29 27 22 24 25 24 27 25 20 22 23 22 25 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 9 14 15 14 17 15 9 15 11))
                   (list :vertices (let ((mat (make-matrix 50 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -5.0000000000000000e+01 -1.5000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5000000000000000e+02 5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -1.5000000000000000e+02 5.0000000000000000e+01 -5.0000000000000000e+01 5.0000000000000000e+01 5.0000000000000000e+01 -5.0000000000000000e+01 -1.5000000000000000e+02 0.0000000000000000e+00 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 1.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 3.0616202813666922e-15 5.0000000000000000e+01 1.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 1.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 -2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 -4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 -4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 -2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 -1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 -9.1848508914629465e-15 5.0000000000000000e+01 5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 276 -> 11 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 -1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK6_kl16bt.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.0000000000000000e+01 0.0000000000000000e+00 4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -5.0000000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -5.0000000000000000e+01 0.0000000000000000e+00 4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 3.0616202813666922e-15 5.0000000000000000e+01 5.0000000000000000e+01 3.0616202813666922e-15 -5.0000000000000000e+01 5.0000000000000000e+01 -1.5450900077819824e+01 5.0000000000000000e+01 4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 4.7552803039550781e+01 -2.9389299392700195e+01 5.0000000000000000e+01 4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 4.0450801849365234e+01 -4.0450801849365234e+01 5.0000000000000000e+01 2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 2.9389299392700195e+01 -4.7552803039550781e+01 5.0000000000000000e+01 1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.0000000000000000e+01 6.1232299748215438e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 6.1232299748215438e-15 -4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 -4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 -2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 -1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 -9.1848508914629465e-15 5.0000000000000000e+01 -5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 -5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 -4.7552803039550781e+01 1.5450900077819824e+01 -5.0000000000000000e+01 -4.7552803039550781e+01 2.9389299392700195e+01 5.0000000000000000e+01 -4.0450801849365234e+01 2.9389299392700195e+01 -5.0000000000000000e+01 -4.0450801849365234e+01 4.0450801849365234e+01 5.0000000000000000e+01 -2.9389299392700195e+01 4.0450801849365234e+01 -5.0000000000000000e+01 -2.9389299392700195e+01 4.7552803039550781e+01 5.0000000000000000e+01 -1.5450900077819824e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 -4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 4.0450800210237503e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.5450900420546532e+01) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 4.0450800210237503e+01) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 0.0000000000000000e+00) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 -1.5450900420546532e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 -4.0450800210237503e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 -5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 -4.7552801668643951e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 -2.9389299452304840e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 6.1232301270227765e-15)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 2.9389299452304840e+01) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 4.7552801668643951e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK2_iTKutX.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK7_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK7_TxLqry.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK8_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 1.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 3.0616202813666922e-15 5.0000000000000000e+01 1.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 1.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 -2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 -4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 -4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 -2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 -1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 -9.1848508914629465e-15 5.0000000000000000e+01 5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK8_s0TWID.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK7_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -3.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 3.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 3.0616202813666922e-15 5.0000000000000000e+01 3.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 3.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 3.4755300903320312e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 3.4755300903320312e+02 -2.9389299392700195e+01 5.0000000000000000e+01 3.4045098876953125e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 3.4045098876953125e+02 -4.0450801849365234e+01 5.0000000000000000e+01 3.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 3.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 3.1545098876953125e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 3.1545098876953125e+02 -5.0000000000000000e+01 5.0000000000000000e+01 3.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 3.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 -4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 -2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 -1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 -9.1848508914629465e-15 5.0000000000000000e+01 2.5000000000000000e+02 -9.1848508914629465e-15 -5.0000000000000000e+01 2.5000000000000000e+02 1.5450900077819824e+01 5.0000000000000000e+01 2.5244700622558594e+02 1.5450900077819824e+01 -5.0000000000000000e+01 2.5244700622558594e+02 2.9389299392700195e+01 5.0000000000000000e+01 2.5954898071289062e+02 2.9389299392700195e+01 -5.0000000000000000e+01 2.5954898071289062e+02 4.0450801849365234e+01 5.0000000000000000e+01 2.7061099243164062e+02 4.0450801849365234e+01 -5.0000000000000000e+01 2.7061099243164062e+02 4.7552803039550781e+01 5.0000000000000000e+01 2.8454901123046875e+02 4.7552803039550781e+01 -5.0000000000000000e+01 2.8454901123046875e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 14 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 2.5000000000000000e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 2.5954899191856384e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 2.5000000000000000e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 2.5954899191856384e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 2.8454899787902832e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 3.0000001192092896e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 3.4999999403953552e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 3.1545099616050720e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 3.4045100212097168e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 3.1545099616050720e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK7_vqUDj4.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK9_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 3 2 4 3 4 5 4 2 1 1 6 4 1 0 6 6 0 7 6 7 4 4 7 5 5 7 0 0 3 5))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 8.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 8.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 8.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 8.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK9_NhmO1I.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK1_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 9.0000000000000000e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(-5.0000000000000000e+01 -9.0000198364257812e+01 0.0000000000000000e+00 -5.0000198364257812e+01 -4.2447399139404297e+01 1.5450900077819824e+01 -5.0000198364257812e+01 -4.0000198364257812e+01 0.0000000000000000e+00 4.9999797821044922e+01 -4.2447002410888672e+01 1.5450900077819824e+01 4.9999797821044922e+01 -3.9999801635742188e+01 0.0000000000000000e+00 5.0000000000000000e+01 -8.9999801635742188e+01 0.0000000000000000e+00 -5.0000102996826172e+01 -4.9549301147460938e+01 2.9389299392700195e+01 4.9999900817871094e+01 -4.9548999786376953e+01 2.9389299392700195e+01 -5.0000102996826172e+01 -6.0610900878906250e+01 4.0450801849365234e+01 4.9999900817871094e+01 -6.0610599517822266e+01 4.0450801849365234e+01 -5.0000102996826172e+01 -7.4549301147460938e+01 4.7552803039550781e+01 4.9999900817871094e+01 -7.4548995971679688e+01 4.7552803039550781e+01 -5.0000000000000000e+01 -9.0000198364257812e+01 5.0000000000000000e+01 5.0000000000000000e+01 -8.9999801635742188e+01 5.0000000000000000e+01 -4.9999900817871094e+01 -1.0545100402832031e+02 4.7552803039550781e+01 5.0000102996826172e+01 -1.0545100402832031e+02 4.7552803039550781e+01 -4.9999900817871094e+01 -1.1938899993896484e+02 4.0450801849365234e+01 5.0000102996826172e+01 -1.1938899993896484e+02 4.0450801849365234e+01 -4.9999900817871094e+01 -1.3045098876953125e+02 2.9389299392700195e+01 5.0000102996826172e+01 -1.3045098876953125e+02 2.9389299392700195e+01 -4.9999797821044922e+01 -1.3755300903320312e+02 1.5450900077819824e+01 5.0000198364257812e+01 -1.3755300903320312e+02 1.5450900077819824e+01 -4.9999797821044922e+01 -1.4000000000000000e+02 6.1232299748215438e-15 5.0000198364257812e+01 -1.4000000000000000e+02 6.1232299748215438e-15 -4.9999797821044922e+01 -1.3755300903320312e+02 -1.5450900077819824e+01 5.0000198364257812e+01 -1.3755300903320312e+02 -1.5450900077819824e+01 -4.9999900817871094e+01 -1.3045098876953125e+02 -2.9389299392700195e+01 5.0000102996826172e+01 -1.3045098876953125e+02 -2.9389299392700195e+01 -4.9999900817871094e+01 -1.1938899993896484e+02 -4.0450801849365234e+01 5.0000102996826172e+01 -1.1938899993896484e+02 -4.0450801849365234e+01 -4.9999900817871094e+01 -1.0545100402832031e+02 -4.7552803039550781e+01 5.0000102996826172e+01 -1.0545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 -9.0000198364257812e+01 -5.0000000000000000e+01 5.0000000000000000e+01 -8.9999801635742188e+01 -5.0000000000000000e+01 -5.0000102996826172e+01 -7.4549301147460938e+01 -4.7552803039550781e+01 4.9999900817871094e+01 -7.4548995971679688e+01 -4.7552803039550781e+01 -5.0000102996826172e+01 -6.0610900878906250e+01 -4.0450801849365234e+01 4.9999900817871094e+01 -6.0610599517822266e+01 -4.0450801849365234e+01 -5.0000102996826172e+01 -4.9549301147460938e+01 -2.9389299392700195e+01 4.9999900817871094e+01 -4.9548999786376953e+01 -2.9389299392700195e+01 -5.0000198364257812e+01 -4.2447399139404297e+01 -1.5450900077819824e+01 4.9999797821044922e+01 -4.2447002410888672e+01 -1.5450900077819824e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999799579381943e+01 -3.9999801665544510e+01 0.0000000000000000e+00) (float-vector 4.9999799579381943e+01 -4.2447000741958618e+01 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -4.2447399348020554e+01 1.5450900420546532e+01) (float-vector -5.0000198185443878e+01 -4.0000200271606445e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 5.0000000745058060e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 -4.2447399348020554e+01 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 -4.2447000741958618e+01 1.5450900420546532e+01) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 5.0000000745058060e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 -3.9999801665544510e+01 0.0000000000000000e+00) (float-vector -5.0000198185443878e+01 -4.0000200271606445e+01 0.0000000000000000e+00) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 1.5450900420546532e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 -5.0000000745058060e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 -4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector -5.0000198185443878e+01 -4.0000200271606445e+01 0.0000000000000000e+00) (float-vector -5.0000198185443878e+01 -4.2447399348020554e+01 1.5450900420546532e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 4.7552801668643951e+01) (float-vector -5.0000000745058060e+01 -9.0000197291374207e+01 5.0000000745058060e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector -4.9999799579381943e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 -2.9389299452304840e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 -4.7552801668643951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 -2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector -4.9999900162220001e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 -1.5450900420546532e+01) (float-vector 5.0000198185443878e+01 -1.3755300641059875e+02 1.5450900420546532e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 2.9389299452304840e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 5.0000000745058060e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 4.7552801668643951e+01) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 2.9389299452304840e+01) (float-vector 4.9999799579381943e+01 -4.2447000741958618e+01 1.5450900420546532e+01) (float-vector 4.9999799579381943e+01 -3.9999801665544510e+01 0.0000000000000000e+00) (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 -2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 -4.7552801668643951e+01) (float-vector 5.0000000745058060e+01 -8.9999802410602570e+01 -5.0000000745058060e+01) (float-vector 5.0000101327896118e+01 -1.0545100271701813e+02 -4.7552801668643951e+01) (float-vector 5.0000101327896118e+01 -1.3045099377632141e+02 -2.9389299452304840e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9999900162220001e+01 -4.9548998475074768e+01 2.9389299452304840e+01) (float-vector 4.9999900162220001e+01 -7.4548996984958649e+01 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -7.4549302458763123e+01 4.7552801668643951e+01) (float-vector -5.0000101327896118e+01 -4.9549300223588943e+01 2.9389299452304840e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK1_9Ta8dW.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_RLEG_LINK10_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 -6.0000000000000000e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.500000 0.500000 0.500000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 3 2 4 3 4 5 4 2 1 1 6 4 1 0 6 6 0 7 6 7 4 4 7 5 5 7 0 0 3 5))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-8.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -8.0000000000000000e+01 -7.0000000000000000e+01 9.0000000000000000e+01 -8.0000000000000000e+01 7.0000000000000000e+01 9.0000000000000000e+01 -8.0000000000000000e+01 7.0000000000000000e+01 5.0000000000000000e+01 2.0000000000000000e+01 7.0000000000000000e+01 9.0000000000000000e+01 2.0000000000000000e+01 7.0000000000000000e+01 5.0000000000000000e+01 2.0000000000000000e+01 -7.0000000000000000e+01 9.0000000000000000e+01 2.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 9.0000003576278687e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 5.0000000745058060e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_RLEG_LINK10_yuPcnO.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK3_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 1.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 3.0616202813666922e-15 5.0000000000000000e+01 1.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 1.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 -2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 -4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 -4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 -2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 -1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 -9.1848508914629465e-15 5.0000000000000000e+01 5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK3_DsqmLY.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK8_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.800000 0.800000 0.800000 1.000000))))
                   (list :indices #i( 0 1 2 0 6 1 0 8 6 0 10 8 0 12 10 0 14 12 0 16 14 0 18 16 0 20 18 0 22 20 0 24 22 0 26 24 0 28 26 0 30 28 0 32 30 0 34 32 0 36 34 0 38 36 0 40 38 0 2 40 30 32 33 32 35 33 32 34 35 34 37 35 34 36 37 36 39 37 36 38 39 38 41 39 38 40 41 40 4 41 40 2 4 2 3 4 2 1 3 5 4 3 5 41 4 5 39 41 5 37 39 5 35 37 5 33 35 5 3 7 5 7 9 5 9 11 5 11 13 5 13 15 5 15 17 5 17 19 5 19 21 5 21 23 5 23 25 5 25 27 5 27 29 5 29 31 5 31 33 22 25 23 22 24 25 24 27 25 24 26 27 26 29 27 26 28 29 28 31 29 28 30 31 30 33 31 20 22 23 18 20 21 20 23 21 16 18 19 18 21 19 14 16 17 16 19 17 12 14 15 14 17 15 10 12 13 12 15 13 8 10 11 10 13 11 6 8 9 8 11 9 1 6 7 6 9 7 1 7 3))
                   (list :vertices (let ((mat (make-matrix 42 3))) (fvector-replace (array-entity mat) #f(0.0000000000000000e+00 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 0.0000000000000000e+00 -5.0000000000000000e+01 1.0000000000000000e+02 4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 3.0616202813666922e-15 5.0000000000000000e+01 1.5000000000000000e+02 3.0616202813666922e-15 -5.0000000000000000e+01 1.5000000000000000e+02 -1.5450900077819824e+01 5.0000000000000000e+01 1.4755299377441406e+02 -1.5450900077819824e+01 -5.0000000000000000e+01 1.4755299377441406e+02 -2.9389299392700195e+01 5.0000000000000000e+01 1.4045100402832031e+02 -2.9389299392700195e+01 -5.0000000000000000e+01 1.4045100402832031e+02 -4.0450801849365234e+01 5.0000000000000000e+01 1.2938900756835938e+02 -4.0450801849365234e+01 -5.0000000000000000e+01 1.2938900756835938e+02 -4.7552803039550781e+01 5.0000000000000000e+01 1.1545100402832031e+02 -4.7552803039550781e+01 -5.0000000000000000e+01 1.1545100402832031e+02 -5.0000000000000000e+01 5.0000000000000000e+01 1.0000000000000000e+02 -5.0000000000000000e+01 -5.0000000000000000e+01 1.0000000000000000e+02 -4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 -4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 -4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 -4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 -2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 -2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 -1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 -1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 -9.1848508914629465e-15 5.0000000000000000e+01 5.0000000000000000e+01 -9.1848508914629465e-15 -5.0000000000000000e+01 5.0000000000000000e+01 1.5450900077819824e+01 5.0000000000000000e+01 5.2447200775146484e+01 1.5450900077819824e+01 -5.0000000000000000e+01 5.2447200775146484e+01 2.9389299392700195e+01 5.0000000000000000e+01 5.9549201965332031e+01 2.9389299392700195e+01 -5.0000000000000000e+01 5.9549201965332031e+01 4.0450801849365234e+01 5.0000000000000000e+01 7.0610702514648438e+01 4.0450801849365234e+01 -5.0000000000000000e+01 7.0610702514648438e+01 4.7552803039550781e+01 5.0000000000000000e+01 8.4549102783203125e+01 4.7552803039550781e+01 -5.0000000000000000e+01 8.4549102783203125e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 240 -> 16 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -9.1848505672081464e-15 5.0000000745058060e+01 5.0000000745058060e+01) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 5.9549201279878616e+01) (float-vector 4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 5.0000000745058060e+01 5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 1.5450900420546532e+01 5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 3.0616202333902167e-15 5.0000000745058060e+01 1.5000000596046448e+02) (float-vector -2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5450900420546532e+01 -5.0000000745058060e+01 5.2447199821472168e+01) (float-vector -4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 8.4549099206924438e+01) (float-vector -5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector -4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector -2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 3.0616202333902167e-15 -5.0000000745058060e+01 1.5000000596046448e+02) (float-vector 1.5450900420546532e+01 -5.0000000745058060e+01 1.4755299687385559e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 5.0000000745058060e+01 -5.0000000745058060e+01 1.0000000149011612e+02) (float-vector 4.0450800210237503e+01 -5.0000000745058060e+01 7.0610702037811279e+01) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 5.9549201279878616e+01) (float-vector -9.1848505672081464e-15 -5.0000000745058060e+01 5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7552801668643951e+01 -5.0000000745058060e+01 1.1545100063085556e+02) (float-vector 2.9389299452304840e+01 -5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 2.9389299452304840e+01 5.0000000745058060e+01 1.4045099914073944e+02) (float-vector 4.7552801668643951e+01 5.0000000745058060e+01 1.1545100063085556e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK8_AtX9M5.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK9_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.000000 0.500000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 3 2 4 3 4 5 4 2 1 1 6 4 1 0 6 6 0 7 6 7 4 4 7 5 5 7 0 0 3 5))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 -7.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 8.0000000000000000e+01 7.0000000000000000e+01 -5.0000000000000000e+01 8.0000000000000000e+01 7.0000000000000000e+01 -7.0000000000000000e+01 8.0000000000000000e+01 -7.0000000000000000e+01 -5.0000000000000000e+01 8.0000000000000000e+01 -7.0000000000000000e+01 -7.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -5.0000000745058060e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -5.0000000745058060e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.9999998211860657e+01 -7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector 7.9999998211860657e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 7.0000000298023224e+01 -7.0000000298023224e+01) (float-vector -7.0000000298023224e+01 -7.0000000298023224e+01 -7.0000000298023224e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK9_xMkfg7.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_LLEG_LINK10_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 8.0000000000000000e+01 0.0000000000000000e+00 -6.0000000000000000e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.100000 0.100000 0.100000 1.000000))
                    (list :diffuse (float-vector 0.500000 0.500000 0.500000 1.000000))))
                   (list :indices #i( 0 1 2 2 3 0 3 2 4 3 4 5 4 2 1 1 6 4 1 0 6 6 0 7 6 7 4 4 7 5 5 7 0 0 3 5))
                   (list :vertices (let ((mat (make-matrix 8 3))) (fvector-replace (array-entity mat) #f(-8.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 -8.0000000000000000e+01 -7.0000000000000000e+01 9.0000000000000000e+01 -8.0000000000000000e+01 7.0000000000000000e+01 9.0000000000000000e+01 -8.0000000000000000e+01 7.0000000000000000e+01 5.0000000000000000e+01 2.0000000000000000e+01 7.0000000000000000e+01 9.0000000000000000e+01 2.0000000000000000e+01 7.0000000000000000e+01 5.0000000000000000e+01 2.0000000000000000e+01 -7.0000000000000000e+01 9.0000000000000000e+01 2.0000000000000000e+01 -7.0000000000000000e+01 5.0000000000000000e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 36 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 9.0000003576278687e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 9.0000003576278687e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 9.0000003576278687e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 9.0000003576278687e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9999999552965164e+01 -7.0000000298023224e+01 5.0000000745058060e+01) (float-vector 1.9999999552965164e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 7.0000000298023224e+01 5.0000000745058060e+01) (float-vector -7.9999998211860657e+01 -7.0000000298023224e+01 5.0000000745058060e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_LLEG_LINK10_cWFLL8.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  )


(provide :SampleSpecialJointRobot "(ip-10-0-1-159 5.4.0-1037-aws aarch64) at 2021-09-21 17:24:15 PST")

